(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define gerbil/tools/gxtags#main
    (lambda _args1146_
      (letrec* ((_gopt1148_
                 (std/getopt#getopt
                  (std/getopt#flag__%__0
                   '#f
                   '"append to existing tag file"
                   'append
                   '"-a")
                  (std/getopt#option__%__0
                   '#f
                   '"explicit name of file for tag table"
                   absent-value
                   '"TAGS"
                   'output
                   '"-o")
                  (std/getopt#flag__%__%
                   '#f
                   '"display help"
                   'help
                   '"-h"
                   '"--help")
                  (std/getopt#rest-arguments__%
                   '#f
                   '"source file or directory"
                   absent-value
                   'input)))
                (_help1149_
                 (lambda (_what1165_)
                   (std/getopt#getopt-display-help__0 _what1165_ '"gxtags"))))
        (with-exception-catcher
         (lambda (_g11501152_)
           (if ((lambda (_$obj1155_)
                  (let ()
                    (declare (not safe))
                    (##structure-instance-of?
                     _$obj1155_
                     'std/getopt#getopt-error::t)))
                _g11501152_)
               (let ((_exn1158_ _g11501152_)) (_help1149_ _exn1158_) (exit '1))
               (raise _g11501152_)))
         (lambda ()
           (let ((_opt1161_ (std/getopt#getopt-parse _gopt1148_ _args1146_)))
             (if (table-ref _opt1161_ 'help '#f)
                 (_help1149_ _gopt1148_)
                 (let ((_inputs1163_ (table-ref _opt1161_ 'input '#f)))
                   (if (null? _inputs1163_)
                       (begin (_help1149_ _gopt1148_) (exit '1))
                       (gerbil/tools/gxtags#run
                        (table-ref _opt1161_ 'input '#f)
                        (table-ref _opt1161_ 'output '#f)
                        (table-ref _opt1161_ 'append '#f)))))))))))
  (define gerbil/tools/gxtags#run
    (lambda (_inputs1142_ _tagfile1143_ _append?1144_)
      (_gx#load-expander!)
      (gerbil/tools/gxtags#make-tags__%
       _inputs1142_
       _tagfile1143_
       _append?1144_)))
  (define gerbil/tools/gxtags#current-tags-path (make-parameter '#f))
  (define gerbil/tools/gxtags#make-tags__%
    (lambda (_inputs1119_ _tagfile1120_ _append?1121_)
      (call-with-output-file
       (cons 'path:
             (cons _tagfile1120_ (cons 'append: (cons _append?1121_ '()))))
       (lambda (_output1123_)
         (call-with-parameters
          (lambda ()
            (for-each
             (lambda (_g11251127_)
               (gerbil/tools/gxtags#tag-input _g11251127_ _output1123_))
             _inputs1119_))
          gerbil/tools/gxtags#current-tags-path
          (path-normalize _tagfile1120_))))))
  (define gerbil/tools/gxtags#make-tags__0
    (lambda (_inputs1133_ _tagfile1134_)
      (let ((_append?1136_ '#f))
        (gerbil/tools/gxtags#make-tags__%
         _inputs1133_
         _tagfile1134_
         _append?1136_))))
  (define gerbil/tools/gxtags#make-tags
    (lambda _g7368_
      (let ((_g7367_ (let () (declare (not safe)) (##length _g7368_))))
        (cond ((let () (declare (not safe)) (##fx= _g7367_ 2))
               (apply gerbil/tools/gxtags#make-tags__0 _g7368_))
              ((let () (declare (not safe)) (##fx= _g7367_ 3))
               (apply gerbil/tools/gxtags#make-tags__% _g7368_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxtags#make-tags
                _g7368_))))))
  (define gerbil/tools/gxtags#file-directory?
    (lambda (_path1116_) (eq? (file-type _path1116_) 'directory)))
  (define gerbil/tools/gxtags#tag-input
    (lambda (_input1113_ _output1114_)
      (if (file-exists? _input1113_)
          (if (gerbil/tools/gxtags#file-directory? _input1113_)
              (gerbil/tools/gxtags#tag-directory _input1113_ _output1114_)
              (gerbil/tools/gxtags#tag-source-file _input1113_ _output1114_))
          (error '"No such file or directory" _input1113_))))
  (define gerbil/tools/gxtags#tag-directory
    (lambda (_dirname1101_ _output1102_)
      (let ((_files1104_
             (std/sort#sort (directory-files _dirname1101_) string<?)))
        (for-each
         (lambda (_file1106_)
           (let ((_path1108_ (path-expand _file1106_ _dirname1101_)))
             (if (or (gerbil/tools/gxtags#file-directory? _path1108_)
                     (member (path-extension _path1108_) '(".ss" ".ssi")))
                 (gerbil/tools/gxtags#tag-input _path1108_ _output1102_)
                 '#!void)))
         _files1104_))))
  (define gerbil/tools/gxtags#tag-source-file
    (lambda (_filename1083_ _output1084_)
      (let ((_$e1086_ (gerbil/tools/gxtags#try-import-module _filename1083_)))
        (if _$e1086_
            ((lambda (_ctx1089_)
               (displayln '"TAG " _filename1083_)
               (let ((_xtab1091_ (make-table 'test: eq?)))
                 (for-each
                  (lambda (_xport1093_)
                    (let ((_bind1095_
                           (gx#core-resolve-module-export _xport1093_)))
                      (hash-update!
                       _xtab1091_
                       (##structure-ref _bind1095_ '1 gx#binding::t '#f)
                       (lambda (_g10961098_)
                         (cons (##direct-structure-ref
                                _xport1093_
                                '4
                                gx#module-export::t
                                '#f)
                               _g10961098_))
                       '())))
                  (##structure-ref _ctx1089_ '9 gx#module-context::t '#f))
                 (gerbil/tools/gxtags#write-tags
                  (gerbil/tools/gxtags#module-tags _ctx1089_ _xtab1091_)
                  _filename1083_
                  _output1084_)))
             _$e1086_)
            (displayln '"SKIP " _filename1083_)))))
  (define gerbil/tools/gxtags#module-tags
    (lambda (_ctx335_ _xtab336_)
      (letrec* ((_tags338_ '())
                (_loc339_ '#f)
                (_tag!484_
                 (lambda (_eid1080_ _name1081_)
                   (set! _tags338_
                         (cons (cons _eid1080_
                                     (cons _name1081_ (cons _loc339_ '())))
                               _tags338_))))
                (_tag-e485_
                 (lambda (_stx594_)
                   (let* ((_K1071_ (lambda ()
                                     (let* ((___stx72147215_ _stx594_)
                                            (_g603694_
                                             (lambda ()
                                               (gx#raise-syntax-error
                                                '#f
                                                '"Bad syntax"
                                                ___stx72147215_))))
                                       (let ((___kont72167217_
                                              (lambda (_L1048_)
                                                (for-each
                                                 _tag-e485_
                                                 (foldr1 (lambda (_g10601063_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _g10611065_)
                   (cons _g10601063_ _g10611065_))
                 '()
                 _L1048_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                             (___kont72207221_
                                              (lambda (_L990_)
                                                (call-with-parameters
                                                 (lambda ()
                                                   (for-each
                                                    _tag-e485_
                                                    (foldr1 (lambda (_g10031006_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             _g10041008_)
                      (cons _g10031006_ _g10041008_))
                    '()
                    _L990_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 gx#current-expander-phi
                                                 (fx+ (gx#current-expander-phi)
                                                      '1))))
                                             (___kont72247225_
                                              (lambda (_L929_)
                                                (for-each
                                                 _tag-def486_
                                                 (filter values
                                                         (foldr1 (lambda (_g945948_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                                  _g946950_)
                           (cons _g945948_ _g946950_))
                         '()
                         _L929_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                             (___kont72287229_
                                              (lambda (_L863_)
                                                (_tag-def486_ _L863_)))
                                             (___kont72307231_
                                              (lambda (_L814_)
                                                (for-each
                                                 _tag-decl487_
                                                 (foldr1 (lambda (_g826829_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          _g827831_)
                   (cons _g826829_ _g827831_))
                 '()
                 _L814_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                             (___kont72347235_
                                              (lambda (_L746_ _L747_)
                                                (let ((_eid766_
                                                       (##structure-ref
                                                        (gx#resolve-identifier__0
                                                         _L747_)
                                                        '1
                                                        gx#binding::t
                                                        '#f))
                                                      (_ctx767_
                                                       (gx#syntax-local-e__0
                                                        _L747_)))
                                                  (call-with-parameters
                                                   (lambda ()
                                                     (_tag-name!488_ _eid766_)
                                                     (for-each
                                                      _tag-e485_
                                                      (foldr1 (lambda (_g769772_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                               _g770774_)
                        (cons _g769772_ _g770774_))
                      '()
                      _L746_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   gx#current-expander-context
                                                   _ctx767_))))
                                             (___kont72387239_
                                              (lambda () '#!void)))
                                         (let* ((___match73657366_
                                                 (lambda (_e675706_
                                                          _hd676709_
                                                          _tl677711_
                                                          _e678714_
                                                          _hd679717_
                                                          _tl680719_
                                                          ___splice72367237_
                                                          _target681722_
                                                          _tl683724_)
                                                   (letrec ((_loop684727_
                                                             (lambda (_hd682730_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _expr688732_)
                       (if (gx#stx-pair? _hd682730_)
                           (let ((_e685735_ (gx#stx-e _hd682730_)))
                             (let ((_lp-tl687740_
                                    (let ()
                                      (declare (not safe))
                                      (##cdr _e685735_)))
                                   (_lp-hd686738_
                                    (let ()
                                      (declare (not safe))
                                      (##car _e685735_))))
                               (_loop684727_
                                _lp-tl687740_
                                (cons _lp-hd686738_ _expr688732_))))
                           (let ((_expr689743_ (reverse _expr688732_)))
                             (___kont72347235_ _expr689743_ _hd679717_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop684727_
                                                      _target681722_
                                                      '()))))
                                                (___match73417342_
                                                 (lambda (_e661782_
                                                          _hd662785_
                                                          _tl663787_
                                                          ___splice72327233_
                                                          _target664790_
                                                          _tl666792_)
                                                   (letrec ((_loop667795_
                                                             (lambda (_hd665798_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _decl671800_)
                       (if (gx#stx-pair? _hd665798_)
                           (let ((_e668803_ (gx#stx-e _hd665798_)))
                             (let ((_lp-tl670808_
                                    (let ()
                                      (declare (not safe))
                                      (##cdr _e668803_)))
                                   (_lp-hd669806_
                                    (let ()
                                      (declare (not safe))
                                      (##car _e668803_))))
                               (_loop667795_
                                _lp-tl670808_
                                (cons _lp-hd669806_ _decl671800_))))
                           (let ((_decl672811_ (reverse _decl671800_)))
                             (___kont72307231_ _decl672811_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop667795_
                                                      _target664790_
                                                      '()))))
                                                (___match72997300_
                                                 (lambda (_e632881_
                                                          _hd633884_
                                                          _tl634886_
                                                          _e635889_
                                                          _hd636892_
                                                          _tl637894_
                                                          ___splice72267227_
                                                          _target638897_
                                                          _tl640899_)
                                                   (letrec ((_loop641902_
                                                             (lambda (_hd639905_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _id645907_)
                       (if (gx#stx-pair? _hd639905_)
                           (let ((_e642910_ (gx#stx-e _hd639905_)))
                             (let ((_lp-tl644915_
                                    (let ()
                                      (declare (not safe))
                                      (##cdr _e642910_)))
                                   (_lp-hd643913_
                                    (let ()
                                      (declare (not safe))
                                      (##car _e642910_))))
                               (_loop641902_
                                _lp-tl644915_
                                (cons _lp-hd643913_ _id645907_))))
                           (let ((_id646918_ (reverse _id645907_)))
                             (if (gx#stx-pair? _tl637894_)
                                 (let ((_e647921_ (gx#stx-e _tl637894_)))
                                   (let ((_tl649926_
                                          (let ()
                                            (declare (not safe))
                                            (##cdr _e647921_)))
                                         (_hd648924_
                                          (let ()
                                            (declare (not safe))
                                            (##car _e647921_))))
                                     (if (gx#stx-null? _tl649926_)
                                         (___kont72247225_ _id646918_)
                                         (___kont72387239_))))
                                 (___kont72387239_)))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop641902_
                                                      _target638897_
                                                      '()))))
                                                (___match72757276_
                                                 (lambda (_e619958_
                                                          _hd620961_
                                                          _tl621963_
                                                          ___splice72227223_
                                                          _target622966_
                                                          _tl624968_)
                                                   (letrec ((_loop625971_
                                                             (lambda (_hd623974_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _expr629976_)
                       (if (gx#stx-pair? _hd623974_)
                           (let ((_e626979_ (gx#stx-e _hd623974_)))
                             (let ((_lp-tl628984_
                                    (let ()
                                      (declare (not safe))
                                      (##cdr _e626979_)))
                                   (_lp-hd627982_
                                    (let ()
                                      (declare (not safe))
                                      (##car _e626979_))))
                               (_loop625971_
                                _lp-tl628984_
                                (cons _lp-hd627982_ _expr629976_))))
                           (let ((_expr630987_ (reverse _expr629976_)))
                             (___kont72207221_ _expr630987_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop625971_
                                                      _target622966_
                                                      '()))))
                                                (___match72577258_
                                                 (lambda (_e6061016_
                                                          _hd6071019_
                                                          _tl6081021_
                                                          ___splice72187219_
                                                          _target6091024_
                                                          _tl6111026_)
                                                   (letrec ((_loop6121029_
                                                             (lambda (_hd6101032_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _expr6161034_)
                       (if (gx#stx-pair? _hd6101032_)
                           (let ((_e6131037_ (gx#stx-e _hd6101032_)))
                             (let ((_lp-tl6151042_
                                    (let ()
                                      (declare (not safe))
                                      (##cdr _e6131037_)))
                                   (_lp-hd6141040_
                                    (let ()
                                      (declare (not safe))
                                      (##car _e6131037_))))
                               (_loop6121029_
                                _lp-tl6151042_
                                (cons _lp-hd6141040_ _expr6161034_))))
                           (let ((_expr6171045_ (reverse _expr6161034_)))
                             (___kont72167217_ _expr6171045_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (_loop6121029_
                                                      _target6091024_
                                                      '())))))
                                           (if (gx#stx-pair? ___stx72147215_)
                                               (let ((_e6061016_
                                                      (gx#stx-e
                                                       ___stx72147215_)))
                                                 (let ((_tl6081021_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##cdr _e6061016_)))
                                                       (_hd6071019_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##car _e6061016_))))
                                                   (if (gx#identifier?
                                                        _hd6071019_)
                                                       (if (gx#stx-eq?
                                                            '%#begin
                                                            _hd6071019_)
                                                           (if (gx#stx-pair/null?
                                                                _tl6081021_)
                                                               (let ((___splice72187219_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              (gx#syntax-split-splice _tl6081021_ '0)))
                         (let ((_tl6111026_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref ___splice72187219_ '1)))
                               (_target6091024_
                                (let ()
                                  (declare (not safe))
                                  (##vector-ref ___splice72187219_ '0))))
                           (if (gx#stx-null? _tl6111026_)
                               (___match72577258_
                                _e6061016_
                                _hd6071019_
                                _tl6081021_
                                ___splice72187219_
                                _target6091024_
                                _tl6111026_)
                               (___kont72387239_))))
                       (___kont72387239_))
                   (if (gx#stx-eq? '%#begin-syntax _hd6071019_)
                       (if (gx#stx-pair/null? _tl6081021_)
                           (let ((___splice72227223_
                                  (gx#syntax-split-splice _tl6081021_ '0)))
                             (let ((_tl624968_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref ___splice72227223_ '1)))
                                   (_target622966_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref ___splice72227223_ '0))))
                               (if (gx#stx-null? _tl624968_)
                                   (___match72757276_
                                    _e6061016_
                                    _hd6071019_
                                    _tl6081021_
                                    ___splice72227223_
                                    _target622966_
                                    _tl624968_)
                                   (___kont72387239_))))
                           (___kont72387239_))
                       (if (gx#stx-eq? '%#define-values _hd6071019_)
                           (if (gx#stx-pair? _tl6081021_)
                               (let ((_e635889_ (gx#stx-e _tl6081021_)))
                                 (let ((_tl637894_
                                        (let ()
                                          (declare (not safe))
                                          (##cdr _e635889_)))
                                       (_hd636892_
                                        (let ()
                                          (declare (not safe))
                                          (##car _e635889_))))
                                   (if (gx#stx-pair/null? _hd636892_)
                                       (let ((___splice72267227_
                                              (gx#syntax-split-splice
                                               _hd636892_
                                               '0)))
                                         (let ((_tl640899_
                                                (let ()
                                                  (declare (not safe))
                                                  (##vector-ref
                                                   ___splice72267227_
                                                   '1)))
                                               (_target638897_
                                                (let ()
                                                  (declare (not safe))
                                                  (##vector-ref
                                                   ___splice72267227_
                                                   '0))))
                                           (if (gx#stx-null? _tl640899_)
                                               (___match72997300_
                                                _e6061016_
                                                _hd6071019_
                                                _tl6081021_
                                                _e635889_
                                                _hd636892_
                                                _tl637894_
                                                ___splice72267227_
                                                _target638897_
                                                _tl640899_)
                                               (___kont72387239_))))
                                       (___kont72387239_))))
                               (___kont72387239_))
                           (if (gx#stx-eq? '%#define-syntax _hd6071019_)
                               (if (gx#stx-pair? _tl6081021_)
                                   (let ((_e654847_ (gx#stx-e _tl6081021_)))
                                     (let ((_tl656852_
                                            (let ()
                                              (declare (not safe))
                                              (##cdr _e654847_)))
                                           (_hd655850_
                                            (let ()
                                              (declare (not safe))
                                              (##car _e654847_))))
                                       (if (gx#stx-pair? _tl656852_)
                                           (let ((_e657855_
                                                  (gx#stx-e _tl656852_)))
                                             (let ((_tl659860_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##cdr _e657855_)))
                                                   (_hd658858_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _e657855_))))
                                               (if (gx#stx-null? _tl659860_)
                                                   (___kont72287229_
                                                    _hd655850_)
                                                   (___kont72387239_))))
                                           (___kont72387239_))))
                                   (___kont72387239_))
                               (if (gx#stx-eq? '%#extern _hd6071019_)
                                   (if (gx#stx-pair/null? _tl6081021_)
                                       (let ((___splice72327233_
                                              (gx#syntax-split-splice
                                               _tl6081021_
                                               '0)))
                                         (let ((_tl666792_
                                                (let ()
                                                  (declare (not safe))
                                                  (##vector-ref
                                                   ___splice72327233_
                                                   '1)))
                                               (_target664790_
                                                (let ()
                                                  (declare (not safe))
                                                  (##vector-ref
                                                   ___splice72327233_
                                                   '0))))
                                           (if (gx#stx-null? _tl666792_)
                                               (___match73417342_
                                                _e6061016_
                                                _hd6071019_
                                                _tl6081021_
                                                ___splice72327233_
                                                _target664790_
                                                _tl666792_)
                                               (___kont72387239_))))
                                       (___kont72387239_))
                                   (if (gx#stx-eq? '%#module _hd6071019_)
                                       (if (gx#stx-pair? _tl6081021_)
                                           (let ((_e678714_
                                                  (gx#stx-e _tl6081021_)))
                                             (let ((_tl680719_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##cdr _e678714_)))
                                                   (_hd679717_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _e678714_))))
                                               (if (gx#stx-pair/null?
                                                    _tl680719_)
                                                   (let ((___splice72367237_
                                                          (gx#syntax-split-splice
                                                           _tl680719_
                                                           '0)))
                                                     (let ((_tl683724_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               ___splice72367237_
                                                               '1)))
                                                           (_target681722_
                                                            (let ()
                                                              (declare
                                                                (not safe))
                                                              (##vector-ref
                                                               ___splice72367237_
                                                               '0))))
                                                       (if (gx#stx-null?
                                                            _tl683724_)
                                                           (___match73657366_
                                                            _e6061016_
                                                            _hd6071019_
                                                            _tl6081021_
                                                            _e678714_
                                                            _hd679717_
                                                            _tl680719_
                                                            ___splice72367237_
                                                            _target681722_
                                                            _tl683724_)
                                                           (___kont72387239_))))
                                                   (___kont72387239_))))
                                           (___kont72387239_))
                                       (___kont72387239_)))))))
               (___kont72387239_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (___kont72387239_)))))))
                          (_new-loc1074_ (gx#stx-source _stx594_)))
                     (if _new-loc1074_
                         (let ((_save-loc1077_ _loc339_))
                           (set! _loc339_ _new-loc1074_)
                           (_K1071_)
                           (set! _loc339_ _save-loc1077_))
                         (_K1071_)))))
                (_tag-def486_
                 (lambda (_id582_)
                   (let* ((_K585_ (lambda ()
                                    (_tag-name!488_
                                     (##structure-ref
                                      (gx#resolve-identifier__0 _id582_)
                                      '1
                                      gx#binding::t
                                      '#f))))
                          (_new-loc588_ (gx#stx-source _id582_)))
                     (if _new-loc588_
                         (let ((_save-loc591_ _loc339_))
                           (set! _loc339_ _new-loc588_)
                           (_K585_)
                           (set! _loc339_ _save-loc591_))
                         (_K585_)))))
                (_tag-decl487_
                 (lambda (_decl518_)
                   (let* ((_g520534_
                           (lambda (_g521531_)
                             (gx#raise-syntax-error
                              '#f
                              '"Bad syntax"
                              _g521531_)))
                          (_g519579_
                           (lambda (_g521537_)
                             (if (gx#stx-pair? _g521537_)
                                 (let ((_e524539_ (gx#stx-e _g521537_)))
                                   (let ((_hd525542_
                                          (let ()
                                            (declare (not safe))
                                            (##car _e524539_)))
                                         (_tl526544_
                                          (let ()
                                            (declare (not safe))
                                            (##cdr _e524539_))))
                                     (if (gx#stx-pair? _tl526544_)
                                         (let ((_e527547_
                                                (gx#stx-e _tl526544_)))
                                           (let ((_hd528550_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##car _e527547_)))
                                                 (_tl529552_
                                                  (let ()
                                                    (declare (not safe))
                                                    (##cdr _e527547_))))
                                             (if (gx#stx-null? _tl529552_)
                                                 ((lambda (_L555_ _L556_)
                                                    (let* ((_K570_ (lambda ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (_tag-name!488_ (gx#stx-e _L555_))))
                   (_new-loc573_ (gx#stx-source _L556_)))
              (if _new-loc573_
                  (let ((_save-loc576_ _loc339_))
                    (set! _loc339_ _new-loc573_)
                    (_K570_)
                    (set! _loc339_ _save-loc576_))
                  (_K570_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                  _hd528550_
                                                  _hd525542_)
                                                 (_g520534_ _g521537_))))
                                         (_g520534_ _g521537_))))
                                 (_g520534_ _g521537_)))))
                     (_g519579_ _decl518_))))
                (_tag-name!488_
                 (lambda (_eid508_)
                   (let ((_names509511_ (table-ref _xtab336_ _eid508_ '#f)))
                     (if _names509511_
                         (let ((_names514_ _names509511_))
                           (for-each
                            (lambda (_name516_) (_tag!484_ _eid508_ _name516_))
                            (std/srfi/1#delete-duplicates _names514_ eq?)))
                         '#f)))))
        (let ((_stx490_
               (##structure-ref _ctx335_ '11 gx#module-context::t '#f)))
          (let* ((_id492_ (##structure-ref
                           _ctx335_
                           '1
                           gx#expander-context::t
                           '#f))
                 (_gid494_ (make-symbol '":" _id492_)))
            (let* ((_K498_ (lambda () (_tag!484_ 'module _gid494_)))
                   (_new-loc501_ (gx#stx-source _stx490_)))
              (if _new-loc501_
                  (let ((_save-loc504_ _loc339_))
                    (set! _loc339_ _new-loc501_)
                    (_K498_)
                    (set! _loc339_ _save-loc504_))
                  (_K498_))))
          (call-with-parameters
           (lambda () (_tag-e485_ _stx490_))
           gx#current-expander-context
           _ctx335_
           gx#current-expander-phi
           '0)
          (std/srfi/1#reverse! _tags338_)))))
  (define gerbil/tools/gxtags#write-tags
    (lambda (_tags250_ _filename251_ _output252_)
      (let* ((_lines254_
              (std/misc/ports#read-file-lines__%
               '#f
               absent-value
               _filename251_))
             (_lines256_
              (if (null? _lines254_) '#("") (list->vector _lines254_)))
             (_offsets258_
              (gerbil/tools/gxtags#file-line-offsets _filename251_))
             (_tmp260_ (open-output-string))
             (_filepath262_ (path-normalize _filename251_))
             (_rfilepath264_
              (path-normalize
               _filepath262_
               '#t
               (gerbil/tools/gxtags#current-tags-path)))
             (_out-of-file-tags266_ '()))
        (for-each
         (lambda (_tag269_)
           (let* ((_tag270281_ _tag269_)
                  (_E272285_
                   (lambda () (error '"No clause matching" _tag270281_)))
                  (_K273303_
                   (lambda (_loc288_ _name289_)
                     (let ((_path291_ (source-location-path _loc288_)))
                       (if (or (equal? _path291_ _filepath262_)
                               (not _path291_))
                           (let* ((_line296_
                                   (gerbil/tools/gxtags#source-location-line
                                    _loc288_))
                                  (_anchor298_
                                   (vector-ref _lines256_ (fx- _line296_ '1)))
                                  (_offset300_
                                   (vector-ref
                                    _offsets258_
                                    (fx- _line296_ '1))))
                             (gerbil/gambit/ports#write-string__%
                              _anchor298_
                              _tmp260_)
                             (write-char '#\delete _tmp260_)
                             (display _name289_ _tmp260_)
                             (write-char '#\x1 _tmp260_)
                             (display _line296_ _tmp260_)
                             (write-char '#\, _tmp260_)
                             (display _offset300_ _tmp260_)
                             (newline _tmp260_))
                           (set! _out-of-file-tags266_
                                 (cons _tag269_ _out-of-file-tags266_)))))))
             (if (let () (declare (not safe)) (##pair? _tag270281_))
                 (let ((_tl275306_
                        (let () (declare (not safe)) (##cdr _tag270281_))))
                   (if (let () (declare (not safe)) (##pair? _tl275306_))
                       (let ((_hd276309_
                              (let () (declare (not safe)) (##car _tl275306_)))
                             (_tl277311_
                              (let ()
                                (declare (not safe))
                                (##cdr _tl275306_))))
                         (let ((_name314_ _hd276309_))
                           (if (let ()
                                 (declare (not safe))
                                 (##pair? _tl277311_))
                               (let ((_hd278316_
                                      (let ()
                                        (declare (not safe))
                                        (##car _tl277311_)))
                                     (_tl279318_
                                      (let ()
                                        (declare (not safe))
                                        (##cdr _tl277311_))))
                                 (let ((_loc321_ _hd278316_))
                                   (if (let ()
                                         (declare (not safe))
                                         (##null? _tl279318_))
                                       (_K273303_ _loc321_ _name314_)
                                       (_E272285_))))
                               (_E272285_))))
                       (_E272285_)))
                 (_E272285_))))
         _tags250_)
        (let* ((_str323_ (get-output-string _tmp260_))
               (_len325_ (std/text/utf8#string-utf8-length__0 _str323_)))
          (write-char '#\page _output252_)
          (newline _output252_)
          (gerbil/gambit/ports#write-string__% _rfilepath264_ _output252_)
          (write-char '#\, _output252_)
          (display _len325_ _output252_)
          (newline _output252_)
          (gerbil/gambit/ports#write-string__% _str323_ _output252_)
          (if (null? _out-of-file-tags266_)
              '#!void
              (let* ((_tags328_ (std/srfi/1#reverse! _out-of-file-tags266_))
                     (_path330_ (source-location-path (caddar _tags328_)))
                     (_filename332_ (path-normalize _path330_ '#t)))
                (gerbil/tools/gxtags#write-tags
                 _tags328_
                 _filename332_
                 _output252_)))))))
  (define gerbil/tools/gxtags#+nl+ (char->integer '#\newline))
  (define gerbil/tools/gxtags#file-line-offsets
    (lambda (_filename237_)
      (call-with-input-file
       _filename237_
       (lambda (_inp239_)
         (let _lp241_ ((_i243_ '0) (_offs244_ (cons '0 '())))
           (let ((_next246_ (read-u8 _inp239_)))
             (if (eof-object? _next246_)
                 (list->vector (std/srfi/1#reverse! _offs244_))
                 (if (eq? _next246_ gerbil/tools/gxtags#+nl+)
                     (let ((_i+1248_ (fx+ _i243_ '1)))
                       (_lp241_ _i+1248_ (cons _i+1248_ _offs244_)))
                     (_lp241_ (fx+ _i243_ '1) _offs244_)))))))))
  (define gerbil/tools/gxtags#source-location-line
    (lambda (_locat233_)
      (if (let () (declare (not safe)) (##locat? _locat233_))
          (let ((_filepos235_
                 (let ((__tmp7369
                        (let ()
                          (declare (not safe))
                          (##locat-position _locat233_))))
                   (declare (not safe))
                   (##position->filepos __tmp7369))))
            (fx+ (let () (declare (not safe)) (##filepos-line _filepos235_))
                 '1))
          '1)))
  (define gerbil/tools/gxtags#try-import-module
    (lambda (_filename224_)
      (with-exception-catcher
       (lambda (_g225227_)
         (if '#t (let ((_e230_ _g225227_)) '#f) (raise _g225227_)))
       (lambda () (gx#import-module__0 _filename224_))))))
