(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define scheme/base-ports#input-port-open?
    (lambda (_port1287_)
      (if (not (input-port? _port1287_))
          (error '"Bad argument; expected input port" _port1287_)
          (if (macro-closed? (macro-port-roptions _port1287_))
              '#f
              (if (macro-device-port? _port1287_)
                  (scheme/base-ports#rdevice-open?
                   (macro-condvar-name
                    (macro-device-port-rdevice-condvar _port1287_)))
                  (if (macro-raw-device-port? _port1287_)
                      (scheme/base-ports#rdevice-open?
                       (macro-condvar-name
                        (macro-raw-device-port-rdevice-condvar _port1287_)))
                      '#t))))))
  (define scheme/base-ports#output-port-open?
    (lambda (_port1285_)
      (if (not (output-port? _port1285_))
          (error '"Bad argument; expected input port" _port1285_)
          (if (macro-closed? (macro-port-woptions _port1285_))
              '#f
              (if (macro-device-port? _port1285_)
                  (scheme/base-ports#wdevice-open?
                   (macro-condvar-name
                    (macro-device-port-wdevice-condvar _port1285_)))
                  (if (macro-raw-device-port? _port1285_)
                      (scheme/base-ports#wdevice-open?
                       (macro-condvar-name
                        (macro-raw-device-port-wdevice-condvar _port1285_)))
                      '#t))))))
  (namespace ("scheme/base-ports#" rdevice-open? wdevice-open?))
  (c-declare
   "#ifndef ___STAGE_OPEN\n#define ___STAGE_OPEN 0\n#endif\n#ifndef ___FFI_HAVE_DEVICE\n#define ___FFI_HAVE_DEVICE\ntypedef struct ___device_struct\n  {\n    void *vtbl;\n    int refcount;                  /* device structure is released when zero */\n    void *group;                   /* device group this device belongs to */\n    struct ___device_struct *prev; /* bidirectional list pointer to previous */\n    struct ___device_struct *next; /* bidirectional list pointer to next */\n    int direction;                 /* ___DIRECTION_RD and/or ___DIRECTION_WR */\n    int close_direction;           /* ___DIRECTION_RD and/or ___DIRECTION_WR */\n    int read_stage;                /* ___STAGE_OPEN ... ___STAGE_CLOSED */\n    int write_stage;               /* ___STAGE_OPEN ... ___STAGE_CLOSED */\n  } ___device;\n#endif\n\nstatic ___SCMOBJ ___rdevice_openp(___SCMOBJ dev)\n{\n ___device *d = ___CAST(___device*,___FIELD(dev,___FOREIGN_PTR));\n if (d->read_stage != ___STAGE_OPEN)\n {\n  return ___FAL;\n }\n else\n {\n  return ___TRU;\n }\n}\n\nstatic ___SCMOBJ ___wdevice_openp(___SCMOBJ dev)\n{\n ___device *d = ___CAST(___device*,___FIELD(dev,___FOREIGN_PTR));\n if (d->write_stage != ___STAGE_OPEN)\n {\n  return ___FAL;\n }\n else\n {\n  return ___TRU;\n }\n}")
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (##symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-c-lambda
   rdevice-open?
   (scheme-object)
   scheme-object
   "___rdevice_openp")
  (define-c-lambda
   wdevice-open?
   (scheme-object)
   scheme-object
   "___wdevice_openp")
  (define scheme/base-ports#port-buffered-chars?
    (lambda (_port1280_)
      (let ((_$e1282_
             (let ((__tmp9693 (macro-character-port-rlo _port1280_))
                   (__tmp9692 (macro-character-port-rhi _port1280_)))
               (declare (not safe))
               (##fx< __tmp9693 __tmp9692))))
        (if _$e1282_ _$e1282_ (macro-character-port-peek-eof? _port1280_)))))
  (define scheme/base-ports#check-byte-port/lock!
    (lambda (_port1277_ _proc1278_)
      (if (macro-byte-port? _port1277_)
          '#!void
          (error '"Illegal argument; expected byte-port" _port1277_))
      (macro-port-mutex-lock! _port1277_)
      (if (scheme/base-ports#port-buffered-chars? _port1277_)
          (begin
            (macro-port-mutex-unlock! _port1277_)
            (let ()
              (declare (not safe))
              (##raise-nonempty-input-port-character-buffer-exception
               _port1277_
               _proc1278_
               _port1277_)))
          '#!void)))
  (define scheme/base-ports#peek-u8
    (lambda (_port1265_)
      (scheme/base-ports#check-byte-port/lock!
       _port1265_
       scheme/base-ports#peek-u8)
      (let _lp1267_ ()
        (let ((_byte-rlo1270_ (macro-byte-port-rlo _port1265_))
              (_byte-rhi1271_ (macro-byte-port-rhi _port1265_)))
          (if (let ()
                (declare (not safe))
                (##fx< _byte-rlo1270_ _byte-rhi1271_))
              (let ((_byte1273_
                     (u8vector-ref
                      (macro-byte-port-rbuf _port1265_)
                      _byte-rlo1270_)))
                (macro-port-mutex-unlock! _port1265_)
                _byte1273_)
              (let ((_res1275_
                     ((macro-byte-port-rbuf-fill _port1265_)
                      _port1265_
                      '1
                      '#t)))
                (if (eq? _res1275_ ##err-code-EAGAIN)
                    (begin (macro-port-mutex-unlock! _port1265_) (eof-object))
                    (if (fixnum? _res1275_)
                        (begin
                          (macro-port-mutex-unlock! _port1265_)
                          (let ()
                            (declare (not safe))
                            (##raise-os-io-exception
                             _port1265_
                             '#f
                             _res1275_
                             scheme/base-ports#peek-u8
                             _port1265_)))
                        (if _res1275_
                            (_lp1267_)
                            (begin
                              (macro-port-mutex-unlock! _port1265_)
                              (eof-object))))))))))))
