(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/connection#errorf
    (lambda (_fmt256350_ . _args256351_)
      (std/logger#log-message 'rpc '0 _fmt256350_ _args256351_)))
  (define std/actor/rpc/connection#warnf
    (lambda (_fmt256347_ . _args256348_)
      (std/logger#log-message 'rpc '1 _fmt256347_ _args256348_)))
  (define std/actor/rpc/connection#infof
    (lambda (_fmt256344_ . _args256345_)
      (std/logger#log-message 'rpc '2 _fmt256344_ _args256345_)))
  (define std/actor/rpc/connection#debugf
    (lambda (_fmt256341_ . _args256342_)
      (std/logger#log-message 'rpc '3 _fmt256341_ _args256342_)))
  (define std/actor/rpc/connection#verbosef
    (lambda (_fmt256336_ . _args256338_)
      (std/logger#log-message 'rpc '4 _fmt256336_ _args256338_)))
  (define std/actor/rpc/connection#rpc-server-connection
    (lambda (_rpc-server256322_
             _actors256323_
             _sock256324_
             _sa256325_
             _cliaddr256326_
             _proto-e256327_)
      (with-exception-catcher
       (lambda (_g256328256330_)
         (if '#t
             (let ((_e256333_ _g256328256330_))
               (std/actor/rpc/connection#rpc-connection-cleanup
                _rpc-server256322_
                _e256333_
                _sock256324_))
             (raise _g256328256330_)))
       (lambda ()
         (std/actor/rpc/connection#rpc-set-nodelay!
          _sock256324_
          (std/os/_socket#sockaddr_family _sa256325_))
         (std/actor/rpc/connection#rpc-connection-loop
          _rpc-server256322_
          _actors256323_
          _sock256324_
          _cliaddr256326_
          _proto-e256327_)))))
  (define std/actor/rpc/connection#rpc-client-connection
    (lambda (_rpc-server256305_ _actors256306_ _address256307_ _proto-e256308_)
      (with-exception-catcher
       (lambda (_g256309256311_)
         (if '#t
             (let ((_e256314_ _g256309256311_))
               (std/actor/rpc/connection#rpc-connection-cleanup
                _rpc-server256305_
                _e256314_
                '#f))
             (raise _g256309256311_)))
       (lambda ()
         (let* ((_sa256317_ (std/os/socket#socket-address _address256307_))
                (_cli256319_
                 (std/net/socket/api#ssocket-connect__0 _sa256317_)))
           (std/actor/rpc/connection#rpc-set-nodelay!
            _cli256319_
            (std/os/_socket#sockaddr_family _sa256317_))
           (std/actor/rpc/connection#rpc-connection-loop
            _rpc-server256305_
            _actors256306_
            _cli256319_
            _address256307_
            _proto-e256308_))))))
  (define std/actor/rpc/connection#rpc-set-nodelay!
    (lambda (_sock256299_ _safamily256300_)
      (if (or (eq? _safamily256300_ std/os/_socket#AF_INET)
              (eq? _safamily256300_ std/os/_socket#AF_INET6))
          (std/os/socket#socket-setsockopt
           (##direct-structure-ref
            _sock256299_
            '1
            std/net/socket/base#!socket::t
            '#f)
           std/os/_socket#IPPROTO_TCP
           std/os/_socket#TCP_NODELAY
           '1)
          '#!void)))
  (define std/actor/rpc/connection#rpc-keep-alive '60)
  (define std/actor/rpc/connection#set-rpc-keep-alive-interval!
    (lambda (_dt256294_)
      (if (or (not _dt256294_) (and (real? _dt256294_) (positive? _dt256294_)))
          (set! std/actor/rpc/connection#rpc-keep-alive _dt256294_)
          (error '"bad keep-alive; expected positive real or #f" _dt256294_))))
  (define std/actor/rpc/connection#rpc-idle-timeout '#f)
  (define std/actor/rpc/connection#set-rpc-idle-timeout!
    (lambda (_dt256289_)
      (if (or (not _dt256289_) (and (real? _dt256289_) (positive? _dt256289_)))
          (set! std/actor/rpc/connection#rpc-idle-timeout _dt256289_)
          (error '"bad idle interval; expected positive real or #f"
                 _dt256289_))))
  (define std/actor/rpc/connection#rpc-call-timeout '60)
  (define std/actor/rpc/connection#set-rpc-call-timeout!
    (lambda (_dt256287_)
      (if (and (real? _dt256287_) (positive? _dt256287_) (finite? _dt256287_))
          (set! std/actor/rpc/connection#rpc-call-timeout _dt256287_)
          (if (not _dt256287_)
              (set! std/actor/rpc/connection#rpc-call-timeout '#f)
              (error '"bad timeout; expected finite positive real or #f"
                     _dt256287_)))))
  (define std/actor/rpc/connection#continuation-table::t
    (make-struct-type
     'std/actor/rpc/connection#continuation-table::t
     '#f
     '6
     'continuation-table
     '((final: . #t))
     ':init!
     '(mx continuations
          stream-continuations
          stream-actors
          timeouts
          continuation-timeouts)))
  (define std/actor/rpc/connection#continuation-table?
    (make-struct-predicate std/actor/rpc/connection#continuation-table::t))
  (define std/actor/rpc/connection#make-continuation-table
    (lambda _$args256284_
      (apply make-struct-instance
             std/actor/rpc/connection#continuation-table::t
             _$args256284_)))
  (define std/actor/rpc/connection#continuation-table-mx
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#continuation-table-continuations
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#continuation-table-stream-continuations
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#continuation-table-stream-actors
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#continuation-table-timeouts
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#continuation-table-continuation-timeouts
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#continuation-table-mx-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#continuation-table-continuations-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#continuation-table-stream-continuations-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#continuation-table-stream-actors-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#continuation-table-timeouts-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#continuation-table-continuation-timeouts-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#&continuation-table-mx
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#&continuation-table-continuations
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#&continuation-table-stream-continuations
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#&continuation-table-stream-actors
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#&continuation-table-timeouts
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#&continuation-table-continuation-timeouts
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#&continuation-table-mx-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#&continuation-table-continuations-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#&continuation-table-stream-continuations-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#&continuation-table-stream-actors-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#&continuation-table-timeouts-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#&continuation-table-continuation-timeouts-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#continuation-table:::init!
    (lambda (_self256282_)
      (if (##fx< '6 (##vector-length _self256282_))
          (begin
            (##vector-set! _self256282_ '1 (make-mutex 'continuation-table))
            (##vector-set! _self256282_ '2 (make-table 'test: eqv?))
            (##vector-set! _self256282_ '3 (make-table 'test: eq?))
            (##vector-set! _self256282_ '4 (make-table 'test: eqv?))
            (##vector-set! _self256282_ '5 (make-table 'test: eq?))
            (##vector-set! _self256282_ '6 (make-table 'test: eqv?)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self256282_))))
  (bind-method!
   std/actor/rpc/connection#continuation-table::t
   ':init!
   std/actor/rpc/connection#continuation-table:::init!
   '#f)
  (define std/actor/rpc/connection#continuation-table-get
    (lambda (_cont-table256149_ _cont256150_)
      (let ((_mx256152_
             (##unchecked-structure-ref
              _cont-table256149_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256152_)
        (let ((_res256157_
               (let ((_ct256155_
                      (##unchecked-structure-ref
                       _cont-table256149_
                       '2
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _ct256155_ _cont256150_ '#f))))
          (mutex-unlock! _mx256152_)
          _res256157_))))
  (define std/actor/rpc/connection#continuation-table-remove!
    (lambda (_cont-table256087_ _cont256088_)
      (let ((_mx256090_
             (##unchecked-structure-ref
              _cont-table256087_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256090_)
        (let ((_res256146_
               (let* ((_ct256093_
                       (##unchecked-structure-ref
                        _cont-table256087_
                        '2
                        std/actor/rpc/connection#continuation-table::t
                        '#f))
                      (_continuation256094256096_
                       (table-ref _ct256093_ _cont256088_ '#f)))
                 (if _continuation256094256096_
                     (let ((_continuation256099_ _continuation256094256096_))
                       (table-set! _ct256093_ _cont256088_)
                       (let* ((_continuation256100256109_ _continuation256099_)
                              (_E256102256113_
                               (lambda ()
                                 (error '"No clause matching"
                                        _continuation256100256109_)))
                              (_K256103256119_
                               (lambda (_stream?256116_ _k256117_)
                                 (if _stream?256116_
                                     (table-set!
                                      (##unchecked-structure-ref
                                       _cont-table256087_
                                       '3
                                       std/actor/rpc/connection#continuation-table::t
                                       '#f)
                                      _k256117_)
                                     '#!void))))
                         (if (##fx= (if (##values? _continuation256100256109_)
                                        (##vector-length
                                         _continuation256100256109_)
                                        '1)
                                    '4)
                             (let* ((_e256104256122_
                                     (##vector-ref
                                      _continuation256100256109_
                                      '0))
                                    (_e256105256125_
                                     (##vector-ref
                                      _continuation256100256109_
                                      '1))
                                    (_e256106256128_
                                     (##vector-ref
                                      _continuation256100256109_
                                      '2))
                                    (_k256131_ _e256106256128_)
                                    (_e256107256133_
                                     (##vector-ref
                                      _continuation256100256109_
                                      '3))
                                    (_stream?256136_ _e256107256133_))
                               (_K256103256119_ _stream?256136_ _k256131_))
                             (_E256102256113_)))
                       (let* ((_tt256138_
                               (##unchecked-structure-ref
                                _cont-table256087_
                                '6
                                std/actor/rpc/connection#continuation-table::t
                                '#f))
                              (_timeo256139256141_
                               (table-ref _tt256138_ _cont256088_ '#f)))
                         (if _timeo256139256141_
                             (let ((_timeo256144_ _timeo256139256141_))
                               (table-set! _tt256138_ _cont256088_)
                               (table-set!
                                (##unchecked-structure-ref
                                 _cont-table256087_
                                 '5
                                 std/actor/rpc/connection#continuation-table::t
                                 '#f)
                                _timeo256144_))
                             '#f))
                       _continuation256099_)
                     '#f))))
          (mutex-unlock! _mx256090_)
          _res256146_))))
  (define std/actor/rpc/connection#continuation-table-get-stream-actor
    (lambda (_cont-table256076_ _cont256077_)
      (let ((_mx256079_
             (##unchecked-structure-ref
              _cont-table256076_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256079_)
        (let ((_res256084_
               (let ((_st256082_
                      (##unchecked-structure-ref
                       _cont-table256076_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _st256082_ _cont256077_ '#f))))
          (mutex-unlock! _mx256079_)
          _res256084_))))
  (define std/actor/rpc/connection#continuation-table-put-stream-actor!
    (lambda (_cont-table256064_ _cont256065_ _val256066_)
      (let ((_mx256068_
             (##unchecked-structure-ref
              _cont-table256064_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256068_)
        (let ((_res256073_
               (let ((_st256071_
                      (##unchecked-structure-ref
                       _cont-table256064_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-set! _st256071_ _cont256065_ _val256066_))))
          (mutex-unlock! _mx256068_)
          _res256073_))))
  (define std/actor/rpc/connection#continuation-table-remove-stream-actor!
    (lambda (_cont-table256053_ _cont256054_)
      (let ((_mx256056_
             (##unchecked-structure-ref
              _cont-table256053_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256056_)
        (let ((_res256061_
               (let ((_st256059_
                      (##unchecked-structure-ref
                       _cont-table256053_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-set! _st256059_ _cont256054_))))
          (mutex-unlock! _mx256056_)
          _res256061_))))
  (define std/actor/rpc/connection#continuation-table-get-stream-cont
    (lambda (_cont-table256042_ _k256043_)
      (let ((_mx256045_
             (##unchecked-structure-ref
              _cont-table256042_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256045_)
        (let ((_res256050_
               (let ((_sct256048_
                      (##unchecked-structure-ref
                       _cont-table256042_
                       '3
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _sct256048_ _k256043_ '#f))))
          (mutex-unlock! _mx256045_)
          _res256050_))))
  (define std/actor/rpc/connection#continuation-table-get-timeout
    (lambda (_cont-table256031_ _timeo256032_)
      (let ((_mx256034_
             (##unchecked-structure-ref
              _cont-table256031_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256034_)
        (let ((_res256039_
               (let ((_tt256037_
                      (##unchecked-structure-ref
                       _cont-table256031_
                       '5
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _tt256037_ _timeo256032_ '#f))))
          (mutex-unlock! _mx256034_)
          _res256039_))))
  (define std/actor/rpc/connection#continuation-table-dump!__%
    (lambda (_cont-table255905_ _port255906_)
      (call-with-parameters
       (lambda ()
         (let ((_mx255909_
                (##unchecked-structure-ref
                 _cont-table255905_
                 '1
                 std/actor/rpc/connection#continuation-table::t
                 '#f)))
           (mutex-lock! _mx255909_)
           (let* ((_cont-table255911255922_ _cont-table255905_)
                  (_E255913255926_
                   (lambda ()
                     (error '"No clause matching" _cont-table255911255922_)))
                  (_K255914255990_
                   (lambda (_ctmos255929_
                            _tmos255930_
                            _sactors255931_
                            _sconts255932_
                            _conts255933_)
                     (displayln
                      '"continuations: "
                      (table-length _conts255933_))
                     (table-for-each
                      (lambda (_wire-id255935_ _continuation255936_)
                        (let* ((_continuation255937255946_
                                _continuation255936_)
                               (_E255939255950_
                                (lambda ()
                                  (error '"No clause matching"
                                         _continuation255937255946_)))
                               (_K255940255958_
                                (lambda (_stream?255953_
                                         _k255954_
                                         _proto255955_
                                         _actor255956_)
                                  (displayln
                                   _wire-id255935_
                                   '" -> "
                                   (cons _actor255956_
                                         (cons _proto255955_
                                               (cons _k255954_
                                                     (cons _stream?255953_
                                                           '()))))))))
                          (if (##fx= (if (##values? _continuation255937255946_)
                                         (##vector-length
                                          _continuation255937255946_)
                                         '1)
                                     '4)
                              (let* ((_e255941255961_
                                      (##vector-ref
                                       _continuation255937255946_
                                       '0))
                                     (_actor255964_ _e255941255961_)
                                     (_e255942255966_
                                      (##vector-ref
                                       _continuation255937255946_
                                       '1))
                                     (_proto255969_ _e255942255966_)
                                     (_e255943255971_
                                      (##vector-ref
                                       _continuation255937255946_
                                       '2))
                                     (_k255974_ _e255943255971_)
                                     (_e255944255976_
                                      (##vector-ref
                                       _continuation255937255946_
                                       '3))
                                     (_stream?255979_ _e255944255976_))
                                (_K255940255958_
                                 _stream?255979_
                                 _k255974_
                                 _proto255969_
                                 _actor255964_))
                              (_E255939255950_))))
                      _conts255933_)
                     (displayln
                      '"stream-continuations: "
                      (table-length _sconts255932_))
                     (table-for-each
                      (lambda (_k255981_ _wire-id255982_)
                        (displayln _k255981_ '" -> " _wire-id255982_))
                      _sconts255932_)
                     (displayln
                      '"stream-actors: "
                      (table-length _sactors255931_))
                     (table-for-each
                      (lambda (_wire-id255984_ _sactor255985_)
                        (displayln _wire-id255984_ '" -> " _sactor255985_))
                      _sactors255931_)
                     (displayln '"timeouts: " (table-length _tmos255930_))
                     (table-for-each
                      (lambda (_tmo255987_ _wire-id255988_)
                        (displayln
                         (time->seconds _tmo255987_)
                         '" -> "
                         _wire-id255988_))
                      _tmos255930_))))
             (if (##structure-direct-instance-of?
                  _cont-table255911255922_
                  'std/actor/rpc/connection#continuation-table::t)
                 (let* ((_e255915255993_
                         (##vector-ref _cont-table255911255922_ '1))
                        (_e255916255996_
                         (##vector-ref _cont-table255911255922_ '2))
                        (_conts255999_ _e255916255996_)
                        (_e255917256001_
                         (##vector-ref _cont-table255911255922_ '3))
                        (_sconts256004_ _e255917256001_)
                        (_e255918256006_
                         (##vector-ref _cont-table255911255922_ '4))
                        (_sactors256009_ _e255918256006_)
                        (_e255919256011_
                         (##vector-ref _cont-table255911255922_ '5))
                        (_tmos256014_ _e255919256011_)
                        (_e255920256016_
                         (##vector-ref _cont-table255911255922_ '6))
                        (_ctmos256019_ _e255920256016_))
                   (_K255914255990_
                    _ctmos256019_
                    _tmos256014_
                    _sactors256009_
                    _sconts256004_
                    _conts255999_))
                 (_E255913255926_)))
           (mutex-unlock! _mx255909_)))
       current-output-port
       _port255906_)))
  (define std/actor/rpc/connection#continuation-table-dump!__0
    (lambda (_cont-table256024_)
      (let ((_port256026_ (current-error-port)))
        (std/actor/rpc/connection#continuation-table-dump!__%
         _cont-table256024_
         _port256026_))))
  (define std/actor/rpc/connection#continuation-table-dump!
    (lambda _g306781_
      (let ((_g306780_ (##length _g306781_)))
        (cond ((##fx= _g306780_ 1)
               (apply std/actor/rpc/connection#continuation-table-dump!__0
                      _g306781_))
              ((##fx= _g306780_ 2)
               (apply std/actor/rpc/connection#continuation-table-dump!__%
                      _g306781_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/connection#continuation-table-dump!
                _g306781_))))))
  (define std/actor/rpc/connection#rpc-connection-loop
    (lambda (_rpc-server254855_
             _actors254856_
             _sock254857_
             _peer-address254858_
             _proto-e254859_)
      (letrec* ((_input-buffer254861_
                 (std/net/socket/buffer#open-ssocket-input-buffer__0
                  _sock254857_))
                (_output-buffer254862_
                 (std/net/socket/buffer#open-ssocket-output-buffer__0
                  _sock254857_))
                (_g306782_
                 (let ((_g306783_
                        (_proto-e254859_
                         _input-buffer254861_
                         _output-buffer254862_)))
                   (let ((_g306784_
                          (if (##values? _g306783_)
                              (##vector-length _g306783_)
                              1)))
                     (if (not (##fx= _g306784_ 2))
                         (error "Context expects 2 values" _g306784_)))
                   _g306783_))
                (_read-e254863_ (##vector-ref _g306782_ 0))
                (_write-e254864_ (##vector-ref _g306782_ 1))
                (_cont-table254865_
                 (let ((__obj306777
                        (make-object
                         std/actor/rpc/connection#continuation-table::t
                         '6)))
                   (std/actor/rpc/connection#continuation-table:::init!
                    __obj306777)
                   __obj306777))
                (_next-timeout254866_ '#f)
                (_next-continuation-id254867_ '0)
                (_next-heartbeat254868_
                 (seconds->time (+ (##current-time-point) '60)))
                (_writer254869_
                 (gerbil/gambit/threads#spawn/name
                  'rpc-connection-writer
                  std/actor/rpc/connection#rpc-connection-writer
                  _output-buffer254862_
                  _write-e254864_))
                (_reader254870_
                 (gerbil/gambit/threads#spawn/name
                  'rpc-connection-reader
                  std/actor/rpc/connection#rpc-connection-reader
                  (current-thread)
                  _peer-address254858_
                  _input-buffer254861_
                  _actors254856_
                  _cont-table254865_
                  _writer254869_
                  _read-e254863_))
                (_close-connection254871_
                 (lambda ()
                   (std/net/socket/api#ssocket-close _sock254857_)
                   (thread-send _writer254869_ 'exit)
                   (let ((_mx255822_
                          (##unchecked-structure-ref
                           _cont-table254865_
                           '1
                           std/actor/rpc/connection#continuation-table::t
                           '#f)))
                     (mutex-lock! _mx255822_)
                     (table-for-each
                      (lambda (_wire-id255825_ _cont255826_)
                        (let* ((_cont255827255836_ _cont255826_)
                               (_E255829255840_
                                (lambda ()
                                  (error '"No clause matching"
                                         _cont255827255836_)))
                               (_K255830255848_
                                (lambda (_stream?255843_
                                         _k255844_
                                         _proto255845_
                                         _actor255846_)
                                  (std/actor/message#send-message__%
                                   _actor255846_
                                   (##structure
                                    std/actor/proto#!error::t
                                    (make-struct-instance
                                     std/actor/proto#rpc-error::t
                                     'rpc
                                     '"connection error")
                                    _k255844_)
                                   '#f
                                   '#f))))
                          (if (##fx= (if (##values? _cont255827255836_)
                                         (##vector-length _cont255827255836_)
                                         '1)
                                     '4)
                              (let* ((_e255831255851_
                                      (##vector-ref _cont255827255836_ '0))
                                     (_actor255854_ _e255831255851_)
                                     (_e255832255856_
                                      (##vector-ref _cont255827255836_ '1))
                                     (_proto255859_ _e255832255856_)
                                     (_e255833255861_
                                      (##vector-ref _cont255827255836_ '2))
                                     (_k255864_ _e255833255861_)
                                     (_e255834255866_
                                      (##vector-ref _cont255827255836_ '3))
                                     (_stream?255869_ _e255834255866_))
                                (_K255830255848_
                                 _stream?255869_
                                 _k255864_
                                 _proto255859_
                                 _actor255854_))
                              (_E255829255840_))))
                      (##unchecked-structure-ref
                       _cont-table254865_
                       '2
                       std/actor/rpc/connection#continuation-table::t
                       '#f))
                     (table-for-each
                      (lambda (_wire-id255871_ _stream255872_)
                        (let* ((_stream255873255880_ _stream255872_)
                               (_E255875255884_
                                (lambda ()
                                  (error '"No clause matching"
                                         _stream255873255880_)))
                               (_K255876255892_
                                (lambda (_dest255887_ _actor255888_)
                                  (let ((_abort255890_
                                         (##structure
                                          std/actor/message#message::t
                                          (##structure
                                           std/actor/proto#!abort::t
                                           _wire-id255871_)
                                          _dest255887_
                                          _actor255888_
                                          '#f)))
                                    (std/actor/message#send__0
                                     _actor255888_
                                     _abort255890_)))))
                          (if (##pair? _stream255873255880_)
                              (let ((_hd255877255895_
                                     (##car _stream255873255880_))
                                    (_tl255878255897_
                                     (##cdr _stream255873255880_)))
                                (let* ((_actor255900_ _hd255877255895_)
                                       (_dest255902_ _tl255878255897_))
                                  (_K255876255892_
                                   _dest255902_
                                   _actor255900_)))
                              (_E255875255884_))))
                      (##unchecked-structure-ref
                       _cont-table254865_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f))
                     (mutex-unlock! _mx255822_))
                   (std/actor/rpc/connection#rpc-connection-shutdown
                    _rpc-server254855_)
                   (raise 'shutdown)))
                (_write-message254872_
                 (lambda (_msg255569_)
                   (let* ((_msg255570255579_ _msg255569_)
                          (_E255572255583_
                           (lambda ()
                             (error '"No clause matching" _msg255570255579_)))
                          (_K255573255798_
                           (lambda (_opts255586_
                                    _dest255587_
                                    _src255588_
                                    _content255589_)
                             (if (##structure-direct-instance-of?
                                  _dest255587_
                                  'std/actor/proto#remote::t)
                                 (let* ((_dest255590255599_ _dest255587_)
                                        (_E255592255603_
                                         (lambda ()
                                           (error '"No clause matching"
                                                  _dest255590255599_)))
                                        (_K255593255777_
                                         (lambda (_proto255606_
                                                  _address255607_
                                                  _uuid255608_)
                                           (##direct-structure-set!
                                            _msg255569_
                                            _uuid255608_
                                            '3
                                            std/actor/message#message::t
                                            '#f)
                                           (let* ((_content255609255635_
                                                   _content255589_)
                                                  (_else255617255643_
                                                   (lambda ()
                                                     (_marshal-and-write254874_
                                                      _msg255569_
                                                      _proto255606_
                                                      '#t))))
                                             (let ((_K255631255766_
                                                    (lambda (_k255753_)
                                                      (let ((_wire-id255755_
                                                             (_next-continuation-id!254873_)))
                                                        (let ((_mx255757_
                                                               (##unchecked-structure-ref
                                                                _cont-table254865_
                                                                '1
                                                                std/actor/rpc/connection#continuation-table::t
                                                                '#f)))
                                                          (mutex-lock!
                                                           _mx255757_)
                                                          (table-set!
                                                           (##unchecked-structure-ref
                                                            _cont-table254865_
                                                            '2
                                                            std/actor/rpc/connection#continuation-table::t
                                                            '#f)
                                                           _wire-id255755_
                                                           (values _src255588_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _proto255606_
                           _k255753_
                           '#f))
                  (let ((_timeo255759255761_
                         (std/actor/rpc/connection#rpc-options-timeout
                          _opts255586_
                          std/actor/rpc/connection#rpc-call-timeout)))
                    (if _timeo255759255761_
                        (let ((_timeo255764_ _timeo255759255761_))
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table254865_
                            '5
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _timeo255764_
                           _wire-id255755_)
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table254865_
                            '6
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _wire-id255755_
                           _timeo255764_)
                          (_set-timeout!254879_ _timeo255764_))
                        '#f))
                  (mutex-unlock! _mx255757_))
                (##direct-structure-set!
                 _content255589_
                 _wire-id255755_
                 '2
                 std/actor/proto#!call::t
                 '#f)
                (_marshal-and-write254874_ _msg255569_ _proto255606_ '#t))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (_K255628255739_
                                                    (lambda (_k255726_)
                                                      (let ((_wire-id255728_
                                                             (_next-continuation-id!254873_)))
                                                        (let ((_mx255730_
                                                               (##unchecked-structure-ref
                                                                _cont-table254865_
                                                                '1
                                                                std/actor/rpc/connection#continuation-table::t
                                                                '#f)))
                                                          (mutex-lock!
                                                           _mx255730_)
                                                          (table-set!
                                                           (##unchecked-structure-ref
                                                            _cont-table254865_
                                                            '2
                                                            std/actor/rpc/connection#continuation-table::t
                                                            '#f)
                                                           _wire-id255728_
                                                           (values _src255588_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _proto255606_
                           _k255726_
                           '#t))
                  (table-set!
                   (##unchecked-structure-ref
                    _cont-table254865_
                    '3
                    std/actor/rpc/connection#continuation-table::t
                    '#f)
                   _k255726_
                   _wire-id255728_)
                  (let ((_timeo255732255734_
                         (std/actor/rpc/connection#rpc-options-timeout
                          _opts255586_
                          '#f)))
                    (if _timeo255732255734_
                        (let ((_timeo255737_ _timeo255732255734_))
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table254865_
                            '5
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _timeo255737_
                           _wire-id255728_)
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table254865_
                            '6
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _wire-id255728_
                           _timeo255737_)
                          (_set-timeout!254879_ _timeo255737_))
                        '#f))
                  (mutex-unlock! _mx255730_))
                (##direct-structure-set!
                 _content255589_
                 _wire-id255728_
                 '2
                 std/actor/proto#!stream::t
                 '#f)
                (_marshal-and-write254874_ _msg255569_ _proto255606_ '#t))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (_K255627255710_
                                                    (lambda ()
                                                      (_marshal-and-write254874_
                                                       _msg255569_
                                                       _proto255606_
                                                       '#t)))
                                                   (_K255625255697_
                                                    (lambda (_wire-id255695_)
                                                      (std/actor/rpc/connection#continuation-table-put-stream-actor!
                                                       _cont-table254865_
                                                       _wire-id255695_
                                                       (cons _src255588_
                                                             _dest255587_))
                                                      (_marshal-and-write254874_
                                                       _msg255569_
                                                       _proto255606_
                                                       '#t)))
                                                   (_K255623255683_
                                                    (lambda (_k255679_)
                                                      (let ((_wire-id255681_
                                                             (std/actor/rpc/connection#continuation-table-get-stream-cont
                                                              _cont-table254865_
                                                              _k255679_)))
                                                        (if _wire-id255681_
                                                            (begin
                                                              (##direct-structure-set!
                                                               _content255589_
                                                               _wire-id255681_
                                                               '1
                                                               std/actor/proto#!continue::t
                                                               '#f)
                                                              (_marshal-and-write254874_
                                                               _msg255569_
                                                               _proto255606_
                                                               '#t))
                                                            (std/actor/rpc/connection#warnf
                                                             '"bad continue; unknown stream ~a"
                                                             _k255679_)))))
                                                   (_K255621255667_
                                                    (lambda (_k255663_)
                                                      (let ((_wire-id255665_
                                                             (std/actor/rpc/connection#continuation-table-get-stream-cont
                                                              _cont-table254865_
                                                              _k255663_)))
                                                        (if _wire-id255665_
                                                            (begin
                                                              (##direct-structure-set!
                                                               _content255589_
                                                               _wire-id255665_
                                                               '1
                                                               std/actor/proto#!close::t
                                                               '#f)
                                                              (_marshal-and-write254874_
                                                               _msg255569_
                                                               _proto255606_
                                                               '#t))
                                                            (std/actor/rpc/connection#warnf
                                                             '"bad close; unknown stream ~a"
                                                             _k255663_)))))
                                                   (_K255619255651_
                                                    (lambda (_k255647_)
                                                      (let ((_wire-id255649_
                                                             (std/actor/rpc/connection#continuation-table-get-stream-cont
                                                              _cont-table254865_
                                                              _k255647_)))
                                                        (if _wire-id255649_
                                                            (begin
                                                              (##direct-structure-set!
                                                               _content255589_
                                                               _wire-id255649_
                                                               '1
                                                               std/actor/proto#!abort::t
                                                               '#f)
                                                              (std/actor/rpc/connection#continuation-table-remove!
                                                               _cont-table254865_
                                                               _wire-id255649_)
                                                              (_marshal-and-write254874_
                                                               _msg255569_
                                                               _proto255606_
                                                               '#t))
                                                            (std/actor/rpc/connection#warnf
                                                             '"bad abort; unknown stream ~a"
                                                             _k255647_))))))
                                               (let* ((_try-match255616255659_
                                                       (lambda ()
                                                         (if (##structure-direct-instance-of?
                                                              _content255609255635_
                                                              'std/actor/proto#!abort::t)
                                                             (let* ((_e255620255654_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (##vector-ref _content255609255635_ '1))
                            (_k255657_ _e255620255654_))
                       (_K255619255651_ _k255657_))
                     (_else255617255643_))))
              (_try-match255615255675_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content255609255635_
                      'std/actor/proto#!close::t)
                     (let* ((_e255622255670_
                             (##vector-ref _content255609255635_ '1))
                            (_k255673_ _e255622255670_))
                       (_K255621255667_ _k255673_))
                     (_try-match255616255659_))))
              (_try-match255614255691_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content255609255635_
                      'std/actor/proto#!continue::t)
                     (let* ((_e255624255686_
                             (##vector-ref _content255609255635_ '1))
                            (_k255689_ _e255624255686_))
                       (_K255623255683_ _k255689_))
                     (_try-match255615255675_))))
              (_try-match255613255705_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content255609255635_
                      'std/actor/proto#!sync::t)
                     (let* ((_e255626255700_
                             (##vector-ref _content255609255635_ '1))
                            (_wire-id255703_ _e255626255700_))
                       (_K255625255697_ _wire-id255703_))
                     (_try-match255614255691_))))
              (_try-match255612255722_
               (lambda ()
                 (if (or (##structure-direct-instance-of?
                          _content255609255635_
                          'std/actor/proto#!value::t)
                         (##structure-direct-instance-of?
                          _content255609255635_
                          'std/actor/proto#!yield::t)
                         (##structure-direct-instance-of?
                          _content255609255635_
                          'std/actor/proto#!error::t)
                         (##structure-direct-instance-of?
                          _content255609255635_
                          'std/actor/proto#!end::t))
                     (_K255627255710_)
                     (_try-match255613255705_))))
              (_try-match255611255750_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content255609255635_
                      'std/actor/proto#!stream::t)
                     (let* ((_e255629255742_
                             (##vector-ref _content255609255635_ '1))
                            (_e255630255745_
                             (##vector-ref _content255609255635_ '2))
                            (_k255748_ _e255630255745_))
                       (_K255628255739_ _k255748_))
                     (_try-match255612255722_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (if (##structure-direct-instance-of?
                                                      _content255609255635_
                                                      'std/actor/proto#!call::t)
                                                     (let* ((_e255632255769_
                                                             (##vector-ref
                                                              _content255609255635_
                                                              '1))
                                                            (_e255633255772_
                                                             (##vector-ref
                                                              _content255609255635_
                                                              '2))
                                                            (_k255775_
                                                             _e255633255772_))
                                                       (_K255631255766_
                                                        _k255775_))
                                                     (_try-match255611255750_))))))))
                                   (if (##structure-direct-instance-of?
                                        _dest255590255599_
                                        'std/actor/proto#remote::t)
                                       (let* ((_e255594255780_
                                               (##vector-ref
                                                _dest255590255599_
                                                '1))
                                              (_e255595255783_
                                               (##vector-ref
                                                _dest255590255599_
                                                '2))
                                              (_uuid255786_ _e255595255783_)
                                              (_e255596255788_
                                               (##vector-ref
                                                _dest255590255599_
                                                '3))
                                              (_address255791_ _e255596255788_)
                                              (_e255597255793_
                                               (##vector-ref
                                                _dest255590255599_
                                                '4))
                                              (_proto255796_ _e255597255793_))
                                         (_K255593255777_
                                          _proto255796_
                                          _address255791_
                                          _uuid255786_))
                                       (_E255592255603_)))
                                 (std/actor/rpc/connection#warnf
                                  '"bad handle; no protocol ~a ~a"
                                  _dest255587_
                                  _msg255569_)))))
                     (if (##structure-direct-instance-of?
                          _msg255570255579_
                          'std/actor/message#message::t)
                         (let* ((_e255574255801_
                                 (##vector-ref _msg255570255579_ '1))
                                (_content255804_ _e255574255801_)
                                (_e255575255806_
                                 (##vector-ref _msg255570255579_ '2))
                                (_src255809_ _e255575255806_)
                                (_e255576255811_
                                 (##vector-ref _msg255570255579_ '3))
                                (_dest255814_ _e255576255811_)
                                (_e255577255816_
                                 (##vector-ref _msg255570255579_ '4))
                                (_opts255819_ _e255577255816_))
                           (_K255573255798_
                            _opts255819_
                            _dest255814_
                            _src255809_
                            _content255804_))
                         (_E255572255583_)))))
                (_next-continuation-id!254873_
                 (lambda ()
                   (let ((_next255567_ _next-continuation-id254867_))
                     (set! _next-continuation-id254867_ (+ _next255567_ '1))
                     _next255567_)))
                (_marshal-and-write254874_
                 (lambda (_msg255210_
                          _proto255211_
                          _dispatch-marshal-error?255212_)
                   (let ((_e255297_
                          (with-exception-catcher
                           (lambda (_g255286255288_)
                             (if ((lambda (_$obj255291_)
                                    (exception? _$obj255291_))
                                  _g255286255288_)
                                 (let ((_e255294_ _g255286255288_)) _e255294_)
                                 (raise _g255286255288_)))
                           (lambda ()
                             (std/actor/rpc/proto/message#rpc-proto-marshal-message
                              _msg255210_
                              _proto255211_)))))
                     (if (u8vector? _e255297_)
                         (if (fx<= (u8vector-length _e255297_)
                                   std/actor/rpc/proto/message#rpc-proto-message-max-length)
                             (thread-send _writer254869_ _e255297_)
                             (begin
                               (std/actor/rpc/connection#warnf
                                '"message too large; not sending %d bytes"
                                (u8vector-length _e255297_))
                               (let ((_content255299_
                                      (##direct-structure-ref
                                       _msg255210_
                                       '1
                                       std/actor/message#message::t
                                       '#f))
                                     (_dest255301_
                                      (##direct-structure-ref
                                       _msg255210_
                                       '3
                                       std/actor/message#message::t
                                       '#f)))
                                 (let* ((_content255303255319_ _content255299_)
                                        (_else255306255327_
                                         (lambda () '#!void)))
                                   (let ((_K255313255365_
                                          (lambda (_wire-id255362_ _e255363_)
                                            (_dispatch-error254875_
                                             _wire-id255362_
                                             '"message too large")))
                                         (_K255308255336_
                                          (lambda (_wire-id255331_ _e255333_)
                                            (if _dispatch-marshal-error?255212_
                                                (_dispatch-remote-error254876_
                                                 (##structure
                                                  std/actor/proto#!error::t
                                                  '"message too large"
                                                  _wire-id255331_)
                                                 _dest255301_)
                                                '#!void))))
                                     (let* ((___match306629306630_
                                             (lambda ()
                                               (if (##structure-direct-instance-of?
                                                    _content255303255319_
                                                    'std/actor/proto#!yield::t)
                                                   (let* ((_e255309255349_
                                                           (##vector-ref
                                                            _content255303255319_
                                                            '1))
                                                          (_e255310255354_
                                                           (##vector-ref
                                                            _content255303255319_
                                                            '2)))
                                                     (let ((_e255352_
                                                            _e255309255349_)
                                                           (_wire-id255357_
                                                            _e255310255354_))
                                                       (_K255308255336_
                                                        _wire-id255357_
                                                        _e255352_)))
                                                   '#!void)))
                                            (_try-match255305255359_
                                             (lambda ()
                                               (if (##structure-direct-instance-of?
                                                    _content255303255319_
                                                    'std/actor/proto#!error::t)
                                                   (let* ((_e255311255339_
                                                           (##vector-ref
                                                            _content255303255319_
                                                            '1))
                                                          (_e255312255344_
                                                           (##vector-ref
                                                            _content255303255319_
                                                            '2)))
                                                     (let ((_e255342_
                                                            _e255311255339_)
                                                           (_wire-id255347_
                                                            _e255312255344_))
                                                       (_K255308255336_
                                                        _wire-id255347_
                                                        _e255342_)))
                                                   (___match306629306630_))))
                                            (___match306615306616_
                                             (lambda ()
                                               (if (##structure-direct-instance-of?
                                                    _content255303255319_
                                                    'std/actor/proto#!stream::t)
                                                   (let* ((_e255314255378_
                                                           (##vector-ref
                                                            _content255303255319_
                                                            '1))
                                                          (_e255315255383_
                                                           (##vector-ref
                                                            _content255303255319_
                                                            '2)))
                                                     (let ((_e255381_
                                                            _e255314255378_)
                                                           (_wire-id255386_
                                                            _e255315255383_))
                                                       (_K255313255365_
                                                        _wire-id255386_
                                                        _e255381_)))
                                                   (_try-match255305255359_)))))
                                       (if (##structure-direct-instance-of?
                                            _content255303255319_
                                            'std/actor/proto#!call::t)
                                           (let* ((_e255316255368_
                                                   (##vector-ref
                                                    _content255303255319_
                                                    '1))
                                                  (_e255317255373_
                                                   (##vector-ref
                                                    _content255303255319_
                                                    '2)))
                                             (let ((_e255371_ _e255316255368_)
                                                   (_wire-id255376_
                                                    _e255317255373_))
                                               (_K255313255365_
                                                _wire-id255376_
                                                _e255371_)))
                                           (___match306615306616_))))))))
                         (if (##structure-instance-of?
                              _e255297_
                              'std/net/bio/buffer#chunked-output-buffer::t)
                             (if (fx<= (std/net/bio/buffer#chunked-output-length
                                        _e255297_)
                                       std/actor/rpc/proto/message#rpc-proto-message-max-length)
                                 (thread-send _writer254869_ _e255297_)
                                 (begin
                                   (std/actor/rpc/connection#warnf
                                    '"message too large; not sending %d bytes"
                                    (std/net/bio/buffer#chunked-output-length
                                     _e255297_))
                                   (let ((_content255388_
                                          (##direct-structure-ref
                                           _msg255210_
                                           '1
                                           std/actor/message#message::t
                                           '#f))
                                         (_dest255390_
                                          (##direct-structure-ref
                                           _msg255210_
                                           '3
                                           std/actor/message#message::t
                                           '#f)))
                                     (let* ((_content255392255408_
                                             _content255388_)
                                            (_else255395255416_
                                             (lambda () '#!void)))
                                       (let ((_K255402255454_
                                              (lambda (_wire-id255451_
                                                       _e255452_)
                                                (_dispatch-error254875_
                                                 _wire-id255451_
                                                 '"message too large")))
                                             (_K255397255425_
                                              (lambda (_wire-id255420_
                                                       _e255422_)
                                                (if _dispatch-marshal-error?255212_
                                                    (_dispatch-remote-error254876_
                                                     (##structure
                                                      std/actor/proto#!error::t
                                                      '"message too large"
                                                      _wire-id255420_)
                                                     _dest255390_)
                                                    '#!void))))
                                         (let* ((___match306658306659_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content255392255408_
                                                        'std/actor/proto#!yield::t)
                                                       (let* ((_e255398255438_
                                                               (##vector-ref
                                                                _content255392255408_
                                                                '1))
                                                              (_e255399255443_
                                                               (##vector-ref
                                                                _content255392255408_
                                                                '2)))
                                                         (let ((_e255441_
                                                                _e255398255438_)
                                                               (_wire-id255446_
                                                                _e255399255443_))
                                                           (_K255397255425_
                                                            _wire-id255446_
                                                            _e255441_)))
                                                       '#!void)))
                                                (_try-match255394255448_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content255392255408_
                                                        'std/actor/proto#!error::t)
                                                       (let* ((_e255400255428_
                                                               (##vector-ref
                                                                _content255392255408_
                                                                '1))
                                                              (_e255401255433_
                                                               (##vector-ref
                                                                _content255392255408_
                                                                '2)))
                                                         (let ((_e255431_
                                                                _e255400255428_)
                                                               (_wire-id255436_
                                                                _e255401255433_))
                                                           (_K255397255425_
                                                            _wire-id255436_
                                                            _e255431_)))
                                                       (___match306658306659_))))
                                                (___match306644306645_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content255392255408_
                                                        'std/actor/proto#!stream::t)
                                                       (let* ((_e255403255467_
                                                               (##vector-ref
                                                                _content255392255408_
                                                                '1))
                                                              (_e255404255472_
                                                               (##vector-ref
                                                                _content255392255408_
                                                                '2)))
                                                         (let ((_e255470_
                                                                _e255403255467_)
                                                               (_wire-id255475_
                                                                _e255404255472_))
                                                           (_K255402255454_
                                                            _wire-id255475_
                                                            _e255470_)))
                                                       (_try-match255394255448_)))))
                                           (if (##structure-direct-instance-of?
                                                _content255392255408_
                                                'std/actor/proto#!call::t)
                                               (let* ((_e255405255457_
                                                       (##vector-ref
                                                        _content255392255408_
                                                        '1))
                                                      (_e255406255462_
                                                       (##vector-ref
                                                        _content255392255408_
                                                        '2)))
                                                 (let ((_e255460_
                                                        _e255405255457_)
                                                       (_wire-id255465_
                                                        _e255406255462_))
                                                   (_K255402255454_
                                                    _wire-id255465_
                                                    _e255460_)))
                                               (___match306644306645_))))))))
                             (if _dispatch-marshal-error?255212_
                                 (begin
                                   (std/actor/rpc/connection#errorf
                                    '"marshal error: ~a"
                                    _e255297_)
                                   (let ((_content255477_
                                          (##direct-structure-ref
                                           _msg255210_
                                           '1
                                           std/actor/message#message::t
                                           '#f))
                                         (_dest255479_
                                          (##direct-structure-ref
                                           _msg255210_
                                           '3
                                           std/actor/message#message::t
                                           '#f)))
                                     (let* ((_content255481255497_
                                             _content255477_)
                                            (_else255484255505_
                                             (lambda () '#!void)))
                                       (let ((_K255491255543_
                                              (lambda (_wire-id255540_
                                                       _e255541_)
                                                (_dispatch-error254875_
                                                 _wire-id255540_
                                                 '"marshal error")))
                                             (_K255486255514_
                                              (lambda (_wire-id255509_
                                                       _e255511_)
                                                (if _dispatch-marshal-error?255212_
                                                    (_dispatch-remote-error254876_
                                                     (##structure
                                                      std/actor/proto#!error::t
                                                      '"marshal error"
                                                      _wire-id255509_)
                                                     _dest255479_)
                                                    '#!void))))
                                         (let* ((___match306687306688_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content255481255497_
                                                        'std/actor/proto#!yield::t)
                                                       (let* ((_e255487255527_
                                                               (##vector-ref
                                                                _content255481255497_
                                                                '1))
                                                              (_e255488255532_
                                                               (##vector-ref
                                                                _content255481255497_
                                                                '2)))
                                                         (let ((_e255530_
                                                                _e255487255527_)
                                                               (_wire-id255535_
                                                                _e255488255532_))
                                                           (_K255486255514_
                                                            _wire-id255535_
                                                            _e255530_)))
                                                       '#!void)))
                                                (_try-match255483255537_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content255481255497_
                                                        'std/actor/proto#!error::t)
                                                       (let* ((_e255489255517_
                                                               (##vector-ref
                                                                _content255481255497_
                                                                '1))
                                                              (_e255490255522_
                                                               (##vector-ref
                                                                _content255481255497_
                                                                '2)))
                                                         (let ((_e255520_
                                                                _e255489255517_)
                                                               (_wire-id255525_
                                                                _e255490255522_))
                                                           (_K255486255514_
                                                            _wire-id255525_
                                                            _e255520_)))
                                                       (___match306687306688_))))
                                                (___match306673306674_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content255481255497_
                                                        'std/actor/proto#!stream::t)
                                                       (let* ((_e255492255556_
                                                               (##vector-ref
                                                                _content255481255497_
                                                                '1))
                                                              (_e255493255561_
                                                               (##vector-ref
                                                                _content255481255497_
                                                                '2)))
                                                         (let ((_e255559_
                                                                _e255492255556_)
                                                               (_wire-id255564_
                                                                _e255493255561_))
                                                           (_K255491255543_
                                                            _wire-id255564_
                                                            _e255559_)))
                                                       (_try-match255483255537_)))))
                                           (if (##structure-direct-instance-of?
                                                _content255481255497_
                                                'std/actor/proto#!call::t)
                                               (let* ((_e255494255546_
                                                       (##vector-ref
                                                        _content255481255497_
                                                        '1))
                                                      (_e255495255551_
                                                       (##vector-ref
                                                        _content255481255497_
                                                        '2)))
                                                 (let ((_e255549_
                                                        _e255494255546_)
                                                       (_wire-id255554_
                                                        _e255495255551_))
                                                   (_K255491255543_
                                                    _wire-id255554_
                                                    _e255549_)))
                                               (___match306673306674_)))))))
                                 (std/actor/rpc/connection#errorf
                                  '"marshal error: ~a"
                                  _e255297_)))))))
                (_dispatch-error254875_
                 (lambda (_wire-id255159_ _what255160_)
                   (let* ((_g255161255171_
                           (std/actor/rpc/connection#continuation-table-remove!
                            _cont-table254865_
                            _wire-id255159_))
                          (_else255163255179_ (lambda () '#!void))
                          (_K255165255187_
                           (lambda (_stream?255182_
                                    _k255183_
                                    _proto255184_
                                    _actor255185_)
                             (std/actor/message#send-message__%
                              _actor255185_
                              (##structure
                               std/actor/proto#!error::t
                               (make-struct-instance
                                std/actor/proto#rpc-error::t
                                'rpc
                                _what255160_)
                               _k255183_)
                              '#f
                              '#f))))
                     (if (##fx= (if (##values? _g255161255171_)
                                    (##vector-length _g255161255171_)
                                    '1)
                                '4)
                         (let* ((_e255166255190_
                                 (##vector-ref _g255161255171_ '0))
                                (_actor255193_ _e255166255190_)
                                (_e255167255195_
                                 (##vector-ref _g255161255171_ '1))
                                (_proto255198_ _e255167255195_)
                                (_e255168255200_
                                 (##vector-ref _g255161255171_ '2))
                                (_k255203_ _e255168255200_)
                                (_e255169255205_
                                 (##vector-ref _g255161255171_ '3))
                                (_stream?255208_ _e255169255205_))
                           (_K255165255187_
                            _stream?255208_
                            _k255203_
                            _proto255198_
                            _actor255193_))
                         '#!void))))
                (_dispatch-remote-error254876_
                 (lambda (_what255156_ _dest255157_)
                   (_marshal-and-write254874_
                    (##structure
                     std/actor/message#message::t
                     _what255156_
                     '#!void
                     _dest255157_
                     '#f)
                    '#f
                    '#f)))
                (_dispatch-timeout254877_
                 (lambda (_timeo255149_)
                   (set! _next-timeout254866_ '#f)
                   (let ((_$e255151_
                          (std/actor/rpc/connection#continuation-table-get-timeout
                           _cont-table254865_
                           _timeo255149_)))
                     (if _$e255151_
                         ((lambda (_wire-id255154_)
                            (_dispatch-error254875_
                             _wire-id255154_
                             '"timeout"))
                          _$e255151_)
                         '#!void))))
                (_timeout<254878_
                 (lambda (_a255146_ _b255147_)
                   (< (time->seconds _a255146_) (time->seconds _b255147_))))
                (_set-timeout!254879_
                 (lambda (_timeo255141_)
                   (if (or (not _next-timeout254866_)
                           (_timeout<254878_
                            _timeo255141_
                            _next-timeout254866_))
                       (set! _next-timeout254866_ _timeo255141_)
                       '#!void)))
                (_timeout-event254880_
                 (lambda ()
                   (if _next-timeout254866_
                       '#!void
                       (let ((_mx255134_
                              (##unchecked-structure-ref
                               _cont-table254865_
                               '1
                               std/actor/rpc/connection#continuation-table::t
                               '#f)))
                         (mutex-lock! _mx255134_)
                         (let ((_timeouts255137_
                                (##unchecked-structure-ref
                                 _cont-table254865_
                                 '5
                                 std/actor/rpc/connection#continuation-table::t
                                 '#f)))
                           (if (fxzero? (table-length _timeouts255137_))
                               '#!void
                               (table-for-each
                                (lambda (_timeo255139_ _g306785_)
                                  (_set-timeout!254879_ _timeo255139_))
                                _timeouts255137_)))
                         (mutex-unlock! _mx255134_)))
                   _next-timeout254866_))
                (_heartbeat!254881_
                 (lambda ()
                   (let ((_dead-continuations255081_
                          (let ((_mx255037_
                                 (##unchecked-structure-ref
                                  _cont-table254865_
                                  '1
                                  std/actor/rpc/connection#continuation-table::t
                                  '#f)))
                            (mutex-lock! _mx255037_)
                            (let ((_res255078_
                                   (hash-fold
                                    (lambda (_wire-id255040_
                                             _continuation255041_
                                             _r255042_)
                                      (let* ((_continuation255043255052_
                                              _continuation255041_)
                                             (_E255045255056_
                                              (lambda ()
                                                (error '"No clause matching"
                                                       _continuation255043255052_)))
                                             (_K255046255061_
                                              (lambda (_actor255059_)
                                                (if (and (thread? _actor255059_)
                                                         (std/misc/threads#thread-dead?
                                                          _actor255059_))
                                                    (cons _wire-id255040_
                                                          _r255042_)
                                                    _r255042_))))
                                        (if (##fx= (if (##values?
                                                        _continuation255043255052_)
                                                       (##vector-length
                                                        _continuation255043255052_)
                                                       '1)
                                                   '4)
                                            (let* ((_e255047255064_
                                                    (##vector-ref
                                                     _continuation255043255052_
                                                     '0))
                                                   (_actor255067_
                                                    _e255047255064_)
                                                   (_e255048255069_
                                                    (##vector-ref
                                                     _continuation255043255052_
                                                     '1))
                                                   (_e255049255072_
                                                    (##vector-ref
                                                     _continuation255043255052_
                                                     '2))
                                                   (_e255050255075_
                                                    (##vector-ref
                                                     _continuation255043255052_
                                                     '3)))
                                              (_K255046255061_ _actor255067_))
                                            (_E255045255056_))))
                                    '()
                                    (##unchecked-structure-ref
                                     _cont-table254865_
                                     '2
                                     std/actor/rpc/connection#continuation-table::t
                                     '#f))))
                              (mutex-unlock! _mx255037_)
                              _res255078_))))
                     (for-each
                      (lambda (_wire-id255083_)
                        (let* ((_g255084255094_
                                (std/actor/rpc/connection#continuation-table-remove!
                                 _cont-table254865_
                                 _wire-id255083_))
                               (_else255086255102_ (lambda () '#!void))
                               (_K255088255110_
                                (lambda (_stream?255105_
                                         _k255106_
                                         _proto255107_
                                         _actor255108_)
                                  (std/actor/rpc/connection#debugf
                                   '"removing continuation ~a for dead actor ~a"
                                   _wire-id255083_
                                   _actor255108_)
                                  (if _stream?255105_
                                      (_dispatch-remote-error254876_
                                       (##structure
                                        std/actor/proto#!abort::t
                                        _wire-id255083_)
                                       std/actor/rpc/base#null-uuid)
                                      '#!void))))
                          (if (##fx= (if (##values? _g255084255094_)
                                         (##vector-length _g255084255094_)
                                         '1)
                                     '4)
                              (let* ((_e255089255113_
                                      (##vector-ref _g255084255094_ '0))
                                     (_actor255116_ _e255089255113_)
                                     (_e255090255118_
                                      (##vector-ref _g255084255094_ '1))
                                     (_proto255121_ _e255090255118_)
                                     (_e255091255123_
                                      (##vector-ref _g255084255094_ '2))
                                     (_k255126_ _e255091255123_)
                                     (_e255092255128_
                                      (##vector-ref _g255084255094_ '3))
                                     (_stream?255131_ _e255092255128_))
                                (_K255088255110_
                                 _stream?255131_
                                 _k255126_
                                 _proto255121_
                                 _actor255116_))
                              '#!void)))
                      _dead-continuations255081_))
                   (set! _next-heartbeat254868_
                         (seconds->time (+ (##current-time-point) '60)))))
                (_dump!254882_
                 (lambda (_port255033_)
                   (call-with-parameters
                    (lambda ()
                      (displayln '"=== rpc-connection ===")
                      (displayln '"peer-address: " _peer-address254858_)
                      (displayln
                       '"next-continuation-id: "
                       _next-continuation-id254867_)
                      (displayln
                       '"next-timeout: "
                       (if _next-timeout254866_
                           (time->seconds _next-timeout254866_)
                           '#f)))
                    current-output-port
                    _port255033_)
                   (std/actor/rpc/connection#continuation-table-dump!__%
                    _cont-table254865_
                    _port255033_)))
                (_loop254883_
                 (lambda ()
                   (let ((_g306786_
                          (std/actor/message#receive-timeout
                           (_timeout-event254880_)
                           _dispatch-timeout254877_
                           _next-heartbeat254868_
                           (lambda (_$e254897_) (_heartbeat!254881_)))))
                     (begin
                       (let ((_g306787_
                              (if (##values? _g306786_)
                                  (##vector-length _g306786_)
                                  1)))
                         (if (not (##fx= _g306787_ 2))
                             (error "Context expects 2 values" _g306787_)))
                       (let ((_timeo254900_ (##vector-ref _g306786_ 0))
                             (_K254902_ (##vector-ref _g306786_ 1)))
                         (let _loop254895254905_ ()
                           (let ((_next254909_
                                  (thread-mailbox-next
                                   _timeo254900_
                                   std/actor/message#mailbox-timeout)))
                             (if (eq? _next254909_
                                      std/actor/message#mailbox-timeout)
                                 (begin
                                   (thread-mailbox-rewind)
                                   (_K254902_ _timeo254900_))
                                 ((lambda (_msg254912_)
                                    (let* ((_msg254914254936_ _msg254912_)
                                           (_else254922254944_
                                            (lambda () (_loop254895254905_))))
                                      (let ((_K254934255028_
                                             (lambda (_msg255026_)
                                               (thread-mailbox-extract-and-rewind)
                                               (_write-message254872_
                                                _msg255026_)))
                                            (_K254933255020_
                                             (lambda ()
                                               (thread-mailbox-extract-and-rewind)
                                               (_close-connection254871_)))
                                            (_K254932255012_
                                             (lambda ()
                                               (thread-mailbox-extract-and-rewind)
                                               (_close-connection254871_)))
                                            (_K254931255002_
                                             (lambda (_thread254988_)
                                               (thread-mailbox-extract-and-rewind)
                                               (with-exception-catcher
                                                (lambda (_g254989254991_)
                                                  (if ((lambda (_$obj254994_)
                                                         (uncaught-exception?
                                                          _$obj254994_))
                                                       _g254989254991_)
                                                      (let ((_e254997_
                                                             _g254989254991_))
                                                        (std/actor/rpc/connection#errorf
                                                         '"connection error: ~a"
                                                         (uncaught-exception-reason
                                                          _e254997_)))
                                                      (if '#t
                                                          (let ((_e254999_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _g254989254991_))
                    (std/actor/rpc/connection#errorf
                     '"connection error: ~a"
                     _e254999_))
                  (raise _g254989254991_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                (lambda ()
                                                  (thread-join! _thread254988_)
                                                  (std/actor/rpc/connection#warnf
                                                   '"connection error: i/o thread ~a exited unexpectedly"
                                                   (thread-name
                                                    _thread254988_))))
                                               (_close-connection254871_)))
                                            (_K254930254981_
                                             (lambda ()
                                               (thread-mailbox-extract-and-rewind)
                                               (_dump!254882_
                                                (current-error-port))))
                                            (_K254925254961_
                                             (lambda (_port254959_)
                                               (thread-mailbox-extract-and-rewind)
                                               (_dump!254882_ _port254959_)))
                                            (_K254924254950_
                                             (lambda (_bogus254948_)
                                               (thread-mailbox-extract-and-rewind)
                                               (std/actor/rpc/connection#warnf
                                                '"unexpected message ~a"
                                                _bogus254948_))))
                                        (let* ((_try-match254920254976_
                                                (lambda ()
                                                  (if (##pair? _msg254914254936_)
                                                      (let ((_tl254927254966_
                                                             (##cdr _msg254914254936_))
                                                            (_hd254926254964_
                                                             (##car _msg254914254936_)))
                                                        (if (##eq? _hd254926254964_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           'dump)
                    (if (##pair? _tl254927254966_)
                        (let ((_tl254929254971_ (##cdr _tl254927254966_))
                              (_hd254928254969_ (##car _tl254927254966_)))
                          (if (##null? _tl254929254971_)
                              (let ((_port254974_ _hd254928254969_))
                                (_K254925254961_ _port254974_))
                              (let ((_bogus254953_ _msg254914254936_))
                                (_K254924254950_ _bogus254953_))))
                        (let ((_bogus254953_ _msg254914254936_))
                          (_K254924254950_ _bogus254953_)))
                    (let ((_bogus254953_ _msg254914254936_))
                      (_K254924254950_ _bogus254953_))))
              (let ((_bogus254953_ _msg254914254936_))
                (_K254924254950_ _bogus254953_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (_try-match254919254984_
                                                (lambda ()
                                                  (if (##eq? _msg254914254936_
                                                             'dump)
                                                      (_K254930254981_)
                                                      (_try-match254920254976_))))
                                               (_try-match254918255007_
                                                (lambda ()
                                                  (if (thread? _msg254914254936_)
                                                      (let ((_thread255005_
                                                             _msg254914254936_))
                                                        (_K254931255002_
                                                         _thread255005_))
                                                      (_try-match254919254984_))))
                                               (_try-match254917255015_
                                                (lambda ()
                                                  (if (##eq? _msg254914254936_
                                                             'shutdown)
                                                      (_K254932255012_)
                                                      (_try-match254918255007_))))
                                               (_try-match254916255023_
                                                (lambda ()
                                                  (if (eof-object?
                                                       _msg254914254936_)
                                                      (_K254933255020_)
                                                      (_try-match254917255015_)))))
                                          (if (##structure-direct-instance-of?
                                               _msg254914254936_
                                               'std/actor/message#message::t)
                                              (let ((_msg255031_
                                                     _msg254914254936_))
                                                (_K254934255028_ _msg255031_))
                                              (_try-match254916255023_))))))
                                  _next254909_)))))))
                   (_loop254883_)))
                (_run254884_
                 (lambda ()
                   (call-with-parameters
                    (lambda () (_loop254883_))
                    std/actor/xdr#current-xdr-type-registry
                    std/actor/xdr#+xdr-default-type-registry+))))
        (begin
          (std/actor/rpc/base#rpc-monitor__0 _reader254870_)
          (std/actor/rpc/base#rpc-monitor__0 _writer254869_)
          (with-exception-catcher
           (lambda (_g254885254887_)
             (if '#t
                 (let ((_e254890_ _g254885254887_))
                   (if (eq? 'shutdown _e254890_)
                       '#!void
                       (begin
                         (std/actor/rpc/connection#errorf
                          '"unhandled exception: ~a"
                          _e254890_)
                         (with-exception-catcher
                          void
                          _close-connection254871_))))
                 (raise _g254885254887_)))
           (lambda () (_run254884_)))))))
  (define std/actor/rpc/connection#rpc-connection-writer
    (lambda (_sockbuf254764_ _write-e254765_)
      (letrec ((_loop254767_
                (lambda ()
                  (let ((_g306788_
                         (std/actor/message#receive-timeout
                          std/actor/rpc/connection#rpc-keep-alive
                          (lambda (_$e254778_)
                            (_write-e254765_ _sockbuf254764_ '#!void)
                            (_loop254767_)))))
                    (begin
                      (let ((_g306789_
                             (if (##values? _g306788_)
                                 (##vector-length _g306788_)
                                 1)))
                        (if (not (##fx= _g306789_ 2))
                            (error "Context expects 2 values" _g306789_)))
                      (let ((_timeo254781_ (##vector-ref _g306788_ 0))
                            (_K254783_ (##vector-ref _g306788_ 1)))
                        (let _loop254776254786_ ()
                          (let ((_next254790_
                                 (thread-mailbox-next
                                  _timeo254781_
                                  std/actor/message#mailbox-timeout)))
                            (if (eq? _next254790_
                                     std/actor/message#mailbox-timeout)
                                (begin
                                  (thread-mailbox-rewind)
                                  (_K254783_ _timeo254781_))
                                ((lambda (_msg254793_)
                                   (let* ((_msg254795254807_ _msg254793_)
                                          (_else254800254815_
                                           (lambda () (_loop254776254786_))))
                                     (let ((_K254805254850_
                                            (lambda (_buf254848_)
                                              (thread-mailbox-extract-and-rewind)
                                              (_write-e254765_
                                               _sockbuf254764_
                                               _buf254848_)
                                              (_loop254767_)))
                                           (_K254804254840_
                                            (lambda (_data254838_)
                                              (thread-mailbox-extract-and-rewind)
                                              (_write-e254765_
                                               _sockbuf254764_
                                               _data254838_)
                                              (_loop254767_)))
                                           (_K254803254831_
                                            (lambda ()
                                              (thread-mailbox-extract-and-rewind)
                                              '#!void))
                                           (_K254802254821_
                                            (lambda (_bogus254819_)
                                              (thread-mailbox-extract-and-rewind)
                                              (std/actor/rpc/connection#warnf
                                               '"unexpected message ~a"
                                               _bogus254819_)
                                              (_loop254767_))))
                                       (let* ((_try-match254798254834_
                                               (lambda ()
                                                 (if (##eq? _msg254795254807_
                                                            'exit)
                                                     (_K254803254831_)
                                                     (let ((_bogus254824_
                                                            _msg254795254807_))
                                                       (_K254802254821_
                                                        _bogus254824_)))))
                                              (_try-match254797254845_
                                               (lambda ()
                                                 (if (u8vector?
                                                      _msg254795254807_)
                                                     (let ((_data254843_
                                                            _msg254795254807_))
                                                       (_K254804254840_
                                                        _data254843_))
                                                     (_try-match254798254834_)))))
                                         (if (##structure-instance-of?
                                              _msg254795254807_
                                              'std/net/bio/output#output-buffer::t)
                                             (let ((_buf254853_
                                                    _msg254795254807_))
                                               (_K254805254850_ _buf254853_))
                                             (_try-match254797254845_))))))
                                 _next254790_))))))))))
        (with-exception-catcher
         (lambda (_g254768254770_)
           (if '#t
               (let ((_e254773_ _g254768254770_))
                 (std/actor/rpc/connection#errorf
                  '"unhandled exception: ~a"
                  _e254773_))
               (raise _g254768254770_)))
         (lambda () (_loop254767_))))))
  (define std/actor/rpc/connection#rpc-connection-reader
    (lambda (_conn254343_
             _connaddr254344_
             _sockbuf254345_
             _actor-table254346_
             _cont-table254347_
             _writer254348_
             _read-e254349_)
      (letrec ((_loop254351_
                (lambda (_u8buf254604_)
                  (let* ((_g254605254618_
                          (_read-e254349_ _sockbuf254345_ _u8buf254604_))
                         (_E254610254622_
                          (lambda ()
                            (error '"No clause matching" _g254605254618_))))
                    (let ((_K254614254751_
                           (lambda (_count254652_ _u8buf254653_)
                             (let* ((_buffer254655_
                                     (std/net/bio/buffer#open-input-buffer__%
                                      _u8buf254653_
                                      '0
                                      _count254652_))
                                    (_msg254657_
                                     (_read-envelope254358_ _buffer254655_)))
                               (let* ((_msg254659254666_ _msg254657_)
                                      (_else254661254674_ (lambda () '#!void))
                                      (_K254663254743_
                                       (lambda (_content254677_)
                                         (let* ((_content254678254688_
                                                 _content254677_)
                                                (_else254682254696_
                                                 (lambda ()
                                                   (_dispatch-call254352_
                                                    _msg254657_
                                                    _buffer254655_))))
                                           (let ((_K254686254734_
                                                  (lambda ()
                                                    (_dispatch-call254352_
                                                     _msg254657_
                                                     _buffer254655_)))
                                                 (_K254685254715_
                                                  (lambda ()
                                                    (_dispatch-value254353_
                                                     _msg254657_
                                                     _buffer254655_)))
                                                 (_K254684254701_
                                                  (lambda ()
                                                    (_dispatch-control254354_
                                                     _msg254657_
                                                     _buffer254655_))))
                                             (let* ((_try-match254681254710_
                                                     (lambda ()
                                                       (if (or (##structure-direct-instance-of?
                                                                _content254678254688_
                                                                'std/actor/proto#!continue::t)
                                                               (##structure-direct-instance-of?
                                                                _content254678254688_
                                                                'std/actor/proto#!close::t)
                                                               (##structure-direct-instance-of?
                                                                _content254678254688_
                                                                'std/actor/proto#!abort::t))
                                                           (_K254684254701_)
                                                           (_else254682254696_))))
                                                    (_try-match254680254730_
                                                     (lambda ()
                                                       (if (or (##structure-direct-instance-of?
                                                                _content254678254688_
                                                                'std/actor/proto#!value::t)
                                                               (##structure-direct-instance-of?
                                                                _content254678254688_
                                                                'std/actor/proto#!error::t)
                                                               (##structure-direct-instance-of?
                                                                _content254678254688_
                                                                'std/actor/proto#!yield::t)
                                                               (##structure-direct-instance-of?
                                                                _content254678254688_
                                                                'std/actor/proto#!end::t)
                                                               (##structure-direct-instance-of?
                                                                _content254678254688_
                                                                'std/actor/proto#!sync::t))
                                                           (_K254685254715_)
                                                           (_try-match254681254710_)))))
                                               (if (or (##structure-direct-instance-of?
                                                        _content254678254688_
                                                        'std/actor/proto#!call::t)
                                                       (##structure-direct-instance-of?
                                                        _content254678254688_
                                                        'std/actor/proto#!event::t)
                                                       (##structure-direct-instance-of?
                                                        _content254678254688_
                                                        'std/actor/proto#!stream::t))
                                                   (_K254686254734_)
                                                   (_try-match254680254730_))))))))
                                 (if (##structure-direct-instance-of?
                                      _msg254659254666_
                                      'std/actor/message#message::t)
                                     (let* ((_e254664254746_
                                             (##vector-ref
                                              _msg254659254666_
                                              '1))
                                            (_content254749_ _e254664254746_))
                                       (_K254663254743_ _content254749_))
                                     '#!void))
                               (_loop254351_ _u8buf254653_))))
                          (_K254613254646_
                           (lambda () (_loop254351_ _u8buf254604_)))
                          (_K254612254638_
                           (lambda () (thread-send _conn254343_ '#!eof)))
                          (_K254611254628_
                           (lambda (_unexpected254626_)
                             (error '"read unexpected object"
                                    _unexpected254626_))))
                      (let* ((_try-match254608254641_
                              (lambda ()
                                (if (eof-object? _g254605254618_)
                                    (_K254612254638_)
                                    (let ((_unexpected254631_ _g254605254618_))
                                      (_K254611254628_ _unexpected254631_)))))
                             (_try-match254607254649_
                              (lambda ()
                                (if (eq? _g254605254618_ '#!void)
                                    (_K254613254646_)
                                    (_try-match254608254641_)))))
                        (if (##fx= (if (##values? _g254605254618_)
                                       (##vector-length _g254605254618_)
                                       '1)
                                   '2)
                            (let* ((_e254615254754_
                                    (##vector-ref _g254605254618_ '0))
                                   (_e254616254759_
                                    (##vector-ref _g254605254618_ '1)))
                              (let ((_u8buf254757_ _e254615254754_)
                                    (_count254762_ _e254616254759_))
                                (_K254614254751_ _count254762_ _u8buf254757_)))
                            (_try-match254607254649_)))))))
               (_dispatch-call254352_
                (lambda (_msg254514_ _buffer254515_)
                  (let* ((_uuid254517_
                          (##direct-structure-ref
                           _msg254514_
                           '3
                           std/actor/message#message::t
                           '#f))
                         (_$e254519_
                          (std/misc/sync#sync-hash-get
                           _actor-table254346_
                           _uuid254517_)))
                    (if _$e254519_
                        ((lambda (_e254521254523_)
                           (let* ((_g254525254532_ _e254521254523_)
                                  (_E254527254536_
                                   (lambda ()
                                     (error '"No clause matching"
                                            _g254525254532_)))
                                  (_K254528254550_
                                   (lambda (_proto254539_ _actor254540_)
                                     (if (_read-payload!254359_
                                          _msg254514_
                                          _buffer254515_
                                          _proto254539_)
                                         (begin
                                           (##direct-structure-set!
                                            _msg254514_
                                            _actor254540_
                                            '3
                                            std/actor/message#message::t
                                            '#f)
                                           (##direct-structure-set!
                                            _msg254514_
                                            (let ((__obj306778
                                                   (make-object
                                                    std/actor/proto#remote::t
                                                    '4)))
                                              (std/actor/proto#remote:::init!
                                               __obj306778
                                               _conn254343_
                                               _uuid254517_
                                               _connaddr254344_
                                               _proto254539_)
                                              __obj306778)
                                            '2
                                            std/actor/message#message::t
                                            '#f)
                                           (std/actor/message#send__0
                                            _actor254540_
                                            _msg254514_))
                                         (if (or (##structure-direct-instance-of?
                                                  (##direct-structure-ref
                                                   _msg254514_
                                                   '1
                                                   std/actor/message#message::t
                                                   '#f)
                                                  'std/actor/proto#!call::t)
                                                 (##structure-direct-instance-of?
                                                  (##direct-structure-ref
                                                   _msg254514_
                                                   '1
                                                   std/actor/message#message::t
                                                   '#f)
                                                  'std/actor/proto#!stream::t))
                                             (let* ((_content254545_
                                                     (##direct-structure-ref
                                                      _msg254514_
                                                      '1
                                                      std/actor/message#message::t
                                                      '#f))
                                                    (_k254547_
                                                     (if (##structure-direct-instance-of?
                                                          _content254545_
                                                          'std/actor/proto#!call::t)
                                                         (##direct-structure-ref
                                                          _content254545_
                                                          '2
                                                          std/actor/proto#!call::t
                                                          '#f)
                                                         (##direct-structure-ref
                                                          _content254545_
                                                          '2
                                                          std/actor/proto#!stream::t
                                                          '#f))))
                                               (_dispatch-remote-error254357_
                                                (##structure
                                                 std/actor/proto#!error::t
                                                 '"unmarshal error"
                                                 _k254547_)
                                                _uuid254517_))
                                             '#!void)))))
                             (if (##fx= (if (##values? _g254525254532_)
                                            (##vector-length _g254525254532_)
                                            '1)
                                        '2)
                                 (let* ((_e254529254553_
                                         (##vector-ref _g254525254532_ '0))
                                        (_actor254556_ _e254529254553_)
                                        (_e254530254558_
                                         (##vector-ref _g254525254532_ '1))
                                        (_proto254561_ _e254530254558_))
                                   (_K254528254550_
                                    _proto254561_
                                    _actor254556_))
                                 (_E254527254536_))))
                         _$e254519_)
                        (begin
                          (std/actor/rpc/connection#warnf
                           '"cannot route message; no actor binding ~a"
                           (std/misc/uuid#uuid->string _uuid254517_))
                          (let* ((_g254562254572_
                                  (##direct-structure-ref
                                   _msg254514_
                                   '1
                                   std/actor/message#message::t
                                   '#f))
                                 (_else254564254580_ (lambda () '#!void))
                                 (_K254566254585_
                                  (lambda (_k254583_)
                                    (_dispatch-remote-error254357_
                                     (##structure
                                      std/actor/proto#!error::t
                                      '"no binding"
                                      _k254583_)
                                     _uuid254517_))))
                            (if (##structure-direct-instance-of?
                                 _g254562254572_
                                 'std/actor/proto#!call::t)
                                (let* ((_e254569254588_
                                        (##vector-ref _g254562254572_ '1))
                                       (_e254570254591_
                                        (##vector-ref _g254562254572_ '2))
                                       (_k254594_ _e254570254591_))
                                  (_K254566254585_ _k254594_))
                                (if (##structure-direct-instance-of?
                                     _g254562254572_
                                     'std/actor/proto#!stream::t)
                                    (let* ((_e254567254596_
                                            (##vector-ref _g254562254572_ '1))
                                           (_e254568254599_
                                            (##vector-ref _g254562254572_ '2))
                                           (_k254602_ _e254568254599_))
                                      (_K254566254585_ _k254602_))
                                    '#!void))))))))
               (_dispatch-value254353_
                (lambda (_msg254445_ _buffer254446_)
                  (let* ((_content254448_
                          (##direct-structure-ref
                           _msg254445_
                           '1
                           std/actor/message#message::t
                           '#f))
                         (_cont254450_ (_value-k254355_ _content254448_)))
                    (let ((_$e254453_
                           (std/actor/rpc/connection#continuation-table-get
                            _cont-table254347_
                            _cont254450_)))
                      (if _$e254453_
                          ((lambda (_e254455254457_)
                             (let* ((_g254459254468_ _e254455254457_)
                                    (_E254461254472_
                                     (lambda ()
                                       (error '"No clause matching"
                                              _g254459254468_)))
                                    (_K254462254491_
                                     (lambda (_stream?254475_
                                              _k254476_
                                              _proto254477_
                                              _actor254478_)
                                       (if (_read-payload!254359_
                                            _msg254445_
                                            _buffer254446_
                                            _proto254477_)
                                           (begin
                                             (_value-k-set!254356_
                                              _content254448_
                                              _k254476_)
                                             (##direct-structure-set!
                                              _msg254445_
                                              (let ((__obj306779
                                                     (make-object
                                                      std/actor/proto#remote::t
                                                      '4)))
                                                (std/actor/proto#remote:::init!
                                                 __obj306779
                                                 _conn254343_
                                                 (##direct-structure-ref
                                                  _msg254445_
                                                  '3
                                                  std/actor/message#message::t
                                                  '#f)
                                                 _connaddr254344_
                                                 _proto254477_)
                                                __obj306779)
                                              '2
                                              std/actor/message#message::t
                                              '#f)
                                             (if (or (##structure-direct-instance-of?
                                                      _content254448_
                                                      'std/actor/proto#!yield::t)
                                                     (##structure-direct-instance-of?
                                                      _content254448_
                                                      'std/actor/proto#!sync::t))
                                                 (let ((_ok254489_
                                                        (let ((_mx254483_
                                                               (##unchecked-structure-ref
                                                                _cont-table254347_
                                                                '1
                                                                std/actor/rpc/connection#continuation-table::t
                                                                '#f)))
                                                          (mutex-lock!
                                                           _mx254483_)
                                                          (let ((_res254486_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (if (table-ref
                              (##unchecked-structure-ref
                               _cont-table254347_
                               '2
                               std/actor/rpc/connection#continuation-table::t
                               '#f)
                              _cont254450_
                              '#f)
                             (begin
                               (std/actor/message#send__0
                                _actor254478_
                                _msg254445_)
                               '#t)
                             '#f)))
                    (mutex-unlock! _mx254483_)
                    _res254486_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (if _ok254489_
                                                       '#!void
                                                       (if (##structure-direct-instance-of?
                                                            _content254448_
                                                            'std/actor/proto#!sync::t)
                                                           (_dispatch-remote-error254357_
                                                            (##structure
                                                             std/actor/proto#!abort::t
                                                             _cont254450_)
                                                            (##direct-structure-ref
                                                             _msg254445_
                                                             '3
                                                             std/actor/message#message::t
                                                             '#f))
                                                           '#!void)))
                                                 (if (std/actor/rpc/connection#continuation-table-remove!
                                                      _cont-table254347_
                                                      _cont254450_)
                                                     (std/actor/message#send__0
                                                      _actor254478_
                                                      _msg254445_)
                                                     '#!void)))
                                           (begin
                                             (if (std/actor/rpc/connection#continuation-table-remove!
                                                  _cont-table254347_
                                                  _cont254450_)
                                                 (std/actor/message#send-message__%
                                                  _actor254478_
                                                  (##structure
                                                   std/actor/proto#!error::t
                                                   (make-struct-instance
                                                    std/actor/proto#rpc-error::t
                                                    'rpc
                                                    '"unmarshal error")
                                                   _k254476_)
                                                  '#f
                                                  '#f)
                                                 '#!void)
                                             (if (##structure-direct-instance-of?
                                                  _content254448_
                                                  'std/actor/proto#!sync::t)
                                                 (_dispatch-remote-error254357_
                                                  (##structure
                                                   std/actor/proto#!abort::t
                                                   _cont254450_)
                                                  (##direct-structure-ref
                                                   _msg254445_
                                                   '3
                                                   std/actor/message#message::t
                                                   '#f))
                                                 '#!void))))))
                               (if (##fx= (if (##values? _g254459254468_)
                                              (##vector-length _g254459254468_)
                                              '1)
                                          '4)
                                   (let* ((_e254463254494_
                                           (##vector-ref _g254459254468_ '0))
                                          (_actor254497_ _e254463254494_)
                                          (_e254464254499_
                                           (##vector-ref _g254459254468_ '1))
                                          (_proto254502_ _e254464254499_)
                                          (_e254465254504_
                                           (##vector-ref _g254459254468_ '2))
                                          (_k254507_ _e254465254504_)
                                          (_e254466254509_
                                           (##vector-ref _g254459254468_ '3))
                                          (_stream?254512_ _e254466254509_))
                                     (_K254462254491_
                                      _stream?254512_
                                      _k254507_
                                      _proto254502_
                                      _actor254497_))
                                   (_E254461254472_))))
                           _$e254453_)
                          (begin
                            (std/actor/rpc/connection#warnf
                             '"cannot route message; unknown continuation ~a"
                             _cont254450_)
                            (if (##structure-direct-instance-of?
                                 _content254448_
                                 'std/actor/proto#!sync::t)
                                (_dispatch-remote-error254357_
                                 (##structure
                                  std/actor/proto#!abort::t
                                  _cont254450_)
                                 (##direct-structure-ref
                                  _msg254445_
                                  '3
                                  std/actor/message#message::t
                                  '#f))
                                '#!void)))))))
               (_dispatch-control254354_
                (lambda (_msg254407_ _buffer254408_)
                  (let* ((_content254410_
                          (##direct-structure-ref
                           _msg254407_
                           '1
                           std/actor/message#message::t
                           '#f))
                         (_cont254412_ (_value-k254355_ _content254410_))
                         (_stream254414_
                          (std/actor/rpc/connection#continuation-table-get-stream-actor
                           _cont-table254347_
                           _cont254412_)))
                    (if _stream254414_
                        (let* ((_stream254416254423_ _stream254414_)
                               (_E254418254427_
                                (lambda ()
                                  (error '"No clause matching"
                                         _stream254416254423_)))
                               (_K254419254433_
                                (lambda (_dest254430_ _actor254431_)
                                  (##direct-structure-set!
                                   _msg254407_
                                   _dest254430_
                                   '2
                                   std/actor/message#message::t
                                   '#f)
                                  (std/actor/message#send__0
                                   _actor254431_
                                   _msg254407_)
                                  (std/actor/rpc/connection#continuation-table-remove-stream-actor!
                                   _cont-table254347_
                                   _cont254412_))))
                          (if (##pair? _stream254416254423_)
                              (let ((_hd254420254436_
                                     (##car _stream254416254423_))
                                    (_tl254421254438_
                                     (##cdr _stream254416254423_)))
                                (let* ((_actor254441_ _hd254420254436_)
                                       (_dest254443_ _tl254421254438_))
                                  (_K254419254433_
                                   _dest254443_
                                   _actor254441_)))
                              (_E254418254427_)))
                        (begin
                          (std/actor/rpc/connection#warnf
                           '"unexpected control message; unknown stream ~a"
                           _cont254412_)
                          (if (##structure-direct-instance-of?
                               _content254410_
                               'std/actor/proto#!abort::t)
                              '#!void
                              (_dispatch-remote-error254357_
                               (##structure
                                std/actor/proto#!error::t
                                '"uknown stream"
                                _cont254412_)
                               (##direct-structure-ref
                                _msg254407_
                                '3
                                std/actor/message#message::t
                                '#f))))))))
               (_value-k254355_
                (lambda (_obj254405_)
                  (##vector-ref
                   _obj254405_
                   (fx- (##vector-length _obj254405_) '1))))
               (_value-k-set!254356_
                (lambda (_obj254402_ _k254403_)
                  (##vector-set!
                   _obj254402_
                   (fx- (##vector-length _obj254402_) '1)
                   _k254403_)))
               (_dispatch-remote-error254357_
                (lambda (_err254394_ _dest254395_)
                  (let* ((_msg254397_
                          (##structure
                           std/actor/message#message::t
                           _err254394_
                           '#!void
                           _dest254395_
                           '#f))
                         (_data254399_
                          (std/actor/rpc/proto/message#rpc-proto-marshal-message
                           _msg254397_
                           '#f)))
                    (thread-send _writer254348_ _data254399_))))
               (_read-envelope254358_
                (lambda (_buffer254382_)
                  (with-exception-catcher
                   (lambda (_g254383254385_)
                     (if ((lambda (_$obj254388_) (exception? _$obj254388_))
                          _g254383254385_)
                         (let ((_e254391_ _g254383254385_))
                           (std/actor/rpc/connection#errorf
                            '"read error: ~a"
                            _e254391_)
                           _e254391_)
                         (raise _g254383254385_)))
                   (lambda ()
                     (std/actor/rpc/proto/message#rpc-proto-read-envelope
                      _buffer254382_)))))
               (_read-payload!254359_
                (lambda (_msg254371_ _buffer254372_ _proto254373_)
                  (with-exception-catcher
                   (lambda (_g254374254376_)
                     (if '#t
                         (let ((_e254379_ _g254374254376_))
                           (std/actor/rpc/connection#errorf
                            '"unmarshal error: ~a"
                            _e254379_)
                           '#f)
                         (raise _g254374254376_)))
                   (lambda ()
                     (std/actor/rpc/proto/message#rpc-proto-read-payload!
                      _msg254371_
                      _buffer254372_
                      _proto254373_)))))
               (_run254360_
                (lambda ()
                  (call-with-parameters
                   (lambda () (_loop254351_ (make-u8vector '4096)))
                   std/actor/xdr#current-xdr-type-registry
                   std/actor/xdr#+xdr-default-type-registry+))))
        (with-exception-catcher
         (lambda (_g254361254363_)
           (if '#t
               (let ((_e254366_ _g254361254363_))
                 (std/actor/rpc/connection#errorf
                  '"unhandled exception: ~a"
                  _e254366_))
               (raise _g254361254363_)))
         (lambda () (_run254360_))))))
  (define std/actor/rpc/connection#rpc-options-timeout
    (lambda (_opts254330_ _default254331_)
      (letrec ((_timeout254333_
                (lambda (_dt254340_ _default254341_)
                  (if (real? _dt254340_)
                      (seconds->time (+ (##current-time-point) _dt254340_))
                      (if (time? _dt254340_)
                          _dt254340_
                          (if (not _dt254340_)
                              _dt254340_
                              (_timeout254333_ _default254341_ '#f)))))))
        (let ((_$e254335_ (if _opts254330_ (memq 'timeout: _opts254330_) '#f)))
          (if _$e254335_
              ((lambda (_plist254338_)
                 (_timeout254333_ (cadr _plist254338_) _default254331_))
               _$e254335_)
              (_timeout254333_ _default254331_ '#f))))))
  (define std/actor/rpc/connection#rpc-connection-shutdown
    (lambda (_rpc-server254232_)
      (std/actor/message#send-message__0
       _rpc-server254232_
       (##structure
        std/actor/proto#!event::t
        (##structure std/actor/rpc/base#rpc.connection-shutdown::t)))
      (let _lp254234_ ()
        (let _loop254236254238_ ()
          (let ((_next254242_ (thread-mailbox-next)))
            ((lambda (_msg254245_)
               (let* ((_msg254247254255_ _msg254245_)
                      (_else254250254263_ (lambda () (_loop254236254238_))))
                 (let ((_K254253254325_
                        (lambda (_msg254277_)
                          (thread-mailbox-extract-and-rewind)
                          (let* ((_msg254278254284_ _msg254277_)
                                 (_E254280254288_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _msg254278254284_)))
                                 (_K254281254317_
                                  (lambda (_content254291_)
                                    (let* ((_content254292254299_
                                            _content254291_)
                                           (_else254294254307_
                                            (lambda ()
                                              (std/actor/rpc/connection#rpc-send-error-response
                                               _msg254277_
                                               '"connection error")
                                              (_lp254234_)))
                                           (_K254296254311_
                                            (lambda ()
                                              (std/actor/rpc/connection#rpc-send-error-responses
                                               '"connection error"))))
                                      (if (##structure-direct-instance-of?
                                           _content254292254299_
                                           'std/actor/proto#!event::t)
                                          (let ((_e254297254314_
                                                 (##vector-ref
                                                  _content254292254299_
                                                  '1)))
                                            (if (##structure-direct-instance-of?
                                                 _e254297254314_
                                                 'std/actor#rpc.connection-close::t)
                                                (_K254296254311_)
                                                (_else254294254307_)))
                                          (_else254294254307_))))))
                            (if (##structure-direct-instance-of?
                                 _msg254278254284_
                                 'std/actor/message#message::t)
                                (let* ((_e254282254320_
                                        (##vector-ref _msg254278254284_ '1))
                                       (_content254323_ _e254282254320_))
                                  (_K254281254317_ _content254323_))
                                (_E254280254288_)))))
                       (_K254252254269_
                        (lambda (_ignore254267_)
                          (thread-mailbox-extract-and-rewind)
                          (_lp254234_))))
                   (if (##structure-direct-instance-of?
                        _msg254247254255_
                        'std/actor/message#message::t)
                       (let ((_msg254328_ _msg254247254255_))
                         (_K254253254325_ _msg254328_))
                       (let ((_ignore254272_ _msg254247254255_))
                         (_K254252254269_ _ignore254272_))))))
             _next254242_))))))
  (define std/actor/rpc/connection#rpc-connection-cleanup
    (lambda (_rpc-server254228_ _exn254229_ _sock254230_)
      (std/actor/rpc/connection#errorf '"connection error: ~a" _exn254229_)
      (if _sock254230_ (std/net/socket/api#ssocket-close _sock254230_) '#!void)
      (std/actor/rpc/connection#rpc-connection-shutdown _rpc-server254228_)))
  (define std/actor/rpc/connection#rpc-send-error-response
    (lambda (_msg254129_ _what254130_)
      (if (##structure-direct-instance-of?
           _msg254129_
           'std/actor/message#message::t)
          (let* ((_msg254131254139_ _msg254129_)
                 (_E254133254143_
                  (lambda () (error '"No clause matching" _msg254131254139_)))
                 (_K254134254210_
                  (lambda (_dest254146_ _src254147_ _content254148_)
                    (let* ((_content254149254162_ _content254148_)
                           (_else254152254170_ (lambda () '#!void)))
                      (let ((_K254156254191_
                             (lambda (_k254189_)
                               (std/actor/message#send-message__%
                                (##direct-structure-ref
                                 _msg254129_
                                 '2
                                 std/actor/message#message::t
                                 '#f)
                                (##structure
                                 std/actor/proto#!error::t
                                 (make-struct-instance
                                  std/actor/proto#rpc-error::t
                                  'rpc
                                  _what254130_)
                                 _k254189_)
                                '#f
                                '#f)))
                            (_K254154254178_
                             (lambda (_k254174_)
                               (let ((_abort254176_
                                      (##structure
                                       std/actor/message#message::t
                                       (##structure
                                        std/actor/proto#!abort::t
                                        _k254174_)
                                       _dest254146_
                                       _src254147_
                                       '#f)))
                                 (std/actor/message#send__0
                                  _src254147_
                                  _abort254176_)))))
                        (let* ((_try-match254151254186_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254149254162_
                                       'std/actor/proto#!yield::t)
                                      (let* ((_e254155254181_
                                              (##vector-ref
                                               _content254149254162_
                                               '1))
                                             (_k254184_ _e254155254181_))
                                        (_K254154254178_ _k254184_))
                                      '#!void)))
                               (___match306758306759_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254149254162_
                                       'std/actor/proto#!stream::t)
                                      (let* ((_e254157254202_
                                              (##vector-ref
                                               _content254149254162_
                                               '1))
                                             (_e254158254205_
                                              (##vector-ref
                                               _content254149254162_
                                               '2))
                                             (_k254208_ _e254158254205_))
                                        (_K254156254191_ _k254208_))
                                      (_try-match254151254186_)))))
                          (if (##structure-direct-instance-of?
                               _content254149254162_
                               'std/actor/proto#!call::t)
                              (let* ((_e254159254194_
                                      (##vector-ref _content254149254162_ '1))
                                     (_e254160254197_
                                      (##vector-ref _content254149254162_ '2))
                                     (_k254200_ _e254160254197_))
                                (_K254156254191_ _k254200_))
                              (___match306758306759_))))))))
            (if (##structure-direct-instance-of?
                 _msg254131254139_
                 'std/actor/message#message::t)
                (let* ((_e254135254213_ (##vector-ref _msg254131254139_ '1))
                       (_content254216_ _e254135254213_)
                       (_e254136254218_ (##vector-ref _msg254131254139_ '2))
                       (_src254221_ _e254136254218_)
                       (_e254137254223_ (##vector-ref _msg254131254139_ '3))
                       (_dest254226_ _e254137254223_))
                  (_K254134254210_ _dest254226_ _src254221_ _content254216_))
                (_E254133254143_)))
          '#!void)))
  (define std/actor/rpc/connection#rpc-send-error-responses
    (lambda (_what254076_)
      (let _lp254078_ ()
        (let _loop254080254082_ ()
          (let ((_next254086_ (std/actor/message#mailbox-next)))
            (if (eq? _next254086_ std/actor/message#mailbox-empty)
                ((lambda () (thread-mailbox-rewind) '#!void))
                ((lambda (_msg254090_)
                   (let* ((_msg254092254100_ _msg254090_)
                          (_else254095254108_
                           (lambda () (_loop254080254082_))))
                     (let ((_K254098254124_
                            (lambda (_msg254122_)
                              (thread-mailbox-extract-and-rewind)
                              (std/actor/rpc/connection#rpc-send-error-response
                               _msg254122_
                               _what254076_)
                              (_lp254078_)))
                           (_K254097254114_
                            (lambda (_ignore254112_)
                              (thread-mailbox-extract-and-rewind)
                              (_lp254078_))))
                       (if (##structure-direct-instance-of?
                            _msg254092254100_
                            'std/actor/message#message::t)
                           (let ((_msg254127_ _msg254092254100_))
                             (_K254098254124_ _msg254127_))
                           (let ((_ignore254117_ _msg254092254100_))
                             (_K254097254114_ _ignore254117_))))))
                 _next254086_))))))))
