(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/proto/cipher#::digest-type
    std/crypto/digest#digest::sha256)
  (define std/actor/rpc/proto/cipher#::digest-size
    (std/crypto/digest#digest-size std/actor/rpc/proto/cipher#::digest-type))
  (define std/actor/rpc/proto/cipher#::cipher-type
    std/crypto/cipher#cipher::aes-128-cbc)
  (define std/actor/rpc/proto/cipher#::cipher-key-length
    (std/crypto/cipher#cipher-key-length
     std/actor/rpc/proto/cipher#::cipher-type))
  (define std/actor/rpc/proto/cipher#::cipher-iv-length
    (std/crypto/cipher#cipher-iv-length
     std/actor/rpc/proto/cipher#::cipher-type))
  (define std/actor/rpc/proto/cipher#::cipher-block-size
    (std/crypto/cipher#cipher-block-size
     std/actor/rpc/proto/cipher#::cipher-type))
  (define std/actor/rpc/proto/cipher#::DH::new std/crypto/dh#DH-get-1024-160)
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
    (lambda (_ibuf253816_ _obuf253817_)
      (let* ((_dh253819_ (std/actor/rpc/proto/cipher#::DH::new))
             (_g306559_ (std/crypto/dh#DH-generate-key _dh253819_))
             (_pubk253822_ (std/crypto/libcrypto#DH_pub_key _dh253819_))
             (_bytes253824_ (std/crypto/bn#BN->bytes _pubk253822_)))
        (std/net/bio/output#bio-write-u8
         std/actor/rpc/proto/message#rpc-proto-key-exchange
         _obuf253817_)
        (std/net/bio/output#bio-write-u32
         (u8vector-length _bytes253824_)
         _obuf253817_)
        (std/net/bio/output#bio-write-bytes _bytes253824_ _obuf253817_)
        (std/net/bio/output#bio-force-output _obuf253817_)
        (let ((_e253827_ (std/net/bio/input#bio-read-u8 _ibuf253816_)))
          (if (eq? _e253827_
                   std/actor/rpc/proto/message#rpc-proto-key-exchange)
              (let* ((_sz253829_ (std/net/bio/input#bio-read-u32 _ibuf253816_))
                     (_g306560_
                      (if (fx> _sz253829_ '1024)
                          (std/actor/proto#raise-rpc-io-error
                           'rpc-proto-key-exchange
                           '"inordinately sized key"
                           _sz253829_)
                          '#!void))
                     (_bytes253832_ (make-u8vector _sz253829_))
                     (_g306561_
                      (std/net/bio/input#bio-read-bytes
                       _bytes253832_
                       _ibuf253816_))
                     (_peerk253835_
                      (std/crypto/bn#bytes->BN__0 _bytes253832_)))
                (std/crypto/dh#DH-compute-key _dh253819_ _peerk253835_))
              (if (eof-object? _e253827_)
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-key-exchange
                   '"connection closed")
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-key-exchange
                   '"key exchange error"
                   _e253827_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
    (lambda (_secret253802_)
      (let ((_key253804_
             (subu8vector
              _secret253802_
              '0
              std/actor/rpc/proto/cipher#::cipher-key-length))
            (_hmac253805_
             (make-u8vector std/actor/rpc/proto/cipher#::digest-size))
            (_iv253806_
             (make-u8vector std/actor/rpc/proto/cipher#::cipher-iv-length))
            (_ctext253807_ (box (make-u8vector '4096))))
        (lambda (_g253808253811_ _g253809253813_)
          (std/actor/rpc/proto/cipher#rpc-cipher-proto-read
           _g253808253811_
           _g253809253813_
           _secret253802_
           _key253804_
           _hmac253805_
           _iv253806_
           _ctext253807_)))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-read
    (lambda (_ibuf253763_
             _bytes253764_
             _secret253765_
             _key253766_
             _hmac253767_
             _iv253768_
             _ctext253769_)
      (let ((_e253771_ (std/net/bio/input#bio-read-u8 _ibuf253763_)))
        (if (eq? _e253771_ std/actor/rpc/proto/message#rpc-proto-message)
            (let* ((_digest253773_
                    (let ((__obj306553
                           (make-object std/crypto/digest#digest::t '2)))
                      (std/crypto/digest#digest:::init!
                       __obj306553
                       std/actor/rpc/proto/cipher#::digest-type)
                      __obj306553))
                   (_cipher253775_
                    (let ((__obj306554
                           (make-object std/crypto/cipher#cipher::t '2)))
                      (std/crypto/cipher#cipher:::init!
                       __obj306554
                       std/actor/rpc/proto/cipher#::cipher-type)
                      __obj306554))
                   (_g306562_
                    (std/net/bio/input#bio-read-bytes
                     _hmac253767_
                     _ibuf253763_))
                   (_g306563_
                    (std/net/bio/input#bio-read-bytes _iv253768_ _ibuf253763_))
                   (_size253779_ (std/net/bio/input#bio-read-u32 _ibuf253763_))
                   (_g306564_
                    (if (fx<= _size253779_
                              std/actor/rpc/proto/message#rpc-proto-message-max-length)
                        '#!void
                        (std/actor/proto#raise-rpc-io-error
                         'rpc-proto-read
                         '"message too large"
                         _size253779_)))
                   (_ctext253786_
                    (let ((_buf253782_ (unbox _ctext253769_)))
                      (if (fx< (u8vector-length _buf253782_) _size253779_)
                          (let ((_buf253784_ (make-u8vector _size253779_)))
                            (set-box! _ctext253769_ _buf253784_)
                            _buf253784_)
                          _buf253782_)))
                   (_rd253788_
                    (std/net/bio/input#bio-read-subu8vector-unbuffered
                     _ctext253786_
                     '0
                     _size253779_
                     _ibuf253763_))
                   (_g306565_
                    (if (fx< _rd253788_ _size253779_)
                        (std/actor/proto#raise-rpc-io-error
                         'rpc-proto-read
                         '"incomplete message"
                         _rd253788_
                         _size253779_)
                        '#!void))
                   (_g306566_
                    (std/crypto/digest#digest-update!__0
                     _digest253773_
                     _secret253765_))
                   (_g306567_
                    (std/crypto/digest#digest-update!__0
                     _digest253773_
                     _iv253768_))
                   (_g306568_
                    (std/crypto/digest#digest-update!__%
                     _digest253773_
                     _ctext253786_
                     '0
                     _size253779_))
                   (_hmac*253794_
                    (std/crypto/digest#digest-final!__0 _digest253773_))
                   (_g306569_
                    (if (equal? _hmac253767_ _hmac*253794_)
                        '#!void
                        (std/actor/proto#raise-rpc-io-error
                         'rpc-proto-read
                         '"HMAC failure")))
                   (_bytes253797_
                    (if (fx< (u8vector-length _bytes253764_) _size253779_)
                        (make-u8vector _size253779_)
                        _bytes253764_))
                   (_len253799_
                    (std/crypto/cipher#decrypt-u8vector!
                     _cipher253775_
                     _key253766_
                     _iv253768_
                     _ctext253786_
                     '0
                     _size253779_
                     _bytes253797_)))
              (values _bytes253797_ _len253799_))
            (if (eq? _e253771_
                     std/actor/rpc/proto/message#rpc-proto-keep-alive)
                '#!void
                (if (eof-object? _e253771_)
                    _e253771_
                    (std/actor/proto#raise-rpc-io-error
                     'rpc-proto-read
                     '"bad message"
                     _e253771_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
    (lambda (_secret253750_)
      (let ((_key253752_
             (subu8vector
              _secret253750_
              '0
              std/actor/rpc/proto/cipher#::cipher-key-length))
            (_iv253753_
             (make-u8vector std/actor/rpc/proto/cipher#::cipher-iv-length))
            (_ctext253754_ (box (make-u8vector '4096))))
        (lambda (_g253755253758_ _g253756253760_)
          (std/actor/rpc/proto/cipher#rpc-cipher-proto-write
           _g253755253758_
           _g253756253760_
           _secret253750_
           _key253752_
           _iv253753_
           _ctext253754_)))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-write
    (lambda (_obuf253685_
             _obj253686_
             _secret253687_
             _key253688_
             _iv253689_
             _ctext253690_)
      (if (eq? _obj253686_ '#!void)
          (begin
            (std/net/bio/output#bio-write-u8
             std/actor/rpc/proto/message#rpc-proto-keep-alive
             _obuf253685_)
            (std/net/bio/output#bio-force-output _obuf253685_))
          (if (u8vector? _obj253686_)
              (begin
                (std/net/bio/output#bio-write-u8
                 std/actor/rpc/proto/message#rpc-proto-message
                 _obuf253685_)
                (let* ((_digest253692_
                        (let ((__obj306555
                               (make-object std/crypto/digest#digest::t '2)))
                          (std/crypto/digest#digest:::init!
                           __obj306555
                           std/actor/rpc/proto/cipher#::digest-type)
                          __obj306555))
                       (_cipher253694_
                        (let ((__obj306556
                               (make-object std/crypto/cipher#cipher::t '2)))
                          (std/crypto/cipher#cipher:::init!
                           __obj306556
                           std/actor/rpc/proto/cipher#::cipher-type)
                          __obj306556))
                       (_g306570_ (std/crypto/etc#random-bytes!__0 _iv253689_))
                       (_plen253697_ (u8vector-length _obj253686_))
                       (_maxlen253699_
                        (fx+ _plen253697_
                             std/actor/rpc/proto/cipher#::cipher-block-size))
                       (_ctext253705_
                        (let ((_buf253701_ (unbox _ctext253690_)))
                          (if (fx< (u8vector-length _buf253701_)
                                   _maxlen253699_)
                              (let ((_buf253703_
                                     (make-u8vector _maxlen253699_)))
                                (set-box! _ctext253690_ _buf253703_)
                                _buf253703_)
                              _buf253701_)))
                       (_clen253707_
                        (std/crypto/cipher#encrypt-u8vector!
                         _cipher253694_
                         _key253688_
                         _iv253689_
                         _obj253686_
                         '0
                         _plen253697_
                         _ctext253705_))
                       (_g306571_
                        (std/crypto/digest#digest-update!__0
                         _digest253692_
                         _secret253687_))
                       (_g306572_
                        (std/crypto/digest#digest-update!__0
                         _digest253692_
                         _iv253689_))
                       (_g306573_
                        (std/crypto/digest#digest-update!__%
                         _digest253692_
                         _ctext253705_
                         '0
                         _clen253707_))
                       (_hmac253712_
                        (std/crypto/digest#digest-final!__0 _digest253692_)))
                  (std/net/bio/output#bio-write-bytes
                   _hmac253712_
                   _obuf253685_)
                  (std/net/bio/output#bio-write-bytes _iv253689_ _obuf253685_)
                  (std/net/bio/output#bio-write-u32 _clen253707_ _obuf253685_)
                  (std/net/bio/output#bio-write-subu8vector
                   _ctext253705_
                   '0
                   _clen253707_
                   _obuf253685_)
                  (std/net/bio/output#bio-force-output _obuf253685_)))
              (if (##structure-instance-of?
                   _obj253686_
                   'std/net/bio/buffer#chunked-output-buffer::t)
                  (begin
                    (std/net/bio/output#bio-write-u8
                     std/actor/rpc/proto/message#rpc-proto-message
                     _obuf253685_)
                    (let* ((_digest253715_
                            (let ((__obj306557
                                   (make-object
                                    std/crypto/digest#digest::t
                                    '2)))
                              (std/crypto/digest#digest:::init!
                               __obj306557
                               std/actor/rpc/proto/cipher#::digest-type)
                              __obj306557))
                           (_cipher253717_
                            (let ((__obj306558
                                   (make-object
                                    std/crypto/cipher#cipher::t
                                    '2)))
                              (std/crypto/cipher#cipher:::init!
                               __obj306558
                               std/actor/rpc/proto/cipher#::cipher-type)
                              __obj306558))
                           (_g306574_
                            (std/crypto/etc#random-bytes!__0 _iv253689_))
                           (_plen253720_
                            (std/net/bio/buffer#chunked-output-length
                             _obj253686_))
                           (_chunks253722_
                            (std/net/bio/buffer#chunked-output-chunks
                             _obj253686_))
                           (_maxlen253724_
                            (fx+ _plen253720_
                                 std/actor/rpc/proto/cipher#::cipher-block-size))
                           (_ctext253730_
                            (let ((_buf253726_ (unbox _ctext253690_)))
                              (if (fx< (u8vector-length _buf253726_)
                                       _maxlen253724_)
                                  (let ((_buf253728_
                                         (make-u8vector _maxlen253724_)))
                                    (set-box! _ctext253690_ _buf253728_)
                                    _buf253728_)
                                  _buf253726_)))
                           (_g306575_
                            (std/crypto/cipher#encrypt-init!
                             _cipher253717_
                             _key253688_
                             _iv253689_))
                           (_clen253738_
                            (foldl1 (lambda (_chunk253733_ _r253734_)
                                      (let ((_count253736_
                                             (std/crypto/cipher#encrypt-update!
                                              _cipher253717_
                                              _ctext253730_
                                              _r253734_
                                              _chunk253733_
                                              '0
                                              (u8vector-length
                                               _chunk253733_))))
                                        (fx+ _r253734_ _count253736_)))
                                    '0
                                    _chunks253722_))
                           (_flen253740_
                            (std/crypto/cipher#encrypt-final!__%
                             _cipher253717_
                             _ctext253730_
                             _clen253738_))
                           (_clen253742_ (fx+ _clen253738_ _flen253740_))
                           (_g306576_
                            (std/crypto/digest#digest-update!__0
                             _digest253715_
                             _secret253687_))
                           (_g306577_
                            (std/crypto/digest#digest-update!__0
                             _digest253715_
                             _iv253689_))
                           (_g306578_
                            (std/crypto/digest#digest-update!__%
                             _digest253715_
                             _ctext253730_
                             '0
                             _clen253742_))
                           (_hmac253747_
                            (std/crypto/digest#digest-final!__0
                             _digest253715_)))
                      (std/net/bio/output#bio-write-bytes
                       _hmac253747_
                       _obuf253685_)
                      (std/net/bio/output#bio-write-bytes
                       _iv253689_
                       _obuf253685_)
                      (std/net/bio/output#bio-write-u32
                       _clen253742_
                       _obuf253685_)
                      (std/net/bio/output#bio-write-subu8vector
                       _ctext253730_
                       '0
                       _clen253742_
                       _obuf253685_)
                      (std/net/bio/output#bio-force-output _obuf253685_)))
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-write
                   '"unexpected object"
                   _obj253686_))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-accept
    (lambda (_ibuf253677_ _obuf253678_)
      (std/actor/rpc/proto/null#rpc-proto-accept-e
       _ibuf253677_
       _obuf253678_
       std/actor/rpc/proto/message#rpc-proto-cipher
       (lambda (_ibuf253680_ _obuf253681_)
         (let ((_secret253683_
                (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                 _ibuf253680_
                 _obuf253681_)))
           (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                    _secret253683_)
                   (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                    _secret253683_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-connect
    (lambda (_ibuf253669_ _obuf253670_)
      (std/actor/rpc/proto/null#rpc-proto-connect-e
       _ibuf253669_
       _obuf253670_
       std/actor/rpc/proto/message#rpc-proto-cipher
       (lambda (_ibuf253672_ _obuf253673_)
         (let ((_secret253675_
                (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                 _ibuf253672_
                 _obuf253673_)))
           (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                    _secret253675_)
                   (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                    _secret253675_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-accept
    (lambda (_ibuf253660_ _obuf253661_ _cookie253662_)
      (std/actor/rpc/proto/null#rpc-proto-accept-e
       _ibuf253660_
       _obuf253661_
       std/actor/rpc/proto/message#rpc-proto-cookie-cipher
       (lambda (_ibuf253664_ _obuf253665_)
         (std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge
          _ibuf253664_
          _obuf253665_
          _cookie253662_)
         (let ((_secret253667_
                (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                 _ibuf253664_
                 _obuf253665_)))
           (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                    _secret253667_)
                   (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                    _secret253667_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-connect
    (lambda (_ibuf253649_ _obuf253650_ _cookie253651_)
      (std/actor/rpc/proto/null#rpc-proto-connect-e
       _ibuf253649_
       _obuf253650_
       std/actor/rpc/proto/message#rpc-proto-cookie-cipher
       (lambda (_ibuf253653_ _obuf253654_)
         (let ((_e253656_ (std/net/bio/input#bio-read-u8 _ibuf253653_)))
           (if (eq? _e253656_ std/actor/rpc/proto/message#rpc-proto-challenge)
               (begin
                 (std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge-respond
                  _ibuf253653_
                  _obuf253654_
                  _cookie253651_)
                 (let ((_secret253658_
                        (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                         _ibuf253653_
                         _obuf253654_)))
                   (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                            _secret253658_)
                           (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                            _secret253658_))))
               (if (eof-object? _e253656_)
                   (std/actor/proto#raise-rpc-io-error
                    'rpc-proto-connect
                    '"connect closed")
                   (std/actor/proto#raise-rpc-io-error
                    'rpc-proto-connect
                    '"bad hello"
                    _e253656_))))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto
    (lambda ()
      (##structure
       std/actor/rpc/base#!rpc-protocol::t
       std/actor/rpc/proto/cipher#rpc-cipher-proto-accept
       std/actor/rpc/proto/cipher#rpc-cipher-proto-connect)))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__%
    (lambda (_cookie-file253622_)
      (let ((_cookie253624_ (call-with-input-file _cookie-file253622_ read)))
        (if (u8vector? _cookie253624_)
            (##structure
             std/actor/rpc/base#!rpc-protocol::t
             (lambda (_g253625253628_ _g253626253630_)
               (std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-connect
                _g253625253628_
                _g253626253630_
                _cookie253624_))
             (lambda (_g253632253635_ _g253633253637_)
               (std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-accept
                _g253632253635_
                _g253633253637_
                _cookie253624_)))
            (error '"Invalid cookie; expected u8vector"
                   _cookie-file253622_
                   _cookie253624_)))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__0
    (lambda ()
      (let ((_cookie-file253644_ '"~/.gerbil/cookie"))
        (std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__%
         _cookie-file253644_))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto
    (lambda _g306580_
      (let ((_g306579_ (##length _g306580_)))
        (cond ((##fx= _g306579_ 0)
               (apply std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__0
                      _g306580_))
              ((##fx= _g306579_ 1)
               (apply std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__%
                      _g306580_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto
                _g306580_)))))))
