(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/cipher#cipher::t
    (make-struct-type
     'std/crypto#cipher::t
     '#f
     '2
     'cipher
     '()
     ':init!
     '(type ctx)))
  (define std/crypto/cipher#cipher?
    (make-struct-predicate std/crypto/cipher#cipher::t))
  (define std/crypto/cipher#make-cipher
    (lambda _$args209014_
      (apply make-struct-instance std/crypto/cipher#cipher::t _$args209014_)))
  (define std/crypto/cipher#cipher-type
    (make-struct-field-accessor std/crypto/cipher#cipher::t '0))
  (define std/crypto/cipher#cipher-ctx
    (make-struct-field-accessor std/crypto/cipher#cipher::t '1))
  (define std/crypto/cipher#cipher-type-set!
    (make-struct-field-mutator std/crypto/cipher#cipher::t '0))
  (define std/crypto/cipher#cipher-ctx-set!
    (make-struct-field-mutator std/crypto/cipher#cipher::t '1))
  (define std/crypto/cipher#cipher:::init!
    (lambda (_self209009_ _type209010_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _type209010_)
          '#!void
          (error '"Invalid cipher" _type209010_))
      (let ((_ctx209012_ (std/crypto/libcrypto#EVP_CIPHER_CTX_create)))
        (if _ctx209012_ '#!void (error '"Failed to allocate cipher context"))
        (if (let ((__tmp297449
                   (let ()
                     (declare (not safe))
                     (##vector-length _self209009_))))
              (declare (not safe))
              (##fx< '2 __tmp297449))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self209009_ '1 _type209010_))
              (let ()
                (declare (not safe))
                (##vector-set! _self209009_ '2 _ctx209012_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self209009_)))))
  (bind-method!
   std/crypto/cipher#cipher::t
   ':init!
   std/crypto/cipher#cipher:::init!
   '#f)
  (define std/crypto/cipher#cipher-name
    (lambda (_cipher208885_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher208885_)
          (std/crypto/libcrypto#EVP_CIPHER_name _cipher208885_)
          (std/crypto/libcrypto#EVP_CIPHER_name
           (##structure-ref
            _cipher208885_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-block-size
    (lambda (_cipher208883_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher208883_)
          (std/crypto/libcrypto#EVP_CIPHER_block_size _cipher208883_)
          (std/crypto/libcrypto#EVP_CIPHER_block_size
           (##structure-ref
            _cipher208883_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-key-length
    (lambda (_cipher208881_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher208881_)
          (std/crypto/libcrypto#EVP_CIPHER_key_length _cipher208881_)
          (std/crypto/libcrypto#EVP_CIPHER_key_length
           (##structure-ref
            _cipher208881_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-iv-length
    (lambda (_cipher208879_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher208879_)
          (std/crypto/libcrypto#EVP_CIPHER_iv_length _cipher208879_)
          (std/crypto/libcrypto#EVP_CIPHER_iv_length
           (##structure-ref
            _cipher208879_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-copy
    (lambda (_cipher208869_)
      (let* ((_ctx208871_ (std/crypto/cipher#cipher-context _cipher208869_))
             (_copy208873_
              (let ((__obj297404 (make-object std/crypto/cipher#cipher::t '2)))
                (std/crypto/cipher#cipher:::init!
                 __obj297404
                 (##structure-ref
                  _cipher208869_
                  '1
                  std/crypto/cipher#cipher::t
                  '#f))
                __obj297404)))
        (let ((_res208876_
               (std/crypto/libcrypto#EVP_CIPHER_CTX_copy
                (##structure-ref
                 _copy208873_
                 '2
                 std/crypto/cipher#cipher::t
                 '#f)
                _ctx208871_)))
          (if (let () (declare (not safe)) (##fxzero? _res208876_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        _copy208873_)))
  (define std/crypto/cipher#cipher-context
    (lambda (_cipher208864_)
      (let ((_$e208866_
             (##structure-ref
              _cipher208864_
              '2
              std/crypto/cipher#cipher::t
              '#f)))
        (if _$e208866_
            _$e208866_
            (error '"Cipher has been finalized" _cipher208864_)))))
  (define std/crypto/cipher#cipher-check-key+iv-length
    (lambda (_cipher208860_ _key208861_ _iv208862_)
      (if (= (std/crypto/cipher#cipher-key-length
              (##structure-ref
               _cipher208860_
               '1
               std/crypto/cipher#cipher::t
               '#f))
             (u8vector-length _key208861_))
          '#!void
          (error '"Bad cipher key; key length mismatch"))
      (if (= (std/crypto/cipher#cipher-iv-length
              (##structure-ref
               _cipher208860_
               '1
               std/crypto/cipher#cipher::t
               '#f))
             (u8vector-length _iv208862_))
          '#!void
          (error '"Bad cipher iv; iv length mismatch"))))
  (define std/crypto/cipher#cipher-init!
    (lambda (_cipher208852_ _key208853_ _iv208854_ _EVP-init208855_)
      (std/crypto/cipher#cipher-check-key+iv-length
       _cipher208852_
       _key208853_
       _iv208854_)
      (let ((_res208857_
             (_EVP-init208855_
              (std/crypto/cipher#cipher-context _cipher208852_)
              (##structure-ref
               _cipher208852_
               '1
               std/crypto/cipher#cipher::t
               '#f)
              _key208853_
              _iv208854_)))
        (if (let () (declare (not safe)) (##fxzero? _res208857_))
            (apply std/crypto/etc#raise-libcrypto-error '())
            '#!void))))
  (define std/crypto/cipher#cipher-update!
    (lambda (_ctx208842_
             _out208843_
             _out-start208844_
             _in208845_
             _start208846_
             _end208847_
             _EVP-update208848_)
      (let ((_r208850_
             (_EVP-update208848_
              _ctx208842_
              _out208843_
              _out-start208844_
              _in208845_
              _start208846_
              _end208847_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r208850_)))
            _r208850_
            (std/crypto/etc#raise-libcrypto-error _ctx208842_)))))
  (define std/crypto/cipher#cipher-final!
    (lambda (_ctx208835_ _out208836_ _out-start208837_ _EVP-final208838_)
      (let ((_r208840_
             (_EVP-final208838_ _ctx208835_ _out208836_ _out-start208837_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r208840_)))
            _r208840_
            (std/crypto/etc#raise-libcrypto-error _ctx208835_)))))
  (define std/crypto/cipher#encrypt-init!
    (lambda (_cipher208831_ _key208832_ _iv208833_)
      (std/crypto/cipher#cipher-init!
       _cipher208831_
       _key208832_
       _iv208833_
       std/crypto/libcrypto#EVP_EncryptInit)))
  (define std/crypto/cipher#encrypt-update!
    (lambda (_cipher208824_
             _out208825_
             _out-start208826_
             _in208827_
             _start208828_
             _end208829_)
      (std/crypto/cipher#cipher-update!
       (std/crypto/cipher#cipher-context _cipher208824_)
       _out208825_
       _out-start208826_
       _in208827_
       _start208828_
       _end208829_
       std/crypto/libcrypto#EVP_EncryptUpdate)))
  (define std/crypto/cipher#encrypt-final!__%
    (lambda (_cipher208806_ _out208807_ _out-start208808_)
      (let ((_olen208810_
             (std/crypto/cipher#cipher-final!
              (std/crypto/cipher#cipher-context _cipher208806_)
              _out208807_
              _out-start208808_
              std/crypto/libcrypto#EVP_EncryptFinal)))
        (##structure-set!
         _cipher208806_
         '#f
         '2
         std/crypto/cipher#cipher::t
         '#f)
        _olen208810_)))
  (define std/crypto/cipher#encrypt-final!__0
    (lambda (_cipher208815_ _out208816_)
      (let ((_out-start208818_ '0))
        (std/crypto/cipher#encrypt-final!__%
         _cipher208815_
         _out208816_
         _out-start208818_))))
  (define std/crypto/cipher#encrypt-final!
    (lambda _g297451_
      (let ((_g297450_ (let () (declare (not safe)) (##length _g297451_))))
        (cond ((let () (declare (not safe)) (##fx= _g297450_ 2))
               (apply std/crypto/cipher#encrypt-final!__0 _g297451_))
              ((let () (declare (not safe)) (##fx= _g297450_ 3))
               (apply std/crypto/cipher#encrypt-final!__% _g297451_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#encrypt-final!
                _g297451_))))))
  (define std/crypto/cipher#decrypt-init!
    (lambda (_cipher208801_ _key208802_ _iv208803_)
      (std/crypto/cipher#cipher-init!
       _cipher208801_
       _key208802_
       _iv208803_
       std/crypto/libcrypto#EVP_DecryptInit)))
  (define std/crypto/cipher#decrypt-update!
    (lambda (_cipher208794_
             _out208795_
             _out-start208796_
             _in208797_
             _start208798_
             _end208799_)
      (std/crypto/cipher#cipher-update!
       (std/crypto/cipher#cipher-context _cipher208794_)
       _out208795_
       _out-start208796_
       _in208797_
       _start208798_
       _end208799_
       std/crypto/libcrypto#EVP_DecryptUpdate)))
  (define std/crypto/cipher#decrypt-final!__%
    (lambda (_cipher208776_ _out208777_ _out-start208778_)
      (let ((_olen208780_
             (std/crypto/cipher#cipher-final!
              (std/crypto/cipher#cipher-context _cipher208776_)
              _out208777_
              _out-start208778_
              std/crypto/libcrypto#EVP_DecryptFinal)))
        (##structure-set!
         _cipher208776_
         '#f
         '2
         std/crypto/cipher#cipher::t
         '#f)
        _olen208780_)))
  (define std/crypto/cipher#decrypt-final!__0
    (lambda (_cipher208785_ _out208786_)
      (let ((_out-start208788_ '0))
        (std/crypto/cipher#decrypt-final!__%
         _cipher208785_
         _out208786_
         _out-start208788_))))
  (define std/crypto/cipher#decrypt-final!
    (lambda _g297453_
      (let ((_g297452_ (let () (declare (not safe)) (##length _g297453_))))
        (cond ((let () (declare (not safe)) (##fx= _g297452_ 2))
               (apply std/crypto/cipher#decrypt-final!__0 _g297453_))
              ((let () (declare (not safe)) (##fx= _g297452_ 3))
               (apply std/crypto/cipher#decrypt-final!__% _g297453_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#decrypt-final!
                _g297453_))))))
  (define std/crypto/cipher#encrypt
    (lambda (_cipher208770_ _key208771_ _iv208772_ _in208773_)
      (if (string? _in208773_)
          (std/crypto/cipher#encrypt-u8vector__0
           _cipher208770_
           _key208771_
           _iv208772_
           (std/text/utf8#string->utf8__0 _in208773_))
          (if (u8vector? _in208773_)
              (std/crypto/cipher#encrypt-u8vector__0
               _cipher208770_
               _key208771_
               _iv208772_
               _in208773_)
              (if (input-port? _in208773_)
                  (std/crypto/cipher#encrypt-port
                   _cipher208770_
                   _key208771_
                   _iv208772_
                   _in208773_)
                  (error '"Bad input source" _in208773_))))))
  (define std/crypto/cipher#encrypt-u8vector__%
    (lambda (_cipher208716_
             _key208717_
             _iv208718_
             _in208719_
             _start208720_
             _end208721_)
      (let* ((_len208723_
              (let () (declare (not safe)) (##fx- _end208721_ _start208720_)))
             (_buflen208726_
              (let ((__tmp297454
                     (let ((__tmp297455
                            (std/crypto/cipher#cipher-block-size
                             _cipher208716_)))
                       (declare (not safe))
                       (##fx* '2 __tmp297455))))
                (declare (not safe))
                (##fx+ _len208723_ __tmp297454)))
             (_buf208729_ (make-u8vector _buflen208726_)))
        (std/crypto/cipher#encrypt-init! _cipher208716_ _key208717_ _iv208718_)
        (let* ((_ulen208733_
                (std/crypto/cipher#encrypt-update!
                 _cipher208716_
                 _buf208729_
                 '0
                 _in208719_
                 _start208720_
                 _end208721_))
               (_flen208736_
                (std/crypto/cipher#encrypt-final!__%
                 _cipher208716_
                 _buf208729_
                 _ulen208733_))
               (_olen208739_
                (let ()
                  (declare (not safe))
                  (##fx+ _ulen208733_ _flen208736_))))
          (if (let () (declare (not safe)) (##fx< _olen208739_ _buflen208726_))
              (u8vector-shrink! _buf208729_ _olen208739_)
              '#!void)
          _buf208729_))))
  (define std/crypto/cipher#encrypt-u8vector__0
    (lambda (_cipher208746_ _key208747_ _iv208748_ _in208749_)
      (let* ((_start208751_ '0) (_end208753_ (u8vector-length _in208749_)))
        (std/crypto/cipher#encrypt-u8vector__%
         _cipher208746_
         _key208747_
         _iv208748_
         _in208749_
         _start208751_
         _end208753_))))
  (define std/crypto/cipher#encrypt-u8vector__1
    (lambda (_cipher208755_ _key208756_ _iv208757_ _in208758_ _start208759_)
      (let ((_end208761_ (u8vector-length _in208758_)))
        (std/crypto/cipher#encrypt-u8vector__%
         _cipher208755_
         _key208756_
         _iv208757_
         _in208758_
         _start208759_
         _end208761_))))
  (define std/crypto/cipher#encrypt-u8vector
    (lambda _g297457_
      (let ((_g297456_ (let () (declare (not safe)) (##length _g297457_))))
        (cond ((let () (declare (not safe)) (##fx= _g297456_ 4))
               (apply std/crypto/cipher#encrypt-u8vector__0 _g297457_))
              ((let () (declare (not safe)) (##fx= _g297456_ 5))
               (apply std/crypto/cipher#encrypt-u8vector__1 _g297457_))
              ((let () (declare (not safe)) (##fx= _g297456_ 6))
               (apply std/crypto/cipher#encrypt-u8vector__% _g297457_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#encrypt-u8vector
                _g297457_))))))
  (define std/crypto/cipher#encrypt-u8vector!
    (lambda (_cipher208700_
             _key208701_
             _iv208702_
             _bytes208703_
             _start208704_
             _end208705_
             _buf208706_)
      (std/crypto/cipher#encrypt-init! _cipher208700_ _key208701_ _iv208702_)
      (let* ((_ulen208708_
              (std/crypto/cipher#encrypt-update!
               _cipher208700_
               _buf208706_
               '0
               _bytes208703_
               _start208704_
               _end208705_))
             (_flen208710_
              (std/crypto/cipher#encrypt-final!__%
               _cipher208700_
               _buf208706_
               _ulen208708_))
             (_olen208712_
              (let () (declare (not safe)) (##fx+ _ulen208708_ _flen208710_))))
        _olen208712_)))
  (define std/crypto/cipher#encrypt-port
    (lambda (_cipher208664_ _key208665_ _iv208666_ _inp208667_)
      (let* ((_bufsz208669_ '1024)
             (_buf208672_
              (make-u8vector
               (let ((__tmp297458
                      (std/crypto/cipher#cipher-block-size _cipher208664_)))
                 (declare (not safe))
                 (##fx+ _bufsz208669_ __tmp297458))))
             (_outp208675_ (open-output-u8vector)))
        (letrec ((_grow-buffer-if-needed208679_
                  (lambda (_ilen208694_)
                    (let ((_max-olen208697_
                           (let ((__tmp297459
                                  (std/crypto/cipher#cipher-block-size
                                   _cipher208664_)))
                             (declare (not safe))
                             (##fx+ _ilen208694_ __tmp297459))))
                      (if (let ((__tmp297460 (u8vector-length _buf208672_)))
                            (declare (not safe))
                            (##fx> _max-olen208697_ __tmp297460))
                          (set! _buf208672_ (make-u8vector _max-olen208697_))
                          '#!void)))))
          (std/crypto/cipher#encrypt-init!
           _cipher208664_
           _key208665_
           _iv208666_)
          (std/crypto/etc#call-with-binary-input
           (lambda (_bytes208682_ _start208684_ _end208686_)
             (_grow-buffer-if-needed208679_ (- _end208686_ _start208684_))
             (let ((_olen208689_
                    (std/crypto/cipher#encrypt-update!
                     _cipher208664_
                     _buf208672_
                     '0
                     _bytes208682_
                     _start208684_
                     _end208686_)))
               (write-subu8vector _buf208672_ '0 _olen208689_ _outp208675_)))
           _inp208667_)
          (let ((_olen208692_
                 (std/crypto/cipher#encrypt-final!__0
                  _cipher208664_
                  _buf208672_)))
            (write-subu8vector _buf208672_ '0 _olen208692_ _outp208675_)
            (get-output-u8vector _outp208675_))))))
  (define std/crypto/cipher#decrypt
    (lambda (_cipher208659_ _key208660_ _iv208661_ _in208662_)
      (if (u8vector? _in208662_)
          (std/crypto/cipher#decrypt-u8vector__0
           _cipher208659_
           _key208660_
           _iv208661_
           _in208662_)
          (if (input-port? _in208662_)
              (std/crypto/cipher#decrypt-port
               _cipher208659_
               _key208660_
               _iv208661_
               _in208662_)
              (error '"Bad input source" _in208662_)))))
  (define std/crypto/cipher#decrypt-u8vector__%
    (lambda (_cipher208605_
             _key208606_
             _iv208607_
             _in208608_
             _start208609_
             _end208610_)
      (let* ((_len208612_
              (let () (declare (not safe)) (##fx- _end208610_ _start208609_)))
             (_buflen208615_
              (let ((__tmp297461
                     (let ((__tmp297462
                            (std/crypto/cipher#cipher-block-size
                             _cipher208605_)))
                       (declare (not safe))
                       (##fx* '2 __tmp297462))))
                (declare (not safe))
                (##fx+ _len208612_ __tmp297461)))
             (_buf208618_ (make-u8vector _buflen208615_)))
        (std/crypto/cipher#decrypt-init! _cipher208605_ _key208606_ _iv208607_)
        (let* ((_ulen208622_
                (std/crypto/cipher#decrypt-update!
                 _cipher208605_
                 _buf208618_
                 '0
                 _in208608_
                 _start208609_
                 _end208610_))
               (_flen208625_
                (std/crypto/cipher#decrypt-final!__%
                 _cipher208605_
                 _buf208618_
                 _ulen208622_))
               (_olen208628_
                (let ()
                  (declare (not safe))
                  (##fx+ _ulen208622_ _flen208625_))))
          (if (let () (declare (not safe)) (##fx< _olen208628_ _buflen208615_))
              (u8vector-shrink! _buf208618_ _olen208628_)
              '#!void)
          _buf208618_))))
  (define std/crypto/cipher#decrypt-u8vector__0
    (lambda (_cipher208635_ _key208636_ _iv208637_ _in208638_)
      (let* ((_start208640_ '0) (_end208642_ (u8vector-length _in208638_)))
        (std/crypto/cipher#decrypt-u8vector__%
         _cipher208635_
         _key208636_
         _iv208637_
         _in208638_
         _start208640_
         _end208642_))))
  (define std/crypto/cipher#decrypt-u8vector__1
    (lambda (_cipher208644_ _key208645_ _iv208646_ _in208647_ _start208648_)
      (let ((_end208650_ (u8vector-length _in208647_)))
        (std/crypto/cipher#decrypt-u8vector__%
         _cipher208644_
         _key208645_
         _iv208646_
         _in208647_
         _start208648_
         _end208650_))))
  (define std/crypto/cipher#decrypt-u8vector
    (lambda _g297464_
      (let ((_g297463_ (let () (declare (not safe)) (##length _g297464_))))
        (cond ((let () (declare (not safe)) (##fx= _g297463_ 4))
               (apply std/crypto/cipher#decrypt-u8vector__0 _g297464_))
              ((let () (declare (not safe)) (##fx= _g297463_ 5))
               (apply std/crypto/cipher#decrypt-u8vector__1 _g297464_))
              ((let () (declare (not safe)) (##fx= _g297463_ 6))
               (apply std/crypto/cipher#decrypt-u8vector__% _g297464_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#decrypt-u8vector
                _g297464_))))))
  (define std/crypto/cipher#decrypt-u8vector!
    (lambda (_cipher208589_
             _key208590_
             _iv208591_
             _bytes208592_
             _start208593_
             _end208594_
             _buf208595_)
      (std/crypto/cipher#decrypt-init! _cipher208589_ _key208590_ _iv208591_)
      (let* ((_ulen208597_
              (std/crypto/cipher#decrypt-update!
               _cipher208589_
               _buf208595_
               '0
               _bytes208592_
               _start208593_
               _end208594_))
             (_flen208599_
              (std/crypto/cipher#decrypt-final!__%
               _cipher208589_
               _buf208595_
               _ulen208597_))
             (_olen208601_
              (let () (declare (not safe)) (##fx+ _ulen208597_ _flen208599_))))
        _olen208601_)))
  (define std/crypto/cipher#decrypt-port
    (lambda (_cipher208553_ _key208554_ _iv208555_ _inp208556_)
      (let* ((_bufsz208558_ '1024)
             (_buf208561_
              (make-u8vector
               (let ((__tmp297465
                      (std/crypto/cipher#cipher-block-size _cipher208553_)))
                 (declare (not safe))
                 (##fx+ _bufsz208558_ __tmp297465))))
             (_outp208564_ (open-output-u8vector)))
        (letrec ((_grow-buffer-if-needed208568_
                  (lambda (_ilen208583_)
                    (let ((_max-olen208586_
                           (let ((__tmp297466
                                  (std/crypto/cipher#cipher-block-size
                                   _cipher208553_)))
                             (declare (not safe))
                             (##fx+ _ilen208583_ __tmp297466))))
                      (if (let ((__tmp297467 (u8vector-length _buf208561_)))
                            (declare (not safe))
                            (##fx> _max-olen208586_ __tmp297467))
                          (set! _buf208561_ (make-u8vector _max-olen208586_))
                          '#!void)))))
          (std/crypto/cipher#decrypt-init!
           _cipher208553_
           _key208554_
           _iv208555_)
          (std/crypto/etc#call-with-binary-input
           (lambda (_bytes208571_ _start208573_ _end208575_)
             (_grow-buffer-if-needed208568_ (- _end208575_ _start208573_))
             (let ((_olen208578_
                    (std/crypto/cipher#decrypt-update!
                     _cipher208553_
                     _buf208561_
                     '0
                     _bytes208571_
                     _start208573_
                     _end208575_)))
               (write-subu8vector _buf208561_ '0 _olen208578_ _outp208564_)))
           _inp208556_)
          (let ((_olen208581_
                 (std/crypto/cipher#decrypt-final!__0
                  _cipher208553_
                  _buf208561_)))
            (write-subu8vector _buf208561_ '0 _olen208581_ _outp208564_)
            (get-output-u8vector _outp208564_))))))
  (define std/crypto/cipher#cipher::aes-128-ecb
    (std/crypto/libcrypto#EVP_aes_128_ecb))
  (define std/crypto/cipher#make-aes-128-ecb-cipher
    (lambda ()
      (let ((__obj297405 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297405
         std/crypto/cipher#cipher::aes-128-ecb)
        __obj297405)))
  (define std/crypto/cipher#aes-128-ecb-cipher?
    (lambda (_obj208550_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208550_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208550_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-cbc
    (std/crypto/libcrypto#EVP_aes_128_cbc))
  (define std/crypto/cipher#make-aes-128-cbc-cipher
    (lambda ()
      (let ((__obj297406 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297406
         std/crypto/cipher#cipher::aes-128-cbc)
        __obj297406)))
  (define std/crypto/cipher#aes-128-cbc-cipher?
    (lambda (_obj208547_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208547_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208547_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-cfb
    (std/crypto/libcrypto#EVP_aes_128_cfb))
  (define std/crypto/cipher#make-aes-128-cfb-cipher
    (lambda ()
      (let ((__obj297407 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297407
         std/crypto/cipher#cipher::aes-128-cfb)
        __obj297407)))
  (define std/crypto/cipher#aes-128-cfb-cipher?
    (lambda (_obj208544_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208544_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208544_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-ofb
    (std/crypto/libcrypto#EVP_aes_128_ofb))
  (define std/crypto/cipher#make-aes-128-ofb-cipher
    (lambda ()
      (let ((__obj297408 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297408
         std/crypto/cipher#cipher::aes-128-ofb)
        __obj297408)))
  (define std/crypto/cipher#aes-128-ofb-cipher?
    (lambda (_obj208541_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208541_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208541_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-ctr
    (std/crypto/libcrypto#EVP_aes_128_ctr))
  (define std/crypto/cipher#make-aes-128-ctr-cipher
    (lambda ()
      (let ((__obj297409 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297409
         std/crypto/cipher#cipher::aes-128-ctr)
        __obj297409)))
  (define std/crypto/cipher#aes-128-ctr-cipher?
    (lambda (_obj208538_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208538_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208538_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ctr))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-ccm
    (std/crypto/libcrypto#EVP_aes_128_ccm))
  (define std/crypto/cipher#make-aes-128-ccm-cipher
    (lambda ()
      (let ((__obj297410 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297410
         std/crypto/cipher#cipher::aes-128-ccm)
        __obj297410)))
  (define std/crypto/cipher#aes-128-ccm-cipher?
    (lambda (_obj208535_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208535_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208535_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ccm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-gcm
    (std/crypto/libcrypto#EVP_aes_128_gcm))
  (define std/crypto/cipher#make-aes-128-gcm-cipher
    (lambda ()
      (let ((__obj297411 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297411
         std/crypto/cipher#cipher::aes-128-gcm)
        __obj297411)))
  (define std/crypto/cipher#aes-128-gcm-cipher?
    (lambda (_obj208532_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208532_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208532_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-gcm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-xts
    (std/crypto/libcrypto#EVP_aes_128_xts))
  (define std/crypto/cipher#make-aes-128-xts-cipher
    (lambda ()
      (let ((__obj297412 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297412
         std/crypto/cipher#cipher::aes-128-xts)
        __obj297412)))
  (define std/crypto/cipher#aes-128-xts-cipher?
    (lambda (_obj208528_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208528_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208528_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-xts))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ecb
    (std/crypto/libcrypto#EVP_aes_192_ecb))
  (define std/crypto/cipher#make-aes-192-ecb-cipher
    (lambda ()
      (let ((__obj297413 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297413
         std/crypto/cipher#cipher::aes-192-ecb)
        __obj297413)))
  (define std/crypto/cipher#aes-192-ecb-cipher?
    (lambda (_obj208525_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208525_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208525_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-cbc
    (std/crypto/libcrypto#EVP_aes_192_cbc))
  (define std/crypto/cipher#make-aes-192-cbc-cipher
    (lambda ()
      (let ((__obj297414 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297414
         std/crypto/cipher#cipher::aes-192-cbc)
        __obj297414)))
  (define std/crypto/cipher#aes-192-cbc-cipher?
    (lambda (_obj208522_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208522_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208522_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-cfb
    (std/crypto/libcrypto#EVP_aes_192_cfb))
  (define std/crypto/cipher#make-aes-192-cfb-cipher
    (lambda ()
      (let ((__obj297415 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297415
         std/crypto/cipher#cipher::aes-192-cfb)
        __obj297415)))
  (define std/crypto/cipher#aes-192-cfb-cipher?
    (lambda (_obj208519_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208519_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208519_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ofb
    (std/crypto/libcrypto#EVP_aes_192_ofb))
  (define std/crypto/cipher#make-aes-192-ofb-cipher
    (lambda ()
      (let ((__obj297416 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297416
         std/crypto/cipher#cipher::aes-192-ofb)
        __obj297416)))
  (define std/crypto/cipher#aes-192-ofb-cipher?
    (lambda (_obj208516_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208516_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208516_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ctr
    (std/crypto/libcrypto#EVP_aes_192_ctr))
  (define std/crypto/cipher#make-aes-192-ctr-cipher
    (lambda ()
      (let ((__obj297417 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297417
         std/crypto/cipher#cipher::aes-192-ctr)
        __obj297417)))
  (define std/crypto/cipher#aes-192-ctr-cipher?
    (lambda (_obj208513_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208513_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208513_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ctr))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ccm
    (std/crypto/libcrypto#EVP_aes_192_ccm))
  (define std/crypto/cipher#make-aes-192-ccm-cipher
    (lambda ()
      (let ((__obj297418 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297418
         std/crypto/cipher#cipher::aes-192-ccm)
        __obj297418)))
  (define std/crypto/cipher#aes-192-ccm-cipher?
    (lambda (_obj208510_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208510_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208510_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ccm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-gcm
    (std/crypto/libcrypto#EVP_aes_192_gcm))
  (define std/crypto/cipher#make-aes-192-gcm-cipher
    (lambda ()
      (let ((__obj297419 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297419
         std/crypto/cipher#cipher::aes-192-gcm)
        __obj297419)))
  (define std/crypto/cipher#aes-192-gcm-cipher?
    (lambda (_obj208506_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208506_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208506_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-gcm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ecb
    (std/crypto/libcrypto#EVP_aes_256_ecb))
  (define std/crypto/cipher#make-aes-256-ecb-cipher
    (lambda ()
      (let ((__obj297420 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297420
         std/crypto/cipher#cipher::aes-256-ecb)
        __obj297420)))
  (define std/crypto/cipher#aes-256-ecb-cipher?
    (lambda (_obj208503_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208503_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208503_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-cbc
    (std/crypto/libcrypto#EVP_aes_256_cbc))
  (define std/crypto/cipher#make-aes-256-cbc-cipher
    (lambda ()
      (let ((__obj297421 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297421
         std/crypto/cipher#cipher::aes-256-cbc)
        __obj297421)))
  (define std/crypto/cipher#aes-256-cbc-cipher?
    (lambda (_obj208500_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208500_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208500_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-cfb
    (std/crypto/libcrypto#EVP_aes_256_cfb))
  (define std/crypto/cipher#make-aes-256-cfb-cipher
    (lambda ()
      (let ((__obj297422 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297422
         std/crypto/cipher#cipher::aes-256-cfb)
        __obj297422)))
  (define std/crypto/cipher#aes-256-cfb-cipher?
    (lambda (_obj208497_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208497_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208497_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ofb
    (std/crypto/libcrypto#EVP_aes_256_ofb))
  (define std/crypto/cipher#make-aes-256-ofb-cipher
    (lambda ()
      (let ((__obj297423 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297423
         std/crypto/cipher#cipher::aes-256-ofb)
        __obj297423)))
  (define std/crypto/cipher#aes-256-ofb-cipher?
    (lambda (_obj208494_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208494_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208494_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ctr
    (std/crypto/libcrypto#EVP_aes_256_ctr))
  (define std/crypto/cipher#make-aes-256-ctr-cipher
    (lambda ()
      (let ((__obj297424 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297424
         std/crypto/cipher#cipher::aes-256-ctr)
        __obj297424)))
  (define std/crypto/cipher#aes-256-ctr-cipher?
    (lambda (_obj208491_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208491_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208491_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ctr))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ccm
    (std/crypto/libcrypto#EVP_aes_256_ccm))
  (define std/crypto/cipher#make-aes-256-ccm-cipher
    (lambda ()
      (let ((__obj297425 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297425
         std/crypto/cipher#cipher::aes-256-ccm)
        __obj297425)))
  (define std/crypto/cipher#aes-256-ccm-cipher?
    (lambda (_obj208488_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208488_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208488_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ccm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-gcm
    (std/crypto/libcrypto#EVP_aes_256_gcm))
  (define std/crypto/cipher#make-aes-256-gcm-cipher
    (lambda ()
      (let ((__obj297426 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297426
         std/crypto/cipher#cipher::aes-256-gcm)
        __obj297426)))
  (define std/crypto/cipher#aes-256-gcm-cipher?
    (lambda (_obj208485_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208485_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208485_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-gcm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-xts
    (std/crypto/libcrypto#EVP_aes_256_xts))
  (define std/crypto/cipher#make-aes-256-xts-cipher
    (lambda ()
      (let ((__obj297427 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297427
         std/crypto/cipher#cipher::aes-256-xts)
        __obj297427)))
  (define std/crypto/cipher#aes-256-xts-cipher?
    (lambda (_obj208481_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208481_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208481_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-xts))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-ecb
    (std/crypto/libcrypto#EVP_camellia_128_ecb))
  (define std/crypto/cipher#make-camellia-128-ecb-cipher
    (lambda ()
      (let ((__obj297428 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297428
         std/crypto/cipher#cipher::camellia-128-ecb)
        __obj297428)))
  (define std/crypto/cipher#camellia-128-ecb-cipher?
    (lambda (_obj208478_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208478_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208478_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-cbc
    (std/crypto/libcrypto#EVP_camellia_128_cbc))
  (define std/crypto/cipher#make-camellia-128-cbc-cipher
    (lambda ()
      (let ((__obj297429 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297429
         std/crypto/cipher#cipher::camellia-128-cbc)
        __obj297429)))
  (define std/crypto/cipher#camellia-128-cbc-cipher?
    (lambda (_obj208475_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208475_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208475_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-cfb
    (std/crypto/libcrypto#EVP_camellia_128_cfb))
  (define std/crypto/cipher#make-camellia-128-cfb-cipher
    (lambda ()
      (let ((__obj297430 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297430
         std/crypto/cipher#cipher::camellia-128-cfb)
        __obj297430)))
  (define std/crypto/cipher#camellia-128-cfb-cipher?
    (lambda (_obj208472_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208472_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208472_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-ofb
    (std/crypto/libcrypto#EVP_camellia_128_ofb))
  (define std/crypto/cipher#make-camellia-128-ofb-cipher
    (lambda ()
      (let ((__obj297431 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297431
         std/crypto/cipher#cipher::camellia-128-ofb)
        __obj297431)))
  (define std/crypto/cipher#camellia-128-ofb-cipher?
    (lambda (_obj208468_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208468_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208468_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-ecb
    (std/crypto/libcrypto#EVP_camellia_192_ecb))
  (define std/crypto/cipher#make-camellia-192-ecb-cipher
    (lambda ()
      (let ((__obj297432 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297432
         std/crypto/cipher#cipher::camellia-192-ecb)
        __obj297432)))
  (define std/crypto/cipher#camellia-192-ecb-cipher?
    (lambda (_obj208465_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208465_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208465_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-cbc
    (std/crypto/libcrypto#EVP_camellia_192_cbc))
  (define std/crypto/cipher#make-camellia-192-cbc-cipher
    (lambda ()
      (let ((__obj297433 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297433
         std/crypto/cipher#cipher::camellia-192-cbc)
        __obj297433)))
  (define std/crypto/cipher#camellia-192-cbc-cipher?
    (lambda (_obj208462_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208462_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208462_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-cfb
    (std/crypto/libcrypto#EVP_camellia_192_cfb))
  (define std/crypto/cipher#make-camellia-192-cfb-cipher
    (lambda ()
      (let ((__obj297434 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297434
         std/crypto/cipher#cipher::camellia-192-cfb)
        __obj297434)))
  (define std/crypto/cipher#camellia-192-cfb-cipher?
    (lambda (_obj208459_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208459_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208459_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-ofb
    (std/crypto/libcrypto#EVP_camellia_192_ofb))
  (define std/crypto/cipher#make-camellia-192-ofb-cipher
    (lambda ()
      (let ((__obj297435 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297435
         std/crypto/cipher#cipher::camellia-192-ofb)
        __obj297435)))
  (define std/crypto/cipher#camellia-192-ofb-cipher?
    (lambda (_obj208455_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208455_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208455_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-ecb
    (std/crypto/libcrypto#EVP_camellia_256_ecb))
  (define std/crypto/cipher#make-camellia-256-ecb-cipher
    (lambda ()
      (let ((__obj297436 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297436
         std/crypto/cipher#cipher::camellia-256-ecb)
        __obj297436)))
  (define std/crypto/cipher#camellia-256-ecb-cipher?
    (lambda (_obj208452_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208452_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208452_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-cbc
    (std/crypto/libcrypto#EVP_camellia_256_cbc))
  (define std/crypto/cipher#make-camellia-256-cbc-cipher
    (lambda ()
      (let ((__obj297437 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297437
         std/crypto/cipher#cipher::camellia-256-cbc)
        __obj297437)))
  (define std/crypto/cipher#camellia-256-cbc-cipher?
    (lambda (_obj208449_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208449_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208449_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-cfb
    (std/crypto/libcrypto#EVP_camellia_256_cfb))
  (define std/crypto/cipher#make-camellia-256-cfb-cipher
    (lambda ()
      (let ((__obj297438 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297438
         std/crypto/cipher#cipher::camellia-256-cfb)
        __obj297438)))
  (define std/crypto/cipher#camellia-256-cfb-cipher?
    (lambda (_obj208446_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208446_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208446_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-ofb
    (std/crypto/libcrypto#EVP_camellia_256_ofb))
  (define std/crypto/cipher#make-camellia-256-ofb-cipher
    (lambda ()
      (let ((__obj297439 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297439
         std/crypto/cipher#cipher::camellia-256-ofb)
        __obj297439)))
  (define std/crypto/cipher#camellia-256-ofb-cipher?
    (lambda (_obj208442_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208442_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208442_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-ecb
    (std/crypto/libcrypto#EVP_cast5_ecb))
  (define std/crypto/cipher#make-cast5-ecb-cipher
    (lambda ()
      (let ((__obj297440 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297440
         std/crypto/cipher#cipher::cast5-ecb)
        __obj297440)))
  (define std/crypto/cipher#cast5-ecb-cipher?
    (lambda (_obj208439_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208439_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208439_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-cbc
    (std/crypto/libcrypto#EVP_cast5_cbc))
  (define std/crypto/cipher#make-cast5-cbc-cipher
    (lambda ()
      (let ((__obj297441 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297441
         std/crypto/cipher#cipher::cast5-cbc)
        __obj297441)))
  (define std/crypto/cipher#cast5-cbc-cipher?
    (lambda (_obj208436_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208436_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208436_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-cfb
    (std/crypto/libcrypto#EVP_cast5_cfb))
  (define std/crypto/cipher#make-cast5-cfb-cipher
    (lambda ()
      (let ((__obj297442 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297442
         std/crypto/cipher#cipher::cast5-cfb)
        __obj297442)))
  (define std/crypto/cipher#cast5-cfb-cipher?
    (lambda (_obj208433_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208433_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208433_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-ofb
    (std/crypto/libcrypto#EVP_cast5_ofb))
  (define std/crypto/cipher#make-cast5-ofb-cipher
    (lambda ()
      (let ((__obj297443 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297443
         std/crypto/cipher#cipher::cast5-ofb)
        __obj297443)))
  (define std/crypto/cipher#cast5-ofb-cipher?
    (lambda (_obj208429_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208429_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208429_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::bf-ecb (std/crypto/libcrypto#EVP_bf_ecb))
  (define std/crypto/cipher#make-bf-ecb-cipher
    (lambda ()
      (let ((__obj297444 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297444
         std/crypto/cipher#cipher::bf-ecb)
        __obj297444)))
  (define std/crypto/cipher#bf-ecb-cipher?
    (lambda (_obj208426_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208426_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208426_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::bf-cbc (std/crypto/libcrypto#EVP_bf_cbc))
  (define std/crypto/cipher#make-bf-cbc-cipher
    (lambda ()
      (let ((__obj297445 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297445
         std/crypto/cipher#cipher::bf-cbc)
        __obj297445)))
  (define std/crypto/cipher#bf-cbc-cipher?
    (lambda (_obj208423_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208423_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208423_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::bf-cfb (std/crypto/libcrypto#EVP_bf_cfb))
  (define std/crypto/cipher#make-bf-cfb-cipher
    (lambda ()
      (let ((__obj297446 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297446
         std/crypto/cipher#cipher::bf-cfb)
        __obj297446)))
  (define std/crypto/cipher#bf-cfb-cipher?
    (lambda (_obj208420_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208420_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208420_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::bf-ofb (std/crypto/libcrypto#EVP_bf_ofb))
  (define std/crypto/cipher#make-bf-ofb-cipher
    (lambda ()
      (let ((__obj297447 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297447
         std/crypto/cipher#cipher::bf-ofb)
        __obj297447)))
  (define std/crypto/cipher#bf-ofb-cipher?
    (lambda (_obj208416_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208416_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208416_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::rc4 (std/crypto/libcrypto#EVP_rc4))
  (define std/crypto/cipher#make-rc4-cipher
    (lambda ()
      (let ((__obj297448 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj297448
         std/crypto/cipher#cipher::rc4)
        __obj297448)))
  (define std/crypto/cipher#rc4-cipher?
    (lambda (_obj208412_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj208412_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj208412_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::rc4))
          '#f))))
