(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/digest#digest::t
    (make-struct-type
     'std/crypto#digest::t
     '#f
     '2
     'digest
     '()
     ':init!
     '(type ctx)))
  (define std/crypto/digest#digest?
    (make-struct-predicate std/crypto/digest#digest::t))
  (define std/crypto/digest#make-digest
    (lambda _$args173942_
      (apply make-struct-instance std/crypto/digest#digest::t _$args173942_)))
  (define std/crypto/digest#digest-type
    (make-struct-field-accessor std/crypto/digest#digest::t '0))
  (define std/crypto/digest#digest-ctx
    (make-struct-field-accessor std/crypto/digest#digest::t '1))
  (define std/crypto/digest#digest-type-set!
    (make-struct-field-mutator std/crypto/digest#digest::t '0))
  (define std/crypto/digest#digest-ctx-set!
    (make-struct-field-mutator std/crypto/digest#digest::t '1))
  (define std/crypto/digest#digest:::init!
    (lambda (_self173934_ _type173935_)
      (if (std/crypto/libcrypto#EVP_MD? _type173935_)
          '#!void
          (error '"Invalid digest type" _type173935_))
      (let ((_ctx173937_ (std/crypto/libcrypto#EVP_MD_CTX_create)))
        (if _ctx173937_ '#!void (error '"Failed to allocate digest context"))
        (let ((_res173939_
               (std/crypto/libcrypto#EVP_DigestInit _ctx173937_ _type173935_)))
          (if (let () (declare (not safe)) (##fxzero? _res173939_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        (if (let ((__tmp297304
                   (let ()
                     (declare (not safe))
                     (##vector-length _self173934_))))
              (declare (not safe))
              (##fx< '2 __tmp297304))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self173934_ '1 _type173935_))
              (let ()
                (declare (not safe))
                (##vector-set! _self173934_ '2 _ctx173937_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self173934_)))))
  (bind-method!
   std/crypto/digest#digest::t
   ':init!
   std/crypto/digest#digest:::init!
   '#f)
  (define std/crypto/digest#digest-size
    (lambda (_digest173810_)
      (if (std/crypto/libcrypto#EVP_MD? _digest173810_)
          (std/crypto/libcrypto#EVP_MD_size _digest173810_)
          (std/crypto/libcrypto#EVP_MD_size
           (##structure-ref
            _digest173810_
            '1
            std/crypto/digest#digest::t
            '#f)))))
  (define std/crypto/digest#digest-name
    (lambda (_digest173808_)
      (if (std/crypto/libcrypto#EVP_MD? _digest173808_)
          (std/crypto/libcrypto#EVP_MD_name _digest173808_)
          (std/crypto/libcrypto#EVP_MD_name
           (##structure-ref
            _digest173808_
            '1
            std/crypto/digest#digest::t
            '#f)))))
  (define std/crypto/digest#digest-copy
    (lambda (_digest173798_)
      (let* ((_ctx173800_ (std/crypto/digest#digest-context _digest173798_))
             (_copy173802_
              (let ((__obj297286 (make-object std/crypto/digest#digest::t '2)))
                (std/crypto/digest#digest:::init!
                 __obj297286
                 (##structure-ref
                  _digest173798_
                  '1
                  std/crypto/digest#digest::t
                  '#f))
                __obj297286)))
        (let ((_res173805_
               (std/crypto/libcrypto#EVP_MD_CTX_copy
                (##structure-ref
                 _copy173802_
                 '2
                 std/crypto/digest#digest::t
                 '#f)
                _ctx173800_)))
          (if (let () (declare (not safe)) (##fxzero? _res173805_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        _copy173802_)))
  (define std/crypto/digest#digest-context
    (lambda (_digest173793_)
      (let ((_$e173795_
             (##structure-ref
              _digest173793_
              '2
              std/crypto/digest#digest::t
              '#f)))
        (if _$e173795_
            _$e173795_
            (error '"Digest has been finalized" _digest173793_)))))
  (define std/crypto/digest#digest-update!__%
    (lambda (_digest173753_ _bytes173754_ _start173755_ _end173756_)
      (let* ((_start173761_
              (let ((_$e173758_ _start173755_)) (if _$e173758_ _$e173758_ '0)))
             (_end173766_
              (let ((_$e173763_ _end173756_))
                (if _$e173763_ _$e173763_ (u8vector-length _bytes173754_)))))
        (let ((_res173769_
               (std/crypto/libcrypto#EVP_DigestUpdate
                (std/crypto/digest#digest-context _digest173753_)
                _bytes173754_
                _start173761_
                _end173766_)))
          (if (let () (declare (not safe)) (##fxzero? _res173769_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void)))))
  (define std/crypto/digest#digest-update!__0
    (lambda (_digest173775_ _bytes173776_)
      (let* ((_start173778_ '#f) (_end173780_ '#f))
        (std/crypto/digest#digest-update!__%
         _digest173775_
         _bytes173776_
         _start173778_
         _end173780_))))
  (define std/crypto/digest#digest-update!__1
    (lambda (_digest173782_ _bytes173783_ _start173784_)
      (let ((_end173786_ '#f))
        (std/crypto/digest#digest-update!__%
         _digest173782_
         _bytes173783_
         _start173784_
         _end173786_))))
  (define std/crypto/digest#digest-update!
    (lambda _g297306_
      (let ((_g297305_ (let () (declare (not safe)) (##length _g297306_))))
        (cond ((let () (declare (not safe)) (##fx= _g297305_ 2))
               (apply std/crypto/digest#digest-update!__0 _g297306_))
              ((let () (declare (not safe)) (##fx= _g297305_ 3))
               (apply std/crypto/digest#digest-update!__1 _g297306_))
              ((let () (declare (not safe)) (##fx= _g297305_ 4))
               (apply std/crypto/digest#digest-update!__% _g297306_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/digest#digest-update!
                _g297306_))))))
  (define std/crypto/digest#digest-update*
    (lambda (_digest173741_ _in173742_ . _args173743_)
      (apply std/crypto/etc#call-with-binary-input
             (lambda (_bytes173745_ _start173746_ _end173747_)
               (let ((_res173749_
                      (std/crypto/libcrypto#EVP_DigestUpdate
                       (std/crypto/digest#digest-context _digest173741_)
                       _bytes173745_
                       _start173746_
                       _end173747_)))
                 (if (let () (declare (not safe)) (##fxzero? _res173749_))
                     (apply std/crypto/etc#raise-libcrypto-error '())
                     '#!void)))
             _in173742_
             _args173743_)))
  (define std/crypto/digest#digest-final!__%
    (lambda (_digest173715_ _bytes173716_)
      (let* ((_ctx173718_ (std/crypto/digest#digest-context _digest173715_))
             (_size173720_ (std/crypto/libcrypto#EVP_MD_CTX_size _ctx173718_))
             (_bytes173725_
              (let ((_$e173722_ _bytes173716_))
                (if _$e173722_ _$e173722_ (make-u8vector _size173720_)))))
        (let ((_res173728_
               (std/crypto/libcrypto#EVP_DigestFinal
                _ctx173718_
                _bytes173725_)))
          (if (let () (declare (not safe)) (##fxzero? _res173728_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        (##structure-set!
         _digest173715_
         '#f
         '2
         std/crypto/digest#digest::t
         '#f)
        _bytes173725_)))
  (define std/crypto/digest#digest-final!__0
    (lambda (_digest173734_)
      (let ((_bytes173736_ '#f))
        (std/crypto/digest#digest-final!__% _digest173734_ _bytes173736_))))
  (define std/crypto/digest#digest-final!
    (lambda _g297308_
      (let ((_g297307_ (let () (declare (not safe)) (##length _g297308_))))
        (cond ((let () (declare (not safe)) (##fx= _g297307_ 1))
               (apply std/crypto/digest#digest-final!__0 _g297308_))
              ((let () (declare (not safe)) (##fx= _g297307_ 2))
               (apply std/crypto/digest#digest-final!__% _g297308_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/digest#digest-final!
                _g297308_))))))
  (define std/crypto/digest#digest::md5 (std/crypto/libcrypto#EVP_md5))
  (define std/crypto/digest#make-md5-digest
    (if std/crypto/digest#digest::md5
        (lambda ()
          (let ((__obj297287 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297287
             std/crypto/digest#digest::md5)
            __obj297287))
        '#f))
  (define std/crypto/digest#md5-digest?
    (if std/crypto/digest#digest::md5
        (lambda (_obj173710_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173710_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173710_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::md5))
              '#f))
        '#f))
  (define std/crypto/digest#md5
    (if std/crypto/digest#digest::md5
        (lambda _args173704_
          (let ((_digest173707_ (std/crypto/digest#make-md5-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173707_
                   _args173704_)
            (std/crypto/digest#digest-final!__0 _digest173707_)))
        '#f))
  (define std/crypto/digest#digest::sha1 (std/crypto/libcrypto#EVP_sha1))
  (define std/crypto/digest#make-sha1-digest
    (if std/crypto/digest#digest::sha1
        (lambda ()
          (let ((__obj297288 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297288
             std/crypto/digest#digest::sha1)
            __obj297288))
        '#f))
  (define std/crypto/digest#sha1-digest?
    (if std/crypto/digest#digest::sha1
        (lambda (_obj173700_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173700_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173700_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha1))
              '#f))
        '#f))
  (define std/crypto/digest#sha1
    (if std/crypto/digest#digest::sha1
        (lambda _args173694_
          (let ((_digest173697_ (std/crypto/digest#make-sha1-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173697_
                   _args173694_)
            (std/crypto/digest#digest-final!__0 _digest173697_)))
        '#f))
  (define std/crypto/digest#digest::sha224 (std/crypto/libcrypto#EVP_sha224))
  (define std/crypto/digest#make-sha224-digest
    (if std/crypto/digest#digest::sha224
        (lambda ()
          (let ((__obj297289 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297289
             std/crypto/digest#digest::sha224)
            __obj297289))
        '#f))
  (define std/crypto/digest#sha224-digest?
    (if std/crypto/digest#digest::sha224
        (lambda (_obj173690_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173690_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173690_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha224))
              '#f))
        '#f))
  (define std/crypto/digest#sha224
    (if std/crypto/digest#digest::sha224
        (lambda _args173684_
          (let ((_digest173687_ (std/crypto/digest#make-sha224-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173687_
                   _args173684_)
            (std/crypto/digest#digest-final!__0 _digest173687_)))
        '#f))
  (define std/crypto/digest#digest::sha256 (std/crypto/libcrypto#EVP_sha256))
  (define std/crypto/digest#make-sha256-digest
    (if std/crypto/digest#digest::sha256
        (lambda ()
          (let ((__obj297290 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297290
             std/crypto/digest#digest::sha256)
            __obj297290))
        '#f))
  (define std/crypto/digest#sha256-digest?
    (if std/crypto/digest#digest::sha256
        (lambda (_obj173680_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173680_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173680_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha256))
              '#f))
        '#f))
  (define std/crypto/digest#sha256
    (if std/crypto/digest#digest::sha256
        (lambda _args173674_
          (let ((_digest173677_ (std/crypto/digest#make-sha256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173677_
                   _args173674_)
            (std/crypto/digest#digest-final!__0 _digest173677_)))
        '#f))
  (define std/crypto/digest#digest::sha384 (std/crypto/libcrypto#EVP_sha384))
  (define std/crypto/digest#make-sha384-digest
    (if std/crypto/digest#digest::sha384
        (lambda ()
          (let ((__obj297291 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297291
             std/crypto/digest#digest::sha384)
            __obj297291))
        '#f))
  (define std/crypto/digest#sha384-digest?
    (if std/crypto/digest#digest::sha384
        (lambda (_obj173670_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173670_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173670_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha384))
              '#f))
        '#f))
  (define std/crypto/digest#sha384
    (if std/crypto/digest#digest::sha384
        (lambda _args173664_
          (let ((_digest173667_ (std/crypto/digest#make-sha384-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173667_
                   _args173664_)
            (std/crypto/digest#digest-final!__0 _digest173667_)))
        '#f))
  (define std/crypto/digest#digest::sha512 (std/crypto/libcrypto#EVP_sha512))
  (define std/crypto/digest#make-sha512-digest
    (if std/crypto/digest#digest::sha512
        (lambda ()
          (let ((__obj297292 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297292
             std/crypto/digest#digest::sha512)
            __obj297292))
        '#f))
  (define std/crypto/digest#sha512-digest?
    (if std/crypto/digest#digest::sha512
        (lambda (_obj173660_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173660_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173660_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha512))
              '#f))
        '#f))
  (define std/crypto/digest#sha512
    (if std/crypto/digest#digest::sha512
        (lambda _args173654_
          (let ((_digest173657_ (std/crypto/digest#make-sha512-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173657_
                   _args173654_)
            (std/crypto/digest#digest-final!__0 _digest173657_)))
        '#f))
  (define std/crypto/digest#digest::ripemd160
    (std/crypto/libcrypto#EVP_ripemd160))
  (define std/crypto/digest#make-ripemd160-digest
    (if std/crypto/digest#digest::ripemd160
        (lambda ()
          (let ((__obj297293 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297293
             std/crypto/digest#digest::ripemd160)
            __obj297293))
        '#f))
  (define std/crypto/digest#ripemd160-digest?
    (if std/crypto/digest#digest::ripemd160
        (lambda (_obj173650_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173650_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173650_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::ripemd160))
              '#f))
        '#f))
  (define std/crypto/digest#ripemd160
    (if std/crypto/digest#digest::ripemd160
        (lambda _args173644_
          (let ((_digest173647_ (std/crypto/digest#make-ripemd160-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173647_
                   _args173644_)
            (std/crypto/digest#digest-final!__0 _digest173647_)))
        '#f))
  (define std/crypto/digest#digest::whirlpool
    (std/crypto/libcrypto#EVP_whirlpool))
  (define std/crypto/digest#make-whirlpool-digest
    (if std/crypto/digest#digest::whirlpool
        (lambda ()
          (let ((__obj297294 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297294
             std/crypto/digest#digest::whirlpool)
            __obj297294))
        '#f))
  (define std/crypto/digest#whirlpool-digest?
    (if std/crypto/digest#digest::whirlpool
        (lambda (_obj173640_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173640_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173640_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::whirlpool))
              '#f))
        '#f))
  (define std/crypto/digest#whirlpool
    (if std/crypto/digest#digest::whirlpool
        (lambda _args173634_
          (let ((_digest173637_ (std/crypto/digest#make-whirlpool-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173637_
                   _args173634_)
            (std/crypto/digest#digest-final!__0 _digest173637_)))
        '#f))
  (define std/crypto/digest#digest::blake2s256
    (std/crypto/libcrypto#EVP_blake2s256))
  (define std/crypto/digest#make-blake2s256-digest
    (if std/crypto/digest#digest::blake2s256
        (lambda ()
          (let ((__obj297295 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297295
             std/crypto/digest#digest::blake2s256)
            __obj297295))
        '#f))
  (define std/crypto/digest#blake2s256-digest?
    (if std/crypto/digest#digest::blake2s256
        (lambda (_obj173630_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173630_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173630_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::blake2s256))
              '#f))
        '#f))
  (define std/crypto/digest#blake2s256
    (if std/crypto/digest#digest::blake2s256
        (lambda _args173624_
          (let ((_digest173627_ (std/crypto/digest#make-blake2s256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173627_
                   _args173624_)
            (std/crypto/digest#digest-final!__0 _digest173627_)))
        '#f))
  (define std/crypto/digest#digest::blake2b512
    (std/crypto/libcrypto#EVP_blake2b512))
  (define std/crypto/digest#make-blake2b512-digest
    (if std/crypto/digest#digest::blake2b512
        (lambda ()
          (let ((__obj297296 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297296
             std/crypto/digest#digest::blake2b512)
            __obj297296))
        '#f))
  (define std/crypto/digest#blake2b512-digest?
    (if std/crypto/digest#digest::blake2b512
        (lambda (_obj173620_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173620_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173620_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::blake2b512))
              '#f))
        '#f))
  (define std/crypto/digest#blake2b512
    (if std/crypto/digest#digest::blake2b512
        (lambda _args173614_
          (let ((_digest173617_ (std/crypto/digest#make-blake2b512-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173617_
                   _args173614_)
            (std/crypto/digest#digest-final!__0 _digest173617_)))
        '#f))
  (define std/crypto/digest#digest::sha3_224
    (std/crypto/libcrypto#EVP_sha3_224))
  (define std/crypto/digest#make-sha3_224-digest
    (if std/crypto/digest#digest::sha3_224
        (lambda ()
          (let ((__obj297297 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297297
             std/crypto/digest#digest::sha3_224)
            __obj297297))
        '#f))
  (define std/crypto/digest#sha3_224-digest?
    (if std/crypto/digest#digest::sha3_224
        (lambda (_obj173610_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173610_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173610_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_224))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_224
    (if std/crypto/digest#digest::sha3_224
        (lambda _args173604_
          (let ((_digest173607_ (std/crypto/digest#make-sha3_224-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173607_
                   _args173604_)
            (std/crypto/digest#digest-final!__0 _digest173607_)))
        '#f))
  (define std/crypto/digest#digest::sha3_256
    (std/crypto/libcrypto#EVP_sha3_256))
  (define std/crypto/digest#make-sha3_256-digest
    (if std/crypto/digest#digest::sha3_256
        (lambda ()
          (let ((__obj297298 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297298
             std/crypto/digest#digest::sha3_256)
            __obj297298))
        '#f))
  (define std/crypto/digest#sha3_256-digest?
    (if std/crypto/digest#digest::sha3_256
        (lambda (_obj173600_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173600_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173600_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_256))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_256
    (if std/crypto/digest#digest::sha3_256
        (lambda _args173594_
          (let ((_digest173597_ (std/crypto/digest#make-sha3_256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173597_
                   _args173594_)
            (std/crypto/digest#digest-final!__0 _digest173597_)))
        '#f))
  (define std/crypto/digest#digest::sha3_384
    (std/crypto/libcrypto#EVP_sha3_384))
  (define std/crypto/digest#make-sha3_384-digest
    (if std/crypto/digest#digest::sha3_384
        (lambda ()
          (let ((__obj297299 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297299
             std/crypto/digest#digest::sha3_384)
            __obj297299))
        '#f))
  (define std/crypto/digest#sha3_384-digest?
    (if std/crypto/digest#digest::sha3_384
        (lambda (_obj173590_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173590_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173590_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_384))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_384
    (if std/crypto/digest#digest::sha3_384
        (lambda _args173584_
          (let ((_digest173587_ (std/crypto/digest#make-sha3_384-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173587_
                   _args173584_)
            (std/crypto/digest#digest-final!__0 _digest173587_)))
        '#f))
  (define std/crypto/digest#digest::sha3_512
    (std/crypto/libcrypto#EVP_sha3_512))
  (define std/crypto/digest#make-sha3_512-digest
    (if std/crypto/digest#digest::sha3_512
        (lambda ()
          (let ((__obj297300 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297300
             std/crypto/digest#digest::sha3_512)
            __obj297300))
        '#f))
  (define std/crypto/digest#sha3_512-digest?
    (if std/crypto/digest#digest::sha3_512
        (lambda (_obj173580_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173580_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173580_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_512))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_512
    (if std/crypto/digest#digest::sha3_512
        (lambda _args173574_
          (let ((_digest173577_ (std/crypto/digest#make-sha3_512-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173577_
                   _args173574_)
            (std/crypto/digest#digest-final!__0 _digest173577_)))
        '#f))
  (define std/crypto/digest#digest::shake128
    (std/crypto/libcrypto#EVP_shake128))
  (define std/crypto/digest#make-shake128-digest
    (if std/crypto/digest#digest::shake128
        (lambda ()
          (let ((__obj297301 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297301
             std/crypto/digest#digest::shake128)
            __obj297301))
        '#f))
  (define std/crypto/digest#shake128-digest?
    (if std/crypto/digest#digest::shake128
        (lambda (_obj173570_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173570_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173570_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::shake128))
              '#f))
        '#f))
  (define std/crypto/digest#shake128
    (if std/crypto/digest#digest::shake128
        (lambda _args173564_
          (let ((_digest173567_ (std/crypto/digest#make-shake128-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173567_
                   _args173564_)
            (std/crypto/digest#digest-final!__0 _digest173567_)))
        '#f))
  (define std/crypto/digest#digest::shake256
    (std/crypto/libcrypto#EVP_shake256))
  (define std/crypto/digest#make-shake256-digest
    (if std/crypto/digest#digest::shake256
        (lambda ()
          (let ((__obj297302 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297302
             std/crypto/digest#digest::shake256)
            __obj297302))
        '#f))
  (define std/crypto/digest#shake256-digest?
    (if std/crypto/digest#digest::shake256
        (lambda (_obj173560_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173560_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173560_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::shake256))
              '#f))
        '#f))
  (define std/crypto/digest#shake256
    (if std/crypto/digest#digest::shake256
        (lambda _args173554_
          (let ((_digest173557_ (std/crypto/digest#make-shake256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173557_
                   _args173554_)
            (std/crypto/digest#digest-final!__0 _digest173557_)))
        '#f))
  (define std/crypto/digest#digest::keccak256
    (std/crypto/libcrypto#EVP_keccak256))
  (define std/crypto/digest#make-keccak256-digest
    (if std/crypto/digest#digest::keccak256
        (lambda ()
          (let ((__obj297303 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj297303
             std/crypto/digest#digest::keccak256)
            __obj297303))
        '#f))
  (define std/crypto/digest#keccak256-digest?
    (if std/crypto/digest#digest::keccak256
        (lambda (_obj173550_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj173550_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj173550_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::keccak256))
              '#f))
        '#f))
  (define std/crypto/digest#keccak256
    (if std/crypto/digest#digest::keccak256
        (lambda _args173544_
          (let ((_digest173547_ (std/crypto/digest#make-keccak256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest173547_
                   _args173544_)
            (std/crypto/digest#digest-final!__0 _digest173547_)))
        '#f)))
