(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/hmac#hmac::t
    (make-struct-type 'std/crypto#hmac::t '#f '2 'hmac '() ':init! '(md ctx)))
  (define std/crypto/hmac#hmac?
    (make-struct-predicate std/crypto/hmac#hmac::t))
  (define std/crypto/hmac#make-hmac
    (lambda _$args209500_
      (apply make-struct-instance std/crypto/hmac#hmac::t _$args209500_)))
  (define std/crypto/hmac#hmac-md
    (make-struct-field-accessor std/crypto/hmac#hmac::t '0))
  (define std/crypto/hmac#hmac-ctx
    (make-struct-field-accessor std/crypto/hmac#hmac::t '1))
  (define std/crypto/hmac#hmac-md-set!
    (make-struct-field-mutator std/crypto/hmac#hmac::t '0))
  (define std/crypto/hmac#hmac-ctx-set!
    (make-struct-field-mutator std/crypto/hmac#hmac::t '1))
  (define std/crypto/hmac#hmac:::init!
    (lambda (_self209495_ _md209496_)
      (if (std/crypto/libcrypto#EVP_MD? _md209496_)
          '#!void
          (error '"Invalid digest type" _md209496_))
      (let ((_ctx209498_ (std/crypto/libcrypto#HMAC_CTX_create)))
        (if _ctx209498_ '#!void (error '"Failed to allocate hmac context"))
        (if (let ((__tmp297479
                   (let ()
                     (declare (not safe))
                     (##vector-length _self209495_))))
              (declare (not safe))
              (##fx< '2 __tmp297479))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self209495_ '1 _md209496_))
              (let ()
                (declare (not safe))
                (##vector-set! _self209495_ '2 _ctx209498_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self209495_)))))
  (bind-method!
   std/crypto/hmac#hmac::t
   ':init!
   std/crypto/hmac#hmac:::init!
   '#f)
  (define std/crypto/hmac#hmac-init!
    (lambda (_hmac209367_ _key209368_)
      (let ((_res209370_
             (std/crypto/libcrypto#HMAC_Init
              (##structure-ref _hmac209367_ '2 std/crypto/hmac#hmac::t '#f)
              _key209368_
              (##structure-ref _hmac209367_ '1 std/crypto/hmac#hmac::t '#f))))
        (if (let () (declare (not safe)) (##fxzero? _res209370_))
            (apply std/crypto/etc#raise-libcrypto-error '())
            '#!void))))
  (define std/crypto/hmac#hmac-update!__%
    (lambda (_hmac209327_ _bytes209328_ _start209329_ _end209330_)
      (let* ((_start209335_
              (let ((_$e209332_ _start209329_)) (if _$e209332_ _$e209332_ '0)))
             (_end209340_
              (let ((_$e209337_ _end209330_))
                (if _$e209337_ _$e209337_ (u8vector-length _bytes209328_)))))
        (let ((_res209343_
               (std/crypto/libcrypto#HMAC_Update
                (##structure-ref _hmac209327_ '2 std/crypto/hmac#hmac::t '#f)
                _bytes209328_
                _start209335_
                _end209340_)))
          (if (let () (declare (not safe)) (##fxzero? _res209343_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void)))))
  (define std/crypto/hmac#hmac-update!__0
    (lambda (_hmac209349_ _bytes209350_)
      (let* ((_start209352_ '#f) (_end209354_ '#f))
        (std/crypto/hmac#hmac-update!__%
         _hmac209349_
         _bytes209350_
         _start209352_
         _end209354_))))
  (define std/crypto/hmac#hmac-update!__1
    (lambda (_hmac209356_ _bytes209357_ _start209358_)
      (let ((_end209360_ '#f))
        (std/crypto/hmac#hmac-update!__%
         _hmac209356_
         _bytes209357_
         _start209358_
         _end209360_))))
  (define std/crypto/hmac#hmac-update!
    (lambda _g297481_
      (let ((_g297480_ (let () (declare (not safe)) (##length _g297481_))))
        (cond ((let () (declare (not safe)) (##fx= _g297480_ 2))
               (apply std/crypto/hmac#hmac-update!__0 _g297481_))
              ((let () (declare (not safe)) (##fx= _g297480_ 3))
               (apply std/crypto/hmac#hmac-update!__1 _g297481_))
              ((let () (declare (not safe)) (##fx= _g297480_ 4))
               (apply std/crypto/hmac#hmac-update!__% _g297481_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-update!
                _g297481_))))))
  (define std/crypto/hmac#hmac-final!__%
    (lambda (_hmac209302_ _bytes209303_)
      (let* ((_size209305_
              (std/crypto/libcrypto#EVP_MD_size
               (##structure-ref _hmac209302_ '1 std/crypto/hmac#hmac::t '#f)))
             (_bytes209310_
              (let ((_$e209307_ _bytes209303_))
                (if _$e209307_ _$e209307_ (make-u8vector _size209305_)))))
        (let ((_res209313_
               (std/crypto/libcrypto#HMAC_Final
                (##structure-ref _hmac209302_ '2 std/crypto/hmac#hmac::t '#f)
                _bytes209310_)))
          (if (let () (declare (not safe)) (##fxzero? _res209313_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        _bytes209310_)))
  (define std/crypto/hmac#hmac-final!__0
    (lambda (_hmac209319_)
      (let ((_bytes209321_ '#f))
        (std/crypto/hmac#hmac-final!__% _hmac209319_ _bytes209321_))))
  (define std/crypto/hmac#hmac-final!
    (lambda _g297483_
      (let ((_g297482_ (let () (declare (not safe)) (##length _g297483_))))
        (cond ((let () (declare (not safe)) (##fx= _g297482_ 1))
               (apply std/crypto/hmac#hmac-final!__0 _g297483_))
              ((let () (declare (not safe)) (##fx= _g297482_ 2))
               (apply std/crypto/hmac#hmac-final!__% _g297483_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-final!
                _g297483_))))))
  (define std/crypto/hmac#hmac-digest__%
    (lambda (_md209256_ _key209257_ _bytes209258_ _start209259_ _end209260_)
      (if (std/crypto/libcrypto#EVP_MD? _md209256_)
          '#!void
          (error '"Bad digest type" _md209256_))
      (let* ((_start209265_
              (let ((_$e209262_ _start209259_)) (if _$e209262_ _$e209262_ '0)))
             (_end209270_
              (let ((_$e209267_ _end209260_))
                (if _$e209267_ _$e209267_ (u8vector-length _bytes209258_))))
             (_size209272_ (std/crypto/libcrypto#EVP_MD_size _md209256_))
             (_digest209274_ (make-u8vector _size209272_)))
        (std/crypto/libcrypto#HMAC
         _md209256_
         _key209257_
         _bytes209258_
         _start209265_
         _end209270_
         _digest209274_)
        _digest209274_)))
  (define std/crypto/hmac#hmac-digest__0
    (lambda (_md209280_ _key209281_ _bytes209282_)
      (let* ((_start209284_ '#f) (_end209286_ '#f))
        (std/crypto/hmac#hmac-digest__%
         _md209280_
         _key209281_
         _bytes209282_
         _start209284_
         _end209286_))))
  (define std/crypto/hmac#hmac-digest__1
    (lambda (_md209288_ _key209289_ _bytes209290_ _start209291_)
      (let ((_end209293_ '#f))
        (std/crypto/hmac#hmac-digest__%
         _md209288_
         _key209289_
         _bytes209290_
         _start209291_
         _end209293_))))
  (define std/crypto/hmac#hmac-digest
    (lambda _g297485_
      (let ((_g297484_ (let () (declare (not safe)) (##length _g297485_))))
        (cond ((let () (declare (not safe)) (##fx= _g297484_ 3))
               (apply std/crypto/hmac#hmac-digest__0 _g297485_))
              ((let () (declare (not safe)) (##fx= _g297484_ 4))
               (apply std/crypto/hmac#hmac-digest__1 _g297485_))
              ((let () (declare (not safe)) (##fx= _g297484_ 5))
               (apply std/crypto/hmac#hmac-digest__% _g297485_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-digest
                _g297485_))))))
  (define std/crypto/hmac#hmac-md5__%
    (lambda (_key209225_ _bytes209227_ _start209229_ _end209231_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::md5
       _key209225_
       _bytes209227_
       _start209229_
       _end209231_)))
  (define std/crypto/hmac#hmac-md5__0
    (lambda (_key209237_ _bytes209238_)
      (let* ((_start209240_ '#f) (_end209242_ '#f))
        (std/crypto/hmac#hmac-md5__%
         _key209237_
         _bytes209238_
         _start209240_
         _end209242_))))
  (define std/crypto/hmac#hmac-md5__1
    (lambda (_key209244_ _bytes209245_ _start209246_)
      (let ((_end209248_ '#f))
        (std/crypto/hmac#hmac-md5__%
         _key209244_
         _bytes209245_
         _start209246_
         _end209248_))))
  (define std/crypto/hmac#hmac-md5
    (lambda _g297487_
      (let ((_g297486_ (let () (declare (not safe)) (##length _g297487_))))
        (cond ((let () (declare (not safe)) (##fx= _g297486_ 2))
               (apply std/crypto/hmac#hmac-md5__0 _g297487_))
              ((let () (declare (not safe)) (##fx= _g297486_ 3))
               (apply std/crypto/hmac#hmac-md5__1 _g297487_))
              ((let () (declare (not safe)) (##fx= _g297486_ 4))
               (apply std/crypto/hmac#hmac-md5__% _g297487_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-md5
                _g297487_))))))
  (define std/crypto/hmac#hmac-sha1__%
    (lambda (_key209194_ _bytes209196_ _start209198_ _end209200_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha1
       _key209194_
       _bytes209196_
       _start209198_
       _end209200_)))
  (define std/crypto/hmac#hmac-sha1__0
    (lambda (_key209206_ _bytes209207_)
      (let* ((_start209209_ '#f) (_end209211_ '#f))
        (std/crypto/hmac#hmac-sha1__%
         _key209206_
         _bytes209207_
         _start209209_
         _end209211_))))
  (define std/crypto/hmac#hmac-sha1__1
    (lambda (_key209213_ _bytes209214_ _start209215_)
      (let ((_end209217_ '#f))
        (std/crypto/hmac#hmac-sha1__%
         _key209213_
         _bytes209214_
         _start209215_
         _end209217_))))
  (define std/crypto/hmac#hmac-sha1
    (lambda _g297489_
      (let ((_g297488_ (let () (declare (not safe)) (##length _g297489_))))
        (cond ((let () (declare (not safe)) (##fx= _g297488_ 2))
               (apply std/crypto/hmac#hmac-sha1__0 _g297489_))
              ((let () (declare (not safe)) (##fx= _g297488_ 3))
               (apply std/crypto/hmac#hmac-sha1__1 _g297489_))
              ((let () (declare (not safe)) (##fx= _g297488_ 4))
               (apply std/crypto/hmac#hmac-sha1__% _g297489_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha1
                _g297489_))))))
  (define std/crypto/hmac#hmac-sha256__%
    (lambda (_key209163_ _bytes209165_ _start209167_ _end209169_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha256
       _key209163_
       _bytes209165_
       _start209167_
       _end209169_)))
  (define std/crypto/hmac#hmac-sha256__0
    (lambda (_key209175_ _bytes209176_)
      (let* ((_start209178_ '#f) (_end209180_ '#f))
        (std/crypto/hmac#hmac-sha256__%
         _key209175_
         _bytes209176_
         _start209178_
         _end209180_))))
  (define std/crypto/hmac#hmac-sha256__1
    (lambda (_key209182_ _bytes209183_ _start209184_)
      (let ((_end209186_ '#f))
        (std/crypto/hmac#hmac-sha256__%
         _key209182_
         _bytes209183_
         _start209184_
         _end209186_))))
  (define std/crypto/hmac#hmac-sha256
    (lambda _g297491_
      (let ((_g297490_ (let () (declare (not safe)) (##length _g297491_))))
        (cond ((let () (declare (not safe)) (##fx= _g297490_ 2))
               (apply std/crypto/hmac#hmac-sha256__0 _g297491_))
              ((let () (declare (not safe)) (##fx= _g297490_ 3))
               (apply std/crypto/hmac#hmac-sha256__1 _g297491_))
              ((let () (declare (not safe)) (##fx= _g297490_ 4))
               (apply std/crypto/hmac#hmac-sha256__% _g297491_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha256
                _g297491_))))))
  (define std/crypto/hmac#hmac-sha384__%
    (lambda (_key209132_ _bytes209134_ _start209136_ _end209138_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha384
       _key209132_
       _bytes209134_
       _start209136_
       _end209138_)))
  (define std/crypto/hmac#hmac-sha384__0
    (lambda (_key209144_ _bytes209145_)
      (let* ((_start209147_ '#f) (_end209149_ '#f))
        (std/crypto/hmac#hmac-sha384__%
         _key209144_
         _bytes209145_
         _start209147_
         _end209149_))))
  (define std/crypto/hmac#hmac-sha384__1
    (lambda (_key209151_ _bytes209152_ _start209153_)
      (let ((_end209155_ '#f))
        (std/crypto/hmac#hmac-sha384__%
         _key209151_
         _bytes209152_
         _start209153_
         _end209155_))))
  (define std/crypto/hmac#hmac-sha384
    (lambda _g297493_
      (let ((_g297492_ (let () (declare (not safe)) (##length _g297493_))))
        (cond ((let () (declare (not safe)) (##fx= _g297492_ 2))
               (apply std/crypto/hmac#hmac-sha384__0 _g297493_))
              ((let () (declare (not safe)) (##fx= _g297492_ 3))
               (apply std/crypto/hmac#hmac-sha384__1 _g297493_))
              ((let () (declare (not safe)) (##fx= _g297492_ 4))
               (apply std/crypto/hmac#hmac-sha384__% _g297493_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha384
                _g297493_))))))
  (define std/crypto/hmac#hmac-sha512__%
    (lambda (_key209101_ _bytes209103_ _start209105_ _end209107_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha512
       _key209101_
       _bytes209103_
       _start209105_
       _end209107_)))
  (define std/crypto/hmac#hmac-sha512__0
    (lambda (_key209113_ _bytes209114_)
      (let* ((_start209116_ '#f) (_end209118_ '#f))
        (std/crypto/hmac#hmac-sha512__%
         _key209113_
         _bytes209114_
         _start209116_
         _end209118_))))
  (define std/crypto/hmac#hmac-sha512__1
    (lambda (_key209120_ _bytes209121_ _start209122_)
      (let ((_end209124_ '#f))
        (std/crypto/hmac#hmac-sha512__%
         _key209120_
         _bytes209121_
         _start209122_
         _end209124_))))
  (define std/crypto/hmac#hmac-sha512
    (lambda _g297495_
      (let ((_g297494_ (let () (declare (not safe)) (##length _g297495_))))
        (cond ((let () (declare (not safe)) (##fx= _g297494_ 2))
               (apply std/crypto/hmac#hmac-sha512__0 _g297495_))
              ((let () (declare (not safe)) (##fx= _g297494_ 3))
               (apply std/crypto/hmac#hmac-sha512__1 _g297495_))
              ((let () (declare (not safe)) (##fx= _g297494_ 4))
               (apply std/crypto/hmac#hmac-sha512__% _g297495_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha512
                _g297495_)))))))
