(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/pkey#keygen/ed25519
    (lambda ()
      (letrec* ((_ctx209730_
                 (std/crypto/libcrypto#EVP_PKEY_CTX_new_id
                  std/crypto/libcrypto#EVP_PKEY_ED25519
                  '#f)))
        (if (and _ctx209730_
                 (< '0
                    (std/crypto/libcrypto#EVP_PKEY_keygen_init _ctx209730_)))
            '#!void
            (error '"Can't create ED25519 keygen context"))
        (std/crypto/libcrypto#EVP_PKEY_keygen _ctx209730_))))
  (define std/crypto/pkey#bytes->private-key__%
    (lambda (_g297506_ _engine209705209708_ _type209710_ _bytes209711_)
      (let ((_engine209713_
             (if (eq? _engine209705209708_ absent-value)
                 '#f
                 _engine209705209708_)))
        (std/crypto/libcrypto#EVP_PKEY_new_raw_private_key
         _type209710_
         _engine209713_
         _bytes209711_))))
  (define std/crypto/pkey#bytes->private-key__@
    (lambda (_keys209704209718_ . _args209720_)
      (apply std/crypto/pkey#bytes->private-key__%
             _keys209704209718_
             (table-ref _keys209704209718_ 'engine: absent-value)
             _args209720_)))
  (define std/crypto/pkey#bytes->private-key
    (lambda _args209706209726_
      (apply keyword-dispatch
             '#(engine:)
             std/crypto/pkey#bytes->private-key__@
             _args209706209726_)))
  (define std/crypto/pkey#bytes->public-key__%
    (lambda (_g297507_ _engine209679209682_ _type209684_ _bytes209685_)
      (let ((_engine209687_
             (if (eq? _engine209679209682_ absent-value)
                 '#f
                 _engine209679209682_)))
        (std/crypto/libcrypto#EVP_PKEY_new_raw_public_key
         _type209684_
         _engine209687_
         _bytes209685_))))
  (define std/crypto/pkey#bytes->public-key__@
    (lambda (_keys209678209692_ . _args209694_)
      (apply std/crypto/pkey#bytes->public-key__%
             _keys209678209692_
             (table-ref _keys209678209692_ 'engine: absent-value)
             _args209694_)))
  (define std/crypto/pkey#bytes->public-key
    (lambda _args209680209700_
      (apply keyword-dispatch
             '#(engine:)
             std/crypto/pkey#bytes->public-key__@
             _args209680209700_)))
  (define std/crypto/pkey#bytes-argument
    (lambda (_bytes209675_)
      (if (u8vector? _bytes209675_)
          _bytes209675_
          (if (fixnum? _bytes209675_)
              (make-u8vector _bytes209675_)
              (if (not _bytes209675_)
                  '#f
                  (error '"invalid bytes argument" _bytes209675_))))))
  (define std/crypto/pkey#bytes-result
    (lambda (_bytes209672_ _len209673_)
      (if (zero? _len209673_)
          '#f
          (if (= _len209673_ (u8vector-length _bytes209672_))
              _bytes209672_
              (if (< _len209673_ (u8vector-length _bytes209672_))
                  (subu8vector _bytes209672_ '0 _len209673_)
                  '#f)))))
  (define std/crypto/pkey#key->bytes
    (lambda (_pkey209662_ _bytes209663_ _get_raw209664_)
      (letrec* ((_b209666_
                 (let ((_$e209669_
                        (std/crypto/pkey#bytes-argument _bytes209663_)))
                   (if _$e209669_
                       _$e209669_
                       (make-u8vector (_get_raw209664_ _pkey209662_ '#f)))))
                (_len209667_ (_get_raw209664_ _pkey209662_ _b209666_)))
        (std/crypto/pkey#bytes-result _b209666_ _len209667_))))
  (define std/crypto/pkey#private-key->bytes__%
    (lambda (_pkey209649_ _bytes209650_)
      (std/crypto/pkey#key->bytes
       _pkey209649_
       _bytes209650_
       std/crypto/libcrypto#EVP_PKEY_get_raw_private_key)))
  (define std/crypto/pkey#private-key->bytes__0
    (lambda (_pkey209655_)
      (let ((_bytes209657_ '#f))
        (std/crypto/pkey#private-key->bytes__% _pkey209655_ _bytes209657_))))
  (define std/crypto/pkey#private-key->bytes
    (lambda _g297509_
      (let ((_g297508_ (let () (declare (not safe)) (##length _g297509_))))
        (cond ((let () (declare (not safe)) (##fx= _g297508_ 1))
               (apply std/crypto/pkey#private-key->bytes__0 _g297509_))
              ((let () (declare (not safe)) (##fx= _g297508_ 2))
               (apply std/crypto/pkey#private-key->bytes__% _g297509_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/pkey#private-key->bytes
                _g297509_))))))
  (define std/crypto/pkey#public-key->bytes__%
    (lambda (_pkey209635_ _bytes209636_)
      (std/crypto/pkey#key->bytes
       _pkey209635_
       _bytes209636_
       std/crypto/libcrypto#EVP_PKEY_get_raw_public_key)))
  (define std/crypto/pkey#public-key->bytes__0
    (lambda (_pkey209641_)
      (let ((_bytes209643_ '#f))
        (std/crypto/pkey#public-key->bytes__% _pkey209641_ _bytes209643_))))
  (define std/crypto/pkey#public-key->bytes
    (lambda _g297511_
      (let ((_g297510_ (let () (declare (not safe)) (##length _g297511_))))
        (cond ((let () (declare (not safe)) (##fx= _g297510_ 1))
               (apply std/crypto/pkey#public-key->bytes__0 _g297511_))
              ((let () (declare (not safe)) (##fx= _g297510_ 2))
               (apply std/crypto/pkey#public-key->bytes__% _g297511_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/pkey#public-key->bytes
                _g297511_))))))
  (define std/crypto/pkey#digest-sign__%
    (lambda (_g297512_
             _engine209597209601_
             _sig209598209603_
             _pkey209605_
             _bytes209606_)
      (let* ((_engine209608_
              (if (eq? _engine209597209601_ absent-value)
                  '#f
                  _engine209597209601_))
             (_sig209610_
              (if (eq? _sig209598209603_ absent-value) '#f _sig209598209603_)))
        (letrec* ((_mctx209612_ (std/crypto/libcrypto#EVP_MD_CTX_create))
                  (_pctx209613_
                   (std/crypto/libcrypto#EVP_PKEY_CTX_new
                    _pkey209605_
                    _engine209608_))
                  (_g297513_
                   (let ((_g297514_
                          (if (and _mctx209612_ _pctx209613_)
                              (std/crypto/libcrypto#EVP_MD_CTX_set_pkey_ctx
                               _mctx209612_
                               _pctx209613_)
                              (error '"Can't create signing context"))))
                     #!void
                     _g297514_))
                  (_s209614_
                   (let ((_$e209617_
                          (std/crypto/pkey#bytes-argument _sig209610_)))
                     (if _$e209617_ _$e209617_ (make-u8vector '8192))))
                  (_len209615_
                   (std/crypto/libcrypto#EVP_DigestSign
                    _mctx209612_
                    _s209614_
                    _bytes209606_)))
          (std/crypto/pkey#bytes-result _s209614_ _len209615_)))))
  (define std/crypto/pkey#digest-sign__@
    (lambda (_keys209596209623_ . _args209625_)
      (apply std/crypto/pkey#digest-sign__%
             _keys209596209623_
             (table-ref _keys209596209623_ 'engine: absent-value)
             (table-ref _keys209596209623_ 'sig: absent-value)
             _args209625_)))
  (define std/crypto/pkey#digest-sign
    (lambda _args209599209631_
      (apply keyword-dispatch
             '#(sig: engine:)
             std/crypto/pkey#digest-sign__@
             _args209599209631_)))
  (define std/crypto/pkey#digest-verify__%
    (lambda (_g297516_
             _engine209567209570_
             _pkey209572_
             _sig209573_
             _bytes209574_)
      (let ((_engine209576_
             (if (eq? _engine209567209570_ absent-value)
                 '#f
                 _engine209567209570_)))
        (letrec* ((_mctx209578_ (std/crypto/libcrypto#EVP_MD_CTX_create))
                  (_pctx209579_
                   (std/crypto/libcrypto#EVP_PKEY_CTX_new
                    _pkey209572_
                    _engine209576_)))
          (if (and _mctx209578_ _pctx209579_)
              (std/crypto/libcrypto#EVP_MD_CTX_set_pkey_ctx
               _mctx209578_
               _pctx209579_)
              (error '"Can't create verification context"))
          (= '1
             (std/crypto/libcrypto#EVP_DigestVerify
              _mctx209578_
              _sig209573_
              _bytes209574_))))))
  (define std/crypto/pkey#digest-verify__@
    (lambda (_keys209566209584_ . _args209586_)
      (apply std/crypto/pkey#digest-verify__%
             _keys209566209584_
             (table-ref _keys209566209584_ 'engine: absent-value)
             _args209586_)))
  (define std/crypto/pkey#digest-verify
    (lambda _args209568209592_
      (apply keyword-dispatch
             '#(engine:)
             std/crypto/pkey#digest-verify__@
             _args209568209592_))))
