(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/logger#default-level '1)
  (define std/logger#verbose-level '4)
  (define std/logger#levels
    (let ((_ht49027_ (make-table 'size: '5)))
      (table-set! _ht49027_ '0 'ERROR)
      (table-set! _ht49027_ '1 'WARN)
      (table-set! _ht49027_ '2 'INFO)
      (table-set! _ht49027_ '3 'DEBUG)
      (table-set! _ht49027_ '4 'VERBOSE)
      _ht49027_))
  (define std/logger#symbolic-levels
    (let ((_ht49024_ (make-table 'size: '5)))
      (table-set! _ht49024_ 'ERROR '0)
      (table-set! _ht49024_ 'WARN '1)
      (table-set! _ht49024_ 'INFO '2)
      (table-set! _ht49024_ 'DEBUG '3)
      (table-set! _ht49024_ 'VERBOSE '4)
      _ht49024_))
  (define std/logger#level->symbolic
    (lambda (_level49022_)
      (table-ref std/logger#levels _level49022_ 'UNKNOWN)))
  (define std/logger#object->level
    (lambda (_level49020_)
      (if (fixnum? _level49020_)
          _level49020_
          (if (symbol? _level49020_)
              (table-ref
               std/logger#symbolic-levels
               _level49020_
               std/logger#verbose-level)
              (error '"invalid level; must be fixnum or symbol"
                     _level49020_)))))
  (define std/logger#current-logger (make-parameter '#f))
  (define std/logger#current-logger-options (make-parameter '1))
  (define std/logger#logger-options::t
    (make-struct-type
     'std/logger#logger-options::t
     '#f
     '2
     'logger-options
     '()
     '#f
     '(threshold sources)))
  (define std/logger#logger-options?
    (make-struct-predicate std/logger#logger-options::t))
  (define std/logger#make-logger-options
    (lambda _$args49017_
      (apply make-struct-instance std/logger#logger-options::t _$args49017_)))
  (define std/logger#logger-options-threshold
    (make-struct-field-accessor std/logger#logger-options::t '0))
  (define std/logger#logger-options-sources
    (make-struct-field-accessor std/logger#logger-options::t '1))
  (define std/logger#logger-options-threshold-set!
    (make-struct-field-mutator std/logger#logger-options::t '0))
  (define std/logger#logger-options-sources-set!
    (make-struct-field-mutator std/logger#logger-options::t '1))
  (define std/logger#log-message
    (lambda (_source48987_ _level48988_ _fmt48989_ _args48990_)
      (letrec ((_log-it48992_
                (lambda (_logger49008_ _threshold49009_)
                  (let ((_level49011_ (std/logger#object->level _level48988_))
                        (_threshold49012_
                         (std/logger#object->level _threshold49009_)))
                    (if (let ()
                          (declare (not safe))
                          (##fx<= _level49011_ _threshold49012_))
                        (let ((_now49014_ (std/srfi/19#current-date))
                              (_msg49015_
                               (if (null? _args48990_)
                                   _fmt48989_
                                   (apply std/format#format
                                          _fmt48989_
                                          (map std/logger#exception->string
                                               _args48990_)))))
                          (thread-send
                           _logger49008_
                           (let ()
                             (declare (not safe))
                             (##structure
                              std/logger#!log-message::t
                              _now49014_
                              _level49011_
                              _source48987_
                              _msg49015_))))
                        '#!void)))))
        (let ((_$e48994_ (std/logger#current-logger)))
          (if _$e48994_
              ((lambda (_logger48997_)
                 (let ((_opts48999_ (std/logger#current-logger-options)))
                   (if (let ()
                         (declare (not safe))
                         (##structure-instance-of?
                          _opts48999_
                          'std/logger#logger-options::t))
                       (let ((_$e49001_
                              (table-ref
                               (##structure-ref
                                _opts48999_
                                '2
                                std/logger#logger-options::t
                                '#f)
                               _source48987_
                               '#f)))
                         (if _$e49001_
                             ((lambda (_g4900349005_)
                                (_log-it48992_ _logger48997_ _g4900349005_))
                              _$e49001_)
                             (_log-it48992_
                              _logger48997_
                              (##structure-ref
                               _opts48999_
                               '1
                               std/logger#logger-options::t
                               '#f))))
                       (_log-it48992_ _logger48997_ _opts48999_))))
               _$e48994_)
              '#!void)))))
  (define std/logger#exception->string
    (lambda (_obj48983_)
      (if (exception? _obj48983_)
          (let ((_outp48985_ (open-output-string)))
            (display-exception _obj48983_ _outp48985_)
            (get-output-string _outp48985_))
          _obj48983_)))
  (define std/logger#errorf
    (lambda (_fmt48980_ . _args48981_)
      (std/logger#log-message 'default '0 _fmt48980_ _args48981_)))
  (define std/logger#warnf
    (lambda (_fmt48977_ . _args48978_)
      (std/logger#log-message 'default '1 _fmt48977_ _args48978_)))
  (define std/logger#infof
    (lambda (_fmt48974_ . _args48975_)
      (std/logger#log-message 'default '2 _fmt48974_ _args48975_)))
  (define std/logger#debugf
    (lambda (_fmt48971_ . _args48972_)
      (std/logger#log-message 'default '3 _fmt48971_ _args48972_)))
  (define std/logger#verbosef
    (lambda (_fmt48966_ . _args48968_)
      (std/logger#log-message 'default '4 _fmt48966_ _args48968_)))
  (define std/logger#!log-message::t
    (make-struct-type
     'std/logger#!log-message::t
     '#f
     '4
     '!log-message
     '()
     '#f
     '(ts level source msg)))
  (define std/logger#!log-message?
    (make-struct-predicate std/logger#!log-message::t))
  (define std/logger#make-!log-message
    (lambda _$args48963_
      (apply make-struct-instance std/logger#!log-message::t _$args48963_)))
  (define std/logger#!log-message-ts
    (make-struct-field-accessor std/logger#!log-message::t '0))
  (define std/logger#!log-message-level
    (make-struct-field-accessor std/logger#!log-message::t '1))
  (define std/logger#!log-message-source
    (make-struct-field-accessor std/logger#!log-message::t '2))
  (define std/logger#!log-message-msg
    (make-struct-field-accessor std/logger#!log-message::t '3))
  (define std/logger#!log-message-ts-set!
    (make-struct-field-mutator std/logger#!log-message::t '0))
  (define std/logger#!log-message-level-set!
    (make-struct-field-mutator std/logger#!log-message::t '1))
  (define std/logger#!log-message-source-set!
    (make-struct-field-mutator std/logger#!log-message::t '2))
  (define std/logger#!log-message-msg-set!
    (make-struct-field-mutator std/logger#!log-message::t '3))
  (define std/logger#start-logger!__%
    (lambda (_output48944_)
      (let ((_$e48946_ (std/logger#current-logger)))
        (if _$e48946_
            (values _$e48946_)
            (let ((_g288121_
                   (if (output-port? _output48944_)
                       (values _output48944_ '#f)
                       (if (string? _output48944_)
                           (values (open-output-file
                                    (cons 'path:
                                          (cons _output48944_
                                                (cons 'append:
                                                      (cons '#t '())))))
                                   '#t)
                           (error '"Bad output; expected filename or port"
                                  _output48944_)))))
              (begin
                (let ((_g288122_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g288121_)
                             (##vector-length _g288121_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g288122_ 2)))
                      (error "Context expects 2 values" _g288122_)))
                (let ((_port48949_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288121_ 0)))
                      (_own-port?48950_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288121_ 1))))
                  (let ((_srv48952_
                         (gerbil/gambit/threads#spawn/name
                          'logger
                          std/logger#logger-server
                          _port48949_
                          _own-port?48950_)))
                    (std/logger#current-logger _srv48952_)
                    _srv48952_))))))))
  (define std/logger#start-logger!__0
    (lambda ()
      (let ((_output48959_ (current-error-port)))
        (std/logger#start-logger!__% _output48959_))))
  (define std/logger#start-logger!
    (lambda _g288124_
      (let ((_g288123_ (let () (declare (not safe)) (##length _g288124_))))
        (cond ((let () (declare (not safe)) (##fx= _g288123_ 0))
               (apply std/logger#start-logger!__0 _g288124_))
              ((let () (declare (not safe)) (##fx= _g288123_ 1))
               (apply std/logger#start-logger!__% _g288124_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/logger#start-logger!
                _g288124_))))))
  (define std/logger#logger-server
    (lambda (_port48877_ _own-port?48878_)
      (letrec ((_loop48880_
                (lambda ()
                  (let* ((_g4888448896_ (thread-receive))
                         (_else4888748904_ (lambda () (_loop48880_))))
                    (let ((_K4889048920_
                           (lambda (_msg48915_
                                    _source48916_
                                    _level48917_
                                    _ts48918_)
                             (std/format#fprintf
                              _port48877_
                              '"~a ~a ~a ~a~n"
                              (std/srfi/19#date->string _ts48918_ '"~4")
                              (std/logger#level->symbolic _level48917_)
                              _source48916_
                              _msg48915_)
                             (force-output _port48877_)
                             (_loop48880_)))
                          (_K4888948909_ (lambda () '#!void)))
                      (let ((_try-match4888648912_
                             (lambda ()
                               (if (let ()
                                     (declare (not safe))
                                     (##eq? _g4888448896_ 'shutdown))
                                   '#!void
                                   (_loop48880_)))))
                        (if (let ()
                              (declare (not safe))
                              (##structure-instance-of?
                               _g4888448896_
                               'std/logger#!log-message::t))
                            (let* ((_e4889148923_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g4888448896_ '1)))
                                   (_e4889248928_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g4888448896_ '2)))
                                   (_e4889348933_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g4888448896_ '3)))
                                   (_e4889448938_
                                    (let ()
                                      (declare (not safe))
                                      (##vector-ref _g4888448896_ '4))))
                              (let ((_ts48926_ _e4889148923_)
                                    (_level48931_ _e4889248928_)
                                    (_source48936_ _e4889348933_)
                                    (_msg48941_ _e4889448938_))
                                (_K4889048920_
                                 _msg48941_
                                 _source48936_
                                 _level48931_
                                 _ts48926_)))
                            (_try-match4888648912_))))))))
        (with-unwind-protect
         (lambda () (_loop48880_))
         (lambda ()
           (if _own-port?48878_ (close-port _port48877_) '#!void)))))))
