(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/uuid#uuid-length '16)
  (define std/misc/uuid#uuid::t
    (make-struct-type
     'std/misc/uuid#uuid::t
     '#f
     '2
     'uuid
     '((equal: bytes) (final: . #t))
     '#f
     '(bytes str)))
  (define std/misc/uuid#uuid? (make-struct-predicate std/misc/uuid#uuid::t))
  (define std/misc/uuid#make-uuid
    (lambda _$args177382_
      (apply make-struct-instance std/misc/uuid#uuid::t _$args177382_)))
  (define std/misc/uuid#uuid-bytes
    (make-struct-field-accessor std/misc/uuid#uuid::t '0))
  (define std/misc/uuid#uuid-str
    (make-struct-field-accessor std/misc/uuid#uuid::t '1))
  (define std/misc/uuid#uuid-bytes-set!
    (make-struct-field-mutator std/misc/uuid#uuid::t '0))
  (define std/misc/uuid#uuid-str-set!
    (make-struct-field-mutator std/misc/uuid#uuid::t '1))
  (define std/misc/uuid#uuid=?
    (lambda (_a177379_ _b177380_)
      (equal? (##direct-structure-ref _a177379_ '1 std/misc/uuid#uuid::t '#f)
              (##direct-structure-ref
               _b177380_
               '1
               std/misc/uuid#uuid::t
               '#f))))
  (define std/misc/uuid#uuid-hash
    (lambda (_uuid177377_)
      (equal?-hash
       (##direct-structure-ref _uuid177377_ '1 std/misc/uuid#uuid::t '#f))))
  (define std/misc/uuid#UUID
    (lambda (_obj177375_)
      (if (let ()
            (declare (not safe))
            (##structure-direct-instance-of?
             _obj177375_
             'std/misc/uuid#uuid::t))
          _obj177375_
          (if (string? _obj177375_)
              (std/misc/uuid#text->uuid _obj177375_)
              (if (symbol? _obj177375_)
                  (std/misc/uuid#text->uuid (symbol->string _obj177375_))
                  (if (u8vector? _obj177375_)
                      (std/misc/uuid#u8vector->uuid _obj177375_)
                      (error '"bad uuid identifier" _obj177375_)))))))
  (define std/misc/uuid#random-uuid
    (lambda ()
      (let ((_bytes177373_ (make-u8vector std/misc/uuid#uuid-length)))
        (std/crypto/etc#random-bytes!__0 _bytes177373_)
        (let ()
          (declare (not safe))
          (##structure std/misc/uuid#uuid::t _bytes177373_ '#f)))))
  (define std/misc/uuid#content-uuid
    (lambda (_str177365_)
      (let* ((_bytes177367_ (std/text/utf8#string->utf8__0 _str177365_))
             (_hash177369_ (std/crypto/digest#md5 _bytes177367_)))
        (let ()
          (declare (not safe))
          (##structure std/misc/uuid#uuid::t _hash177369_ '#f)))))
  (define std/misc/uuid#uuid-re
    (std/pregexp#pregexp
     '"[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}"))
  (define std/misc/uuid#uuid-re-capture
    (std/pregexp#pregexp
     '"([0-9a-fA-F]{8})-([0-9a-fA-F]{4})-([0-9a-fA-F]{4})-([0-9a-fA-F]{4})-([0-9a-fA-F]{12})"))
  (define std/misc/uuid#text->uuid
    (lambda (_str177363_)
      (if (std/pregexp#pregexp-match std/misc/uuid#uuid-re _str177363_)
          (std/misc/uuid#string->uuid _str177363_)
          (std/misc/uuid#content-uuid _str177363_))))
  (define std/misc/uuid#u8vector->uuid
    (lambda (_u8v177361_)
      (if (let ((__tmp297809 (u8vector-length _u8v177361_)))
            (declare (not safe))
            (##fx= __tmp297809 std/misc/uuid#uuid-length))
          (let ()
            (declare (not safe))
            (##structure std/misc/uuid#uuid::t _u8v177361_ '#f))
          (error '"Bad argument; invalid u8vector length" _u8v177361_))))
  (define std/misc/uuid#uuid->u8vector
    (lambda (_uuid177359_)
      (##direct-structure-ref _uuid177359_ '1 std/misc/uuid#uuid::t '#f)))
  (define std/misc/uuid#string->uuid
    (lambda (_str177282_)
      (let* ((_g177283177301_
              (std/pregexp#pregexp-match
               std/misc/uuid#uuid-re-capture
               _str177282_))
             (_else177285177309_
              (lambda () (error '"Bad argument; malformed uuid" _str177282_)))
             (_K177287177318_
              (lambda (_e177312_ _d177313_ _c177314_ _b177315_ _a177316_)
                (let ((__tmp297810
                       (u8vector-append
                        (std/text/hex#hex-decode__0 _a177316_)
                        (std/text/hex#hex-decode__0 _b177315_)
                        (std/text/hex#hex-decode__0 _c177314_)
                        (std/text/hex#hex-decode__0 _d177313_)
                        (std/text/hex#hex-decode__0 _e177312_))))
                  (declare (not safe))
                  (##structure
                   std/misc/uuid#uuid::t
                   __tmp297810
                   _str177282_)))))
        (if (let () (declare (not safe)) (##pair? _g177283177301_))
            (let ((_tl177289177321_
                   (let () (declare (not safe)) (##cdr _g177283177301_))))
              (if (let () (declare (not safe)) (##pair? _tl177289177321_))
                  (let ((_hd177290177324_
                         (let ()
                           (declare (not safe))
                           (##car _tl177289177321_)))
                        (_tl177291177326_
                         (let ()
                           (declare (not safe))
                           (##cdr _tl177289177321_))))
                    (let ((_a177329_ _hd177290177324_))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _tl177291177326_))
                          (let ((_hd177292177331_
                                 (let ()
                                   (declare (not safe))
                                   (##car _tl177291177326_)))
                                (_tl177293177333_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _tl177291177326_))))
                            (let ((_b177336_ _hd177292177331_))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _tl177293177333_))
                                  (let ((_hd177294177338_
                                         (let ()
                                           (declare (not safe))
                                           (##car _tl177293177333_)))
                                        (_tl177295177340_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _tl177293177333_))))
                                    (let ((_c177343_ _hd177294177338_))
                                      (if (let ()
                                            (declare (not safe))
                                            (##pair? _tl177295177340_))
                                          (let ((_hd177296177345_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##car _tl177295177340_)))
                                                (_tl177297177347_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##cdr _tl177295177340_))))
                                            (let ((_d177350_ _hd177296177345_))
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##pair? _tl177297177347_))
                                                  (let ((_hd177298177352_
                                                         (let ()
                                                           (declare (not safe))
                                                           (##car _tl177297177347_)))
                                                        (_tl177299177354_
                                                         (let ()
                                                           (declare (not safe))
                                                           (##cdr _tl177297177347_))))
                                                    (let ((_e177357_
                                                           _hd177298177352_))
                                                      (if (let ()
                                                            (declare
                                                              (not safe))
                                                            (##null? _tl177299177354_))
                                                          (_K177287177318_
                                                           _e177357_
                                                           _d177350_
                                                           _c177343_
                                                           _b177336_
                                                           _a177329_)
                                                          (_else177285177309_))))
                                                  (_else177285177309_))))
                                          (_else177285177309_))))
                                  (_else177285177309_))))
                          (_else177285177309_))))
                  (_else177285177309_)))
            (_else177285177309_)))))
  (define std/misc/uuid#uuid->string
    (lambda (_uuid177262_)
      (let ((_$e177264_
             (##direct-structure-ref
              _uuid177262_
              '2
              std/misc/uuid#uuid::t
              '#f)))
        (if _$e177264_
            (values _$e177264_)
            (let* ((_bytes177267_
                    (##direct-structure-ref
                     _uuid177262_
                     '1
                     std/misc/uuid#uuid::t
                     '#f))
                   (_a177269_ (std/text/hex#hex-encode__% _bytes177267_ '0 '4))
                   (_b177271_ (std/text/hex#hex-encode__% _bytes177267_ '4 '6))
                   (_c177273_ (std/text/hex#hex-encode__% _bytes177267_ '6 '8))
                   (_d177275_
                    (std/text/hex#hex-encode__% _bytes177267_ '8 '10))
                   (_e177277_
                    (std/text/hex#hex-encode__% _bytes177267_ '10 '16))
                   (_str177279_
                    (string-append
                     _a177269_
                     '"-"
                     _b177271_
                     '"-"
                     _c177273_
                     '"-"
                     _d177275_
                     '"-"
                     _e177277_)))
              (##direct-structure-set!
               _uuid177262_
               _str177279_
               '2
               std/misc/uuid#uuid::t
               '#f)
              _str177279_))))))
