(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/address#ip4-address
    (lambda (_obj170930_)
      (if (std/net/address#ip4-address? _obj170930_)
          _obj170930_
          (if (std/net/address#ip4-address-string? _obj170930_)
              (std/net/address#string->ip4-address _obj170930_)
              (error '"Malformed ip4 address" _obj170930_)))))
  (define std/net/address#ip4-address?
    (lambda (_obj170928_)
      (if (let () (declare (not safe)) (##u8vector? _obj170928_))
          (let ((__tmp296712
                 (let ()
                   (declare (not safe))
                   (##u8vector-length _obj170928_))))
            (declare (not safe))
            (##fx= __tmp296712 '4))
          '#f)))
  (define std/net/address#ip4-address-string?
    (lambda (_obj170926_)
      (if (string? _obj170926_)
          (if (std/pregexp#pregexp-match
               std/net/address#ip4-address-rx
               _obj170926_)
              '#t
              '#f)
          '#f)))
  (define std/net/address#ip4-address-rx
    (std/pregexp#pregexp
     '"^(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})$"))
  (define std/net/address#string->ip4-address
    (lambda (_str170901_)
      (let* ((_g170902170909_
              (std/pregexp#pregexp-match
               std/net/address#ip4-address-rx
               _str170901_))
             (_E170904170913_
              (lambda () (error '"No clause matching" _g170902170909_)))
             (_K170905170918_
              (lambda (_octets170916_)
                (apply ##u8vector (map string->number _octets170916_)))))
        (if (let () (declare (not safe)) (##pair? _g170902170909_))
            (let* ((_tl170907170921_
                    (let () (declare (not safe)) (##cdr _g170902170909_)))
                   (_octets170924_ _tl170907170921_))
              (_K170905170918_ _octets170924_))
            (_E170904170913_)))))
  (define std/net/address#ip4-address->string
    (lambda (_ip4170899_)
      (if (std/net/address#ip4-address? _ip4170899_)
          (apply std/format#format
                 '"~a.~a.~a.~a"
                 (let () (declare (not safe)) (##u8vector->list _ip4170899_)))
          (if (std/net/address#ip4-address-string? _ip4170899_)
              _ip4170899_
              (error '"Malformed ip4 address" _ip4170899_)))))
  (define std/net/address#ip6-address
    (lambda (_obj170897_)
      (if (std/net/address#ip6-address? _obj170897_)
          _obj170897_
          (if (std/net/address#ip6-address-string? _obj170897_)
              (std/net/address#string->ip6-address _obj170897_)
              (error '"Malformed ip6 address" _obj170897_)))))
  (define std/net/address#ip6-address?
    (lambda (_obj170895_)
      (if (let () (declare (not safe)) (##u8vector? _obj170895_))
          (let ((__tmp296713
                 (let ()
                   (declare (not safe))
                   (##u8vector-length _obj170895_))))
            (declare (not safe))
            (##fx= __tmp296713 '16))
          '#f)))
  (define std/net/address#ip6-address-rx
    (std/pregexp#pregexp '"^[0-9a-fA-F:]+$"))
  (define std/net/address#ip6-address-string?
    (lambda (_obj170893_)
      (if (string? _obj170893_)
          (if (std/pregexp#pregexp-match
               std/net/address#ip6-address-rx
               _obj170893_)
              '#t
              '#f)
          '#f)))
  (define std/net/address#string->ip6-address
    (lambda (_str170780_)
      (letrec ((_hex-e170782_
                (lambda (_str170885_ _k170886_)
                  (let* ((_char170888_ (string-ref _str170885_ _k170886_))
                         (_$e170890_ (std/text/hex#unhex* _char170888_)))
                    (if _$e170890_
                        (values _$e170890_)
                        (error '"Malformed address; not a hex digit"
                               _str170885_
                               _char170888_)))))
               (_loop170783_
                (lambda (_rest170835_ _bytes170836_ _have-zeros170837_)
                  (let* ((_rest170838170846_ _rest170835_)
                         (_else170840170854_
                          (lambda ()
                            (_check170784_
                             (list->u8vector (reverse _bytes170836_)))))
                         (_K170842170873_
                          (lambda (_rest170857_ _hex170858_)
                            (let ((_$e170860_ (string-length _hex170858_)))
                              (if (eq? '0 _$e170860_)
                                  (if _have-zeros170837_
                                      (error '"Malformed address" _str170780_)
                                      (let* ((_count170863_
                                              (length _rest170857_))
                                             (_count170865_
                                              (let ((__tmp296714
                                                     (let ()
                                                       (declare (not safe))
                                                       (##fx- '8
                                                              _count170863_))))
                                                (declare (not safe))
                                                (##fx* __tmp296714 '2)))
                                             (_count170867_
                                              (let ((__tmp296715
                                                     (length _bytes170836_)))
                                                (declare (not safe))
                                                (##fx- _count170865_
                                                       __tmp296715)))
                                             (_g296716_
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##fxnegative?
                                                     _count170867_))
                                                  (error '"Malformed address; too many bits"
                                                         _str170780_)
                                                  '#!void))
                                             (_block170870_
                                              (make-list _count170867_ '0)))
                                        (_loop170783_
                                         _rest170857_
                                         (foldl1 cons
                                                 _bytes170836_
                                                 _block170870_)
                                         '#t)))
                                  (if (eq? '1 _$e170860_)
                                      (_loop170783_
                                       _rest170857_
                                       (cons (_hex-e170782_ _hex170858_ '0)
                                             (cons '0 _bytes170836_))
                                       _have-zeros170837_)
                                      (if (eq? '2 _$e170860_)
                                          (_loop170783_
                                           _rest170857_
                                           (cons (let ((__tmp296718
                                                        (let ((__tmp296719
                                                               (_hex-e170782_
                                                                _hex170858_
                                                                '0)))
                                                          (declare (not safe))
                                                          (##fxarithmetic-shift
                                                           __tmp296719
                                                           '4)))
                                                       (__tmp296717
                                                        (_hex-e170782_
                                                         _hex170858_
                                                         '1)))
                                                   (declare (not safe))
                                                   (##fxior __tmp296718
                                                            __tmp296717))
                                                 (cons '0 _bytes170836_))
                                           _have-zeros170837_)
                                          (if (eq? '3 _$e170860_)
                                              (_loop170783_
                                               _rest170857_
                                               (cons (let ((__tmp296721
                                                            (let ((__tmp296722
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           (_hex-e170782_ _hex170858_ '1)))
                      (declare (not safe))
                      (##fxarithmetic-shift __tmp296722 '4)))
                   (__tmp296720 (_hex-e170782_ _hex170858_ '2)))
               (declare (not safe))
               (##fxior __tmp296721 __tmp296720))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (cons (_hex-e170782_
                                                            _hex170858_
                                                            '0)
                                                           _bytes170836_))
                                               _have-zeros170837_)
                                              (if (eq? '4 _$e170860_)
                                                  (_loop170783_
                                                   _rest170857_
                                                   (cons (let ((__tmp296724
                                                                (let ((__tmp296725
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                               (_hex-e170782_ _hex170858_ '2)))
                          (declare (not safe))
                          (##fxarithmetic-shift __tmp296725 '4)))
                       (__tmp296723 (_hex-e170782_ _hex170858_ '3)))
                   (declare (not safe))
                   (##fxior __tmp296724 __tmp296723))
                 (cons (let ((__tmp296727
                              (let ((__tmp296728
                                     (_hex-e170782_ _hex170858_ '0)))
                                (declare (not safe))
                                (##fxarithmetic-shift __tmp296728 '4)))
                             (__tmp296726 (_hex-e170782_ _hex170858_ '1)))
                         (declare (not safe))
                         (##fxior __tmp296727 __tmp296726))
                       _bytes170836_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   _have-zeros170837_)
                                                  _hex170858_)))))))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _rest170838170846_))
                        (let ((_hd170843170876_
                               (let ()
                                 (declare (not safe))
                                 (##car _rest170838170846_)))
                              (_tl170844170878_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _rest170838170846_))))
                          (let* ((_hex170881_ _hd170843170876_)
                                 (_rest170883_ _tl170844170878_))
                            (_K170842170873_ _rest170883_ _hex170881_)))
                        (_else170840170854_)))))
               (_check170784_
                (lambda (_bytes170833_)
                  (if (let ((__tmp296729 (u8vector-length _bytes170833_)))
                        (declare (not safe))
                        (##fx= __tmp296729 '16))
                      _bytes170833_
                      (if (let ((__tmp296730 (u8vector-length _bytes170833_)))
                            (declare (not safe))
                            (##fx< __tmp296730 '16))
                          (error '"Malformed address; not enough bits"
                                 _str170780_
                                 _bytes170833_)
                          (error '"malformed address; too many bits"
                                 _str170780_
                                 _bytes170833_))))))
        (let* ((_hexes170786_ (string-split _str170780_ '#\:))
               (_hexes170787170797_ _hexes170786_)
               (_else170789170805_
                (lambda () (_loop170783_ _hexes170786_ '() '#f)))
               (_K170791170818_
                (lambda (_rest170808_)
                  (let* ((_count170810_ (length _rest170808_))
                         (_count170812_
                          (let ((__tmp296731
                                 (let ()
                                   (declare (not safe))
                                   (##fx- '8 _count170810_))))
                            (declare (not safe))
                            (##fx* __tmp296731 '2)))
                         (_g296732_
                          (if (let ()
                                (declare (not safe))
                                (##fxnegative? _count170812_))
                              (error '"Malformed address; too many bits"
                                     _str170780_)
                              '#!void))
                         (_bytes170815_ (make-list _count170812_ '0)))
                    (_loop170783_ _rest170808_ _bytes170815_ '#t)))))
          (if (let () (declare (not safe)) (##pair? _hexes170787170797_))
              (let ((_hd170792170821_
                     (let () (declare (not safe)) (##car _hexes170787170797_)))
                    (_tl170793170823_
                     (let ()
                       (declare (not safe))
                       (##cdr _hexes170787170797_))))
                (if (equal? _hd170792170821_ '"")
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl170793170823_))
                        (let ((_hd170794170826_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl170793170823_)))
                              (_tl170795170828_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl170793170823_))))
                          (if (equal? _hd170794170826_ '"")
                              (let ((_rest170831_ _tl170795170828_))
                                (_K170791170818_ _rest170831_))
                              (_else170789170805_)))
                        (_else170789170805_))
                    (_else170789170805_)))
              (_else170789170805_))))))
  (define std/net/address#ip6-address->string
    (lambda (_ip6170545_)
      (letrec ((_compress-zeros170547_
                (lambda (_hexes170778_)
                  (_compress-leading-trailing170548_
                   (_compress170549_ _hexes170778_))))
               (_compress-leading-trailing170548_
                (lambda (_hexes170776_)
                  (if (equal? (car _hexes170776_) '"")
                      (cons '"" _hexes170776_)
                      (if (equal? (last _hexes170776_) '"")
                          (begin
                            (set-cdr! (last-pair _hexes170776_) '(""))
                            _hexes170776_)
                          _hexes170776_))))
               (_compress170549_
                (lambda (_hexes170714_)
                  (let* ((_hexes170715170729_ _hexes170714_)
                         (_else170718170737_ (lambda () '())))
                    (let ((_K170723170761_
                           (lambda (_rest170759_)
                             (cons '"" (_compress*170550_ _rest170759_))))
                          (_K170720170744_
                           (lambda (_rest170741_ _hd170742_)
                             (cons _hd170742_
                                   (_compress170549_ _rest170741_)))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _hexes170715170729_))
                          (let ((_tl170725170766_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _hexes170715170729_)))
                                (_hd170724170764_
                                 (let ()
                                   (declare (not safe))
                                   (##car _hexes170715170729_))))
                            (if (equal? _hd170724170764_ '"0")
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl170725170766_))
                                    (let ((_tl170727170771_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl170725170766_)))
                                          (_hd170726170769_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl170725170766_))))
                                      (if (equal? _hd170726170769_ '"0")
                                          (let ((_rest170774_
                                                 _tl170727170771_))
                                            (_K170723170761_ _rest170774_))
                                          (let ((_hd170752_ _hd170724170764_)
                                                (_rest170754_
                                                 _tl170725170766_))
                                            (_K170720170744_
                                             _rest170754_
                                             _hd170752_))))
                                    (let ((_hd170752_ _hd170724170764_)
                                          (_rest170754_ _tl170725170766_))
                                      (_K170720170744_
                                       _rest170754_
                                       _hd170752_)))
                                (let ((_hd170752_ _hd170724170764_)
                                      (_rest170754_ _tl170725170766_))
                                  (_K170720170744_ _rest170754_ _hd170752_))))
                          (_else170718170737_))))))
               (_compress*170550_
                (lambda (_hexes170682_)
                  (let* ((_hexes170683170691_ _hexes170682_)
                         (_else170685170699_ (lambda () _hexes170682_))
                         (_K170687170704_
                          (lambda (_rest170702_)
                            (_compress*170550_ _rest170702_))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _hexes170683170691_))
                        (let ((_hd170688170707_
                               (let ()
                                 (declare (not safe))
                                 (##car _hexes170683170691_)))
                              (_tl170689170709_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _hexes170683170691_))))
                          (if (equal? _hd170688170707_ '"0")
                              (let ((_rest170712_ _tl170689170709_))
                                (_compress*170550_ _rest170712_))
                              (_else170685170699_)))
                        (_else170685170699_))))))
        (let _lp170552_ ((_rest170554_ (u8vector->list _ip6170545_))
                         (_hexes170555_ '()))
          (let* ((_rest170556170566_ _rest170554_)
                 (_else170558170574_
                  (lambda ()
                    (string-join
                     (_compress-zeros170547_ (reverse _hexes170555_))
                     '#\:)))
                 (_K170560170663_
                  (lambda (_rest170577_ _b1170578_ _b0170579_)
                    (let ((_b0h170581_
                           (let ((__tmp296733
                                  (let ()
                                    (declare (not safe))
                                    (##fxarithmetic-shift _b0170579_ '-4))))
                             (declare (not safe))
                             (##fxand __tmp296733 '15)))
                          (_b0l170582_
                           (let ()
                             (declare (not safe))
                             (##fxand _b0170579_ '15)))
                          (_b1h170583_
                           (let ((__tmp296734
                                  (let ()
                                    (declare (not safe))
                                    (##fxarithmetic-shift _b1170578_ '-4))))
                             (declare (not safe))
                             (##fxand __tmp296734 '15)))
                          (_b1l170584_
                           (let ()
                             (declare (not safe))
                             (##fxand _b1170578_ '15))))
                      (let ((_b0h170585170600_ _b0h170581_)
                            (_b0l170586170602_ _b0l170582_)
                            (_b1h170587170604_ _b1h170583_)
                            (_b1l170588170606_ _b1l170584_))
                        (let ((_else170593170614_
                               (lambda ()
                                 (_lp170552_
                                  _rest170577_
                                  (cons (string (std/text/hex#hex _b0h170581_)
                                                (std/text/hex#hex _b0l170582_)
                                                (std/text/hex#hex _b1h170583_)
                                                (std/text/hex#hex _b1l170584_))
                                        _hexes170555_)))))
                          (let ((_K170598170660_
                                 (lambda ()
                                   (_lp170552_
                                    _rest170577_
                                    (cons '"0" _hexes170555_))))
                                (_K170597170651_
                                 (lambda (_b1l170649_)
                                   (_lp170552_
                                    _rest170577_
                                    (cons (string (std/text/hex#hex
                                                   _b1l170649_))
                                          _hexes170555_))))
                                (_K170596170638_
                                 (lambda (_b1h170635_ _b1l170636_)
                                   (_lp170552_
                                    _rest170577_
                                    (cons (string (std/text/hex#hex
                                                   _b1h170635_)
                                                  (std/text/hex#hex
                                                   _b1l170636_))
                                          _hexes170555_))))
                                (_K170595170622_
                                 (lambda (_b0l170618_ _b1h170619_ _b1l170620_)
                                   (_lp170552_
                                    _rest170577_
                                    (cons (string (std/text/hex#hex
                                                   _b0l170618_)
                                                  (std/text/hex#hex
                                                   _b1h170619_)
                                                  (std/text/hex#hex
                                                   _b1l170620_))
                                          _hexes170555_)))))
                            (if (let ()
                                  (declare (not safe))
                                  (##eq? _b0h170585170600_ '0))
                                (if (let ()
                                      (declare (not safe))
                                      (##eq? _b0l170586170602_ '0))
                                    (if (let ()
                                          (declare (not safe))
                                          (##eq? _b1h170587170604_ '0))
                                        (if (let ()
                                              (declare (not safe))
                                              (##eq? _b1l170588170606_ '0))
                                            (_K170598170660_)
                                            (let ((_b1l170654_
                                                   _b1l170588170606_))
                                              (_K170597170651_ _b1l170654_)))
                                        (let ((_b1h170641_ _b1h170587170604_)
                                              (_b1l170643_ _b1l170588170606_))
                                          (_K170596170638_
                                           _b1h170641_
                                           _b1l170643_)))
                                    (let ((_b0l170625_ _b0l170586170602_)
                                          (_b1h170627_ _b1h170587170604_)
                                          (_b1l170629_ _b1l170588170606_))
                                      (_K170595170622_
                                       _b0l170625_
                                       _b1h170627_
                                       _b1l170629_)))
                                (_else170593170614_)))))))))
            (if (let () (declare (not safe)) (##pair? _rest170556170566_))
                (let ((_hd170561170666_
                       (let ()
                         (declare (not safe))
                         (##car _rest170556170566_)))
                      (_tl170562170668_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest170556170566_))))
                  (let ((_b0170671_ _hd170561170666_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl170562170668_))
                        (let ((_hd170563170673_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl170562170668_)))
                              (_tl170564170675_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl170562170668_))))
                          (let* ((_b1170678_ _hd170563170673_)
                                 (_rest170680_ _tl170564170675_))
                            (_K170560170663_
                             _rest170680_
                             _b1170678_
                             _b0170671_)))
                        (_else170558170574_))))
                (_else170558170574_)))))))
  (define std/net/address#inet-address
    (lambda (_obj170543_)
      (if (std/net/address#inet-address? _obj170543_)
          (std/net/address#inet-address-normalize _obj170543_)
          (if (std/net/address#inet-address-string? _obj170543_)
              (std/net/address#string->inet-address _obj170543_)
              (error '"Malformed inet address" _obj170543_)))))
  (define std/net/address#inet-address-normalize
    (lambda (_addr170510_)
      (let* ((_addr170511170518_ _addr170510_)
             (_E170513170522_
              (lambda () (error '"No clause matching" _addr170511170518_)))
             (_K170514170531_
              (lambda (_port170525_ _host170526_)
                (if (or (std/net/address#ip4-address? _host170526_)
                        (std/net/address#ip6-address? _host170526_))
                    _addr170510_
                    (if (std/net/address#ip4-address-string? _host170526_)
                        (cons (std/net/address#string->ip4-address
                               _host170526_)
                              _port170525_)
                        (if (std/net/address#ip6-address-string? _host170526_)
                            (cons (std/net/address#string->ip6-address
                                   _host170526_)
                                  _port170525_)
                            _addr170510_))))))
        (if (let () (declare (not safe)) (##pair? _addr170511170518_))
            (let ((_hd170515170534_
                   (let () (declare (not safe)) (##car _addr170511170518_)))
                  (_tl170516170536_
                   (let () (declare (not safe)) (##cdr _addr170511170518_))))
              (let* ((_host170539_ _hd170515170534_)
                     (_port170541_ _tl170516170536_))
                (_K170514170531_ _port170541_ _host170539_)))
            (_E170513170522_)))))
  (define std/net/address#inet-address?
    (lambda (_obj170475_)
      (let* ((_obj170476170484_ _obj170475_)
             (_else170478170492_ (lambda () '#f))
             (_K170480170498_
              (lambda (_port170495_ _host170496_)
                (if (std/net/address#inet-host-address? _host170496_)
                    (fixnum? _port170495_)
                    '#f))))
        (if (let () (declare (not safe)) (##pair? _obj170476170484_))
            (let ((_hd170481170501_
                   (let () (declare (not safe)) (##car _obj170476170484_)))
                  (_tl170482170503_
                   (let () (declare (not safe)) (##cdr _obj170476170484_))))
              (let* ((_host170506_ _hd170481170501_)
                     (_port170508_ _tl170482170503_))
                (_K170480170498_ _port170508_ _host170506_)))
            (_else170478170492_)))))
  (define std/net/address#inet-address-string?
    (lambda (_obj170429_)
      (let ((_$e170431_
             (if (string? _obj170429_)
                 (std/net/address#inet-address-split__% _obj170429_ false)
                 '#f)))
        (if _$e170431_
            ((lambda (_e170433170435_)
               (let* ((_g170437170445_ _e170433170435_)
                      (_else170439170453_ (lambda () '#f))
                      (_K170441170462_
                       (lambda (_port170456_ _host170457_)
                         (let ((_$e170459_ (string-empty? _host170457_)))
                           (if _$e170459_
                               _$e170459_
                               (std/net/address#inet-host-address-string?
                                _host170457_))))))
                 (if (let ((__tmp296735
                            (if (let ()
                                  (declare (not safe))
                                  (##values? _g170437170445_))
                                (let ()
                                  (declare (not safe))
                                  (##vector-length _g170437170445_))
                                '1)))
                       (declare (not safe))
                       (##fx= __tmp296735 '2))
                     (let* ((_e170442170465_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _g170437170445_ '0)))
                            (_host170468_ _e170442170465_)
                            (_e170443170470_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _g170437170445_ '1)))
                            (_port170473_ _e170443170470_))
                       (_K170441170462_ _port170473_ _host170468_))
                     (_else170439170453_))))
             _$e170431_)
            '#f))))
  (define std/net/address#inet-address-split__%
    (lambda (_str170411_ _E170412_)
      (let ((_$e170414_ (string-rindex _str170411_ '#\:)))
        (if _$e170414_
            ((lambda (_ix170417_)
               (values (substring _str170411_ '0 _ix170417_)
                       (substring
                        _str170411_
                        (let () (declare (not safe)) (##fx+ _ix170417_ '1))
                        (string-length _str170411_))))
             _$e170414_)
            (_E170412_ '"Malformed address; no port separator" _str170411_)))))
  (define std/net/address#inet-address-split__0
    (lambda (_str170422_)
      (let ((_E170424_ error))
        (std/net/address#inet-address-split__% _str170422_ _E170424_))))
  (define std/net/address#inet-address-split
    (lambda _g296737_
      (let ((_g296736_ (let () (declare (not safe)) (##length _g296737_))))
        (cond ((let () (declare (not safe)) (##fx= _g296736_ 1))
               (apply std/net/address#inet-address-split__0 _g296737_))
              ((let () (declare (not safe)) (##fx= _g296736_ 2))
               (apply std/net/address#inet-address-split__% _g296737_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/address#inet-address-split
                _g296737_))))))
  (define std/net/address#inet-host-address?
    (lambda (_obj170402_)
      (let ((_$e170404_ (std/net/address#ip4-address? _obj170402_)))
        (if _$e170404_
            _$e170404_
            (let ((_$e170407_ (std/net/address#ip6-address? _obj170402_)))
              (if _$e170407_
                  _$e170407_
                  (std/net/address#inet-host-address-string? _obj170402_)))))))
  (define std/net/address#inet-host-address-string?
    (lambda (_obj170394_)
      (let ((_$e170396_ (std/net/address#ip4-address-string? _obj170394_)))
        (if _$e170396_
            _$e170396_
            (let ((_$e170399_
                   (std/net/address#ip6-address-string? _obj170394_)))
              (if _$e170399_
                  _$e170399_
                  (std/net/address#inet-host-name? _obj170394_)))))))
  (define std/net/address#inet-host-name?
    (lambda (_obj170392_)
      (if (string? _obj170392_)
          (std/pregexp#pregexp-match
           std/net/address#inet-host-name-rx
           _obj170392_)
          '#f)))
  (define std/net/address#inet-host-name-rx
    (std/pregexp#pregexp
     '"^[a-zA-Z0-9](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?(?:\\.[a-zA-Z0-9](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?)*$"))
  (define std/net/address#string->inet-address
    (lambda (_str170352_)
      (letrec ((_string->host170354_
                (lambda (_host170390_)
                  (if (std/net/address#ip4-address-string? _host170390_)
                      (std/net/address#string->ip4-address _host170390_)
                      (if (std/net/address#ip6-address-string? _host170390_)
                          (std/net/address#string->ip6-address _host170390_)
                          (if (std/net/address#inet-host-name? _host170390_)
                              _host170390_
                              (if (string-empty? _host170390_)
                                  '#u8(0 0 0 0)
                                  (error '"Malformed address; bad host"
                                         _str170352_
                                         _host170390_)))))))
               (_string->port170355_
                (lambda (_port170386_)
                  (let ((_port170388_ (string->number _port170386_)))
                    (if (and (fixnum? _port170388_)
                             (let ()
                               (declare (not safe))
                               (##fx<= '0 _port170388_ '65535)))
                        _port170388_
                        (error '"Malformed address; bad port"
                               _str170352_
                               _port170388_))))))
        (let* ((_g170356170363_
                (std/net/address#inet-address-split__0 _str170352_))
               (_E170358170367_
                (lambda () (error '"No clause matching" _g170356170363_)))
               (_K170359170373_
                (lambda (_port170370_ _host170371_)
                  (cons (_string->host170354_ _host170371_)
                        (_string->port170355_ _port170370_)))))
          (if (let ((__tmp296738
                     (if (let ()
                           (declare (not safe))
                           (##values? _g170356170363_))
                         (let ()
                           (declare (not safe))
                           (##vector-length _g170356170363_))
                         '1)))
                (declare (not safe))
                (##fx= __tmp296738 '2))
              (let* ((_e170360170376_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g170356170363_ '0)))
                     (_host170379_ _e170360170376_)
                     (_e170361170381_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g170356170363_ '1)))
                     (_port170384_ _e170361170381_))
                (_K170359170373_ _port170384_ _host170379_))
              (_E170358170367_))))))
  (define std/net/address#inet-address->string
    (lambda (_obj170322_)
      (if (std/net/address#inet-address? _obj170322_)
          (let* ((_obj170323170330_ _obj170322_)
                 (_E170325170334_
                  (lambda () (error '"No clause matching" _obj170323170330_)))
                 (_K170326170340_
                  (lambda (_port170337_ _host170338_)
                    (std/format#format
                     '"~a:~a"
                     (std/net/address#inet-host-address->string _host170338_)
                     _port170337_))))
            (if (let () (declare (not safe)) (##pair? _obj170323170330_))
                (let ((_hd170327170343_
                       (let () (declare (not safe)) (##car _obj170323170330_)))
                      (_tl170328170345_
                       (let ()
                         (declare (not safe))
                         (##cdr _obj170323170330_))))
                  (let* ((_host170348_ _hd170327170343_)
                         (_port170350_ _tl170328170345_))
                    (_K170326170340_ _port170350_ _host170348_)))
                (_E170325170334_)))
          (if (std/net/address#inet-address-string? _obj170322_)
              _obj170322_
              (error '"Malformed inet address")))))
  (define std/net/address#inet-host-address->string
    (lambda (_host170320_)
      (if (string? _host170320_)
          _host170320_
          (if (std/net/address#ip4-address? _host170320_)
              (std/net/address#ip4-address->string _host170320_)
              (if (std/net/address#ip6-address? _host170320_)
                  (std/net/address#ip6-address->string _host170320_)
                  (error '"Malformed inet host address" _host170320_))))))
  (define std/net/address#resolve-address
    (lambda (_addr170250_)
      (let* ((_addr170252_ (std/net/address#inet-address _addr170250_))
             (_addr170253170260_ _addr170252_)
             (_E170255170264_
              (lambda () (error '"No clause matching" _addr170253170260_)))
             (_K170256170308_
              (lambda (_port170267_ _host170268_)
                (if (or (std/net/address#ip4-address? _host170268_)
                        (std/net/address#ip6-address? _host170268_))
                    _addr170252_
                    (let* ((_info170273_ (host-info _host170268_))
                           (_g170274170282_ (host-info-addresses _info170273_))
                           (_else170276170290_
                            (lambda ()
                              (error '"Failed to resolve address"
                                     _addr170252_)))
                           (_K170278170296_
                            (lambda (_rest170293_ _ip170294_)
                              (cons _ip170294_ _port170267_))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _g170274170282_))
                          (let ((_hd170279170299_
                                 (let ()
                                   (declare (not safe))
                                   (##car _g170274170282_)))
                                (_tl170280170301_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _g170274170282_))))
                            (let* ((_ip170304_ _hd170279170299_)
                                   (_rest170306_ _tl170280170301_))
                              (_K170278170296_ _rest170306_ _ip170304_)))
                          (_else170276170290_)))))))
        (if (let () (declare (not safe)) (##pair? _addr170253170260_))
            (let ((_hd170257170311_
                   (let () (declare (not safe)) (##car _addr170253170260_)))
                  (_tl170258170313_
                   (let () (declare (not safe)) (##cdr _addr170253170260_))))
              (let* ((_host170316_ _hd170257170311_)
                     (_port170318_ _tl170258170313_))
                (_K170256170308_ _port170318_ _host170316_)))
            (_E170255170264_)))))
  (define std/net/address#resolved-address?
    (lambda (_obj170212_)
      (let* ((_obj170213170221_ _obj170212_)
             (_else170215170229_ (lambda () '#f))
             (_K170217170238_
              (lambda (_port170232_ _host170233_)
                (if (or (std/net/address#ip4-address? _host170233_)
                        (std/net/address#ip6-address? _host170233_))
                    (fixnum? _port170232_)
                    '#f))))
        (if (let () (declare (not safe)) (##pair? _obj170213170221_))
            (let ((_hd170218170241_
                   (let () (declare (not safe)) (##car _obj170213170221_)))
                  (_tl170219170243_
                   (let () (declare (not safe)) (##cdr _obj170213170221_))))
              (let* ((_host170246_ _hd170218170241_)
                     (_port170248_ _tl170219170243_))
                (_K170217170238_ _port170248_ _host170246_)))
            (_else170215170229_))))))
