(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/repl#errorf
    (lambda (_fmt197181_ . _args197182_)
      (std/logger#log-message 'repl '0 _fmt197181_ _args197182_)))
  (define std/net/repl#warnf
    (lambda (_fmt197178_ . _args197179_)
      (std/logger#log-message 'repl '1 _fmt197178_ _args197179_)))
  (define std/net/repl#infof
    (lambda (_fmt197175_ . _args197176_)
      (std/logger#log-message 'repl '2 _fmt197175_ _args197176_)))
  (define std/net/repl#debugf
    (lambda (_fmt197172_ . _args197173_)
      (std/logger#log-message 'repl '3 _fmt197172_ _args197173_)))
  (define std/net/repl#verbosef
    (lambda (_fmt197167_ . _args197169_)
      (std/logger#log-message 'repl '4 _fmt197167_ _args197169_)))
  (define std/net/repl#repl-state::t
    (make-struct-type
     'std/net/repl#repl-state::t
     '#f
     '4
     'repl-state
     '((final: . #t))
     '#f
     '(client channel reader eof)))
  (define std/net/repl#repl-state?
    (make-struct-predicate std/net/repl#repl-state::t))
  (define std/net/repl#make-repl-state
    (lambda _$args197164_
      (apply make-struct-instance std/net/repl#repl-state::t _$args197164_)))
  (define std/net/repl#repl-state-client
    (make-struct-field-accessor std/net/repl#repl-state::t '0))
  (define std/net/repl#repl-state-channel
    (make-struct-field-accessor std/net/repl#repl-state::t '1))
  (define std/net/repl#repl-state-reader
    (make-struct-field-accessor std/net/repl#repl-state::t '2))
  (define std/net/repl#repl-state-eof
    (make-struct-field-accessor std/net/repl#repl-state::t '3))
  (define std/net/repl#repl-state-client-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '0))
  (define std/net/repl#repl-state-channel-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '1))
  (define std/net/repl#repl-state-reader-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '2))
  (define std/net/repl#repl-state-eof-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '3))
  (define std/net/repl#start-repl-server!__%
    (lambda (_g298956_ _passwd197132197136_ _address197133197138_)
      (let* ((_passwd197141_
              (if (eq? _passwd197132197136_ absent-value)
                  '#f
                  _passwd197132197136_))
             (_address197143_
              (if (eq? _address197133197138_ absent-value)
                  '"127.0.0.1:7000"
                  _address197133197138_)))
        (std/logger#start-logger!__0)
        (let* ((_sock197145_
                (open-tcp-server
                 (cons 'server-address:
                       (cons _address197143_
                             (cons 'eol-encoding:
                                   (cons 'cr-lf
                                         (cons 'reuse-address:
                                               (cons '#t '()))))))))
               (_server197147_
                (gerbil/gambit/threads#spawn/group
                 'repl-server
                 std/net/repl#repl-server
                 _sock197145_
                 _passwd197141_)))
          (thread-specific-set! _server197147_ _sock197145_)
          _server197147_))))
  (define std/net/repl#start-repl-server!__@
    (lambda (_keys197131197153_ . _args197155_)
      (apply std/net/repl#start-repl-server!__%
             _keys197131197153_
             (table-ref _keys197131197153_ 'password: absent-value)
             (table-ref _keys197131197153_ 'address: absent-value)
             _args197155_)))
  (define std/net/repl#start-repl-server!
    (lambda _args197134197161_
      (apply keyword-dispatch
             '#(password: address:)
             std/net/repl#start-repl-server!__@
             _args197134197161_)))
  (define std/net/repl#stop-repl-server!
    (lambda (_server197113_)
      (let ((_tgroup197115_ (thread-thread-group _server197113_))
            (_port197116_ (thread-specific _server197113_)))
        (with-unwind-protect
         (lambda ()
           (with-exception-catcher
            (lambda (_g197117197120_)
              (if ((lambda (_$obj197123_) (uncaught-exception? _$obj197123_))
                   _g197117197120_)
                  (let ((_e197126_ _g197117197120_))
                    (if (os-exception? (uncaught-exception-reason _e197126_))
                        '#!void
                        (raise _e197126_)))
                  (raise _g197117197120_)))
            (lambda ()
              (close-port _port197116_)
              (std/misc/threads#thread-async! _server197113_ void)
              (thread-join! _server197113_))))
         (lambda () (std/misc/threads#thread-group-kill! _tgroup197115_))))))
  (define std/net/repl#repl-server
    (lambda (_sock197093_ _passwd197094_)
      (let _lp197096_ ()
        (let ((_client197099_ (read _sock197093_)))
          (if (eof-object? _client197099_)
              '#!void
              (begin
                (let ((_sinfo197101_
                       (tcp-client-peer-socket-info _client197099_)))
                  (std/net/repl#debugf
                   '"accepted repl connection from ~a"
                   (std/net/address#inet-address->string
                    (cons (socket-info-address _sinfo197101_)
                          (socket-info-port-number _sinfo197101_)))))
                (output-port-readtable-set!
                 _client197099_
                 (readtable-sharing-allowed?-set
                  (output-port-readtable _client197099_)
                  '#t))
                (let* ((_tgroup197103_ (make-thread-group 'repl-client))
                       (_thread197106_
                        (make-thread
                         (lambda ()
                           (std/net/repl#repl-client
                            _client197099_
                            _passwd197094_))
                         'repl
                         _tgroup197103_))
                       (_state197108_
                        (std/net/repl#make-repl-client-state
                         _client197099_
                         _thread197106_)))
                  (thread-group-specific-set! _tgroup197103_ _state197108_)
                  (thread-start! _thread197106_)
                  (let ((_monitor197111_
                         (gerbil/gambit/threads#spawn/name
                          'repl-client-monitor
                          std/net/repl#repl-client-monitor
                          _thread197106_
                          _tgroup197103_)))
                    (thread-specific-set! _monitor197111_ _tgroup197103_))
                  (_lp197096_))))))))
  (define std/net/repl#repl-client-monitor
    (lambda (_thread197078_ _tgroup197079_)
      (with-unwind-protect
       (lambda ()
         (with-exception-catcher
          (lambda (_g197080197083_)
            (if ((lambda (_$obj197086_) (uncaught-exception? _$obj197086_))
                 _g197080197083_)
                (let ((_e197089_ _g197080197083_))
                  (std/net/repl#errorf
                   '"repl client error: ~a"
                   (uncaught-exception-reason _e197089_)))
                (raise _g197080197083_)))
          (lambda () (thread-join! _thread197078_))))
       (lambda () (std/misc/threads#thread-group-kill! _tgroup197079_)))))
  (define std/net/repl#repl-client
    (lambda (_client197066_ _passwd197067_)
      (if _passwd197067_
          (let _lp197069_ ()
            (display '"Password: " _client197066_)
            (force-output _client197066_)
            (let ((_pw197072_ (read-line _client197066_)))
              (if (equal? _pw197072_ _passwd197067_) '#!void (_lp197069_))))
          '#!void)
      (let ((_state197074_ (std/net/repl#repl-client-state__0)))
        (thread-start!
         (##direct-structure-ref
          _state197074_
          '3
          std/net/repl#repl-state::t
          '#f))
        (call-with-parameters
         (lambda () (replx))
         current-input-port
         (let () (declare (not safe)) (##repl-input-port))
         current-output-port
         (let () (declare (not safe)) (##repl-output-port))
         current-error-port
         (let () (declare (not safe)) (##repl-output-port))
         ##current-user-interrupt-handler
         (lambda () (let () (declare (not safe)) (##handle-interrupt '#f))))
        (close-port _client197066_)
        (thread-terminate!
         (##direct-structure-ref
          _state197074_
          '3
          std/net/repl#repl-state::t
          '#f)))))
  (define std/net/repl#repl-client-reader
    (lambda (_state197025_ _in197026_ _out197027_ _repl-thread197028_)
      (letrec ((_loop197030_
                (lambda (_mode197039_)
                  (let ((_c197041_ (read-char _in197026_)))
                    (if (eof-object? _c197041_)
                        (begin
                          (##direct-structure-set!
                           _state197025_
                           '#t
                           '4
                           std/net/repl#repl-state::t
                           '#f)
                          (close-output-port _out197027_))
                        (let ((_$e197043_ _mode197039_))
                          (if (eq? 'input _$e197043_)
                              (if (char=? _c197041_ '#\ÿ)
                                  (_loop197030_ _c197041_)
                                  (if (char=? _c197041_ '#\x4)
                                      (begin
                                        (close-output-port _out197027_)
                                        (_loop197030_ _mode197039_))
                                      (begin
                                        (write-char _c197041_ _out197027_)
                                        (force-output _out197027_)
                                        (_loop197030_ _mode197039_))))
                              (if (or (eq? '#\û _$e197043_)
                                      (eq? '#\ü _$e197043_)
                                      (eq? '#\þ _$e197043_))
                                  (_loop197030_ 'input)
                                  (if (eq? '#\ý _$e197043_)
                                      (begin
                                        (if (char=? _c197041_ '#\x6)
                                            (let ((_client197052_
                                                   (##direct-structure-ref
                                                    _state197025_
                                                    '1
                                                    std/net/repl#repl-state::t
                                                    '#f)))
                                              (gerbil/gambit/ports#write-u8vector__%
                                               '#u8(255 251 6)
                                               _client197052_)
                                              (force-output _client197052_))
                                            '#!void)
                                        (_loop197030_ 'input))
                                      (if (eq? '#\ÿ _$e197043_)
                                          (let ((_$e197054_ _c197041_))
                                            (if (eq? '#\ô _$e197054_)
                                                (begin
                                                  (std/misc/threads#thread-async!
                                                   _repl-thread197028_
                                                   ##user-interrupt!)
                                                  (_loop197030_ 'input))
                                                (if (or (eq? '#\û _$e197054_)
                                                        (eq? '#\ü _$e197054_)
                                                        (eq? '#\ý _$e197054_)
                                                        (eq? '#\þ _$e197054_))
                                                    (_loop197030_ _c197041_)
                                                    (_loop197030_ 'input))))
                                          (_loop197030_ 'input)))))))))))
        (with-exception-catcher
         (lambda (_g197031197033_)
           (if '#t
               (let ((_e197036_ _g197031197033_))
                 (std/net/repl#errorf '"repl reader error: ~a" _e197036_)
                 (##direct-structure-set!
                  _state197025_
                  '#t
                  '4
                  std/net/repl#repl-state::t
                  '#f)
                 (close-output-port _out197027_))
               (raise _g197031197033_)))
         (lambda () (_loop197030_ 'input))))))
  (define std/net/repl#make-repl-client-state
    (lambda (_client197007_ _thread197008_)
      (let ((_g298957_
             (open-string-pipe '(direction: input permanent-close: #f))))
        (begin
          (let ((_g298958_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g298957_) (##vector-length _g298957_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g298958_ 2)))
                (error "Context expects 2 values" _g298958_)))
          (let ((_in-rd197010_
                 (let () (declare (not safe)) (##vector-ref _g298957_ 0)))
                (_in-wr197011_
                 (let () (declare (not safe)) (##vector-ref _g298957_ 1))))
            (let* ((_g298959_
                    (macro-port-name-set!
                     _in-rd197010_
                     (lambda (_port197013_) '(repl))))
                   (_channel197016_
                    (let ()
                      (declare (not safe))
                      (##make-repl-channel-ports
                       _in-rd197010_
                       _client197007_)))
                   (_g298960_
                    (macro-repl-channel-last-owner-set!
                     _channel197016_
                     _thread197008_))
                   (_state197019_
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/net/repl#repl-state::t
                       _client197007_
                       _channel197016_
                       '#f
                       '#f)))
                   (_reader197022_
                    (make-thread
                     (lambda ()
                       (std/net/repl#repl-client-reader
                        _state197019_
                        _client197007_
                        _in-wr197011_
                        _thread197008_))
                     'repl-client-reader)))
              (##direct-structure-set!
               _state197019_
               _reader197022_
               '3
               std/net/repl#repl-state::t
               '#f)
              _state197019_))))))
  (define std/net/repl#repl-context-command
    (lambda (_repl-context196999_ _src197000_)
      (if (eof-object? _src197000_)
          (let ((_$e197002_ (std/net/repl#repl-client-state__0)))
            (if _$e197002_
                ((lambda (_state197005_)
                   (if (##direct-structure-ref
                        _state197005_
                        '4
                        std/net/repl#repl-state::t
                        '#f)
                       (let ()
                         (declare (not safe))
                         (##repl-context-return _repl-context196999_ '#!void))
                       (begin
                         (let () (declare (not safe)) (##repl-channel-newline))
                         (if (fx< '0
                                  (macro-repl-context-level
                                   _repl-context196999_))
                             (let ()
                               (declare (not safe))
                               (##repl-cmd-d _repl-context196999_))
                             (if (let ()
                                   (declare (not safe))
                                   (##repl-channel-really-exit?))
                                 (let ()
                                   (declare (not safe))
                                   (##repl-context-return
                                    _repl-context196999_
                                    '#!void))
                                 (let ()
                                   (declare (not safe))
                                   (##repl-context-prompt
                                    _repl-context196999_)))))))
                 _$e197002_)
                (let ()
                  (declare (not safe))
                  (##default-repl-context-command
                   _repl-context196999_
                   _src197000_))))
          (let ()
            (declare (not safe))
            (##default-repl-context-command
             _repl-context196999_
             _src197000_)))))
  (let ()
    (declare (not safe))
    (##repl-context-command-set! std/net/repl#repl-context-command))
  (define std/net/repl#make-repl-channel
    (lambda (_thread196994_)
      (let ((_$e196996_ (std/net/repl#repl-client-state__% _thread196994_)))
        (if _$e196996_
            (##direct-structure-ref
             _$e196996_
             '2
             std/net/repl#repl-state::t
             '#f)
            (let ()
              (declare (not safe))
              (##default-thread-make-repl-channel _thread196994_))))))
  (let ()
    (declare (not safe))
    (##thread-make-repl-channel-set! std/net/repl#make-repl-channel))
  (define std/net/repl#repl-client-state__%
    (lambda (_thread196975_)
      (let _lp196977_ ((_tgroup196979_ (thread-thread-group _thread196975_)))
        (if (not _tgroup196979_)
            '#f
            (let ((_$e196981_ (thread-group-specific _tgroup196979_)))
              (if _$e196981_
                  ((lambda (_state196984_)
                     (if (let ()
                           (declare (not safe))
                           (##structure-direct-instance-of?
                            _state196984_
                            'std/net/repl#repl-state::t))
                         _state196984_
                         (_lp196977_ (thread-group-parent _tgroup196979_))))
                   _$e196981_)
                  (_lp196977_ (thread-group-parent _tgroup196979_))))))))
  (define std/net/repl#repl-client-state__0
    (lambda ()
      (let ((_thread196990_ (current-thread)))
        (std/net/repl#repl-client-state__% _thread196990_))))
  (define std/net/repl#repl-client-state
    (lambda _g298962_
      (let ((_g298961_ (let () (declare (not safe)) (##length _g298962_))))
        (cond ((let () (declare (not safe)) (##fx= _g298961_ 0))
               (apply std/net/repl#repl-client-state__0 _g298962_))
              ((let () (declare (not safe)) (##fx= _g298961_ 1))
               (apply std/net/repl#repl-client-state__% _g298962_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/repl#repl-client-state
                _g298962_))))))
  (define std/net/repl#taint!__%
    (lambda (_tgroup196951_)
      (let ((_$e196953_ (std/net/repl#repl-client-state__0)))
        (if _$e196953_
            ((lambda (_state196956_)
               (let* ((_tgroup196961_
                       (let ((_$e196958_ _tgroup196951_))
                         (if _$e196958_
                             _$e196958_
                             (std/misc/threads#primordial-thread-group))))
                      (_ostate196963_ (thread-group-specific _tgroup196961_)))
                 (thread-group-specific-set! _tgroup196961_ _state196956_)
                 _ostate196963_))
             _$e196953_)
            (error '"No repl state")))))
  (define std/net/repl#taint!__0
    (lambda ()
      (let ((_tgroup196970_ '#f)) (std/net/repl#taint!__% _tgroup196970_))))
  (define std/net/repl#taint!
    (lambda _g298964_
      (let ((_g298963_ (let () (declare (not safe)) (##length _g298964_))))
        (cond ((let () (declare (not safe)) (##fx= _g298963_ 0))
               (apply std/net/repl#taint!__0 _g298964_))
              ((let () (declare (not safe)) (##fx= _g298963_ 1))
               (apply std/net/repl#taint!__% _g298964_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/repl#taint!
                _g298964_))))))
  (define std/net/repl#untaint!__%
    (lambda (_tgroup196927_ _state196928_)
      (let ((_tgroup196933_
             (let ((_$e196930_ _tgroup196927_))
               (if _$e196930_
                   _$e196930_
                   (std/misc/threads#primordial-thread-group)))))
        (if (let ((__tmp298965 (thread-group-specific _tgroup196933_)))
              (declare (not safe))
              (##structure-direct-instance-of?
               __tmp298965
               'std/net/repl#repl-state::t))
            (thread-group-specific-set! _tgroup196933_ _state196928_)
            (error '"No tainted repl state in thread-group" _tgroup196933_)))))
  (define std/net/repl#untaint!__0
    (lambda ()
      (let* ((_tgroup196939_ '#f) (_state196941_ '#f))
        (std/net/repl#untaint!__% _tgroup196939_ _state196941_))))
  (define std/net/repl#untaint!__1
    (lambda (_tgroup196943_)
      (let ((_state196945_ '#f))
        (std/net/repl#untaint!__% _tgroup196943_ _state196945_))))
  (define std/net/repl#untaint!
    (lambda _g298967_
      (let ((_g298966_ (let () (declare (not safe)) (##length _g298967_))))
        (cond ((let () (declare (not safe)) (##fx= _g298966_ 0))
               (apply std/net/repl#untaint!__0 _g298967_))
              ((let () (declare (not safe)) (##fx= _g298966_ 1))
               (apply std/net/repl#untaint!__1 _g298967_))
              ((let () (declare (not safe)) (##fx= _g298966_ 2))
               (apply std/net/repl#untaint!__% _g298967_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/repl#untaint!
                _g298967_)))))))
