(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/request#request::t
    (make-struct-type
     'std/net#request::t
     '#f
     '8
     'request
     '()
     ':init!
     '(port url history status status-text headers body encoding)))
  (define std/net/request#request?
    (make-struct-predicate std/net/request#request::t))
  (define std/net/request#make-request
    (lambda _$args172885_
      (apply make-struct-instance std/net/request#request::t _$args172885_)))
  (define std/net/request#request-port
    (make-struct-field-accessor std/net/request#request::t '0))
  (define std/net/request#request-url
    (make-struct-field-accessor std/net/request#request::t '1))
  (define std/net/request#request-history
    (make-struct-field-accessor std/net/request#request::t '2))
  (define std/net/request#request-status
    (make-struct-field-accessor std/net/request#request::t '3))
  (define std/net/request#request-status-text
    (make-struct-field-accessor std/net/request#request::t '4))
  (define std/net/request#request-headers
    (make-struct-field-accessor std/net/request#request::t '5))
  (define std/net/request#request-body
    (make-struct-field-accessor std/net/request#request::t '6))
  (define std/net/request#request-encoding
    (make-struct-field-accessor std/net/request#request::t '7))
  (define std/net/request#request-port-set!
    (make-struct-field-mutator std/net/request#request::t '0))
  (define std/net/request#request-url-set!
    (make-struct-field-mutator std/net/request#request::t '1))
  (define std/net/request#request-history-set!
    (make-struct-field-mutator std/net/request#request::t '2))
  (define std/net/request#request-status-set!
    (make-struct-field-mutator std/net/request#request::t '3))
  (define std/net/request#request-status-text-set!
    (make-struct-field-mutator std/net/request#request::t '4))
  (define std/net/request#request-headers-set!
    (make-struct-field-mutator std/net/request#request::t '5))
  (define std/net/request#request-body-set!
    (make-struct-field-mutator std/net/request#request::t '6))
  (define std/net/request#request-encoding-set!
    (make-struct-field-mutator std/net/request#request::t '7))
  (define std/net/request#request:::init!
    (lambda (_self172880_ _port172881_ _url172882_ _history172883_)
      (if (let ((__tmp296783
                 (let () (declare (not safe)) (##vector-length _self172880_))))
            (declare (not safe))
            (##fx< '3 __tmp296783))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self172880_ '1 _port172881_))
            (let ()
              (declare (not safe))
              (##vector-set! _self172880_ '2 _url172882_))
            (let ()
              (declare (not safe))
              (##vector-set! _self172880_ '3 _history172883_)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self172880_))))
  (bind-method!
   std/net/request#request::t
   ':init!
   std/net/request#request:::init!
   '#f)
  (define std/net/request#url-target-e
    (lambda (_url172755_ _params172756_)
      (if _params172756_
          (string-append
           _url172755_
           '"?"
           (std/net/uri#form-url-encode__% _params172756_ '#f))
          _url172755_)))
  (define std/net/request#header-string-e
    (lambda (_str172753_)
      (if (string? _str172753_)
          _str172753_
          (if (symbol? _str172753_)
              (symbol->string _str172753_)
              (if (keyword? _str172753_)
                  (keyword->string _str172753_)
                  (error '"bad header key" _str172753_))))))
  (define std/net/request#make-http/1.1-headers
    (lambda (_headers172746_ _cookies172747_ _auth172748_)
      (std/net/request#http-headers-cons!
       _headers172746_
       (std/net/request#http-headers-cons
        (std/net/request#http-headers-cons
         std/net/request#http/1.1-base-headers
         (std/net/request#http-headers-cookies
          (let ((_$e172750_ _cookies172747_)) (if _$e172750_ _$e172750_ '()))))
        (std/net/request#http-headers-auth _auth172748_)))))
  (define std/net/request#http/1.1-base-headers
    '(("User-Agent" . "Mozilla/5.0 (compatible; gerbil/1.0)")
      ("Connection" . "close")
      ("Accept" . "*/*")
      ("Accept-Encoding" . "gzip, deflate, identity")))
  (define std/net/request#http-headers-auth
    (lambda (_auth172674_)
      (letrec ((_basic-auth-header172676_
                (lambda (_user172740_ _password172741_)
                  (let ((_credentials172744_
                         (std/text/base64#u8vector->base64-string
                          (with-output-to-u8vector
                           (lambda ()
                             (display _user172740_)
                             (display '":")
                             (display _password172741_))))))
                    (cons '"Authorization"
                          (string-append '"Basic " _credentials172744_))))))
        (let* ((_auth172677172692_ _auth172674_)
               (_E172681172696_
                (lambda () (error '"No clause matching" _auth172677172692_))))
          (let ((_K172684172718_
                 (lambda (_password172715_ _user172716_)
                   (cons (_basic-auth-header172676_
                          _user172716_
                          _password172715_)
                         '())))
                (_K172683172709_ (lambda () '()))
                (_K172682172701_
                 (lambda () (error '"unknown auth value" _auth172674_))))
            (let ((_try-match172679172712_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##eq? _auth172677172692_ '#f))
                         (_K172683172709_)
                         (_K172682172701_)))))
              (if (let () (declare (not safe)) (##pair? _auth172677172692_))
                  (let ((_tl172686172723_
                         (let ()
                           (declare (not safe))
                           (##cdr _auth172677172692_)))
                        (_hd172685172721_
                         (let ()
                           (declare (not safe))
                           (##car _auth172677172692_))))
                    (if (let ()
                          (declare (not safe))
                          (##eq? _hd172685172721_ 'basic:))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl172686172723_))
                            (let ((_tl172688172728_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl172686172723_)))
                                  (_hd172687172726_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl172686172723_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _tl172688172728_))
                                  (let ((_tl172690172735_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _tl172688172728_)))
                                        (_hd172689172733_
                                         (let ()
                                           (declare (not safe))
                                           (##car _tl172688172728_))))
                                    (if (let ()
                                          (declare (not safe))
                                          (##null? _tl172690172735_))
                                        (let ((_user172731_ _hd172687172726_)
                                              (_password172738_
                                               _hd172689172733_))
                                          (_K172684172718_
                                           _password172738_
                                           _user172731_))
                                        (_try-match172679172712_)))
                                  (_try-match172679172712_)))
                            (_try-match172679172712_))
                        (_try-match172679172712_)))
                  (_try-match172679172712_))))))))
  (define std/net/request#http-headers-cookies
    (lambda (_cookies172639_)
      (letrec ((_fold-e172641_
                (lambda (_cookie172643_ _str172644_)
                  (let* ((_cookie172645172652_ _cookie172643_)
                         (_E172647172656_
                          (lambda ()
                            (error '"No clause matching"
                                   _cookie172645172652_)))
                         (_K172648172662_
                          (lambda (_value172659_ _key172660_)
                            (if (string-empty? _str172644_)
                                (std/format#format
                                 '"~a=~a"
                                 _key172660_
                                 _value172659_)
                                (std/format#format
                                 '"~a; ~a=~a"
                                 _str172644_
                                 _key172660_
                                 _value172659_)))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _cookie172645172652_))
                        (let ((_hd172649172665_
                               (let ()
                                 (declare (not safe))
                                 (##car _cookie172645172652_)))
                              (_tl172650172667_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _cookie172645172652_))))
                          (let* ((_key172670_ _hd172649172665_)
                                 (_value172672_ _tl172650172667_))
                            (_K172648172662_ _value172672_ _key172670_)))
                        (_E172647172656_))))))
        (if (null? _cookies172639_)
            '()
            (cons (cons '"Cookie" (foldr1 _fold-e172641_ _cookies172639_ '""))
                  '())))))
  (define std/net/request#http-headers-cons
    (lambda (_new-headers172599_ _headers172600_)
      (letrec ((_fold-e172602_
                (lambda (_header172604_ _headers172605_)
                  (let* ((_header172606172613_ _header172604_)
                         (_E172608172617_
                          (lambda ()
                            (error '"No clause matching"
                                   _header172606172613_)))
                         (_K172609172627_
                          (lambda (_value172620_ _key172621_)
                            (let ((_key172623_
                                   (std/srfi/13#string-titlecase__0
                                    (std/net/request#header-string-e
                                     _key172621_))))
                              (if (assoc _key172623_ _headers172605_)
                                  _headers172605_
                                  (let ((_value172625_
                                         (std/format#format
                                          '"~a"
                                          _value172620_)))
                                    (cons (cons _key172623_ _value172625_)
                                          _headers172605_)))))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _header172606172613_))
                        (let ((_hd172610172630_
                               (let ()
                                 (declare (not safe))
                                 (##car _header172606172613_)))
                              (_tl172611172632_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _header172606172613_))))
                          (let* ((_key172635_ _hd172610172630_)
                                 (_value172637_ _tl172611172632_))
                            (_K172609172627_ _value172637_ _key172635_)))
                        (_E172608172617_))))))
        (foldr1 _fold-e172602_ _headers172600_ _new-headers172599_))))
  (define std/net/request#http-headers-cons!
    (lambda (_new-headers172555_ _headers172556_)
      (letrec ((_fold-e172558_
                (lambda (_header172560_ _headers172561_)
                  (let* ((_header172562172569_ _header172560_)
                         (_E172564172573_
                          (lambda ()
                            (error '"No clause matching"
                                   _header172562172569_)))
                         (_K172565172587_
                          (lambda (_value172576_ _key172577_)
                            (let ((_key172579_
                                   (std/srfi/13#string-titlecase__0
                                    (std/net/request#header-string-e
                                     _key172577_)))
                                  (_value172580_
                                   (std/format#format '"~a" _value172576_)))
                              (let ((_$e172582_
                                     (assoc _key172579_ _headers172561_)))
                                (if _$e172582_
                                    ((lambda (_pair172585_)
                                       (set-cdr! _pair172585_ _value172580_)
                                       _headers172561_)
                                     _$e172582_)
                                    (cons (cons _key172579_ _value172580_)
                                          _headers172561_)))))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _header172562172569_))
                        (let ((_hd172566172590_
                               (let ()
                                 (declare (not safe))
                                 (##car _header172562172569_)))
                              (_tl172567172592_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _header172562172569_))))
                          (let* ((_key172595_ _hd172566172590_)
                                 (_value172597_ _tl172567172592_))
                            (_K172565172587_ _value172597_ _key172595_)))
                        (_E172564172573_))))))
        (foldr1 _fold-e172558_ _headers172556_ _new-headers172555_))))
  (define std/net/request#http-get__%
    (lambda (_g296784_
             _redirect172504172512_
             _headers172505172514_
             _cookies172506172516_
             _params172507172518_
             _data172508172520_
             _auth172509172522_
             _url172524_)
      (let* ((_redirect172526_
              (if (eq? _redirect172504172512_ absent-value)
                  '#t
                  _redirect172504172512_))
             (_headers172528_
              (if (eq? _headers172505172514_ absent-value)
                  '#f
                  _headers172505172514_))
             (_cookies172530_
              (if (eq? _cookies172506172516_ absent-value)
                  '#f
                  _cookies172506172516_))
             (_params172532_
              (if (eq? _params172507172518_ absent-value)
                  '#f
                  _params172507172518_))
             (_data172534_
              (if (eq? _data172508172520_ absent-value)
                  '#f
                  _data172508172520_))
             (_auth172536_
              (if (eq? _auth172509172522_ absent-value)
                  '#f
                  _auth172509172522_)))
        (let ((_url172538_
               (std/net/request#url-target-e _url172524_ _params172532_))
              (_headers172539_
               (std/net/request#make-http/1.1-headers
                _headers172528_
                _cookies172530_
                _auth172536_)))
          (std/net/request#http-request
           'GET
           _url172538_
           _headers172539_
           _data172534_
           '()
           _redirect172526_)))))
  (define std/net/request#http-get__@
    (lambda (_keys172503172544_ . _args172546_)
      (apply std/net/request#http-get__%
             _keys172503172544_
             (table-ref _keys172503172544_ 'redirect: absent-value)
             (table-ref _keys172503172544_ 'headers: absent-value)
             (table-ref _keys172503172544_ 'cookies: absent-value)
             (table-ref _keys172503172544_ 'params: absent-value)
             (table-ref _keys172503172544_ 'data: absent-value)
             (table-ref _keys172503172544_ 'auth: absent-value)
             _args172546_)))
  (define std/net/request#http-get
    (lambda _args172510172552_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-get__@
             _args172510172552_)))
  (define std/net/request#http-head__%
    (lambda (_g296785_
             _redirect172451172459_
             _headers172452172461_
             _cookies172453172463_
             _params172454172465_
             _data172455172467_
             _auth172456172469_
             _url172471_)
      (let* ((_redirect172473_
              (if (eq? _redirect172451172459_ absent-value)
                  '#t
                  _redirect172451172459_))
             (_headers172475_
              (if (eq? _headers172452172461_ absent-value)
                  '#f
                  _headers172452172461_))
             (_cookies172477_
              (if (eq? _cookies172453172463_ absent-value)
                  '#f
                  _cookies172453172463_))
             (_params172479_
              (if (eq? _params172454172465_ absent-value)
                  '#f
                  _params172454172465_))
             (_data172481_
              (if (eq? _data172455172467_ absent-value)
                  '#f
                  _data172455172467_))
             (_auth172483_
              (if (eq? _auth172456172469_ absent-value)
                  '#f
                  _auth172456172469_)))
        (let ((_url172485_
               (std/net/request#url-target-e _url172471_ _params172479_))
              (_headers172486_
               (std/net/request#make-http/1.1-headers
                _headers172475_
                _cookies172477_
                _auth172483_)))
          (std/net/request#http-request
           'HEAD
           _url172485_
           _headers172486_
           _data172481_
           '()
           _redirect172473_)))))
  (define std/net/request#http-head__@
    (lambda (_keys172450172491_ . _args172493_)
      (apply std/net/request#http-head__%
             _keys172450172491_
             (table-ref _keys172450172491_ 'redirect: absent-value)
             (table-ref _keys172450172491_ 'headers: absent-value)
             (table-ref _keys172450172491_ 'cookies: absent-value)
             (table-ref _keys172450172491_ 'params: absent-value)
             (table-ref _keys172450172491_ 'data: absent-value)
             (table-ref _keys172450172491_ 'auth: absent-value)
             _args172493_)))
  (define std/net/request#http-head
    (lambda _args172457172499_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-head__@
             _args172457172499_)))
  (define std/net/request#http-post__%
    (lambda (_g296786_
             _redirect172396172404_
             _headers172397172406_
             _cookies172398172408_
             _params172399172410_
             _data172400172412_
             _auth172401172414_
             _url172416_)
      (let* ((_redirect172418_
              (if (eq? _redirect172396172404_ absent-value)
                  '#t
                  _redirect172396172404_))
             (_headers172420_
              (if (eq? _headers172397172406_ absent-value)
                  '#f
                  _headers172397172406_))
             (_cookies172422_
              (if (eq? _cookies172398172408_ absent-value)
                  '#f
                  _cookies172398172408_))
             (_params172424_
              (if (eq? _params172399172410_ absent-value)
                  '#f
                  _params172399172410_))
             (_data172426_
              (if (eq? _data172400172412_ absent-value)
                  '#f
                  _data172400172412_))
             (_auth172428_
              (if (eq? _auth172401172414_ absent-value)
                  '#f
                  _auth172401172414_))
             (_g296787_
              (if _params172424_
                  (let ((_form-data172430_
                         (std/net/uri#form-url-encode__% _params172424_ '#t)))
                    (values (std/net/request#http-headers-cons
                             '(("Content-Type"
                                .
                                "application/x-www-form-urlencoded"))
                             (std/net/request#make-http/1.1-headers
                              _headers172420_
                              _cookies172422_
                              _auth172428_))
                            _form-data172430_))
                  (values (std/net/request#make-http/1.1-headers
                           _headers172420_
                           _cookies172422_
                           _auth172428_)
                          _data172426_))))
        (begin
          #!void
          (let ((_headers172432_
                 (let () (declare (not safe)) (##vector-ref _g296787_ 0)))
                (_data172433_
                 (let () (declare (not safe)) (##vector-ref _g296787_ 1))))
            (std/net/request#http-request
             'POST
             _url172416_
             _headers172432_
             _data172433_
             '()
             _redirect172418_))))))
  (define std/net/request#http-post__@
    (lambda (_keys172395172438_ . _args172440_)
      (apply std/net/request#http-post__%
             _keys172395172438_
             (table-ref _keys172395172438_ 'redirect: absent-value)
             (table-ref _keys172395172438_ 'headers: absent-value)
             (table-ref _keys172395172438_ 'cookies: absent-value)
             (table-ref _keys172395172438_ 'params: absent-value)
             (table-ref _keys172395172438_ 'data: absent-value)
             (table-ref _keys172395172438_ 'auth: absent-value)
             _args172440_)))
  (define std/net/request#http-post
    (lambda _args172402172446_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-post__@
             _args172402172446_)))
  (define std/net/request#http-put__%
    (lambda (_g296788_
             _redirect172343172351_
             _headers172344172353_
             _cookies172345172355_
             _params172346172357_
             _data172347172359_
             _auth172348172361_
             _url172363_)
      (let* ((_redirect172365_
              (if (eq? _redirect172343172351_ absent-value)
                  '#t
                  _redirect172343172351_))
             (_headers172367_
              (if (eq? _headers172344172353_ absent-value)
                  '#f
                  _headers172344172353_))
             (_cookies172369_
              (if (eq? _cookies172345172355_ absent-value)
                  '#f
                  _cookies172345172355_))
             (_params172371_
              (if (eq? _params172346172357_ absent-value)
                  '#f
                  _params172346172357_))
             (_data172373_
              (if (eq? _data172347172359_ absent-value)
                  '#f
                  _data172347172359_))
             (_auth172375_
              (if (eq? _auth172348172361_ absent-value)
                  '#f
                  _auth172348172361_)))
        (let ((_url172377_
               (std/net/request#url-target-e _url172363_ _params172371_))
              (_headers172378_
               (std/net/request#make-http/1.1-headers
                _headers172367_
                _cookies172369_
                _auth172375_)))
          (std/net/request#http-request
           'PUT
           _url172377_
           _headers172378_
           _data172373_
           '()
           _redirect172365_)))))
  (define std/net/request#http-put__@
    (lambda (_keys172342172383_ . _args172385_)
      (apply std/net/request#http-put__%
             _keys172342172383_
             (table-ref _keys172342172383_ 'redirect: absent-value)
             (table-ref _keys172342172383_ 'headers: absent-value)
             (table-ref _keys172342172383_ 'cookies: absent-value)
             (table-ref _keys172342172383_ 'params: absent-value)
             (table-ref _keys172342172383_ 'data: absent-value)
             (table-ref _keys172342172383_ 'auth: absent-value)
             _args172385_)))
  (define std/net/request#http-put
    (lambda _args172349172391_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-put__@
             _args172349172391_)))
  (define std/net/request#http-delete__%
    (lambda (_g296789_
             _redirect172290172298_
             _headers172291172300_
             _cookies172292172302_
             _params172293172304_
             _data172294172306_
             _auth172295172308_
             _url172310_)
      (let* ((_redirect172312_
              (if (eq? _redirect172290172298_ absent-value)
                  '#t
                  _redirect172290172298_))
             (_headers172314_
              (if (eq? _headers172291172300_ absent-value)
                  '#f
                  _headers172291172300_))
             (_cookies172316_
              (if (eq? _cookies172292172302_ absent-value)
                  '#f
                  _cookies172292172302_))
             (_params172318_
              (if (eq? _params172293172304_ absent-value)
                  '#f
                  _params172293172304_))
             (_data172320_
              (if (eq? _data172294172306_ absent-value)
                  '#f
                  _data172294172306_))
             (_auth172322_
              (if (eq? _auth172295172308_ absent-value)
                  '#f
                  _auth172295172308_)))
        (let ((_url172324_
               (std/net/request#url-target-e _url172310_ _params172318_))
              (_headers172325_
               (std/net/request#make-http/1.1-headers
                _headers172314_
                _cookies172316_
                _auth172322_)))
          (std/net/request#http-request
           'DELETE
           _url172324_
           _headers172325_
           _data172320_
           '()
           _redirect172312_)))))
  (define std/net/request#http-delete__@
    (lambda (_keys172289172330_ . _args172332_)
      (apply std/net/request#http-delete__%
             _keys172289172330_
             (table-ref _keys172289172330_ 'redirect: absent-value)
             (table-ref _keys172289172330_ 'headers: absent-value)
             (table-ref _keys172289172330_ 'cookies: absent-value)
             (table-ref _keys172289172330_ 'params: absent-value)
             (table-ref _keys172289172330_ 'data: absent-value)
             (table-ref _keys172289172330_ 'auth: absent-value)
             _args172332_)))
  (define std/net/request#http-delete
    (lambda _args172296172338_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-delete__@
             _args172296172338_)))
  (define std/net/request#http-options__%
    (lambda (_g296790_
             _redirect172237172245_
             _headers172238172247_
             _cookies172239172249_
             _params172240172251_
             _data172241172253_
             _auth172242172255_
             _url172257_)
      (let* ((_redirect172259_
              (if (eq? _redirect172237172245_ absent-value)
                  '#t
                  _redirect172237172245_))
             (_headers172261_
              (if (eq? _headers172238172247_ absent-value)
                  '#f
                  _headers172238172247_))
             (_cookies172263_
              (if (eq? _cookies172239172249_ absent-value)
                  '#f
                  _cookies172239172249_))
             (_params172265_
              (if (eq? _params172240172251_ absent-value)
                  '#f
                  _params172240172251_))
             (_data172267_
              (if (eq? _data172241172253_ absent-value)
                  '#f
                  _data172241172253_))
             (_auth172269_
              (if (eq? _auth172242172255_ absent-value)
                  '#f
                  _auth172242172255_)))
        (let ((_url172271_
               (std/net/request#url-target-e _url172257_ _params172265_))
              (_headers172272_
               (std/net/request#make-http/1.1-headers
                _headers172261_
                _cookies172263_
                _auth172269_)))
          (std/net/request#http-request
           'OPTIONS
           _url172271_
           _headers172272_
           _data172267_
           '()
           _redirect172259_)))))
  (define std/net/request#http-options__@
    (lambda (_keys172236172277_ . _args172279_)
      (apply std/net/request#http-options__%
             _keys172236172277_
             (table-ref _keys172236172277_ 'redirect: absent-value)
             (table-ref _keys172236172277_ 'headers: absent-value)
             (table-ref _keys172236172277_ 'cookies: absent-value)
             (table-ref _keys172236172277_ 'params: absent-value)
             (table-ref _keys172236172277_ 'data: absent-value)
             (table-ref _keys172236172277_ 'auth: absent-value)
             _args172279_)))
  (define std/net/request#http-options
    (lambda _args172243172285_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-options__@
             _args172243172285_)))
  (define std/net/request#url-rx
    (std/pregexp#pregexp '"(?:(https?)://)?([^/:]+)(:[0-9]+)?(/.*)?"))
  (define std/net/request#+tls-context+
    (make-promise (lambda () (make-tls-context))))
  (define std/net/request#http-request
    (lambda (_method172102_
             _url172103_
             _user-headers172104_
             _body172105_
             _history172106_
             _redirect172107_)
      (let* ((_g172108172123_
              (std/pregexp#pregexp-match std/net/request#url-rx _url172103_))
             (_E172110172127_
              (lambda () (error '"No clause matching" _g172108172123_)))
             (_K172111172200_
              (lambda (_target172130_ _port172131_ _host172132_ _scheme172133_)
                (let* ((_scheme172138_
                        (let ((_$e172135_ _scheme172133_))
                          (if _$e172135_ _$e172135_ '"http")))
                       (_port172140_
                        (if _port172131_
                            (string->number
                             (substring
                              _port172131_
                              '1
                              (string-length _port172131_)))
                            (if (equal? _scheme172138_ '"https") '443 '80)))
                       (_target172145_
                        (let ((_$e172142_ _target172130_))
                          (if _$e172142_ _$e172142_ '"/")))
                       (_host-header172153_
                        (let ((_$e172147_ _port172140_))
                          (if (or (eq? '80 _$e172147_) (eq? '443 _$e172147_))
                              _host172132_
                              (std/format#format
                               '"~a:~a"
                               _host172132_
                               _port172140_))))
                       (_headers172155_
                        (std/net/request#http-headers-cons
                         (cons (cons '"Host" _host-header172153_) '())
                         _user-headers172104_))
                       (_body172157_
                        (if (not _body172105_)
                            '#f
                            (if (u8vector? _body172105_)
                                _body172105_
                                (if (string? _body172105_)
                                    (std/text/utf8#string->utf8__0
                                     _body172105_)
                                    (error '"bad request body"
                                           _body172105_)))))
                       (_headers172159_
                        (if _body172157_
                            (std/net/request#http-headers-cons!
                             (cons (cons '"Content-Length"
                                         (u8vector-length _body172157_))
                                   '())
                             _headers172155_)
                            _headers172155_))
                       (_tcp-client-options172161_
                        (cons 'server-address:
                              (cons _host172132_
                                    (cons 'port-number:
                                          (cons _port172140_
                                                (cons 'eol-encoding:
                                                      (cons 'cr-lf '())))))))
                       (_tcp-client-options172163_
                        (if (equal? _scheme172138_ '"https")
                            (cons 'tls-context:
                                  (cons (force std/net/request#+tls-context+)
                                        _tcp-client-options172161_))
                            _tcp-client-options172161_))
                       (_sock172165_
                        (open-tcp-client _tcp-client-options172163_))
                       (_req172167_
                        (let ((__obj296782
                               (make-object std/net/request#request::t '8)))
                          (if (let ((__tmp296791
                                     (let ()
                                       (declare (not safe))
                                       (##vector-length __obj296782))))
                                (declare (not safe))
                                (##fx< '3 __tmp296791))
                              (begin
                                (let ()
                                  (declare (not safe))
                                  (##vector-set! __obj296782 '1 _sock172165_))
                                (let ()
                                  (declare (not safe))
                                  (##vector-set! __obj296782 '2 _url172103_))
                                (let ()
                                  (declare (not safe))
                                  (##vector-set!
                                   __obj296782
                                   '3
                                   _history172106_)))
                              (error '"struct-instance-init!: too many arguments for struct"
                                     __obj296782))
                          __obj296782)))
                  (std/net/request#http-request-write
                   _sock172165_
                   _method172102_
                   _target172145_
                   _headers172159_
                   _body172157_)
                  (std/net/request#http-request-read-response! _req172167_)
                  (let ((_$e172170_
                         (if _redirect172107_
                             (if (memv (##structure-ref
                                        _req172167_
                                        '4
                                        std/net/request#request::t
                                        '#f)
                                       '(301 302 303 307))
                                 (if (memq _method172102_ '(GET HEAD))
                                     (assoc '"Location"
                                            (##structure-ref
                                             _req172167_
                                             '6
                                             std/net/request#request::t
                                             '#f))
                                     '#f)
                                 '#f)
                             '#f)))
                    (if _$e172170_
                        ((lambda (_e172172172174_)
                           (let* ((_g172176172183_ _e172172172174_)
                                  (_E172178172187_
                                   (lambda ()
                                     (error '"No clause matching"
                                            _g172176172183_)))
                                  (_K172179172192_
                                   (lambda (_new-url172190_)
                                     (if (member _new-url172190_
                                                 _history172106_)
                                         (error '"URL redirection loop"
                                                _url172103_)
                                         (begin
                                           (std/net/request#request-close
                                            _req172167_)
                                           (std/net/request#http-request
                                            _method172102_
                                            _new-url172190_
                                            _user-headers172104_
                                            _body172157_
                                            (cons _url172103_ _history172106_)
                                            '#t))))))
                             (if (let ()
                                   (declare (not safe))
                                   (##pair? _g172176172183_))
                                 (let* ((_tl172181172195_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _g172176172183_)))
                                        (_new-url172198_ _tl172181172195_))
                                   (_K172179172192_ _new-url172198_))
                                 (_E172178172187_))))
                         _$e172170_)
                        _req172167_))))))
        (if (let () (declare (not safe)) (##pair? _g172108172123_))
            (let ((_tl172113172203_
                   (let () (declare (not safe)) (##cdr _g172108172123_))))
              (if (let () (declare (not safe)) (##pair? _tl172113172203_))
                  (let ((_hd172114172206_
                         (let ()
                           (declare (not safe))
                           (##car _tl172113172203_)))
                        (_tl172115172208_
                         (let ()
                           (declare (not safe))
                           (##cdr _tl172113172203_))))
                    (let ((_scheme172211_ _hd172114172206_))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _tl172115172208_))
                          (let ((_hd172116172213_
                                 (let ()
                                   (declare (not safe))
                                   (##car _tl172115172208_)))
                                (_tl172117172215_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _tl172115172208_))))
                            (let ((_host172218_ _hd172116172213_))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _tl172117172215_))
                                  (let ((_hd172118172220_
                                         (let ()
                                           (declare (not safe))
                                           (##car _tl172117172215_)))
                                        (_tl172119172222_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _tl172117172215_))))
                                    (let ((_port172225_ _hd172118172220_))
                                      (if (let ()
                                            (declare (not safe))
                                            (##pair? _tl172119172222_))
                                          (let ((_hd172120172227_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##car _tl172119172222_)))
                                                (_tl172121172229_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##cdr _tl172119172222_))))
                                            (let ((_target172232_
                                                   _hd172120172227_))
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##null? _tl172121172229_))
                                                  (_K172111172200_
                                                   _target172232_
                                                   _port172225_
                                                   _host172218_
                                                   _scheme172211_)
                                                  (_E172110172127_))))
                                          (_E172110172127_))))
                                  (_E172110172127_))))
                          (_E172110172127_))))
                  (_E172110172127_)))
            (_E172110172127_)))))
  (define std/net/request#http-request-write
    (lambda (_port172064_
             _method172065_
             _target172066_
             _headers172067_
             _body172068_)
      (std/format#fprintf
       _port172064_
       '"~a ~a HTTP/1.1~n"
       _method172065_
       _target172066_)
      (for-each
       (lambda (_e172069172071_)
         (let* ((_g172073172080_ _e172069172071_)
                (_E172075172084_
                 (lambda () (error '"No clause matching" _g172073172080_)))
                (_K172076172090_
                 (lambda (_val172087_ _key172088_)
                   (std/format#fprintf
                    _port172064_
                    '"~a: ~a~n"
                    _key172088_
                    _val172087_))))
           (if (let () (declare (not safe)) (##pair? _g172073172080_))
               (let ((_hd172077172093_
                      (let () (declare (not safe)) (##car _g172073172080_)))
                     (_tl172078172095_
                      (let () (declare (not safe)) (##cdr _g172073172080_))))
                 (let* ((_key172098_ _hd172077172093_)
                        (_val172100_ _tl172078172095_))
                   (_K172076172090_ _val172100_ _key172098_)))
               (_E172075172084_))))
       _headers172067_)
      (newline _port172064_)
      (if _body172068_
          (write-subu8vector
           _body172068_
           '0
           (u8vector-length _body172068_)
           _port172064_)
          '#!void)
      (force-output _port172064_)))
  (define std/net/request#status-line-rx
    (std/pregexp#pregexp '"([0-9]{3})\\s+(.*)"))
  (define std/net/request#header-line-rx
    (std/pregexp#pregexp '"([^:]+):\\s*(.*)?"))
  (define std/net/request#http-request-read-response!
    (lambda (_req171957_)
      (let* ((_port171959_
              (##structure-ref _req171957_ '1 std/net/request#request::t '#f))
             (_status-line171961_
              (std/net/request#read-response-line _port171959_)))
        (let* ((_g171963171975_
                (std/pregexp#pregexp-match
                 std/net/request#status-line-rx
                 _status-line171961_))
               (_else171965171983_
                (lambda ()
                  (std/error#raise-io-error
                   'http-request-read-response!
                   '"malformed status line"
                   _port171959_
                   _status-line171961_)))
               (_K171967172044_
                (lambda (_status-text171986_ _status171987_)
                  (##structure-set!
                   _req171957_
                   (string->number _status171987_)
                   '4
                   std/net/request#request::t
                   '#f)
                  (##structure-set!
                   _req171957_
                   (std/srfi/13#string-trim-both__0 _status-text171986_)
                   '5
                   std/net/request#request::t
                   '#f)
                  (let ((_root171989_ (cons '#f '())))
                    (let _lp171991_ ((_tl171993_ _root171989_))
                      (let ((_next171995_
                             (std/net/request#read-response-line
                              _port171959_)))
                        (if (string-empty? _next171995_)
                            (##structure-set!
                             _req171957_
                             (cdr _root171989_)
                             '6
                             std/net/request#request::t
                             '#f)
                            (let* ((_g171996172008_
                                    (std/pregexp#pregexp-match
                                     std/net/request#header-line-rx
                                     _next171995_))
                                   (_else171998172016_
                                    (lambda ()
                                      (std/error#raise-io-error
                                       'http-request-read-response!
                                       '"Malformed header"
                                       _port171959_
                                       _next171995_)))
                                   (_K172000172024_
                                    (lambda (_value172019_ _key172020_)
                                      (let ((_tl*172022_
                                             (cons (cons (std/srfi/13#string-titlecase__0
                                                          _key172020_)
                                                         (std/srfi/13#string-trim-both__0
                                                          _value172019_))
                                                   '())))
                                        (set-cdr! _tl171993_ _tl*172022_)
                                        (_lp171991_ _tl*172022_)))))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _g171996172008_))
                                  (let ((_tl172002172027_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _g171996172008_))))
                                    (if (let ()
                                          (declare (not safe))
                                          (##pair? _tl172002172027_))
                                        (let ((_hd172003172030_
                                               (let ()
                                                 (declare (not safe))
                                                 (##car _tl172002172027_)))
                                              (_tl172004172032_
                                               (let ()
                                                 (declare (not safe))
                                                 (##cdr _tl172002172027_))))
                                          (let ((_key172035_ _hd172003172030_))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##pair? _tl172004172032_))
                                                (let ((_hd172005172037_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##car _tl172004172032_)))
                                                      (_tl172006172039_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##cdr _tl172004172032_))))
                                                  (let ((_value172042_
                                                         _hd172005172037_))
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##null? _tl172006172039_))
                                                        (_K172000172024_
                                                         _value172042_
                                                         _key172035_)
                                                        (_else171998172016_))))
                                                (_else171998172016_))))
                                        (_else171998172016_)))
                                  (_else171998172016_))))))))))
          (if (let () (declare (not safe)) (##pair? _g171963171975_))
              (let ((_tl171969172047_
                     (let () (declare (not safe)) (##cdr _g171963171975_))))
                (if (let () (declare (not safe)) (##pair? _tl171969172047_))
                    (let ((_hd171970172050_
                           (let ()
                             (declare (not safe))
                             (##car _tl171969172047_)))
                          (_tl171971172052_
                           (let ()
                             (declare (not safe))
                             (##cdr _tl171969172047_))))
                      (let ((_status172055_ _hd171970172050_))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl171971172052_))
                            (let ((_hd171972172057_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl171971172052_)))
                                  (_tl171973172059_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl171971172052_))))
                              (let ((_status-text172062_ _hd171972172057_))
                                (if (let ()
                                      (declare (not safe))
                                      (##null? _tl171973172059_))
                                    (_K171967172044_
                                     _status-text172062_
                                     _status172055_)
                                    (_else171965171983_))))
                            (_else171965171983_))))
                    (_else171965171983_)))
              (_else171965171983_))))))
  (define std/net/request#http-request-read-body
    (lambda (_port171942_ _headers171943_)
      (letrec ((_length-e171945_
                (lambda (_headers171952_)
                  (let ((_$e171954_
                         (assget '"Content-Length" _headers171952_)))
                    (if _$e171954_ (string->number _$e171954_) '#f)))))
        (let ((_$e171947_ (assget '"Transfer-Encoding" _headers171943_)))
          (if _$e171947_
              ((lambda (_tenc171950_)
                 (if (not (equal? '"identity" _tenc171950_))
                     (std/net/request#http-request-read-chunked-body
                      _port171942_)
                     (std/net/request#http-request-read-simple-body
                      _port171942_
                      (_length-e171945_ _headers171943_))))
               _$e171947_)
              (std/net/request#http-request-read-simple-body
               _port171942_
               (_length-e171945_ _headers171943_)))))))
  (define std/net/request#http-request-read-chunked-body
    (lambda (_port171922_)
      (let ((_root171924_ (cons '#f '())))
        (let _lp171926_ ((_tl171928_ _root171924_))
          (let* ((_line171930_
                  (std/net/request#read-response-line _port171922_))
                 (_clen171932_
                  (string->number
                   (car (string-split _line171930_ '#\space))
                   '16)))
            (if (fxzero? _clen171932_)
                (u8vector-concatenate (cdr _root171924_))
                (let* ((_chunk171935_ (make-u8vector _clen171932_))
                       (_rd171937_
                        (read-subu8vector
                         _chunk171935_
                         '0
                         _clen171932_
                         _port171922_)))
                  (if (let ()
                        (declare (not safe))
                        (##fx< _rd171937_ _clen171932_))
                      (std/error#raise-io-error
                       'http-request-read-body
                       '"error reading chunk; premature end of port")
                      '#!void)
                  (std/net/request#read-response-line _port171922_)
                  (let ((_tl*171940_ (cons _chunk171935_ '())))
                    (set-cdr! _tl171928_ _tl*171940_)
                    (_lp171926_ _tl*171940_)))))))))
  (define std/net/request#http-request-read-simple-body
    (lambda (_port171891_ _length171892_)
      (letrec ((_read/length171894_
                (lambda (_port171914_ _length171915_)
                  (let* ((_data171917_ (make-u8vector _length171915_))
                         (_rd171919_
                          (read-subu8vector
                           _data171917_
                           '0
                           _length171915_
                           _port171914_)))
                    (if (let ()
                          (declare (not safe))
                          (##fx< _rd171919_ _length171915_))
                        (begin
                          (u8vector-shrink! _data171917_ _rd171919_)
                          _data171917_)
                        _data171917_))))
               (_read/end171895_
                (lambda (_port171897_)
                  (let ((_root171899_ (cons '#f '())))
                    (let _lp171901_ ((_tl171903_ _root171899_))
                      (let* ((_buflen171905_ '4096)
                             (_buf171907_ (make-u8vector _buflen171905_))
                             (_rd171909_
                              (read-subu8vector
                               _buf171907_
                               '0
                               _buflen171905_
                               _port171897_)))
                        (if (let ()
                              (declare (not safe))
                              (##fxzero? _rd171909_))
                            (u8vector-concatenate (cdr _root171899_))
                            (if (let ()
                                  (declare (not safe))
                                  (##fx< _rd171909_ _buflen171905_))
                                (begin
                                  (u8vector-shrink! _buf171907_ _rd171909_)
                                  (set-cdr! _tl171903_ (cons _buf171907_ '()))
                                  (u8vector-concatenate (cdr _root171899_)))
                                (let ((_tl*171912_ (cons _buf171907_ '())))
                                  (set-cdr! _tl171903_ _tl*171912_)
                                  (_lp171901_ _tl*171912_))))))))))
        (if _length171892_
            (_read/length171894_ _port171891_ _length171892_)
            (_read/end171895_ _port171891_)))))
  (define std/net/request#cr (char->integer '#\return))
  (define std/net/request#lf (char->integer '#\newline))
  (define std/net/request#crlf
    (u8vector std/net/request#cr std/net/request#lf))
  (define std/net/request#read-response-line
    (lambda (_port171875_)
      (let ((_root171877_ (cons '#f '())))
        (let _lp171879_ ((_tl171881_ _root171877_))
          (let ((_next171883_ (read-u8 _port171875_)))
            (if (eof-object? _next171883_)
                (std/error#raise-io-error
                 'request-read-response-line
                 '"Incomplete response; connection closed"
                 _port171875_)
                (if (eq? _next171883_ std/net/request#cr)
                    (let ((_next171885_ (read-u8 _port171875_)))
                      (if (eof-object? _next171885_)
                          (std/error#raise-io-error
                           'request-read-response-line
                           '"Incomplete response; connection closed"
                           _port171875_)
                          (if (eq? _next171885_ std/net/request#lf)
                              (std/text/utf8#utf8->string__0
                               (list->u8vector (cdr _root171877_)))
                              (let ((_tl*171887_
                                     (cons std/net/request#cr
                                           (cons _next171885_ '()))))
                                (set-cdr! _tl171881_ _tl*171887_)
                                (_lp171879_ (cdr _tl*171887_))))))
                    (let ((_tl*171889_ (cons _next171883_ '())))
                      (set-cdr! _tl171881_ _tl*171889_)
                      (_lp171879_ _tl*171889_)))))))))
  (define std/net/request#request-close
    (lambda (_req171866_)
      (let ((_port171867171869_
             (##structure-ref _req171866_ '1 std/net/request#request::t '#f)))
        (if _port171867171869_
            (let ((_port171872_ _port171867171869_))
              (with-exception-catcher
               void
               (lambda () (close-port _port171872_)))
              (##structure-set!
               _req171866_
               '#f
               '1
               std/net/request#request::t
               '#f))
            '#f))))
  (define std/net/request#request::destroy std/net/request#request-close)
  (bind-method!
   std/net/request#request::t
   'destroy
   std/net/request#request::destroy
   '#f)
  (define std/net/request#request-content
    (lambda (_req171714_)
      (let ((_$e171716_
             (##structure-ref _req171714_ '7 std/net/request#request::t '#f)))
        (if _$e171716_
            (values _$e171716_)
            (let ((_$e171719_
                   (##structure-ref
                    _req171714_
                    '1
                    std/net/request#request::t
                    '#f)))
              (if _$e171719_
                  ((lambda (_port171722_)
                     (let ((_headers171724_
                            (##structure-ref
                             _req171714_
                             '6
                             std/net/request#request::t
                             '#f)))
                       (with-unwind-protect
                        (lambda ()
                          (let* ((_body171727_
                                  (std/net/request#http-request-read-body
                                   _port171722_
                                   _headers171724_))
                                 (_body171740_
                                  (let ((_$e171729_
                                         (assoc '"Content-Encoding"
                                                _headers171724_)))
                                    (if _$e171729_
                                        ((lambda (_enc171732_)
                                           (let ((_$e171734_
                                                  (cdr _enc171732_)))
                                             (if (or (equal? '"gzip"
                                                             _$e171734_)
                                                     (equal? '"deflate"
                                                             _$e171734_))
                                                 (std/text/zlib#uncompress
                                                  _body171727_)
                                                 (if (equal? '"identity"
                                                             _$e171734_)
                                                     _body171727_
                                                     (error '"Unsupported content encoding"
                                                            _enc171732_)))))
                                         _$e171729_)
                                        _body171727_))))
                            (##structure-set!
                             _req171714_
                             _body171740_
                             '7
                             std/net/request#request::t
                             '#f)
                            _body171740_))
                        (lambda ()
                          (close-port _port171722_)
                          (##structure-set!
                           _req171714_
                           '#f
                           '1
                           std/net/request#request::t
                           '#f)))))
                   _$e171719_)
                  '#f))))))
  (define std/net/request#request-text
    (lambda (_req171705_)
      (letrec ((_get-text171707_
                (lambda (_enc171712_)
                  (if (eq? _enc171712_ 'UTF-8)
                      (std/text/utf8#utf8->string__0
                       (std/net/request#request-content _req171705_))
                      (bytes->string
                       (std/net/request#request-content _req171705_)
                       _enc171712_)))))
        (let ((_$e171709_
               (##structure-ref
                _req171705_
                '8
                std/net/request#request::t
                '#f)))
          (if _$e171709_
              (_get-text171707_ _$e171709_)
              (_get-text171707_ 'UTF-8))))))
  (define std/net/request#request-json
    (lambda (_req171703_)
      (std/text/json#string->json-object
       (std/net/request#request-text _req171703_))))
  (define std/net/request#request-cookies
    (lambda (_req171468_)
      (let* ((_head171470_ (cons '#f '())) (_tail171473_ _head171470_))
        (let _lp171633_ ((_rest171635_
                          (##structure-ref
                           _req171468_
                           '6
                           std/net/request#request::t
                           '#f)))
          (let* ((_rest171636171644_ _rest171635_)
                 (_else171638171652_ (lambda () '#!void))
                 (_K171640171691_
                  (lambda (_rest171655_ _hd171656_)
                    (let* ((_hd171657171665_ _hd171656_)
                           (_else171659171673_
                            (lambda () (_lp171633_ _rest171655_)))
                           (_K171661171681_
                            (lambda (_cookie171676_)
                              (let ((_new-tail171678_
                                     (cons _cookie171676_ '())))
                                (let ()
                                  (declare (not safe))
                                  (##set-cdr! _tail171473_ _new-tail171678_))
                                (set! _tail171473_ _new-tail171678_))
                              (_lp171633_ _rest171655_))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _hd171657171665_))
                          (let ((_hd171662171684_
                                 (let ()
                                   (declare (not safe))
                                   (##car _hd171657171665_)))
                                (_tl171663171686_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _hd171657171665_))))
                            (if (equal? _hd171662171684_ '"Set-Cookie")
                                (let ((_cookie171689_ _tl171663171686_))
                                  (_K171661171681_ _cookie171689_))
                                (_else171659171673_)))
                          (_else171659171673_))))))
            (if (let () (declare (not safe)) (##pair? _rest171636171644_))
                (let ((_hd171641171694_
                       (let ()
                         (declare (not safe))
                         (##car _rest171636171644_)))
                      (_tl171642171696_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest171636171644_))))
                  (let* ((_hd171699_ _hd171641171694_)
                         (_rest171701_ _tl171642171696_))
                    (_K171640171691_ _rest171701_ _hd171699_)))
                '#!void)))
        (let () (declare (not safe)) (##cdr _head171470_))))))
