(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/socks#open-socks-client
    (lambda (_proxy171456_ _server171457_ _open171458_ _connect171459_)
      (let ((_sock171461_
             (open-tcp-client
              (std/net/address#inet-address->string
               (std/net/address#inet-address _proxy171456_)))))
        (with-exception-catcher
         (lambda (_e171463_)
           (with-exception-catcher void (lambda () (close-port _sock171461_)))
           (raise _e171463_))
         (lambda ()
           (_open171458_ _sock171461_)
           (_connect171459_ _sock171461_ _server171457_)
           _sock171461_)))))
  (define std/net/socks#open-socks4-client
    (lambda (_proxy171453_ _server171454_)
      (std/net/socks#open-socks-client
       _proxy171453_
       _server171454_
       void
       std/net/socks#socks4-connect)))
  (define std/net/socks#open-socks5-client
    (lambda (_proxy171450_ _server171451_)
      (std/net/socks#open-socks-client
       _proxy171450_
       _server171451_
       std/net/socks#socks5-open
       std/net/socks#socks5-connect)))
  (define std/net/socks#socks5-open
    (lambda (_sock171442_)
      (std/net/socks#send-msg _sock171442_ '#u8(5 1 0))
      (let ((_in171444_ (let () (declare (not safe)) (##make-u8vector '2 '0))))
        (std/net/socks#recv-msg _sock171442_ _in171444_)
        (let ((_proto171446_
               (let () (declare (not safe)) (##u8vector-ref _in171444_ '0))))
          (if (eq? _proto171446_ '5)
              '#!void
              (std/error#raise-io-error
               'socks5-open
               '"SOCKS5 handshake error; protocol version mismatch"
               _proto171446_)))
        (let ((_rep171448_
               (let () (declare (not safe)) (##u8vector-ref _in171444_ '1))))
          (if (eq? _rep171448_ '0)
              '#!void
              (std/error#raise-io-error
               'socks5-open
               '"SOCKS5 handshake error; negotiation failed"
               _rep171448_))))))
  (define std/net/socks#socks5-connect
    (lambda (_sock171439_ _address171440_)
      (std/net/socks#socks-connect
       std/net/socks#socks5-send-request
       std/net/socks#socks5-recv-reply
       _sock171439_
       _address171440_)))
  (define std/net/socks#socks5-bind__%
    (lambda (_sock171426_ _address171427_)
      (std/net/socks#socks-bind
       std/net/socks#socks5-send-request
       std/net/socks#socks5-recv-reply
       _sock171426_
       _address171427_)))
  (define std/net/socks#socks5-bind__0
    (lambda (_sock171432_)
      (let ((_address171434_ '#f))
        (std/net/socks#socks5-bind__% _sock171432_ _address171434_))))
  (define std/net/socks#socks5-bind
    (lambda _g296740_
      (let ((_g296739_ (let () (declare (not safe)) (##length _g296740_))))
        (cond ((let () (declare (not safe)) (##fx= _g296739_ 1))
               (apply std/net/socks#socks5-bind__0 _g296740_))
              ((let () (declare (not safe)) (##fx= _g296739_ 2))
               (apply std/net/socks#socks5-bind__% _g296740_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socks#socks5-bind
                _g296740_))))))
  (define std/net/socks#socks5-accept
    (lambda (_sock171423_) (std/net/socks#socks5-recv-reply _sock171423_)))
  (define std/net/socks#socks4-connect__%
    (lambda (_sock171407_ _address171408_ _userid171409_)
      (std/net/socks#socks-connect
       std/net/socks#socks4-send-request
       std/net/socks#socks4-recv-reply
       _sock171407_
       _address171408_
       _userid171409_)))
  (define std/net/socks#socks4-connect__0
    (lambda (_sock171414_ _address171415_)
      (let ((_userid171417_ '#f))
        (std/net/socks#socks4-connect__%
         _sock171414_
         _address171415_
         _userid171417_))))
  (define std/net/socks#socks4-connect
    (lambda _g296742_
      (let ((_g296741_ (let () (declare (not safe)) (##length _g296742_))))
        (cond ((let () (declare (not safe)) (##fx= _g296741_ 2))
               (apply std/net/socks#socks4-connect__0 _g296742_))
              ((let () (declare (not safe)) (##fx= _g296741_ 3))
               (apply std/net/socks#socks4-connect__% _g296742_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socks#socks4-connect
                _g296742_))))))
  (define std/net/socks#socks4-bind__%
    (lambda (_sock171384_ _address171385_ _userid171386_)
      (std/net/socks#socks-bind
       std/net/socks#socks4-send-request
       std/net/socks#socks4-recv-reply
       _sock171384_
       _address171385_
       _userid171386_)))
  (define std/net/socks#socks4-bind__0
    (lambda (_sock171391_)
      (let* ((_address171393_ '#f) (_userid171395_ '#f))
        (std/net/socks#socks4-bind__%
         _sock171391_
         _address171393_
         _userid171395_))))
  (define std/net/socks#socks4-bind__1
    (lambda (_sock171397_ _address171398_)
      (let ((_userid171400_ '#f))
        (std/net/socks#socks4-bind__%
         _sock171397_
         _address171398_
         _userid171400_))))
  (define std/net/socks#socks4-bind
    (lambda _g296744_
      (let ((_g296743_ (let () (declare (not safe)) (##length _g296744_))))
        (cond ((let () (declare (not safe)) (##fx= _g296743_ 1))
               (apply std/net/socks#socks4-bind__0 _g296744_))
              ((let () (declare (not safe)) (##fx= _g296743_ 2))
               (apply std/net/socks#socks4-bind__1 _g296744_))
              ((let () (declare (not safe)) (##fx= _g296743_ 3))
               (apply std/net/socks#socks4-bind__% _g296744_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socks#socks4-bind
                _g296744_))))))
  (define std/net/socks#socks4-accept
    (lambda (_sock171381_) (std/net/socks#socks4-recv-reply _sock171381_)))
  (define std/net/socks#socks-connect
    (lambda (_send171372_
             _recv171373_
             _sock171374_
             _address171375_
             .
             _args171376_)
      (let ((_g296745_ (std/net/socks#parse-address _address171375_)))
        (begin
          (let ((_g296746_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g296745_) (##vector-length _g296745_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g296746_ 2)))
                (error "Context expects 2 values" _g296746_)))
          (let ((_host171378_
                 (let () (declare (not safe)) (##vector-ref _g296745_ 0)))
                (_port171379_
                 (let () (declare (not safe)) (##vector-ref _g296745_ 1))))
            (apply _send171372_
                   _sock171374_
                   '1
                   _host171378_
                   _port171379_
                   _args171376_))))
      (_recv171373_ _sock171374_)))
  (define std/net/socks#socks-bind
    (lambda (_send171363_
             _recv171364_
             _sock171365_
             _address171366_
             .
             _args171367_)
      (let ((_g296747_
             (if _address171366_
                 (std/net/socks#parse-address _address171366_)
                 (values '#u8(0 0 0 0) '0))))
        (begin
          (let ((_g296748_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g296747_) (##vector-length _g296747_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g296748_ 2)))
                (error "Context expects 2 values" _g296748_)))
          (let ((_host171369_
                 (let () (declare (not safe)) (##vector-ref _g296747_ 0)))
                (_port171370_
                 (let () (declare (not safe)) (##vector-ref _g296747_ 1))))
            (begin
              (apply _send171363_
                     _sock171365_
                     '2
                     _host171369_
                     _port171370_
                     _args171367_)
              (_recv171364_ _sock171365_)))))))
  (define std/net/socks#parse-address
    (lambda (_addr171333_)
      (let* ((_g171334171341_ (std/net/address#inet-address _addr171333_))
             (_E171336171345_
              (lambda () (error '"No clause matching" _g171334171341_)))
             (_K171337171351_
              (lambda (_port171348_ _host171349_)
                (values _host171349_ _port171348_))))
        (if (let () (declare (not safe)) (##pair? _g171334171341_))
            (let ((_hd171338171354_
                   (let () (declare (not safe)) (##car _g171334171341_)))
                  (_tl171339171356_
                   (let () (declare (not safe)) (##cdr _g171334171341_))))
              (let* ((_host171359_ _hd171338171354_)
                     (_port171361_ _tl171339171356_))
                (_K171337171351_ _port171361_ _host171359_)))
            (_E171336171345_)))))
  (define std/net/socks#socks5-send-request
    (lambda (_sock171307_ _cmd171308_ _host171309_ _port171310_)
      (let* ((_porthi171312_
              (let ((__tmp296749
                     (let ()
                       (declare (not safe))
                       (##fxarithmetic-shift _port171310_ '-8))))
                (declare (not safe))
                (##fxand __tmp296749 '255)))
             (_portlo171314_
              (let () (declare (not safe)) (##fxand _port171310_ '255)))
             (_out171330_
              (if (string? _host171309_)
                  (let* ((_fqdn171316_
                          (std/text/utf8#string->utf8__0 _host171309_))
                         (_fqdnlen171318_
                          (let ()
                            (declare (not safe))
                            (##u8vector-length _fqdn171316_)))
                         (_g296750_
                          (if (let ()
                                (declare (not safe))
                                (##fx> _fqdnlen171318_ '255))
                              (error '"Domain name too long"
                                     _host171309_
                                     _fqdnlen171318_)
                              '#!void))
                         (_len171321_
                          (let ()
                            (declare (not safe))
                            (##fx+ '7 _fqdnlen171318_)))
                         (_out171323_
                          (let ()
                            (declare (not safe))
                            (##make-u8vector _len171321_ '0))))
                    (let ()
                      (declare (not safe))
                      (##u8vector-set! _out171323_ '3 '3))
                    (let ()
                      (declare (not safe))
                      (##u8vector-set! _out171323_ '4 _fqdnlen171318_))
                    (let ()
                      (declare (not safe))
                      (##subu8vector-move!
                       _fqdn171316_
                       '0
                       _fqdnlen171318_
                       _out171323_
                       '5))
                    (let ((__tmp296751
                           (let ()
                             (declare (not safe))
                             (##fx+ _fqdnlen171318_ '5))))
                      (declare (not safe))
                      (##u8vector-set! _out171323_ __tmp296751 _porthi171312_))
                    (let ((__tmp296752
                           (let ()
                             (declare (not safe))
                             (##fx+ _fqdnlen171318_ '6))))
                      (declare (not safe))
                      (##u8vector-set!
                       _out171323_
                       __tmp296752
                       _portlo171314_)))
                  (if (and (let ()
                             (declare (not safe))
                             (##u8vector? _host171309_))
                           (let ((__tmp296753
                                  (let ()
                                    (declare (not safe))
                                    (##u8vector-length _host171309_))))
                             (declare (not safe))
                             (##fx= __tmp296753 '4)))
                      (let ((_out171326_
                             (let ()
                               (declare (not safe))
                               (##make-u8vector '10 '0))))
                        (let ()
                          (declare (not safe))
                          (##u8vector-set! _out171326_ '3 '1))
                        (let ()
                          (declare (not safe))
                          (##subu8vector-move!
                           _host171309_
                           '0
                           '4
                           _out171326_
                           '4))
                        (let ()
                          (declare (not safe))
                          (##u8vector-set! _out171326_ '8 _porthi171312_))
                        (let ()
                          (declare (not safe))
                          (##u8vector-set! _out171326_ '9 _portlo171314_)))
                      (if (and (let ()
                                 (declare (not safe))
                                 (##u8vector? _host171309_))
                               (let ((__tmp296754
                                      (let ()
                                        (declare (not safe))
                                        (##u8vector-length _host171309_))))
                                 (declare (not safe))
                                 (##fx= __tmp296754 '16)))
                          (let ((_out171328_
                                 (let ()
                                   (declare (not safe))
                                   (##make-u8vector '22 '0))))
                            (let ()
                              (declare (not safe))
                              (##u8vector-set! _out171328_ '3 '4))
                            (let ()
                              (declare (not safe))
                              (##subu8vector-move!
                               _host171309_
                               '0
                               '4
                               _out171328_
                               '16))
                            (let ()
                              (declare (not safe))
                              (##u8vector-set! _out171328_ '20 _porthi171312_))
                            (let ()
                              (declare (not safe))
                              (##u8vector-set!
                               _out171328_
                               '21
                               _portlo171314_)))
                          (error '"Unexpected host address" _host171309_))))))
        (let () (declare (not safe)) (##u8vector-set! _out171330_ '0 '5))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171330_ '1 _cmd171308_))
        (std/net/socks#send-msg _sock171307_ _out171330_))))
  (define std/net/socks#socks5-recv-reply
    (lambda (_sock171277_)
      (letrec ((_recv-port171279_
                (lambda ()
                  (let* ((_porthi171302_
                          (let ()
                            (declare (not safe))
                            (##read-u8 _sock171277_)))
                         (_portlo171304_
                          (let ()
                            (declare (not safe))
                            (##read-u8 _sock171277_))))
                    (let ((__tmp296755
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift _porthi171302_ '8))))
                      (declare (not safe))
                      (##fxior __tmp296755 _portlo171304_)))))
               (_recv-address171280_
                (lambda (_atype171289_ _rep171290_)
                  (let ((_$e171292_ _atype171289_))
                    (if (eq? '1 _$e171292_)
                        (let ((_addr171295_
                               (let ()
                                 (declare (not safe))
                                 (##make-u8vector '4 '0))))
                          (std/net/socks#recv-msg _sock171277_ _addr171295_)
                          (cons _addr171295_ (_recv-port171279_)))
                        (if (eq? '3 _$e171292_)
                            (let ((_buf171297_
                                   (let ((__tmp296756
                                          (let ()
                                            (declare (not safe))
                                            (##read-u8 _sock171277_))))
                                     (declare (not safe))
                                     (##make-u8vector __tmp296756 '0))))
                              (std/net/socks#recv-msg _sock171277_ _buf171297_)
                              (cons (std/text/utf8#utf8->string__0 _buf171297_)
                                    (_recv-port171279_)))
                            (if (eq? '4 _$e171292_)
                                (let ((_addr171299_
                                       (let ()
                                         (declare (not safe))
                                         (##make-u8vector '16 '0))))
                                  (std/net/socks#recv-msg
                                   _sock171277_
                                   _addr171299_)
                                  (cons _addr171299_ (_recv-port171279_)))
                                (std/error#raise-io-error
                                 'socks5-recv-reply
                                 '"Unexpected SOCKS5 address type"
                                 _atype171289_
                                 _rep171290_))))))))
        (let ((_hdr171282_
               (let () (declare (not safe)) (##make-u8vector '4 '0))))
          (std/net/socks#recv-msg _sock171277_ _hdr171282_)
          (let ((_proto171284_
                 (let () (declare (not safe)) (##u8vector-ref _hdr171282_ '0)))
                (_rep171285_
                 (let ()
                   (declare (not safe))
                   (##u8vector-ref _hdr171282_ '1))))
            (if (eq? _proto171284_ '5)
                '#!void
                (std/error#raise-io-error
                 'socks5-recv-reply
                 '"Unexpected SOCKS5 reply; protocol mismatch"
                 _proto171284_))
            (let ((_addr171287_
                   (_recv-address171280_
                    (let ()
                      (declare (not safe))
                      (##u8vector-ref _hdr171282_ '3))
                    _rep171285_)))
              (if (eq? _rep171285_ '0)
                  _addr171287_
                  (std/error#raise-io-error
                   'socks5-recv-reply
                   '"SOCKS5 error response"
                   _rep171285_))))))))
  (define std/net/socks#socks4-send-request
    (lambda (_sock171246_ _cmd171247_ _host171248_ _port171249_ _userid171250_)
      (let* ((_porthi171252_
              (let ((__tmp296757
                     (let ()
                       (declare (not safe))
                       (##fxarithmetic-shift _port171249_ '-8))))
                (declare (not safe))
                (##fxand __tmp296757 '255)))
             (_portlo171254_
              (let () (declare (not safe)) (##fxand _port171249_ '255)))
             (_userid171256_
              (if _userid171250_
                  (std/text/utf8#string->utf8__0 _userid171250_)
                  '#f))
             (_userlen171258_
              (if _userid171256_
                  (let ()
                    (declare (not safe))
                    (##u8vector-length _userid171256_))
                  '0))
             (_out171274_
              (if (string? _host171248_)
                  (let* ((_fqdn171260_
                          (std/text/utf8#string->utf8__0 _host171248_))
                         (_fqdnlen171262_
                          (let ()
                            (declare (not safe))
                            (##u8vector-length _fqdn171260_)))
                         (_len171264_
                          (let ()
                            (declare (not safe))
                            (##fx+ '8 _userlen171258_ '1 _fqdnlen171262_ '1)))
                         (_out171266_
                          (let ()
                            (declare (not safe))
                            (##make-u8vector _len171264_ '0))))
                    (let ()
                      (declare (not safe))
                      (##u8vector-set! _out171266_ '7 '1))
                    (let ((__tmp296758
                           (let ()
                             (declare (not safe))
                             (##fx+ _userlen171258_ '9))))
                      (declare (not safe))
                      (##subu8vector-move!
                       _fqdn171260_
                       '0
                       _fqdnlen171262_
                       _out171266_
                       __tmp296758)))
                  (if (and (let ()
                             (declare (not safe))
                             (##u8vector? _host171248_))
                           (let ((__tmp296759
                                  (let ()
                                    (declare (not safe))
                                    (##u8vector-length _host171248_))))
                             (declare (not safe))
                             (##fx= __tmp296759 '4)))
                      (let* ((_len171269_
                              (let ()
                                (declare (not safe))
                                (##fx+ _userlen171258_ '9)))
                             (_out171271_
                              (let ()
                                (declare (not safe))
                                (##make-u8vector _len171269_ '0))))
                        (let ()
                          (declare (not safe))
                          (##subu8vector-move!
                           _host171248_
                           '0
                           '4
                           _out171271_
                           '4)))
                      (error '"Unexpected host address" _host171248_)))))
        (let () (declare (not safe)) (##u8vector-set! _out171274_ '0 '4))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171274_ '1 _cmd171247_))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171274_ '2 _porthi171252_))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171274_ '3 _portlo171254_))
        (if _userid171256_
            (let ()
              (declare (not safe))
              (##subu8vector-move!
               _userid171256_
               '0
               _userlen171258_
               _out171274_
               '8))
            '#!void)
        (std/net/socks#send-msg _sock171246_ _out171274_))))
  (define std/net/socks#socks4-recv-reply
    (lambda (_sock171238_)
      (let ((_buf171240_
             (let () (declare (not safe)) (##make-u8vector '8 '0))))
        (std/net/socks#recv-msg _sock171238_ _buf171240_)
        (let ((_vn171242_
               (let () (declare (not safe)) (##u8vector-ref _buf171240_ '0))))
          (if (eq? _vn171242_ '0)
              '#!void
              (std/error#raise-io-error
               'socks4-recv-reply
               '"Unexpected SOCKS4 reply; version mismatch"
               _vn171242_)))
        (let ((_rep171244_
               (let () (declare (not safe)) (##u8vector-ref _buf171240_ '1))))
          (if (eq? _rep171244_ '90)
              '#!void
              (std/error#raise-io-error
               'socks4-recv-reply
               '"SOCKS4 request rejected"
               _rep171244_)))
        (cons (let () (declare (not safe)) (##subu8vector _buf171240_ '4 '8))
              (let ((__tmp296761
                     (let ((__tmp296762
                            (let ()
                              (declare (not safe))
                              (##u8vector-ref _buf171240_ '2))))
                       (declare (not safe))
                       (##fxarithmetic-shift __tmp296762 '8)))
                    (__tmp296760
                     (let ()
                       (declare (not safe))
                       (##u8vector-ref _buf171240_ '3))))
                (declare (not safe))
                (##fxior __tmp296761 __tmp296760))))))
  (define std/net/socks#send-msg
    (lambda (_sock171233_ _buf171234_)
      (let ((_wr171236_
             (gerbil/gambit/ports#write-u8vector__% _buf171234_ _sock171233_)))
        (if (eq? _wr171236_
                 (let () (declare (not safe)) (##u8vector-length _buf171234_)))
            '#!void
            (std/error#raise-io-error
             'socks-send-message
             '"Failed to send message; incomplete write"
             _sock171233_
             _wr171236_))
        (force-output _sock171233_))))
  (define std/net/socks#recv-msg
    (lambda (_sock171228_ _buf171229_)
      (let ((_rd171231_
             (gerbil/gambit/ports#read-u8vector__% _buf171229_ _sock171228_)))
        (if (eq? _rd171231_
                 (let () (declare (not safe)) (##u8vector-length _buf171229_)))
            '#!void
            (std/error#raise-io-error
             'socks-recv-message
             '"Failed to receive message; incomplete read"
             _sock171228_
             _rd171231_))))))
