(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/websocket#errorf
    (lambda (_fmt174927_ . _args174928_)
      (std/logger#log-message 'websocket '0 _fmt174927_ _args174928_)))
  (define std/net/websocket#warnf
    (lambda (_fmt174924_ . _args174925_)
      (std/logger#log-message 'websocket '1 _fmt174924_ _args174925_)))
  (define std/net/websocket#infof
    (lambda (_fmt174921_ . _args174922_)
      (std/logger#log-message 'websocket '2 _fmt174921_ _args174922_)))
  (define std/net/websocket#debugf
    (lambda (_fmt174918_ . _args174919_)
      (std/logger#log-message 'websocket '3 _fmt174918_ _args174919_)))
  (define std/net/websocket#verbosef
    (lambda (_fmt174913_ . _args174915_)
      (std/logger#log-message 'websocket '4 _fmt174913_ _args174915_)))
  (define std/net/websocket#wsmagic '"258EAFA5-E914-47DA-95CA-C5AB0DC85B11")
  (define std/net/websocket#open-websocket-client__%
    (lambda (_g297881_
             _redirect174821174827_
             _headers174822174829_
             _cookies174823174831_
             _params174824174833_
             _url174835_)
      (let* ((_redirect174837_
              (if (eq? _redirect174821174827_ absent-value)
                  '#t
                  _redirect174821174827_))
             (_headers174839_
              (if (eq? _headers174822174829_ absent-value)
                  '#f
                  _headers174822174829_))
             (_cookies174841_
              (if (eq? _cookies174823174831_ absent-value)
                  '#f
                  _cookies174823174831_))
             (_params174843_
              (if (eq? _params174824174833_ absent-value)
                  '#f
                  _params174824174833_))
             (_url174845_ (std/net/websocket#url->request-url _url174835_))
             (_nonce174847_ (std/crypto/etc#random-bytes '16))
             (_nonce64174849_
              (std/text/base64#u8vector->base64-string _nonce174847_))
             (_headers174854_
              (cons (cons '"Upgrade" '"websocket")
                    (cons (cons '"Connection" '"Upgrade")
                          (cons (cons '"Sec-WebSocket-Key" _nonce64174849_)
                                (cons (cons '"Sec-WebSocket-Version" '13)
                                      (let ((_$e174851_ _headers174839_))
                                        (if _$e174851_ _$e174851_ '())))))))
             (_req174856_
              (std/net/request#http-get__%
               '#f
               _redirect174837_
               _headers174854_
               _cookies174841_
               _params174843_
               absent-value
               absent-value
               _url174845_)))
        (with-exception-catcher
         (lambda (_g174858174860_)
           (if '#t
               (let ((_e174863_ _g174858174860_))
                 (std/net/request#request-close _req174856_)
                 (raise _e174863_))
               (raise _g174858174860_)))
         (lambda ()
           (let ((_status174866_
                  (##structure-ref
                   _req174856_
                   '4
                   std/net/request#request::t
                   '#f)))
             (if (let () (declare (not safe)) (##fx= _status174866_ '101))
                 '#!void
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Unexpected server response"
                  _url174845_
                  _status174866_)))
           (let* ((_rheaders174868_
                   (##structure-ref
                    _req174856_
                    '6
                    std/net/request#request::t
                    '#f))
                  (_Connection174870_ (assoc '"Connection" _rheaders174868_))
                  (_Upgrade174872_ (assoc '"Upgrade" _rheaders174868_))
                  (_Sec-WebSocket-Accept174874_
                   (assoc '"Sec-Websocket-Accept" _rheaders174868_))
                  (_Sec-WebSocket-Extensions174876_
                   (assoc '"Sec-Websocket-Extensions" _rheaders174868_))
                  (_Sec-WebSocket-Protocol174878_
                   (assoc '"Sec-Websocket-Protocol" _rheaders174868_)))
             (if (and _Connection174870_
                      (equal? (std/srfi/13#string-downcase__0
                               (cdr _Connection174870_))
                              '"upgrade"))
                 '#!void
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Bad server response; no connection upgrade"
                  _url174845_
                  _Connection174870_))
             (if (and _Upgrade174872_
                      (equal? (std/srfi/13#string-downcase__0
                               (cdr _Upgrade174872_))
                              '"websocket"))
                 '#!void
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Bad server response; no websocket upgrade"
                  _url174845_
                  _Upgrade174872_))
             (let* ((_accept64174881_
                     (if _Sec-WebSocket-Accept174874_
                         (cdr _Sec-WebSocket-Accept174874_)
                         '#f))
                    (_digest174883_
                     (let ((__obj297878
                            (make-object std/crypto/digest#digest::t '2)))
                       (std/crypto/digest#digest:::init!
                        __obj297878
                        std/crypto/digest#digest::sha1)
                       __obj297878))
                    (_g297882_
                     (std/crypto/digest#digest-update!__0
                      _digest174883_
                      (std/text/utf8#string->utf8__0 _nonce64174849_)))
                    (_g297883_
                     (std/crypto/digest#digest-update!__0
                      _digest174883_
                      (std/text/utf8#string->utf8__0
                       std/net/websocket#wsmagic)))
                    (_verify174887_
                     (std/crypto/digest#digest-final!__0 _digest174883_))
                    (_verify64174889_
                     (std/text/base64#u8vector->base64-string _verify174887_)))
               (if (equal? _accept64174881_ _verify64174889_)
                   '#!void
                   (std/error#raise-io-error
                    'open-websocket-client
                    '"Bad server response; nonce verification failure"
                    _url174845_
                    _nonce64174849_
                    _accept64174881_
                    _verify64174889_)))
             (if _Sec-WebSocket-Extensions174876_
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Bad server response; includes unsupported exensions"
                  _url174845_
                  _Sec-WebSocket-Extensions174876_)
                 '#!void)
             (if _Sec-WebSocket-Protocol174878_
                 (let* ((_proto174892_ (cdr _Sec-WebSocket-Protocol174878_))
                        (_uproto174894_
                         (assoc '"Sec-WebSocket-Protocol" _headers174854_))
                        (_uproto174896_
                         (string-split
                          (if _uproto174894_ (cdr _uproto174894_) '#f)
                          '#\,)))
                   (if (member _proto174892_ _uproto174896_)
                       '#!void
                       (std/error#raise-io-error
                        'open-websocket-client
                        '"Bad server response; unexpected protocol"
                        _url174845_
                        _Sec-WebSocket-Protocol174878_)))
                 '#!void))
           (std/net/websocket#make-websocket-client
            (##structure-ref
             _req174856_
             '1
             std/net/request#request::t
             '#f)))))))
  (define std/net/websocket#open-websocket-client__@
    (lambda (_keys174820174902_ . _args174904_)
      (apply std/net/websocket#open-websocket-client__%
             _keys174820174902_
             (table-ref _keys174820174902_ 'redirect: absent-value)
             (table-ref _keys174820174902_ 'headers: absent-value)
             (table-ref _keys174820174902_ 'cookies: absent-value)
             (table-ref _keys174820174902_ 'params: absent-value)
             _args174904_)))
  (define std/net/websocket#open-websocket-client
    (lambda _args174825174910_
      (apply keyword-dispatch
             '#(params:
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                redirect:
                headers:
                #f
                #f
                #f
                #f)
             std/net/websocket#open-websocket-client__@
             _args174825174910_)))
  (define std/net/websocket#url->request-url
    (lambda (_url174809_)
      (let ((_colon174811_ (std/srfi/13#string-index__0 _url174809_ '#\:)))
        (if _colon174811_
            (let* ((_scheme174814_ (substring _url174809_ '0 _colon174811_))
                   (_$e174816_ _scheme174814_))
              (if (equal? '"ws" _$e174816_)
                  (string-append
                   '"http"
                   (substring
                    _url174809_
                    _colon174811_
                    (string-length _url174809_)))
                  (if (equal? '"wss" _$e174816_)
                      (string-append
                       '"https"
                       (substring
                        _url174809_
                        _colon174811_
                        (string-length _url174809_)))
                      _url174809_)))
            _url174809_))))
  (define std/net/websocket#websocket::t
    (make-struct-type
     'std/net/websocket#websocket::t
     '#f
     '7
     'websocket
     '((final: . #t))
     ':init!
     '(port rd wr cs q mx cv)))
  (define std/net/websocket#websocket?
    (make-struct-predicate std/net/websocket#websocket::t))
  (define std/net/websocket#make-websocket
    (lambda _$args174806_
      (apply make-struct-instance
             std/net/websocket#websocket::t
             _$args174806_)))
  (define std/net/websocket#websocket-port
    (make-struct-field-accessor std/net/websocket#websocket::t '0))
  (define std/net/websocket#websocket-rd
    (make-struct-field-accessor std/net/websocket#websocket::t '1))
  (define std/net/websocket#websocket-wr
    (make-struct-field-accessor std/net/websocket#websocket::t '2))
  (define std/net/websocket#websocket-cs
    (make-struct-field-accessor std/net/websocket#websocket::t '3))
  (define std/net/websocket#websocket-q
    (make-struct-field-accessor std/net/websocket#websocket::t '4))
  (define std/net/websocket#websocket-mx
    (make-struct-field-accessor std/net/websocket#websocket::t '5))
  (define std/net/websocket#websocket-cv
    (make-struct-field-accessor std/net/websocket#websocket::t '6))
  (define std/net/websocket#websocket-port-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '0))
  (define std/net/websocket#websocket-rd-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '1))
  (define std/net/websocket#websocket-wr-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '2))
  (define std/net/websocket#websocket-cs-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '3))
  (define std/net/websocket#websocket-q-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '4))
  (define std/net/websocket#websocket-mx-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '5))
  (define std/net/websocket#websocket-cv-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '6))
  (define std/net/websocket#websocket:::init!
    (lambda (_self174803_ _port174804_)
      (if (let ((__tmp297884
                 (let () (declare (not safe)) (##vector-length _self174803_))))
            (declare (not safe))
            (##fx< '7 __tmp297884))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self174803_ '1 _port174804_))
            (let () (declare (not safe)) (##vector-set! _self174803_ '2 '#f))
            (let () (declare (not safe)) (##vector-set! _self174803_ '3 '#f))
            (let () (declare (not safe)) (##vector-set! _self174803_ '4 '#f))
            (let ((__tmp297885
                   (let ((__obj297879
                          (make-object std/misc/queue#queue::t '3)))
                     (std/misc/queue#queue:::init! __obj297879)
                     __obj297879)))
              (declare (not safe))
              (##vector-set! _self174803_ '5 __tmp297885))
            (let ((__tmp297886 (make-mutex)))
              (declare (not safe))
              (##vector-set! _self174803_ '6 __tmp297886))
            (let ((__tmp297887 (make-condition-variable)))
              (declare (not safe))
              (##vector-set! _self174803_ '7 __tmp297887)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self174803_))))
  (bind-method!
   std/net/websocket#websocket::t
   ':init!
   std/net/websocket#websocket:::init!
   '#f)
  (define std/net/websocket#make-websocket-client
    (lambda (_port174671_)
      (std/logger#start-logger!__0)
      (let* ((_ws174673_
              (let ((__obj297880
                     (make-object std/net/websocket#websocket::t '7)))
                (std/net/websocket#websocket:::init! __obj297880 _port174671_)
                __obj297880))
             (_reader174675_
              (gerbil/gambit/threads#spawn/name
               'websocket-reader
               std/net/websocket#websocket-reader
               _ws174673_))
             (_writer174677_
              (gerbil/gambit/threads#spawn/name
               'websocket-writer
               std/net/websocket#websocket-writer
               _ws174673_)))
        (##direct-structure-set!
         _ws174673_
         _reader174675_
         '2
         std/net/websocket#websocket::t
         '#f)
        (##direct-structure-set!
         _ws174673_
         _writer174677_
         '3
         std/net/websocket#websocket::t
         '#f)
        _ws174673_)))
  (define std/net/websocket#websocket-send
    (lambda (_ws174659_ _bytes174660_ _type174661_)
      (if (not (u8vector? _bytes174660_))
          (error '"Bad argument; expected u8vector" _bytes174660_)
          (if (not (or (eq? _type174661_ 'binary) (eq? _type174661_ 'text)))
              (error '"Bad argument; expected 'binary or 'text" _type174661_)
              (let ((_$e174666_
                     (##direct-structure-ref
                      _ws174659_
                      '4
                      std/net/websocket#websocket::t
                      '#f)))
                (if _$e174666_
                    ((lambda (_how174669_)
                       (std/error#raise-io-error
                        'websocket-send
                        '"Websocket has been closed"
                        _ws174659_
                        _how174669_))
                     _$e174666_)
                    (thread-send
                     (##direct-structure-ref
                      _ws174659_
                      '3
                      std/net/websocket#websocket::t
                      '#f)
                     (cons _type174661_ _bytes174660_))))))))
  (define std/net/websocket#websocket-write
    (lambda (_ws174656_ _obj174657_)
      (if (string? _obj174657_)
          (std/net/websocket#websocket-send
           _ws174656_
           (std/text/utf8#string->utf8__0 _obj174657_)
           'text)
          (if (u8vector? _obj174657_)
              (std/net/websocket#websocket-send _ws174656_ _obj174657_ 'binary)
              (error '"Bad argument; expected bytes or string" _obj174657_)))))
  (define std/net/websocket#websocket-recv__%
    (lambda (_ws174544_ _timeo174545_ _raise?174546_)
      (let* ((_timeo174548_ (std/misc/timeout#make-timeout__0 _timeo174545_))
             (_ws174549174561_ _ws174544_)
             (_E174551174565_
              (lambda () (error '"No clause matching" _ws174549174561_)))
             (_K174552174608_
              (lambda (_cv174568_ _mx174569_ _q174570_)
                (let _lp174572_ ()
                  (mutex-lock! _mx174569_)
                  (if (not (std/misc/queue#queue-empty? _q174570_))
                      (let* ((_g174574174581_
                              (std/misc/queue#dequeue!__0 _q174570_))
                             (_E174576174585_
                              (lambda ()
                                (error '"No clause matching" _g174574174581_)))
                             (_K174577174591_
                              (lambda (_data174588_ _type174589_)
                                (mutex-unlock! _mx174569_)
                                (values _data174588_ _type174589_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _g174574174581_))
                            (let ((_hd174578174594_
                                   (let ()
                                     (declare (not safe))
                                     (##car _g174574174581_)))
                                  (_tl174579174596_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _g174574174581_))))
                              (let* ((_type174599_ _hd174578174594_)
                                     (_data174601_ _tl174579174596_))
                                (_K174577174591_ _data174601_ _type174599_)))
                            (_E174576174585_)))
                      (let ((_$e174603_
                             (##direct-structure-ref
                              _ws174544_
                              '4
                              std/net/websocket#websocket::t
                              '#f)))
                        (if _$e174603_
                            ((lambda (_how174606_)
                               (mutex-unlock! _mx174569_)
                               (if _raise?174546_
                                   (std/error#raise-io-error
                                    'websocket-recv
                                    '"Websocket has been closed"
                                    _ws174544_
                                    _how174606_)
                                   '#!eof))
                             _$e174603_)
                            (if (mutex-unlock!
                                 _mx174569_
                                 _cv174568_
                                 _timeo174548_)
                                (_lp174572_)
                                (if _raise?174546_
                                    (std/error#raise-timeout
                                     'websocket-recv
                                     '"timeout"
                                     _ws174544_)
                                    '#f)))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ws174549174561_
               'std/net/websocket#websocket::t))
            (let* ((_e174553174611_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174549174561_ '1)))
                   (_e174554174614_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174549174561_ '2)))
                   (_e174555174617_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174549174561_ '3)))
                   (_e174556174620_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174549174561_ '4)))
                   (_e174557174623_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174549174561_ '5)))
                   (_q174626_ _e174557174623_)
                   (_e174558174628_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174549174561_ '6)))
                   (_mx174631_ _e174558174628_)
                   (_e174559174633_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174549174561_ '7)))
                   (_cv174636_ _e174559174633_))
              (_K174552174608_ _cv174636_ _mx174631_ _q174626_))
            (_E174551174565_)))))
  (define std/net/websocket#websocket-recv__0
    (lambda (_ws174641_)
      (let* ((_timeo174643_ '#f) (_raise?174645_ '#t))
        (std/net/websocket#websocket-recv__%
         _ws174641_
         _timeo174643_
         _raise?174645_))))
  (define std/net/websocket#websocket-recv__1
    (lambda (_ws174647_ _timeo174648_)
      (let ((_raise?174650_ '#t))
        (std/net/websocket#websocket-recv__%
         _ws174647_
         _timeo174648_
         _raise?174650_))))
  (define std/net/websocket#websocket-recv
    (lambda _g297889_
      (let ((_g297888_ (let () (declare (not safe)) (##length _g297889_))))
        (cond ((let () (declare (not safe)) (##fx= _g297888_ 1))
               (apply std/net/websocket#websocket-recv__0 _g297889_))
              ((let () (declare (not safe)) (##fx= _g297888_ 2))
               (apply std/net/websocket#websocket-recv__1 _g297889_))
              ((let () (declare (not safe)) (##fx= _g297888_ 3))
               (apply std/net/websocket#websocket-recv__% _g297889_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/websocket#websocket-recv
                _g297889_))))))
  (define std/net/websocket#websocket-read__%
    (lambda (_ws174461_ _timeo174462_ _raise?174463_)
      (let* ((_g174464174477_
              (std/net/websocket#websocket-recv__%
               _ws174461_
               _timeo174462_
               _raise?174463_))
             (_E174468174481_
              (lambda () (error '"No clause matching" _g174464174477_))))
        (let ((_K174473174514_ (lambda (_data174512_) _data174512_))
              (_K174470174498_
               (lambda (_data174496_)
                 (std/text/utf8#utf8->string__0 _data174496_)))
              (_K174469174487_ (lambda (_r174485_) _r174485_)))
          (if (let ((__tmp297890
                     (if (let ()
                           (declare (not safe))
                           (##values? _g174464174477_))
                         (let ()
                           (declare (not safe))
                           (##vector-length _g174464174477_))
                         '1)))
                (declare (not safe))
                (##fx= __tmp297890 '2))
              (let* ((_e174474174517_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g174464174477_ '0)))
                     (_e174475174522_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g174464174477_ '1))))
                (if (let ()
                      (declare (not safe))
                      (##eq? _e174475174522_ 'binary))
                    (let ((_data174520_ _e174474174517_))
                      (_K174473174514_ _data174520_))
                    (if (let ()
                          (declare (not safe))
                          (##eq? _e174475174522_ 'text))
                        (let ((_data174504_ _e174474174517_))
                          (std/text/utf8#utf8->string__0 _data174504_))
                        (let ((_r174490_ _g174464174477_))
                          (_K174469174487_ _r174490_)))))
              (let ((_r174490_ _g174464174477_))
                (_K174469174487_ _r174490_)))))))
  (define std/net/websocket#websocket-read__0
    (lambda (_ws174528_)
      (let* ((_timeo174530_ '#f) (_raise?174532_ '#f))
        (std/net/websocket#websocket-read__%
         _ws174528_
         _timeo174530_
         _raise?174532_))))
  (define std/net/websocket#websocket-read__1
    (lambda (_ws174534_ _timeo174535_)
      (let ((_raise?174537_ '#f))
        (std/net/websocket#websocket-read__%
         _ws174534_
         _timeo174535_
         _raise?174537_))))
  (define std/net/websocket#websocket-read
    (lambda _g297892_
      (let ((_g297891_ (let () (declare (not safe)) (##length _g297892_))))
        (cond ((let () (declare (not safe)) (##fx= _g297891_ 1))
               (apply std/net/websocket#websocket-read__0 _g297892_))
              ((let () (declare (not safe)) (##fx= _g297891_ 2))
               (apply std/net/websocket#websocket-read__1 _g297892_))
              ((let () (declare (not safe)) (##fx= _g297891_ 3))
               (apply std/net/websocket#websocket-read__% _g297892_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/websocket#websocket-read
                _g297892_))))))
  (define std/net/websocket#websocket-close__%__%
    (lambda (__174357174360_ _hard?174355174362_ _ws174364_ _how174365_)
      (let* ((_hard?174367_
              (if (eq? _hard?174355174362_ absent-value)
                  '#f
                  _hard?174355174362_))
             (_ws174368174380_ _ws174364_)
             (_E174370174384_
              (lambda () (error '"No clause matching" _ws174368174380_)))
             (_K174371174396_
              (lambda (_cv174387_
                       _mx174388_
                       _q174389_
                       _cs174390_
                       _writer174391_
                       _port174392_)
                (if _hard?174367_ (close-port _port174392_) '#!void)
                (if _cs174390_
                    '#!void
                    (begin
                      (mutex-lock! _mx174388_)
                      (if (##direct-structure-ref
                           _ws174364_
                           '4
                           std/net/websocket#websocket::t
                           '#f)
                          (mutex-unlock! _mx174388_)
                          (let ((_how174394_
                                 (if _hard?174367_ 'abort _how174365_)))
                            (##direct-structure-set!
                             _ws174364_
                             _how174394_
                             '4
                             std/net/websocket#websocket::t
                             '#f)
                            (thread-send
                             _writer174391_
                             (cons 'close _how174394_))
                            (condition-variable-broadcast! _cv174387_)
                            (mutex-unlock! _mx174388_))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ws174368174380_
               'std/net/websocket#websocket::t))
            (let* ((_e174372174399_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174368174380_ '1)))
                   (_port174402_ _e174372174399_)
                   (_e174373174404_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174368174380_ '2)))
                   (_e174374174407_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174368174380_ '3)))
                   (_writer174410_ _e174374174407_)
                   (_e174375174412_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174368174380_ '4)))
                   (_cs174415_ _e174375174412_)
                   (_e174376174417_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174368174380_ '5)))
                   (_q174420_ _e174376174417_)
                   (_e174377174422_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174368174380_ '6)))
                   (_mx174425_ _e174377174422_)
                   (_e174378174427_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174368174380_ '7)))
                   (_cv174430_ _e174378174427_))
              (_K174371174396_
               _cv174430_
               _mx174425_
               _q174420_
               _cs174415_
               _writer174410_
               _port174402_))
            (_E174370174384_)))))
  (define std/net/websocket#websocket-close__%__0
    (lambda (__174357174435_ _hard?174355174436_ _ws174437_)
      (let ((_how174439_ '1000))
        (std/net/websocket#websocket-close__%__%
         __174357174435_
         _hard?174355174436_
         _ws174437_
         _how174439_))))
  (define std/net/websocket#websocket-close__%
    (lambda _g297894_
      (let ((_g297893_ (let () (declare (not safe)) (##length _g297894_))))
        (cond ((let () (declare (not safe)) (##fx= _g297893_ 3))
               (apply std/net/websocket#websocket-close__%__0 _g297894_))
              ((let () (declare (not safe)) (##fx= _g297893_ 4))
               (apply std/net/websocket#websocket-close__%__% _g297894_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/websocket#websocket-close__%
                _g297894_))))))
  (define std/net/websocket#websocket-close__@
    (lambda (_keys174354174449_ . _args174451_)
      (apply std/net/websocket#websocket-close__%
             _keys174354174449_
             (table-ref _keys174354174449_ 'hard: absent-value)
             _args174451_)))
  (define std/net/websocket#websocket-close
    (lambda _args174356174457_
      (apply keyword-dispatch
             '#(hard:)
             std/net/websocket#websocket-close__@
             _args174356174457_)))
  (define std/net/websocket#max-frame-size (expt '2 '20))
  (define std/net/websocket#max-message-size (expt '2 '20))
  (define std/net/websocket#set-websocket-max-frame-size!
    (lambda (_sz174351_) (set! std/net/websocket#max-frame-size _sz174351_)))
  (define std/net/websocket#set-websocket-max-message-size!
    (lambda (_sz174349_) (set! std/net/websocket#max-message-size _sz174349_)))
  (define std/net/websocket#websocket-reader
    (lambda (_ws174152_)
      (letrec* ((_buf174154_ (make-u8vector '1024))
                (_skip-to-eof174155_
                 (lambda (_port174340_)
                   (let ((_len174342_ (u8vector-length _buf174154_)))
                     (let _lp174344_ ()
                       (let ((_rd174347_
                              (read-subu8vector
                               _buf174154_
                               '0
                               _len174342_
                               _port174340_)))
                         (if (let ()
                               (declare (not safe))
                               (##fx= _len174342_ _rd174347_))
                             (_lp174344_)
                             '#!void))))))
                (_skip-payload174156_
                 (lambda (_port174324_ _plen174325_)
                   (let ((_len174327_ (u8vector-length _buf174154_)))
                     (let _lp174329_ ((_need174331_ _plen174325_))
                       (let ((_$e174333_
                              (let ()
                                (declare (not safe))
                                (##fxzero? _need174331_))))
                         (if _$e174333_
                             _$e174333_
                             (if (let ()
                                   (declare (not safe))
                                   (##fx<= _need174331_ _len174327_))
                                 (let ((_rd174336_
                                        (read-subu8vector
                                         _buf174154_
                                         '0
                                         _need174331_
                                         _port174324_)))
                                   (if (let ()
                                         (declare (not safe))
                                         (##fx< _rd174336_ _need174331_))
                                       (_read-eof174161_)
                                       '#!void))
                                 (let ((_rd174338_
                                        (read-subu8vector
                                         _buf174154_
                                         '0
                                         _len174327_
                                         _port174324_)))
                                   (if (let ()
                                         (declare (not safe))
                                         (##fx< _rd174338_ _len174327_))
                                       (_read-eof174161_)
                                       (_lp174329_
                                        (let ()
                                          (declare (not safe))
                                          (##fx- _need174331_
                                                 _len174327_))))))))))))
                (_read-header174157_
                 (lambda (_port174315_)
                   (let* ((_b0174317_ (read-u8 _port174315_))
                          (_g297895_
                           (if (eof-object? _b0174317_)
                               (_read-eof174161_)
                               '#!void))
                          (_b1174320_ (read-u8 _port174315_))
                          (_g297896_
                           (if (eof-object? _b1174320_)
                               (_read-eof174161_)
                               '#!void)))
                     (values (let ()
                               (declare (not safe))
                               (##fxand _b0174317_ '128))
                             (let ()
                               (declare (not safe))
                               (##fxand _b0174317_ '15))
                             (let ()
                               (declare (not safe))
                               (##fxand _b1174320_ '128))
                             (let ()
                               (declare (not safe))
                               (##fxand _b1174320_ '127))))))
                (_read-payload174158_
                 (lambda (_port174307_ _plen174308_)
                   (if (let () (declare (not safe)) (##fxzero? _plen174308_))
                       '#u8()
                       (let* ((_data174310_ (make-u8vector _plen174308_))
                              (_rd174312_
                               (read-subu8vector
                                _data174310_
                                '0
                                _plen174308_
                                _port174307_)))
                         (if (let ()
                               (declare (not safe))
                               (##fx< _rd174312_ _plen174308_))
                             (_read-eof174161_)
                             _data174310_)))))
                (_read-u16174159_
                 (lambda (_port174298_)
                   (let* ((_b0174300_ (read-u8 _port174298_))
                          (_g297897_
                           (if (eof-object? _b0174300_)
                               (_read-eof174161_)
                               '#!void))
                          (_b1174303_ (read-u8 _port174298_))
                          (_g297898_
                           (if (eof-object? _b1174303_)
                               (_read-eof174161_)
                               '#!void)))
                     (let ((__tmp297899
                            (let ()
                              (declare (not safe))
                              (##fxarithmetic-shift _b0174300_ '8))))
                       (declare (not safe))
                       (##fxior __tmp297899 _b1174303_)))))
                (_read-u64174160_
                 (lambda (_port174289_)
                   (let ((_rd174291_
                          (read-subu8vector _buf174154_ '0 '8 _port174289_)))
                     (if (let () (declare (not safe)) (##fx= _rd174291_ '8))
                         (let _lp174293_ ((_k174295_ '0) (_r174296_ '0))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _k174295_ '8))
                               (_lp174293_
                                (let ()
                                  (declare (not safe))
                                  (##fx+ _k174295_ '1))
                                (bitwise-ior
                                 (arithmetic-shift _r174296_ '8)
                                 (let ()
                                   (declare (not safe))
                                   (##u8vector-ref _buf174154_ _k174295_))))
                               _r174296_))
                         (_read-eof174161_)))))
                (_read-eof174161_ (lambda () (raise 'eof))))
        (let* ((_ws174162174174_ _ws174152_)
               (_E174164174178_
                (lambda () (error '"No clause matching" _ws174162174174_)))
               (_K174165174254_
                (lambda (_cv174181_
                         _mx174182_
                         _q174183_
                         _writer174184_
                         _port174185_)
                  (letrec ((_receive174187_
                            (lambda (_type174251_ _data174252_)
                              (mutex-lock! _mx174182_)
                              (if (##direct-structure-ref
                                   _ws174152_
                                   '4
                                   std/net/websocket#websocket::t
                                   '#f)
                                  (begin
                                    (mutex-unlock! _mx174182_)
                                    (raise 'abort))
                                  (begin
                                    (std/misc/queue#enqueue!
                                     _q174183_
                                     (cons _type174251_ _data174252_))
                                    (condition-variable-broadcast! _cv174181_)
                                    (mutex-unlock! _mx174182_))))))
                    (with-unwind-protect
                     (lambda ()
                       (with-exception-catcher
                        (lambda (_g174188174191_)
                          (if '#t
                              (let ((_e174194_ _g174188174191_))
                                (let ((_$e174196_ _e174194_))
                                  (if (eq? 'eof _$e174196_)
                                      (std/net/websocket#websocket-close__%__%
                                       '#f
                                       absent-value
                                       _ws174152_
                                       'eof)
                                      (if (eq? 'abort _$e174196_)
                                          '#!void
                                          (begin
                                            (std/net/websocket#errorf
                                             '"unhandled exception: ~a"
                                             _e174194_)
                                            (std/net/websocket#websocket-close__%__%
                                             '#f
                                             absent-value
                                             _ws174152_
                                             'abort)
                                            (raise _e174194_)))))
                                _e174194_)
                              (raise _g174188174191_)))
                        (lambda ()
                          (let _lp174200_ ((_type174202_ '#f)
                                           (_frags174203_ '()))
                            (let ((_g297900_
                                   (_read-header174157_ _port174185_)))
                              (begin
                                (let ((_g297901_
                                       (let ()
                                         (declare (not safe))
                                         (if (##values? _g297900_)
                                             (##vector-length _g297900_)
                                             1))))
                                  (if (not (let ()
                                             (declare (not safe))
                                             (##fx= _g297901_ 4)))
                                      (error "Context expects 4 values"
                                             _g297901_)))
                                (let ((_fin174205_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g297900_ 0)))
                                      (_opcode174206_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g297900_ 1)))
                                      (_mask174207_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g297900_ 2)))
                                      (_plen174208_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g297900_ 3))))
                                  (let ((_plen174213_
                                         (let ((_$e174210_ _plen174208_))
                                           (if (eq? '126 _$e174210_)
                                               (_read-u16174159_ _port174185_)
                                               (if (eq? '127 _$e174210_)
                                                   (_read-u64174160_
                                                    _port174185_)
                                                   _plen174208_)))))
                                    (if (not (let ()
                                               (declare (not safe))
                                               (##fxzero? _mask174207_)))
                                        (begin
                                          (std/net/websocket#warnf
                                           '"server sent masked frame; closing websocket connection")
                                          (std/net/websocket#websocket-close__%__%
                                           '#f
                                           absent-value
                                           _ws174152_
                                           '1002)
                                          (_skip-to-eof174155_ _port174185_))
                                        (if (> _plen174213_
                                               std/net/websocket#max-frame-size)
                                            (begin
                                              (std/net/websocket#warnf
                                               '"frame size ~a exceeds max frame size; closing websocket connection"
                                               _plen174213_)
                                              (std/net/websocket#websocket-close__%__%
                                               '#f
                                               absent-value
                                               _ws174152_
                                               '1009)
                                              (_skip-to-eof174155_
                                               _port174185_))
                                            (let ((_$e174216_ _opcode174206_))
                                              (let ((_default174218174222_
                                                     (lambda ()
                                                       (std/net/websocket#warnf
                                                        '"unexpected frame ~x from server; closing websocket connection"
                                                        _opcode174206_)
                                                       (std/net/websocket#websocket-close__%__%
                                                        '#f
                                                        absent-value
                                                        _ws174152_
                                                        '1002)
                                                       (_skip-to-eof174155_
                                                        _port174185_)))
                                                    (_table174219174224_
                                                     '#(0
                                                        1
                                                        1
                                                        #f
                                                        #f
                                                        #f
                                                        #f
                                                        #f
                                                        2
                                                        3
                                                        4)))
                                                (if (fixnum? _$e174216_)
                                                    (if (and (let ()
                                                               (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (not safe))
                       (##fx>= _$e174216_ '0))
                     (let () (declare (not safe)) (##fx< _$e174216_ '11)))
                (let ((_x174227_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _table174219174224_ _$e174216_))))
                  (if _x174227_
                      (if (let () (declare (not safe)) (##fx< _x174227_ '2))
                          (if (let ()
                                (declare (not safe))
                                (##fx= _x174227_ '0))
                              (let ((_dlen174230_
                                     (foldl1 ##fx+
                                             _plen174213_
                                             (map u8vector-length
                                                  _frags174203_))))
                                (if (not _type174202_)
                                    (begin
                                      (std/net/websocket#warnf
                                       '"unexpected continuation frame from server; closing websocket connection")
                                      (std/net/websocket#websocket-close__%__%
                                       '#f
                                       absent-value
                                       _ws174152_
                                       '1002)
                                      (_skip-to-eof174155_ _port174185_))
                                    (if (let ()
                                          (declare (not safe))
                                          (##fx> _dlen174230_
                                                 std/net/websocket#max-message-size))
                                        (begin
                                          (std/net/websocket#warnf
                                           '"message length ~a exceeds max message size; closing websocket connection"
                                           _dlen174230_)
                                          (std/net/websocket#websocket-close__%__%
                                           '#f
                                           absent-value
                                           _ws174152_
                                           '1009)
                                          (_skip-to-eof174155_ _port174185_))
                                        (if (let ()
                                              (declare (not safe))
                                              (##fxzero? _fin174205_))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##fxzero? _plen174213_))
                                                (_lp174200_
                                                 _type174202_
                                                 _frags174203_)
                                                (let ((_data174232_
                                                       (_read-payload174158_
                                                        _port174185_
                                                        _plen174213_)))
                                                  (_lp174200_
                                                   _type174202_
                                                   (cons _data174232_
                                                         _frags174203_))))
                                            (let* ((_data174234_
                                                    (_read-payload174158_
                                                     _port174185_
                                                     _plen174213_))
                                                   (_message174236_
                                                    (u8vector-concatenate
                                                     (reverse (cons _data174234_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _frags174203_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (_receive174187_
                                               _type174202_
                                               _message174236_)
                                              (_lp174200_ '#f '()))))))
                              (let ((_xtype174239_
                                     (if (let ()
                                           (declare (not safe))
                                           (##fx= _opcode174206_ '1))
                                         'text
                                         'binary)))
                                (if _type174202_
                                    (begin
                                      (std/net/websocket#warnf
                                       '"unexpected frame ~x from server; closing websocket connection"
                                       _opcode174206_)
                                      (std/net/websocket#websocket-close__%__%
                                       '#f
                                       absent-value
                                       _ws174152_
                                       '1002)
                                      (_skip-to-eof174155_ _port174185_))
                                    (if (let ()
                                          (declare (not safe))
                                          (##fxzero? _fin174205_))
                                        (let ((_data174241_
                                               (_read-payload174158_
                                                _port174185_
                                                _plen174213_)))
                                          (_lp174200_
                                           _xtype174239_
                                           (cons _data174241_ '())))
                                        (let ((_data174243_
                                               (_read-payload174158_
                                                _port174185_
                                                _plen174213_)))
                                          (_receive174187_
                                           _xtype174239_
                                           _data174243_)
                                          (_lp174200_ '#f '()))))))
                          (if (let ()
                                (declare (not safe))
                                (##fx= _x174227_ '2))
                              (let ((_how174245_
                                     (_read-u16174159_ _port174185_)))
                                (std/net/websocket#websocket-close__%__%
                                 '#f
                                 absent-value
                                 _ws174152_
                                 _how174245_)
                                (_skip-to-eof174155_ _port174185_))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx= _x174227_ '3))
                                  (let ((_data174247_
                                         (_read-payload174158_
                                          _port174185_
                                          _plen174213_)))
                                    (thread-send
                                     _writer174184_
                                     (cons 'pong _data174247_))
                                    (_lp174200_ _type174202_ _frags174203_))
                                  (begin
                                    (_skip-payload174156_
                                     _port174185_
                                     _plen174213_)
                                    (_lp174200_ _type174202_ _frags174203_)))))
                      (_default174218174222_)))
                (_default174218174222_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (_default174218174222_))))))))))))))
                     (lambda ()
                       (with-exception-catcher
                        void
                        (lambda () (close-input-port _port174185_)))))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _ws174162174174_
                 'std/net/websocket#websocket::t))
              (let* ((_e174166174257_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174162174174_ '1)))
                     (_port174260_ _e174166174257_)
                     (_e174167174262_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174162174174_ '2)))
                     (_e174168174265_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174162174174_ '3)))
                     (_writer174268_ _e174168174265_)
                     (_e174169174270_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174162174174_ '4)))
                     (_e174170174273_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174162174174_ '5)))
                     (_q174276_ _e174170174273_)
                     (_e174171174278_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174162174174_ '6)))
                     (_mx174281_ _e174171174278_)
                     (_e174172174283_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174162174174_ '7)))
                     (_cv174286_ _e174172174283_))
                (_K174165174254_
                 _cv174286_
                 _mx174281_
                 _q174276_
                 _writer174268_
                 _port174260_))
              (_E174164174178_))))))
  (define std/net/websocket#websocket-writer
    (lambda (_ws173960_)
      (letrec* ((_buf173962_ (make-u8vector '65535))
                (_mask-bytes173963_ (make-u8vector '4))
                (_write-u16173964_
                 (lambda (_plen174149_ _port174150_)
                   (write-u8
                    (let ((__tmp297902
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift _plen174149_ '-8))))
                      (declare (not safe))
                      (##fxand __tmp297902 '255))
                    _port174150_)
                   (write-u8
                    (let () (declare (not safe)) (##fxand _plen174149_ '255))
                    _port174150_)))
                (_write-payload173965_
                 (lambda (_mask174138_
                          _data174139_
                          _start174140_
                          _end174141_
                          _port174142_)
                   (let _lp174144_ ((_k174146_ _start174140_) (_x174147_ '0))
                     (if (let ()
                           (declare (not safe))
                           (##fx< _k174146_ _end174141_))
                         (begin
                           (let ((__tmp297903
                                  (let ((__tmp297906
                                         (let ()
                                           (declare (not safe))
                                           (##u8vector-ref
                                            _data174139_
                                            _k174146_)))
                                        (__tmp297904
                                         (let ((__tmp297905
                                                (let ()
                                                  (declare (not safe))
                                                  (##fxmodulo _x174147_ '4))))
                                           (declare (not safe))
                                           (##u8vector-ref
                                            _mask174138_
                                            __tmp297905))))
                                    (declare (not safe))
                                    (##fxxor __tmp297906 __tmp297904))))
                             (declare (not safe))
                             (##u8vector-set!
                              _buf173962_
                              _x174147_
                              __tmp297903))
                           (_lp174144_
                            (let () (declare (not safe)) (##fx+ _k174146_ '1))
                            (let ()
                              (declare (not safe))
                              (##fx+ _x174147_ '1))))
                         (write-subu8vector
                          _buf173962_
                          '0
                          _x174147_
                          _port174142_)))))
                (_send-frame173966_
                 (lambda (_port174120_
                          _fin174121_
                          _opcode174122_
                          _data174123_
                          _start174124_
                          _end174125_)
                   (let* ((_plen174127_
                           (let ()
                             (declare (not safe))
                             (##fx- _end174125_ _start174124_)))
                          (_fin174129_
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift _fin174121_ '7)))
                          (_b0174131_
                           (let ()
                             (declare (not safe))
                             (##fxior _fin174129_ _opcode174122_)))
                          (_mask174133_
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift '1 '7)))
                          (_b1174135_
                           (let ((__tmp297907
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _plen174127_ '126))
                                      _plen174127_
                                      '126)))
                             (declare (not safe))
                             (##fxior _mask174133_ __tmp297907))))
                     (std/crypto/etc#random-bytes!__0 _mask-bytes173963_)
                     (write-u8 _b0174131_ _port174120_)
                     (write-u8 _b1174135_ _port174120_)
                     (if (let ()
                           (declare (not safe))
                           (##fx< _plen174127_ '126))
                         '#!void
                         (_write-u16173964_ _plen174127_ _port174120_))
                     (write-subu8vector _mask-bytes173963_ '0 '4 _port174120_)
                     (_write-payload173965_
                      _mask-bytes173963_
                      _data174123_
                      _start174124_
                      _end174125_
                      _port174120_)
                     (force-output _port174120_))))
                (_send173967_
                 (lambda (_port174105_ _opcode174106_ _data174107_)
                   (let ((_end174109_ (u8vector-length _data174107_)))
                     (let _lp174111_ ((_start174113_ '0)
                                      (_opcode174114_ _opcode174106_))
                       (let ((_have174116_
                              (let ()
                                (declare (not safe))
                                (##fx- _end174109_ _start174113_))))
                         (if (let ()
                               (declare (not safe))
                               (##fx< _have174116_ '65536))
                             (_send-frame173966_
                              _port174105_
                              '1
                              _opcode174114_
                              _data174107_
                              _start174113_
                              _end174109_)
                             (let ((_xend174118_
                                    (let ()
                                      (declare (not safe))
                                      (##fx+ _start174113_ '65535))))
                               (_send-frame173966_
                                _port174105_
                                '0
                                _opcode174114_
                                _data174107_
                                _start174113_
                                _xend174118_)
                               (_lp174111_ _xend174118_ '0)))))))))
        (let* ((_ws173968173974_ _ws173960_)
               (_E173970173978_
                (lambda () (error '"No clause matching" _ws173968173974_)))
               (_K173971174097_
                (lambda (_port173981_)
                  (with-unwind-protect
                   (lambda ()
                     (with-exception-catcher
                      (lambda (_g173982173985_)
                        (if '#t
                            (let ((_e173988_ _g173982173985_))
                              (std/net/websocket#errorf
                               '"unhandled exception: ~a"
                               _e173988_)
                              (std/net/websocket#websocket-close__%__%
                               '#f
                               absent-value
                               _ws173960_
                               'abort)
                              (with-exception-catcher
                               void
                               (lambda () (close-port _port173981_))))
                            (raise _g173982173985_)))
                      (lambda ()
                        (let _lp173992_ ()
                          (let* ((_g173994174015_ (thread-receive))
                                 (_E174000174019_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _g173994174015_))))
                            (let ((_K174011174085_
                                   (lambda (_data174083_)
                                     (_send173967_
                                      _port173981_
                                      '1
                                      _data174083_)
                                     (_lp173992_)))
                                  (_K174008174070_
                                   (lambda (_data174068_)
                                     (_send173967_
                                      _port173981_
                                      '2
                                      _data174068_)
                                     (_lp173992_)))
                                  (_K174005174054_
                                   (lambda (_data174052_)
                                     (_send173967_
                                      _port173981_
                                      '10
                                      _data174052_)
                                     (_lp173992_)))
                                  (_K174002174038_
                                   (lambda (_how174034_)
                                     (if (fixnum? _how174034_)
                                         (let ((_bytes174036_
                                                (make-u8vector '2)))
                                           (let ((__tmp297908
                                                  (let ((__tmp297909
                                                         (let ()
                                                           (declare (not safe))
                                                           (##fxarithmetic-shift
                                                            _how174034_
                                                            '-8))))
                                                    (declare (not safe))
                                                    (##fxand __tmp297909
                                                             '255))))
                                             (declare (not safe))
                                             (##u8vector-set!
                                              _bytes174036_
                                              '0
                                              __tmp297908))
                                           (let ((__tmp297910
                                                  (let ()
                                                    (declare (not safe))
                                                    (##fxand _how174034_
                                                             '255))))
                                             (declare (not safe))
                                             (##u8vector-set!
                                              _bytes174036_
                                              '1
                                              __tmp297910))
                                           (_send173967_
                                            _port173981_
                                            '8
                                            _bytes174036_))
                                         '#!void)))
                                  (_K174001174025_
                                   (lambda (_bogus174023_)
                                     (std/net/websocket#warnf
                                      '"unexpected message ~a"
                                      _bogus174023_)
                                     (_lp173992_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _g173994174015_))
                                  (let ((_tl174013174090_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _g173994174015_)))
                                        (_hd174012174088_
                                         (let ()
                                           (declare (not safe))
                                           (##car _g173994174015_))))
                                    (if (let ()
                                          (declare (not safe))
                                          (##eq? _hd174012174088_ 'text))
                                        (let ((_data174093_ _tl174013174090_))
                                          (_K174011174085_ _data174093_))
                                        (if (let ()
                                              (declare (not safe))
                                              (##eq? _hd174012174088_ 'binary))
                                            (let ((_data174078_
                                                   _tl174013174090_))
                                              (_K174008174070_ _data174078_))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##eq? _hd174012174088_
                                                         'pong))
                                                (let ((_data174062_
                                                       _tl174013174090_))
                                                  (_K174005174054_
                                                   _data174062_))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##eq? _hd174012174088_
                                                             'close))
                                                    (let ((_how174046_
                                                           _tl174013174090_))
                                                      (_K174002174038_
                                                       _how174046_))
                                                    (let ((_bogus174028_
                                                           _g173994174015_))
                                                      (_K174001174025_
                                                       _bogus174028_)))))))
                                  (let ((_bogus174028_ _g173994174015_))
                                    (_K174001174025_ _bogus174028_)))))))))
                   (lambda ()
                     (with-exception-catcher
                      void
                      (lambda () (close-output-port _port173981_))))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _ws173968173974_
                 'std/net/websocket#websocket::t))
              (let* ((_e173972174100_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws173968173974_ '1)))
                     (_port174103_ _e173972174100_))
                (_K173971174097_ _port174103_))
              (_E173970173978_)))))))
