(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/epoll#epoll-create
    (lambda ()
      (let* ((_fd198837_
              (let ((_r198834_ (std/os/epoll#_epoll_create '1024)))
                (if (not (let ()
                           (declare (not safe))
                           (##fxnegative? _r198834_)))
                    _r198834_
                    (std/os/error#raise-os-error
                     (let () (declare (not safe)) (##fx- _r198834_))
                     std/os/epoll#epoll-create))))
             (_raw198839_ (std/os/fd#fdopen _fd198837_ 'in 'epoll)))
        (std/os/fcntl#fd-set-closeonexec _raw198839_)
        _raw198839_)))
  (define std/os/epoll#epoll-ctl-add
    (lambda (_epoll198829_ _dev198830_ _events198831_)
      (std/os/epoll#epoll-ctl
       _epoll198829_
       std/os/epoll#EPOLL_CTL_ADD
       _dev198830_
       _events198831_)))
  (define std/os/epoll#epoll-ctl-mod
    (lambda (_epoll198825_ _dev198826_ _events198827_)
      (std/os/epoll#epoll-ctl
       _epoll198825_
       std/os/epoll#EPOLL_CTL_MOD
       _dev198826_
       _events198827_)))
  (define std/os/epoll#epoll-ctl-del
    (lambda (_epoll198822_ _dev198823_)
      (std/os/epoll#epoll-ctl
       _epoll198822_
       std/os/epoll#EPOLL_CTL_DEL
       _dev198823_
       '0)))
  (define std/os/epoll#epoll-ctl
    (lambda (_epoll198812_ _op198813_ _dev198814_ _events198815_)
      (let ((_evt198817_ (std/os/epoll#get-evtptr)))
        (std/os/epoll#epoll_evt_fd_set
         _evt198817_
         '0
         (std/os/fd#fd-e _dev198814_))
        (std/os/epoll#epoll_evt_events_set _evt198817_ '0 _events198815_)
        (let ((_r198819_
               (std/os/epoll#_epoll_ctl
                (std/os/fd#fd-e _epoll198812_)
                _op198813_
                (std/os/fd#fd-e _dev198814_)
                _evt198817_)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198819_)))
              _r198819_
              (std/os/error#raise-os-error
               (let () (declare (not safe)) (##fx- _r198819_))
               std/os/epoll#epoll-ctl
               _epoll198812_
               _op198813_
               _dev198814_
               _events198815_))))))
  (define std/os/epoll#epoll-wait
    (lambda (_epoll198798_ _evts198799_ _maxevts198800_)
      (let _lp198802_ ()
        (let ((_r198806_
               (std/os/epoll#_epoll_wait
                (std/os/fd#fd-e _epoll198798_)
                _evts198799_
                _maxevts198800_
                '0)))
          (if (not (let () (declare (not safe)) (##fxnegative? _r198806_)))
              _r198806_
              (let ((_errno198809_
                     (let () (declare (not safe)) (##fx- _r198806_))))
                (if '#f
                    '#f
                    (if (eq? _errno198809_ std/os/error#EINTR)
                        (_lp198802_)
                        (std/os/error#raise-os-error
                         _errno198809_
                         std/os/epoll#epoll-wait
                         _epoll198798_
                         _evts198799_
                         _maxevts198800_)))))))))
  (define std/os/epoll#epoll-close
    (lambda (_epoll198796_) (close-port _epoll198796_)))
  (define std/os/epoll#make-epoll-events
    (lambda (_size198791_)
      (let ((_r198793_ (std/os/epoll#make_epoll_evt _size198791_)))
        (if _r198793_
            _r198793_
            (error '"Error allocating memory" 'make_epoll_evt)))))
  (define std/os/epoll#epoll-event-fd
    (lambda (_evts198788_ _k198789_)
      (std/os/epoll#epoll_evt_fd _evts198788_ _k198789_)))
  (define std/os/epoll#epoll-event-events
    (lambda (_evts198785_ _k198786_)
      (std/os/epoll#epoll_evt_events _evts198785_ _k198786_)))
  (define std/os/epoll#evtptr-key 'std/os/epoll#evtptr)
  (define std/os/epoll#get-evtptr
    (lambda ()
      (let ((_$e198777_
             (gerbil/gambit/threads#thread-local-get std/os/epoll#evtptr-key)))
        (if _$e198777_
            (values _$e198777_)
            (let ((_evtptr198783_
                   (let ((_r198780_ (std/os/epoll#make_epoll_evt '1)))
                     (if _r198780_
                         _r198780_
                         (error '"Error allocating memory" 'make_epoll_evt)))))
              (gerbil/gambit/threads#thread-local-set!
               std/os/epoll#evtptr-key
               _evtptr198783_)
              _evtptr198783_)))))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace
   ("std/os/epoll#"
    epoll_evt_events_set
    epoll_evt_events
    epoll_evt_fd_set
    epoll_evt_fd
    make_epoll_evt
    _epoll_wait
    _epoll_ctl
    _epoll_create
    EPOLL_CTL_DEL
    EPOLL_CTL_MOD
    EPOLL_CTL_ADD
    EPOLLONESHOT
    EPOLLET
    EPOLLHUP
    EPOLLERR
    EPOLLOUT
    EPOLLIN))
  (c-declare "#include <sys/epoll.h>")
  (namespace
   ("std/os/epoll#"
    epoll_event
    epoll_event*
    __epoll_create
    __epoll_ctl
    __epoll_wait
    _epoll_create
    _epoll_ctl
    _epoll_wait))
  (define-const EPOLL_CTL_ADD)
  (define-const EPOLL_CTL_MOD)
  (define-const EPOLL_CTL_DEL)
  (define-const EPOLLIN)
  (define-const EPOLLOUT)
  (define-const EPOLLERR)
  (define-const EPOLLHUP)
  (define-const EPOLLET)
  (define-const EPOLLONESHOT)
  (c-define-type epoll_event (struct "epoll_event"))
  (c-define-type epoll_event* (pointer epoll_event (epoll_event*) "ffi_free"))
  (define-c-lambda __epoll_create (int) int "epoll_create")
  (define-c-lambda __epoll_ctl (int int int epoll_event*) int "epoll_ctl")
  (define-c-lambda __epoll_wait (int epoll_event* int int) int "epoll_wait")
  (define-with-errno _epoll_create __epoll_create (size))
  (define-with-errno _epoll_ctl __epoll_ctl (epfd op fd evt))
  (define-with-errno _epoll_wait __epoll_wait (epfd evts maxevts timeo))
  (define-c-lambda
   make_epoll_evt
   (int)
   epoll_event*
   "___return ((struct epoll_event*)malloc (___arg1 * sizeof (struct epoll_event)));")
  (define-c-lambda
   epoll_evt_fd
   (epoll_event* int)
   int
   "___return (___arg1[___arg2].data.fd);")
  (define-c-lambda
   epoll_evt_fd_set
   (epoll_event* int int)
   void
   "___arg1[___arg2].data.fd = ___arg3; ___return;")
  (define-c-lambda
   epoll_evt_events
   (epoll_event* int)
   int
   "___return (___arg1[___arg2].events);")
  (define-c-lambda
   epoll_evt_events_set
   (epoll_event* int int)
   void
   "___arg1[___arg2].events = ___arg3; ___return;")
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif"))
