(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/flock#flock
    (lambda (_raw197459_ _op197460_)
      (let ((_fd197462_
             (if (std/os/fd#fd? _raw197459_)
                 (std/os/fd#fd-e _raw197459_)
                 _raw197459_))
            (_op197463_ (fxior _op197460_ std/os/flock#LOCK_NB)))
        (let _lp197465_ ()
          (let ((_r197469_ (std/os/flock#_flock _fd197462_ _op197463_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r197469_)))
                _r197469_
                (let ((_errno197472_
                       (let () (declare (not safe)) (##fx- _r197469_))))
                  (if (or (eq? _errno197472_ std/os/error#EAGAIN)
                          (eq? _errno197472_ std/os/error#EWOULDBLOCK))
                      '#f
                      (if (eq? _errno197472_ std/os/error#EINTR)
                          (_lp197465_)
                          (std/os/error#raise-os-error
                           _errno197472_
                           std/os/flock#flock
                           _raw197459_
                           _op197463_))))))))))
  (define std/os/flock#flock/block__%
    (lambda (_raw-or-fd197438_ _op197439_ _timeout197440_)
      (letrec* ((_deadline197442_
                 (if (not _timeout197440_)
                     '#f
                     (if (time? _timeout197440_)
                         (time->seconds _timeout197440_)
                         (if (real? _timeout197440_)
                             (+ (let ()
                                  (declare (not safe))
                                  (##current-time-point))
                                _timeout197440_)
                             (error '"Bad argument; expected real, time or #f"
                                    _timeout197440_))))))
        (let _lp197444_ ()
          (if (std/os/flock#flock _raw-or-fd197438_ _op197439_)
              '#!void
              (begin
                (if _deadline197442_
                    (if (< _deadline197442_
                           (let ()
                             (declare (not safe))
                             (##current-time-point)))
                        '#!void
                        (std/error#raise-timeout
                         'flock
                         '"Deadline for flock operation exceeded"
                         _raw-or-fd197438_
                         _op197439_))
                    '#!void)
                (thread-sleep! (random-real))
                (_lp197444_)))))))
  (define std/os/flock#flock/block__0
    (lambda (_raw-or-fd197450_ _op197451_)
      (let ((_timeout197453_ '#f))
        (std/os/flock#flock/block__%
         _raw-or-fd197450_
         _op197451_
         _timeout197453_))))
  (define std/os/flock#flock/block
    (lambda _g296831_
      (let ((_g296830_ (let () (declare (not safe)) (##length _g296831_))))
        (cond ((let () (declare (not safe)) (##fx= _g296830_ 2))
               (apply std/os/flock#flock/block__0 _g296831_))
              ((let () (declare (not safe)) (##fx= _g296830_ 3))
               (apply std/os/flock#flock/block__% _g296831_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#flock/block
                _g296831_))))))
  (define std/os/flock#open-input-file/lock__%__%
    (lambda (__197391197394_
             _op197388197396_
             _flags197389197398_
             _path197400_
             _timeout197401_)
      (let* ((_op197403_
              (if (eq? _op197388197396_ absent-value)
                  std/os/flock#LOCK_SH
                  _op197388197396_))
             (_flags197405_
              (if (eq? _flags197389197398_ absent-value)
                  std/os/fcntl#O_RDONLY
                  _flags197389197398_)))
        (std/os/flock#open-file/lock__%__%
         '#f
         'in
         _flags197405_
         '0
         _path197400_
         _op197403_
         _timeout197401_))))
  (define std/os/flock#open-input-file/lock__%__0
    (lambda (__197391197410_ _op197388197411_ _flags197389197412_ _path197413_)
      (let ((_timeout197415_ '#f))
        (std/os/flock#open-input-file/lock__%__%
         __197391197410_
         _op197388197411_
         _flags197389197412_
         _path197413_
         _timeout197415_))))
  (define std/os/flock#open-input-file/lock__%
    (lambda _g296833_
      (let ((_g296832_ (let () (declare (not safe)) (##length _g296833_))))
        (cond ((let () (declare (not safe)) (##fx= _g296832_ 4))
               (apply std/os/flock#open-input-file/lock__%__0 _g296833_))
              ((let () (declare (not safe)) (##fx= _g296832_ 5))
               (apply std/os/flock#open-input-file/lock__%__% _g296833_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open-input-file/lock__%
                _g296833_))))))
  (define std/os/flock#open-input-file/lock__@
    (lambda (_keys197387197426_ . _args197428_)
      (apply std/os/flock#open-input-file/lock__%
             _keys197387197426_
             (table-ref _keys197387197426_ 'op: absent-value)
             (table-ref _keys197387197426_ 'flags: absent-value)
             _args197428_)))
  (define std/os/flock#open-input-file/lock
    (lambda _args197390197434_
      (apply keyword-dispatch
             '#(flags: #f op: #f)
             std/os/flock#open-input-file/lock__@
             _args197390197434_)))
  (define std/os/flock#open-output-file/lock__%__%
    (lambda (__197334197337_
             _op197330197339_
             _flags197331197341_
             _mode197332197343_
             _path197345_
             _timeout197346_)
      (let* ((_op197348_
              (if (eq? _op197330197339_ absent-value)
                  std/os/flock#LOCK_EX
                  _op197330197339_))
             (_flags197350_
              (if (eq? _flags197331197341_ absent-value)
                  (fxior std/os/fcntl#O_WRONLY std/os/fcntl#O_CREAT)
                  _flags197331197341_))
             (_mode197352_
              (if (eq? _mode197332197343_ absent-value)
                  std/os/fdio#S_IRWXU
                  _mode197332197343_)))
        (std/os/flock#open-file/lock__%__%
         '#f
         'out
         _flags197350_
         _mode197352_
         _path197345_
         _op197348_
         _timeout197346_))))
  (define std/os/flock#open-output-file/lock__%__0
    (lambda (__197334197357_
             _op197330197358_
             _flags197331197359_
             _mode197332197360_
             _path197361_)
      (let ((_timeout197363_ '#f))
        (std/os/flock#open-output-file/lock__%__%
         __197334197357_
         _op197330197358_
         _flags197331197359_
         _mode197332197360_
         _path197361_
         _timeout197363_))))
  (define std/os/flock#open-output-file/lock__%
    (lambda _g296835_
      (let ((_g296834_ (let () (declare (not safe)) (##length _g296835_))))
        (cond ((let () (declare (not safe)) (##fx= _g296834_ 5))
               (apply std/os/flock#open-output-file/lock__%__0 _g296835_))
              ((let () (declare (not safe)) (##fx= _g296834_ 6))
               (apply std/os/flock#open-output-file/lock__%__% _g296835_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open-output-file/lock__%
                _g296835_))))))
  (define std/os/flock#open-output-file/lock__@
    (lambda (_keys197329197375_ . _args197377_)
      (apply std/os/flock#open-output-file/lock__%
             _keys197329197375_
             (table-ref _keys197329197375_ 'op: absent-value)
             (table-ref _keys197329197375_ 'flags: absent-value)
             (table-ref _keys197329197375_ 'mode: absent-value)
             _args197377_)))
  (define std/os/flock#open-output-file/lock
    (lambda _args197333197383_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                mode:
                #f
                flags:
                #f
                #f
                #f
                #f
                #f
                #f
                op:
                #f)
             std/os/flock#open-output-file/lock__@
             _args197333197383_)))
  (define std/os/flock#open-file/lock__%__%
    (lambda (__197259197262_
             _dir197255197264_
             _flags197256197266_
             _mode197257197268_
             _path197270_
             _op197271_
             _timeout197272_)
      (let* ((_dir197274_
              (if (eq? _dir197255197264_ absent-value)
                  (error '"Missing required keyword argument" 'direction:)
                  _dir197255197264_))
             (_flags197276_
              (if (eq? _flags197256197266_ absent-value)
                  (error '"Missing required keyword argument" 'flags:)
                  _flags197256197266_))
             (_mode197278_
              (if (eq? _mode197257197268_ absent-value)
                  (error '"Missing required keyword argument" 'mode:)
                  _mode197257197268_))
             (_fd197280_
              (std/os/flock#open/lock__%__%
               '#f
               _flags197276_
               _mode197278_
               _path197270_
               _op197271_
               _timeout197272_))
             (_port197282_
              (std/os/fd#fdopen-port _fd197280_ _dir197274_ _path197270_))
             (_close-it197284_ (macro-port-close _port197282_))
             (_unlocked?197286_ '#f))
        (letrec ((_close197289_
                  (lambda (_port197291_ . _args197292_)
                    (if _unlocked?197286_
                        '#!void
                        (begin
                          (std/os/flock#flock _fd197280_ std/os/flock#LOCK_UN)
                          (set! _unlocked?197286_ '#t)))
                    (apply _close-it197284_ _port197291_ _args197292_))))
          (macro-port-close-set! _port197282_ _close197289_)
          _port197282_))))
  (define std/os/flock#open-file/lock__%__0
    (lambda (__197259197297_
             _dir197255197298_
             _flags197256197299_
             _mode197257197300_
             _path197301_
             _op197302_)
      (let ((_timeout197304_ '#f))
        (std/os/flock#open-file/lock__%__%
         __197259197297_
         _dir197255197298_
         _flags197256197299_
         _mode197257197300_
         _path197301_
         _op197302_
         _timeout197304_))))
  (define std/os/flock#open-file/lock__%
    (lambda _g296837_
      (let ((_g296836_ (let () (declare (not safe)) (##length _g296837_))))
        (cond ((let () (declare (not safe)) (##fx= _g296836_ 6))
               (apply std/os/flock#open-file/lock__%__0 _g296837_))
              ((let () (declare (not safe)) (##fx= _g296836_ 7))
               (apply std/os/flock#open-file/lock__%__% _g296837_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open-file/lock__%
                _g296837_))))))
  (define std/os/flock#open-file/lock__@
    (lambda (_keys197254197317_ . _args197319_)
      (apply std/os/flock#open-file/lock__%
             _keys197254197317_
             (table-ref _keys197254197317_ 'direction: absent-value)
             (table-ref _keys197254197317_ 'flags: absent-value)
             (table-ref _keys197254197317_ 'mode: absent-value)
             _args197319_)))
  (define std/os/flock#open-file/lock
    (lambda _args197258197325_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                mode:
                #f
                flags:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                direction:)
             std/os/flock#open-file/lock__@
             _args197258197325_)))
  (define std/os/flock#open/lock__%__%
    (lambda (__197189197192_
             _flags197186197194_
             _mode197187197196_
             _path197198_
             _op197199_
             _timeout197200_)
      (let* ((_flags197202_
              (if (eq? _flags197186197194_ absent-value)
                  (error '"Missing required keyword argument" 'flags:)
                  _flags197186197194_))
             (_mode197204_
              (if (eq? _mode197187197196_ absent-value)
                  (error '"Missing required keyword argument" 'mode:)
                  _mode197187197196_))
             (_flags197206_
              (fxior _flags197202_
                     std/os/fcntl#O_NONBLOCK
                     std/os/fcntl#O_CLOEXEC))
             (_fd197211_
              (let ((_r197208_
                     (std/os/fdio#_open
                      _path197198_
                      _flags197206_
                      _mode197204_)))
                (if (not (let ()
                           (declare (not safe))
                           (##fxnegative? _r197208_)))
                    _r197208_
                    (std/os/error#raise-os-error
                     (let () (declare (not safe)) (##fx- _r197208_))
                     std/os/fdio#open
                     _path197198_
                     _flags197206_
                     _mode197204_)))))
        (with-exception-catcher
         (lambda (_g197213197215_)
           (if '#t
               (let ((_e197218_ _g197213197215_))
                 (std/os/fdio#_close _fd197211_)
                 (raise _e197218_))
               (raise _g197213197215_)))
         (lambda ()
           (std/os/flock#flock/block__%
            _fd197211_
            _op197199_
            _timeout197200_)))
        _fd197211_)))
  (define std/os/flock#open/lock__%__0
    (lambda (__197189197224_
             _flags197186197225_
             _mode197187197226_
             _path197227_
             _op197228_)
      (let ((_timeout197230_ '#f))
        (std/os/flock#open/lock__%__%
         __197189197224_
         _flags197186197225_
         _mode197187197226_
         _path197227_
         _op197228_
         _timeout197230_))))
  (define std/os/flock#open/lock__%
    (lambda _g296839_
      (let ((_g296838_ (let () (declare (not safe)) (##length _g296839_))))
        (cond ((let () (declare (not safe)) (##fx= _g296838_ 5))
               (apply std/os/flock#open/lock__%__0 _g296839_))
              ((let () (declare (not safe)) (##fx= _g296838_ 6))
               (apply std/os/flock#open/lock__%__% _g296839_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open/lock__%
                _g296839_))))))
  (define std/os/flock#open/lock__@
    (lambda (_keys197185197242_ . _args197244_)
      (apply std/os/flock#open/lock__%
             _keys197185197242_
             (table-ref _keys197185197242_ 'flags: absent-value)
             (table-ref _keys197185197242_ 'mode: absent-value)
             _args197244_)))
  (define std/os/flock#open/lock
    (lambda _args197188197250_
      (apply keyword-dispatch
             '#(flags: mode: #f)
             std/os/flock#open/lock__@
             _args197188197250_)))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace ("std/os/flock#" LOCK_NB LOCK_UN LOCK_EX LOCK_SH _flock))
  (c-declare "#include <sys/file.h>")
  (define-const LOCK_SH)
  (define-const LOCK_EX)
  (define-const LOCK_UN)
  (define-const LOCK_NB)
  (namespace ("std/os/flock#" __flock))
  (define-c-lambda __flock (int int) int "flock")
  (define-with-errno _flock __flock (fd op))
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif"))
