(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (fixnum) (not safe))
  (define std/sort#sort
    (lambda (_seq7646_ _elt<7648_)
      (if (procedure? _elt<7648_)
          '#!void
          (error '"Expected procedure" _elt<7648_))
      (if (null? _seq7646_)
          _seq7646_
          (if (pair? _seq7646_)
              (std/sort#list-merge-sort _seq7646_ _elt<7648_)
              (if (vector? _seq7646_)
                  (std/sort#heap-sort _seq7646_ _elt<7648_)
                  (error '"Expected list or vector" _seq7646_))))))
  (define std/sort#sort!
    (lambda (_seq7641_ _elt<7643_)
      (if (procedure? _elt<7643_)
          '#!void
          (error '"Expected procedure" _elt<7643_))
      (if (null? _seq7641_)
          _seq7641_
          (if (pair? _seq7641_)
              (std/sort#list-merge-sort! _seq7641_ _elt<7643_)
              (if (vector? _seq7641_)
                  (std/sort#vector-heap-sort! _seq7641_ _elt<7643_)
                  (error '"Expected list or vector" _seq7641_))))))
  (define std/sort#stable-sort
    (lambda (_seq7636_ _elt<7638_)
      (if (procedure? _elt<7638_)
          '#!void
          (error '"Expected procedure" _elt<7638_))
      (if (null? _seq7636_)
          _seq7636_
          (if (pair? _seq7636_)
              (std/sort#list-merge-sort _seq7636_ _elt<7638_)
              (if (vector? _seq7636_)
                  (std/sort#vector-merge-sort _seq7636_ _elt<7638_)
                  (error '"Expected list or vector" _seq7636_))))))
  (define std/sort#stable-sort!
    (lambda (_seq7631_ _elt<7633_)
      (if (procedure? _elt<7633_)
          '#!void
          (error '"Expected procedure" _elt<7633_))
      (if (null? _seq7631_)
          _seq7631_
          (if (pair? _seq7631_)
              (std/sort#list-merge-sort! _seq7631_ _elt<7633_)
              (if (vector? _seq7631_)
                  (std/sort#vector-merge-sort! _seq7631_ _elt<7633_)
                  (error '"Expected list or vector" _seq7631_))))))
  (define std/sort#vector-copy!
    (lambda (_target7626_ _src7627_ _start7628_ _end7629_)
      (subvector-move! _src7627_ _start7628_ _end7629_ _target7626_ '0)))
  (define std/sort#vector-merge-sort!
    (lambda (_v7623_ _elt<7624_)
      (std/sort#%vector-merge-sort!
       _v7623_
       _elt<7624_
       '0
       (vector-length _v7623_)
       (vector-copy _v7623_))
      _v7623_))
  (define std/sort#vector-merge-sort
    (lambda (_v7620_ _elt<7621_)
      (std/sort#vector-merge-sort! (vector-copy _v7620_) _elt<7621_)))
  (define std/sort#vector-heap-sort!
    (lambda (_v7617_ _elt<7618_)
      (std/sort#heap-sort! _v7617_ _elt<7618_)
      _v7617_))
  (define std/sort#parse-vector-start+end
    (lambda (_proc7596_ _v7597_ _args7598_)
      (let ((_vlen7600_ (vector-length _v7597_)))
        (if (pair? _args7598_)
            (let ((_start7602_ (car _args7598_)) (_args7603_ (cdr _args7598_)))
              (if (or (not (integer? _start7602_)) (< _start7602_ '0))
                  (error '"Illegal subvector START spec"
                         _proc7596_
                         _start7602_
                         _v7597_)
                  (let ((_g277319_
                         (if (pair? _args7603_)
                             (let ((_end7608_ (car _args7603_))
                                   (_args7609_ (cdr _args7603_)))
                               (if (or (not (integer? _end7608_))
                                       (< _vlen7600_ _end7608_))
                                   (error '"Illegal subvector END spec"
                                          _proc7596_
                                          _end7608_
                                          _v7597_)
                                   (values _end7608_ _args7609_)))
                             (values _vlen7600_ _args7603_))))
                    (begin
                      (let ((_g277320_
                             (if (##values? _g277319_)
                                 (##vector-length _g277319_)
                                 1)))
                        (if (not (##fx= _g277320_ 2))
                            (error "Context expects 2 values" _g277320_)))
                      (let ((_end7614_ (##vector-ref _g277319_ 0))
                            (_args7615_ (##vector-ref _g277319_ 1)))
                        (if (<= _start7602_ _end7614_)
                            (values _start7602_ _end7614_ _args7615_)
                            (error '"Illegal subvector START/END spec"
                                   _proc7596_
                                   _start7602_
                                   _end7614_
                                   _v7597_)))))))
            (values '0 (vector-length _v7597_) '())))))
  (define std/sort#parse-vector-final-start+end
    (lambda (_proc7588_ _v7589_ _args7590_)
      (let ((_g277321_
             (std/sort#parse-vector-start+end _proc7588_ _v7589_ _args7590_)))
        (begin
          (let ((_g277322_
                 (if (##values? _g277321_) (##vector-length _g277321_) 1)))
            (if (not (##fx= _g277322_ 3))
                (error "Context expects 3 values" _g277322_)))
          (let ((_start7592_ (##vector-ref _g277321_ 0))
                (_end7593_ (##vector-ref _g277321_ 1))
                (_rest7594_ (##vector-ref _g277321_ 2)))
            (if (pair? _rest7594_)
                (error '"Extra arguments to procedure" _proc7588_ _rest7594_)
                (values _start7592_ _end7593_)))))))
  (define std/sort#list-merge-sort
    (lambda (_lis7512_ _elt<7513_)
      (letrec ((_getrun7515_
                (lambda (_lis7578_)
                  (let _lp7580_ ((_xs7582_ (cdr _lis7578_))
                                 (_prev7583_ (car _lis7578_))
                                 (_i7584_ '1))
                    (if (pair? _xs7582_)
                        (let ((_x7586_ (car _xs7582_)))
                          (if (_elt<7513_ _x7586_ _prev7583_)
                              (values _i7584_ _xs7582_)
                              (_lp7580_
                               (cdr _xs7582_)
                               _x7586_
                               (+ _i7584_ '1))))
                        (values _i7584_ _xs7582_)))))
               (_cmerge7516_
                (lambda (_a7556_ _la7557_ _b7558_ _lb7559_)
                  (let _recur7561_ ((_x7563_ (car _a7556_))
                                    (_a7564_ _a7556_)
                                    (_la7565_ _la7557_)
                                    (_y7566_ (car _b7558_))
                                    (_b7567_ _b7558_)
                                    (_lb7568_ _lb7559_))
                    (if (_elt<7513_ _y7566_ _x7563_)
                        (cons _y7566_
                              (let ((_lb7570_ (- _lb7568_ '1)))
                                (if (= _lb7570_ '0)
                                    _a7564_
                                    (let ((_b7572_ (cdr _b7567_)))
                                      (_recur7561_
                                       _x7563_
                                       _a7564_
                                       _la7565_
                                       (car _b7572_)
                                       _b7572_
                                       _lb7570_)))))
                        (cons _x7563_
                              (let ((_la7574_ (- _la7565_ '1)))
                                (if (= _la7574_ '0)
                                    _b7567_
                                    (let ((_a7576_ (cdr _a7564_)))
                                      (_recur7561_
                                       (car _a7576_)
                                       _a7576_
                                       _la7574_
                                       _y7566_
                                       _b7567_
                                       _lb7568_)))))))))
               (_grow7517_
                (lambda (_s7532_ _ls7533_ _ls27534_ _u7535_ _lw7536_)
                  (if (or (<= _lw7536_ _ls7533_) (not (pair? _u7535_)))
                      (values _s7532_ _ls7533_ _u7535_)
                      (let* ((_ls27547_
                              (let _lp7541_ ((_ls27543_ _ls27534_))
                                (let ((_ls2*27545_ (+ _ls27543_ _ls27543_)))
                                  (if (<= _ls2*27545_ _ls7533_)
                                      (_lp7541_ _ls2*27545_)
                                      _ls27543_))))
                             (_g277323_ (_getrun7515_ _u7535_)))
                        (begin
                          (let ((_g277324_
                                 (if (##values? _g277323_)
                                     (##vector-length _g277323_)
                                     1)))
                            (if (not (##fx= _g277324_ 2))
                                (error "Context expects 2 values" _g277324_)))
                          (let ((_lr7549_ (##vector-ref _g277323_ 0))
                                (_u27550_ (##vector-ref _g277323_ 1)))
                            (let ((_g277325_
                                   (_grow7517_
                                    _u7535_
                                    _lr7549_
                                    '1
                                    _u27550_
                                    _ls27547_)))
                              (begin
                                (let ((_g277326_
                                       (if (##values? _g277325_)
                                           (##vector-length _g277325_)
                                           1)))
                                  (if (not (##fx= _g277326_ 3))
                                      (error "Context expects 3 values"
                                             _g277326_)))
                                (let ((_t7552_ (##vector-ref _g277325_ 0))
                                      (_lt7553_ (##vector-ref _g277325_ 1))
                                      (_u37554_ (##vector-ref _g277325_ 2)))
                                  (_grow7517_
                                   (_cmerge7516_
                                    _s7532_
                                    _ls7533_
                                    _t7552_
                                    _lt7553_)
                                   (+ _ls7533_ _lt7553_)
                                   (+ _ls27547_ _ls27547_)
                                   _u37554_
                                   _lw7536_))))))))))
               (_first7518_
                (lambda (_lis7529_ _i7530_)
                  (if (= '0 _i7530_)
                      '()
                      (cons (car _lis7529_)
                            (_first7518_ (cdr _lis7529_) (- _i7530_ '1)))))))
        (if (not (pair? _lis7512_))
            '()
            (let ((_g277327_ (_getrun7515_ _lis7512_)))
              (begin
                (let ((_g277328_
                       (if (##values? _g277327_)
                           (##vector-length _g277327_)
                           1)))
                  (if (not (##fx= _g277328_ 2))
                      (error "Context expects 2 values" _g277328_)))
                (let ((_lr7520_ (##vector-ref _g277327_ 0))
                      (_tail7521_ (##vector-ref _g277327_ 1)))
                  (let* ((_infinity7523_ '16777216)
                         (_g277329_
                          (_grow7517_
                           _lis7512_
                           _lr7520_
                           '1
                           _tail7521_
                           _infinity7523_)))
                    (begin
                      (let ((_g277330_
                             (if (##values? _g277329_)
                                 (##vector-length _g277329_)
                                 1)))
                        (if (not (##fx= _g277330_ 3))
                            (error "Context expects 3 values" _g277330_)))
                      (let ((_a7525_ (##vector-ref _g277329_ 0))
                            (_la7526_ (##vector-ref _g277329_ 1))
                            (_v7527_ (##vector-ref _g277329_ 2)))
                        (_first7518_ _a7525_ _la7526_)))))))))))
  (define std/sort#list-merge-sort!
    (lambda (_lis7417_ _elt<7418_)
      (letrec ((_getrun7420_
                (lambda (_lis7501_)
                  (let _lp7503_ ((_lis7505_ _lis7501_)
                                 (_x7506_ (car _lis7501_))
                                 (_i7507_ '1)
                                 (_next7508_ (cdr _lis7501_)))
                    (if (pair? _next7508_)
                        (let ((_y7510_ (car _next7508_)))
                          (if (_elt<7418_ _y7510_ _x7506_)
                              (values _i7507_ _lis7505_ _next7508_)
                              (_lp7503_
                               _next7508_
                               _y7510_
                               (+ _i7507_ '1)
                               (cdr _next7508_))))
                        (values _i7507_ _lis7505_ _next7508_)))))
               (_merge!7421_
                (lambda (_a7462_ _enda7463_ _b7464_ _endb7465_)
                  (letrec ((_scan-a7467_
                            (lambda (_prev7471_
                                     _x7472_
                                     _a7473_
                                     _y7474_
                                     _b7475_)
                              (if (_elt<7418_ _y7474_ _x7472_)
                                  (begin
                                    (set-cdr! _prev7471_ _b7475_)
                                    (let ((_next-b7477_ (cdr _b7475_)))
                                      (if (eq? _b7475_ _endb7465_)
                                          (begin
                                            (set-cdr! _b7475_ _a7473_)
                                            _enda7463_)
                                          (_scan-b7468_
                                           _b7475_
                                           _x7472_
                                           _a7473_
                                           (car _next-b7477_)
                                           _next-b7477_))))
                                  (if (eq? _a7473_ _enda7463_)
                                      (begin
                                        (_maybe-set-cdr!7469_ _a7473_ _b7475_)
                                        _endb7465_)
                                      (let ((_next-a7479_ (cdr _a7473_)))
                                        (_scan-a7467_
                                         _a7473_
                                         (car _next-a7479_)
                                         _next-a7479_
                                         _y7474_
                                         _b7475_))))))
                           (_scan-b7468_
                            (lambda (_prev7481_
                                     _x7482_
                                     _a7483_
                                     _y7484_
                                     _b7485_)
                              (if (_elt<7418_ _y7484_ _x7482_)
                                  (if (eq? _b7485_ _endb7465_)
                                      (begin
                                        (set-cdr! _b7485_ _a7483_)
                                        _enda7463_)
                                      (let ((_next-b7487_ (cdr _b7485_)))
                                        (_scan-b7468_
                                         _b7485_
                                         _x7482_
                                         _a7483_
                                         (car _next-b7487_)
                                         _next-b7487_)))
                                  (begin
                                    (set-cdr! _prev7481_ _a7483_)
                                    (if (eq? _a7483_ _enda7463_)
                                        (begin
                                          (_maybe-set-cdr!7469_
                                           _a7483_
                                           _b7485_)
                                          _endb7465_)
                                        (let ((_next-a7489_ (cdr _a7483_)))
                                          (_scan-a7467_
                                           _a7483_
                                           (car _next-a7489_)
                                           _next-a7489_
                                           _y7484_
                                           _b7485_)))))))
                           (_maybe-set-cdr!7469_
                            (lambda (_pair7491_ _val7492_)
                              (if (not (eq? (cdr _pair7491_) _val7492_))
                                  (set-cdr! _pair7491_ _val7492_)
                                  '#!void))))
                    (let ((_x7494_ (car _a7462_)) (_y7495_ (car _b7464_)))
                      (if (_elt<7418_ _y7495_ _x7494_)
                          (values _b7464_
                                  (if (eq? _b7464_ _endb7465_)
                                      (begin
                                        (set-cdr! _b7464_ _a7462_)
                                        _enda7463_)
                                      (let ((_next-b7497_ (cdr _b7464_)))
                                        (_scan-b7468_
                                         _b7464_
                                         _x7494_
                                         _a7462_
                                         (car _next-b7497_)
                                         _next-b7497_))))
                          (values _a7462_
                                  (if (eq? _a7462_ _enda7463_)
                                      (begin
                                        (_maybe-set-cdr!7469_ _a7462_ _b7464_)
                                        _endb7465_)
                                      (let ((_next-a7499_ (cdr _a7462_)))
                                        (_scan-a7467_
                                         _a7462_
                                         (car _next-a7499_)
                                         _next-a7499_
                                         _y7495_
                                         _b7464_)))))))))
               (_grow7422_
                (lambda (_s7435_
                         _ends7436_
                         _ls7437_
                         _ls27438_
                         _u7439_
                         _lw7440_)
                  (if (and (pair? _u7439_) (< _ls7437_ _lw7440_))
                      (let* ((_ls27448_
                              (let _lp7442_ ((_ls27444_ _ls27438_))
                                (let ((_ls2*27446_ (+ _ls27444_ _ls27444_)))
                                  (if (<= _ls2*27446_ _ls7437_)
                                      (_lp7442_ _ls2*27446_)
                                      _ls27444_))))
                             (_g277331_ (_getrun7420_ _u7439_)))
                        (begin
                          (let ((_g277332_
                                 (if (##values? _g277331_)
                                     (##vector-length _g277331_)
                                     1)))
                            (if (not (##fx= _g277332_ 3))
                                (error "Context expects 3 values" _g277332_)))
                          (let ((_lr7450_ (##vector-ref _g277331_ 0))
                                (_endr7451_ (##vector-ref _g277331_ 1))
                                (_u27452_ (##vector-ref _g277331_ 2)))
                            (let ((_g277333_
                                   (_grow7422_
                                    _u7439_
                                    _endr7451_
                                    _lr7450_
                                    '1
                                    _u27452_
                                    _ls27448_)))
                              (begin
                                (let ((_g277334_
                                       (if (##values? _g277333_)
                                           (##vector-length _g277333_)
                                           1)))
                                  (if (not (##fx= _g277334_ 4))
                                      (error "Context expects 4 values"
                                             _g277334_)))
                                (let ((_t7454_ (##vector-ref _g277333_ 0))
                                      (_endt7455_ (##vector-ref _g277333_ 1))
                                      (_lt7456_ (##vector-ref _g277333_ 2))
                                      (_u37457_ (##vector-ref _g277333_ 3)))
                                  (let ((_g277335_
                                         (_merge!7421_
                                          _s7435_
                                          _ends7436_
                                          _t7454_
                                          _endt7455_)))
                                    (begin
                                      (let ((_g277336_
                                             (if (##values? _g277335_)
                                                 (##vector-length _g277335_)
                                                 1)))
                                        (if (not (##fx= _g277336_ 2))
                                            (error "Context expects 2 values"
                                                   _g277336_)))
                                      (let ((_st7459_
                                             (##vector-ref _g277335_ 0))
                                            (_end-st7460_
                                             (##vector-ref _g277335_ 1)))
                                        (_grow7422_
                                         _st7459_
                                         _end-st7460_
                                         (+ _ls7437_ _lt7456_)
                                         (+ _ls27448_ _ls27448_)
                                         _u37457_
                                         _lw7440_))))))))))
                      (values _s7435_ _ends7436_ _ls7437_ _u7439_)))))
        (if (pair? _lis7417_)
            (let ((_g277337_ (_getrun7420_ _lis7417_)))
              (begin
                (let ((_g277338_
                       (if (##values? _g277337_)
                           (##vector-length _g277337_)
                           1)))
                  (if (not (##fx= _g277338_ 3))
                      (error "Context expects 3 values" _g277338_)))
                (let ((_lr7424_ (##vector-ref _g277337_ 0))
                      (_endr7425_ (##vector-ref _g277337_ 1))
                      (_rest7426_ (##vector-ref _g277337_ 2)))
                  (let* ((_infinity7428_ '16777216)
                         (_g277339_
                          (_grow7422_
                           _lis7417_
                           _endr7425_
                           _lr7424_
                           '1
                           _rest7426_
                           _infinity7428_)))
                    (begin
                      (let ((_g277340_
                             (if (##values? _g277339_)
                                 (##vector-length _g277339_)
                                 1)))
                        (if (not (##fx= _g277340_ 4))
                            (error "Context expects 4 values" _g277340_)))
                      (let ((_a7430_ (##vector-ref _g277339_ 0))
                            (_enda7431_ (##vector-ref _g277339_ 1))
                            (_la7432_ (##vector-ref _g277339_ 2))
                            (_v7433_ (##vector-ref _g277339_ 3)))
                        (begin (set-cdr! _enda7431_ '()) _a7430_)))))))
            '()))))
  (define std/sort#really-heap-sort!
    (lambda (_v7368_ _elt<7369_ _start7370_ _end7371_)
      (letrec ((_restore-heap!7373_
                (lambda (_end7389_ _i7390_)
                  (let* ((_vi7392_ (vector-ref _v7368_ _i7390_))
                         (_first-leaf7394_
                          (quotient (+ _start7370_ _end7389_) '2))
                         (_final-k7414_
                          (let _lp7396_ ((_k7398_ _i7390_))
                            (if (>= _k7398_ _first-leaf7394_)
                                _k7398_
                                (let* ((_k*2-start7400_
                                        (+ _k7398_ (- _k7398_ _start7370_)))
                                       (_child17402_ (+ '1 _k*2-start7400_))
                                       (_child27404_ (+ '2 _k*2-start7400_))
                                       (_child1-val7406_
                                        (vector-ref _v7368_ _child17402_)))
                                  (let ((_g277341_
                                         (if (< _child27404_ _end7389_)
                                             (let ((_child2-val7409_
                                                    (vector-ref
                                                     _v7368_
                                                     _child27404_)))
                                               (if (_elt<7369_
                                                    _child2-val7409_
                                                    _child1-val7406_)
                                                   (values _child17402_
                                                           _child1-val7406_)
                                                   (values _child27404_
                                                           _child2-val7409_)))
                                             (values _child17402_
                                                     _child1-val7406_))))
                                    (begin
                                      #!void
                                      (let ((_max-child7411_
                                             (##vector-ref _g277341_ 0))
                                            (_max-child-val7412_
                                             (##vector-ref _g277341_ 1)))
                                        (if (_elt<7369_
                                             _vi7392_
                                             _max-child-val7412_)
                                            (begin
                                              (vector-set!
                                               _v7368_
                                               _k7398_
                                               _max-child-val7412_)
                                              (_lp7396_ _max-child7411_))
                                            _k7398_)))))))))
                    (vector-set! _v7368_ _final-k7414_ _vi7392_)))))
        (let ((_first-leaf7375_ (quotient (+ _start7370_ _end7371_) '2)))
          (let _$loop7377_ ((_i7380_ (- _first-leaf7375_ '1)))
            (if (< _i7380_ '0)
                '#!void
                (begin
                  (_restore-heap!7373_ _end7371_ _i7380_)
                  (_$loop7377_ (- _i7380_ '1))))))
        (let _$loop7382_ ((_i7385_ (- _end7371_ '1)))
          (if (<= _i7385_ '0)
              '#!void
              (begin
                (let ((_top7387_ (vector-ref _v7368_ _start7370_)))
                  (vector-set!
                   _v7368_
                   _start7370_
                   (vector-ref _v7368_ _i7385_))
                  (vector-set! _v7368_ _i7385_ _top7387_)
                  (_restore-heap!7373_ _i7385_ _start7370_))
                (_$loop7382_ (- _i7385_ '1))))))))
  (define std/sort#heap-sort!
    (lambda (_v7361_ _elt<7362_ . _maybe-start+end7363_)
      (let ((_g277342_
             (std/sort#parse-vector-final-start+end
              std/sort#heap-sort!
              _v7361_
              _maybe-start+end7363_)))
        (begin
          (let ((_g277343_
                 (if (##values? _g277342_) (##vector-length _g277342_) 1)))
            (if (not (##fx= _g277343_ 2))
                (error "Context expects 2 values" _g277343_)))
          (let ((_start7365_ (##vector-ref _g277342_ 0))
                (_end7366_ (##vector-ref _g277342_ 1)))
            (std/sort#really-heap-sort!
             _v7361_
             _elt<7362_
             _start7365_
             _end7366_))))))
  (define std/sort#heap-sort
    (lambda (_v7352_ _elt<7353_ . _maybe-start+end7354_)
      (let ((_g277344_
             (std/sort#parse-vector-final-start+end
              std/sort#heap-sort
              _v7352_
              _maybe-start+end7354_)))
        (begin
          (let ((_g277345_
                 (if (##values? _g277344_) (##vector-length _g277344_) 1)))
            (if (not (##fx= _g277345_ 2))
                (error "Context expects 2 values" _g277345_)))
          (let ((_start7356_ (##vector-ref _g277344_ 0))
                (_end7357_ (##vector-ref _g277344_ 1)))
            (let ((_ans7359_ (subvector _v7352_ _start7356_ _end7357_)))
              (std/sort#really-heap-sort!
               _ans7359_
               _elt<7353_
               '0
               (- _end7357_ _start7356_))
              _ans7359_))))))
  (define std/sort#%vector-merge!
    (lambda (_v7314_
             _v17315_
             _v27316_
             _elt<7317_
             _start07318_
             _start17319_
             _end17320_
             _start27321_
             _end27322_)
      (letrec ((_vblit7324_
                (lambda (_fromv7326_ _j7327_ _i7328_ _end7329_)
                  (let _lp7331_ ((_j7333_ _j7327_) (_i7334_ _i7328_))
                    (vector-set!
                     _v7314_
                     _i7334_
                     (vector-ref _fromv7326_ _j7333_))
                    (let ((_j7336_ (+ _j7333_ '1)))
                      (if (< _j7336_ _end7329_)
                          (_lp7331_ _j7336_ (+ _i7334_ '1))
                          '#!void))))))
        (if (<= _end17320_ _start17319_)
            (if (< _start27321_ _end27322_)
                (_vblit7324_ _v27316_ _start27321_ _start07318_ _end27322_)
                '#!void)
            (if (<= _end27322_ _start27321_)
                (_vblit7324_ _v17315_ _start17319_ _start07318_ _end17320_)
                (let _lp7338_ ((_i7340_ _start07318_)
                               (_j7341_ _start17319_)
                               (_x7342_ (vector-ref _v17315_ _start17319_))
                               (_k7343_ _start27321_)
                               (_y7344_ (vector-ref _v27316_ _start27321_)))
                  (let ((_i17346_ (+ _i7340_ '1)))
                    (if (_elt<7317_ _y7344_ _x7342_)
                        (let ((_k7348_ (+ _k7343_ '1)))
                          (vector-set! _v7314_ _i7340_ _y7344_)
                          (if (< _k7348_ _end27322_)
                              (_lp7338_
                               _i17346_
                               _j7341_
                               _x7342_
                               _k7348_
                               (vector-ref _v27316_ _k7348_))
                              (_vblit7324_
                               _v17315_
                               _j7341_
                               _i17346_
                               _end17320_)))
                        (let ((_j7350_ (+ _j7341_ '1)))
                          (vector-set! _v7314_ _i7340_ _x7342_)
                          (if (< _j7350_ _end17320_)
                              (_vblit7324_
                               _v27316_
                               _k7343_
                               _i17346_
                               _end27322_)
                              (_lp7338_
                               _i17346_
                               _j7350_
                               (vector-ref _v17315_ _j7350_)
                               _k7343_
                               _y7344_)))))))))))
  (define std/sort#%vector-merge-sort!
    (lambda (_v07268_ _elt<7269_ _l7270_ _r7271_ _temp07272_)
      (letrec ((_xor7274_
                (lambda (_a7311_ _b7312_) (not (eq? _a7311_ _b7312_)))))
        (if (< _l7270_ _r7271_)
            (let ((_g277346_
                   (let _recur7276_ ((_l7278_ _l7270_)
                                     (_want7279_ (- _r7271_ _l7270_)))
                     (let ((_len7281_ (- _r7271_ _l7278_)))
                       (let _lp7283_ ((_pfxlen7285_
                                       (std/sort#getrun
                                        _v07268_
                                        _l7278_
                                        _r7271_
                                        _elt<7269_))
                                      (_pfxlen27286_ '1)
                                      (_v7287_ _v07268_)
                                      (_temp7288_ _temp07272_)
                                      (_v=v0?7289_ '#t))
                         (if (or (>= _pfxlen7285_ _want7279_)
                                 (= _pfxlen7285_ _len7281_))
                             (values _pfxlen7285_ _v7287_ _v=v0?7289_)
                             (let ((_pfxlen27300_
                                    (let _lp7294_ ((_j7296_ _pfxlen27286_))
                                      (let ((_j*27298_ (+ _j7296_ _j7296_)))
                                        (if (<= _j7296_ _pfxlen7285_)
                                            (_lp7294_ _j*27298_)
                                            _j7296_))))
                                   (_tail-len7301_ (- _len7281_ _pfxlen7285_)))
                               (let ((_g277348_
                                      (_recur7276_
                                       (+ _pfxlen7285_ _l7278_)
                                       _pfxlen27300_)))
                                 (begin
                                   (let ((_g277349_
                                          (if (##values? _g277348_)
                                              (##vector-length _g277348_)
                                              1)))
                                     (if (not (##fx= _g277349_ 3))
                                         (error "Context expects 3 values"
                                                _g277349_)))
                                   (let ((_nr-len7303_
                                          (##vector-ref _g277348_ 0))
                                         (_nr-vec7304_
                                          (##vector-ref _g277348_ 1))
                                         (_nrvec=v0?7305_
                                          (##vector-ref _g277348_ 2)))
                                     (begin
                                       (std/sort#%vmerge
                                        _temp7288_
                                        _v7287_
                                        _nr-vec7304_
                                        _l7278_
                                        _pfxlen7285_
                                        _nr-len7303_
                                        (_xor7274_ _nrvec=v0?7305_ _v=v0?7289_)
                                        _elt<7269_)
                                       (_lp7283_
                                        (+ _pfxlen7285_ _nr-len7303_)
                                        (+ _pfxlen27300_ _pfxlen27300_)
                                        _temp7288_
                                        _v7287_
                                        (not _v=v0?7289_)))))))))))))
              (begin
                (let ((_g277347_
                       (if (##values? _g277346_)
                           (##vector-length _g277346_)
                           1)))
                  (if (not (##fx= _g277347_ 3))
                      (error "Context expects 3 values" _g277347_)))
                (let ((_ignored-len7307_ (##vector-ref _g277346_ 0))
                      (_ignored-ansvec7308_ (##vector-ref _g277346_ 1))
                      (_ansvec=v0?7309_ (##vector-ref _g277346_ 2)))
                  (if (not _ansvec=v0?7309_)
                      (std/sort#vector-copy!
                       _v07268_
                       _temp07272_
                       _l7270_
                       _r7271_)
                      '#!void))))
            '#!void))))
  (define std/sort#%vmerge
    (lambda (_target7226_
             _v17227_
             _v27228_
             _l7229_
             _len17230_
             _len27231_
             _v2=target?7232_
             _elt<7233_)
      (letrec ((_vblit7235_
                (lambda (_fromv7237_ _j7238_ _i7239_ _end7240_)
                  (let _lp7242_ ((_j7244_ _j7238_) (_i7245_ _i7239_))
                    (vector-set!
                     _target7226_
                     _i7245_
                     (vector-ref _fromv7237_ _j7244_))
                    (let ((_j7247_ (+ _j7244_ '1)))
                      (if (< _j7247_ _end7240_)
                          (_lp7242_ _j7247_ (+ _i7245_ '1))
                          '#!void))))))
        (let* ((_r17249_ (+ _l7229_ _len17230_))
               (_r27251_ (+ _r17249_ _len27231_)))
          (let _lp7254_ ((_i7256_ _l7229_)
                         (_j7257_ _l7229_)
                         (_x7258_ (vector-ref _v17227_ _l7229_))
                         (_k7259_ _r17249_)
                         (_y7260_ (vector-ref _v27228_ _r17249_)))
            (let ((_i17262_ (+ _i7256_ '1)))
              (if (_elt<7233_ _y7260_ _x7258_)
                  (let ((_k7264_ (+ _k7259_ '1)))
                    (vector-set! _target7226_ _i7256_ _y7260_)
                    (if (< _k7264_ _r27251_)
                        (_lp7254_
                         _i17262_
                         _j7257_
                         _x7258_
                         _k7264_
                         (vector-ref _v27228_ _k7264_))
                        (_vblit7235_ _v17227_ _j7257_ _i17262_ _r17249_)))
                  (let ((_j7266_ (+ _j7257_ '1)))
                    (vector-set! _target7226_ _i7256_ _x7258_)
                    (if (< _j7266_ _r17249_)
                        (_lp7254_
                         _i17262_
                         _j7266_
                         (vector-ref _v17227_ _j7266_)
                         _k7259_
                         _y7260_)
                        (if (not _v2=target?7232_)
                            (_vblit7235_ _v27228_ _k7259_ _i17262_ _r27251_)
                            '#!void))))))))))
  (define std/sort#getrun
    (lambda (_v7214_ _l7215_ _r7216_ _elt<7217_)
      (let _lp7219_ ((_i7221_ (+ _l7215_ '1))
                     (_x7222_ (vector-ref _v7214_ _l7215_)))
        (if (>= _i7221_ _r7216_)
            (- _i7221_ _l7215_)
            (let ((_y7224_ (vector-ref _v7214_ _i7221_)))
              (if (_elt<7217_ _y7224_ _x7222_)
                  (- _i7221_ _l7215_)
                  (_lp7219_ (+ _i7221_ '1) _y7224_)))))))
  (define std/sort#list-sorted?
    (lambda (_list7198_ _<7199_)
      (let ((_$e7201_ (not (pair? _list7198_))))
        (if _$e7201_
            _$e7201_
            (let _lp7204_ ((_prev7206_ (car _list7198_))
                           (_tail7207_ (cdr _list7198_)))
              (let ((_$e7209_ (not (pair? _tail7207_))))
                (if _$e7209_
                    _$e7209_
                    (let ((_next7212_ (car _tail7207_)))
                      (if (not (_<7199_ _next7212_ _prev7206_))
                          (_lp7204_ _next7212_ (cdr _tail7207_))
                          '#f)))))))))
  (define std/sort#vector-sorted?
    (lambda (_v7178_ _elt<7179_ . _maybe-start+end7180_)
      (if (vector? _v7178_) '#!void (error '"Expected vector" _v7178_))
      (let ((_g277350_
             (std/sort#parse-vector-final-start+end
              std/sort#vector-sorted?
              _v7178_
              _maybe-start+end7180_)))
        (begin
          (let ((_g277351_
                 (if (##values? _g277350_) (##vector-length _g277350_) 1)))
            (if (not (##fx= _g277351_ 2))
                (error "Context expects 2 values" _g277351_)))
          (let ((_start7182_ (##vector-ref _g277350_ 0))
                (_end7183_ (##vector-ref _g277350_ 1)))
            (let ((_$e7185_ (>= _start7182_ _end7183_)))
              (if _$e7185_
                  _$e7185_
                  (let _lp7188_ ((_i7190_ (+ _start7182_ '1))
                                 (_vi-17191_ (vector-ref _v7178_ _start7182_)))
                    (let ((_$e7193_ (>= _i7190_ _end7183_)))
                      (if _$e7193_
                          _$e7193_
                          (let ((_vi7196_ (vector-ref _v7178_ _i7190_)))
                            (if (not (_elt<7179_ _vi7196_ _vi-17191_))
                                (_lp7188_ (+ _i7190_ '1) _vi7196_)
                                '#f)))))))))))))
