(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/133#nonneg-int?
    (lambda (_x100834_)
      (if (integer? _x100834_) (not (negative? _x100834_)) '#f)))
  (define std/srfi/133#between?
    (lambda (_x100830_ _y100831_ _z100832_)
      (if (< _x100830_ _y100831_) (<= _y100831_ _z100832_) '#f)))
  (define std/srfi/133#unspecified-value (lambda () (if '#f '#f '#!void)))
  (define std/srfi/133#vectors-ref
    (lambda (_vectors100824_ _i100825_)
      (map (lambda (_v100827_) (vector-ref _v100827_ _i100825_))
           _vectors100824_)))
  (define std/srfi/133#check-type
    (lambda (_pred?100820_ _value100821_ _callee100822_)
      (if (_pred?100820_ _value100821_)
          _value100821_
          (std/srfi/133#check-type
           _pred?100820_
           (error '"erroneous value"
                  (list _pred?100820_ _value100821_)
                  (cons 'while (cons 'calling (cons _callee100822_ '()))))
           _callee100822_))))
  (define std/srfi/133#check-index
    (lambda (_vec100814_ _index100815_ _callee100816_)
      (let ((_index100818_
             (std/srfi/133#check-type integer? _index100815_ _callee100816_)))
        (if (< _index100818_ '0)
            (std/srfi/133#check-index
             _vec100814_
             (error '"vector index too low"
                    _index100818_
                    (cons 'into (cons 'vector (cons _vec100814_ '())))
                    (cons 'while (cons 'calling (cons _callee100816_ '()))))
             _callee100816_)
            (if (>= _index100818_ (vector-length _vec100814_))
                (std/srfi/133#check-index
                 _vec100814_
                 (error '"vector index too high"
                        _index100818_
                        (cons 'into (cons 'vector (cons _vec100814_ '())))
                        (cons 'while
                              (cons 'calling (cons _callee100816_ '()))))
                 _callee100816_)
                _index100818_)))))
  (define std/srfi/133#check-indices
    (lambda (_vec100798_
             _start100799_
             _start-name100800_
             _end100801_
             _end-name100802_
             _callee100803_)
      (let ((_lose100807_
             (lambda _things100805_
               (apply error
                      '"vector range out of bounds"
                      (append _things100805_
                              (cons 'vector (cons 'was (cons _vec100798_ '())))
                              (cons _start-name100800_
                                    (cons 'was (cons _start100799_ '())))
                              (cons _end-name100802_
                                    (cons 'was (cons _end100801_ '())))
                              (cons 'while
                                    (cons 'calling
                                          (cons _callee100803_ '())))))))
            (_start100808_
             (std/srfi/133#check-type integer? _start100799_ _callee100803_))
            (_end100809_
             (std/srfi/133#check-type integer? _end100801_ _callee100803_)))
        (if (> _start100808_ _end100809_)
            (let ((_g285539_
                   (_lose100807_
                    (cons _end-name100802_
                          (cons '< (cons _start-name100800_ '()))))))
              (begin
                (let ((_g285540_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g285539_)
                             (##vector-length _g285539_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g285540_ 2)))
                      (error "Context expects 2 values" _g285540_)))
                (let ((_new-start100811_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g285539_ 0)))
                      (_new-end100812_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g285539_ 1))))
                  (std/srfi/133#check-indices
                   _vec100798_
                   _new-start100811_
                   _start-name100800_
                   _new-end100812_
                   _end-name100802_
                   _callee100803_))))
            (if (< _start100808_ '0)
                (std/srfi/133#check-indices
                 _vec100798_
                 (_lose100807_
                  (cons _start-name100800_ (cons '< (cons '0 '()))))
                 _start-name100800_
                 _end100809_
                 _end-name100802_
                 _callee100803_)
                (if (>= _start100808_ (vector-length _vec100798_))
                    (std/srfi/133#check-indices
                     _vec100798_
                     (_lose100807_
                      (cons _start-name100800_ (cons '> (cons 'len '())))
                      (cons 'len
                            (cons 'was
                                  (cons (vector-length _vec100798_) '()))))
                     _start-name100800_
                     _end100809_
                     _end-name100802_
                     _callee100803_)
                    (if (> _end100809_ (vector-length _vec100798_))
                        (std/srfi/133#check-indices
                         _vec100798_
                         _start100808_
                         _start-name100800_
                         (_lose100807_
                          (cons _end-name100802_ (cons '> (cons 'len '())))
                          (cons 'len
                                (cons 'was
                                      (cons (vector-length _vec100798_) '()))))
                         _end-name100802_
                         _callee100803_)
                        (values _start100808_ _end100809_))))))))
  (define std/srfi/133#vector-parse-start+end
    (lambda (_vec100790_
             _args100791_
             _start-name100792_
             _end-name100793_
             _callee100794_)
      (let ((_len100796_ (vector-length _vec100790_)))
        (if (null? _args100791_)
            (values '0 _len100796_)
            (if (null? (cdr _args100791_))
                (std/srfi/133#check-indices
                 _vec100790_
                 (car _args100791_)
                 _start-name100792_
                 _len100796_
                 _end-name100793_
                 _callee100794_)
                (if (null? (cddr _args100791_))
                    (std/srfi/133#check-indices
                     _vec100790_
                     (car _args100791_)
                     _start-name100792_
                     (cadr _args100791_)
                     _end-name100793_
                     _callee100794_)
                    (error '"too many arguments"
                           (cons 'extra
                                 (cons 'args
                                       (cons 'were
                                             (cons (cddr _args100791_) '()))))
                           (cons 'while
                                 (cons 'calling
                                       (cons _callee100794_ '()))))))))))
  (define std/srfi/133#%smallest-length
    (letrec ((_loop100784_
              (lambda (_vector-list100786_ _length100787_ _callee100788_)
                (if (null? _vector-list100786_)
                    _length100787_
                    (_loop100784_
                     (cdr _vector-list100786_)
                     (min (vector-length
                           (std/srfi/133#check-type
                            vector?
                            (car _vector-list100786_)
                            _callee100788_))
                          _length100787_)
                     _callee100788_)))))
      _loop100784_))
  (define std/srfi/133#%vector-copy!
    (letrec ((_loop/l->r100763_
              (lambda (_target100766_
                       _source100767_
                       _send100768_
                       _i100769_
                       _j100770_)
                (if (< _i100769_ _send100768_)
                    (begin
                      (vector-set!
                       _target100766_
                       _j100770_
                       (vector-ref _source100767_ _i100769_))
                      (_loop/l->r100763_
                       _target100766_
                       _source100767_
                       _send100768_
                       (+ _i100769_ '1)
                       (+ _j100770_ '1)))
                    '#!void)))
             (_loop/r->l100764_
              (lambda (_target100772_
                       _source100773_
                       _sstart100774_
                       _i100775_
                       _j100776_)
                (if (>= _i100775_ _sstart100774_)
                    (begin
                      (vector-set!
                       _target100772_
                       _j100776_
                       (vector-ref _source100773_ _i100775_))
                      (_loop/r->l100764_
                       _target100772_
                       _source100773_
                       _sstart100774_
                       (- _i100775_ '1)
                       (- _j100776_ '1)))
                    '#!void))))
      (lambda (_target100778_
               _tstart100779_
               _source100780_
               _sstart100781_
               _send100782_)
        (if (> _sstart100781_ _tstart100779_)
            (_loop/l->r100763_
             _target100778_
             _source100780_
             _send100782_
             _sstart100781_
             _tstart100779_)
            (_loop/r->l100764_
             _target100778_
             _source100780_
             _sstart100781_
             (- _send100782_ '1)
             (+ '-1 _tstart100779_ _send100782_ (- _sstart100781_)))))))
  (define std/srfi/133#%vector-reverse-copy!
    (letrec ((_loop100749_
              (lambda (_target100751_
                       _source100752_
                       _sstart100753_
                       _i100754_
                       _j100755_)
                (if (>= _i100754_ _sstart100753_)
                    (begin
                      (vector-set!
                       _target100751_
                       _j100755_
                       (vector-ref _source100752_ _i100754_))
                      (_loop100749_
                       _target100751_
                       _source100752_
                       _sstart100753_
                       (- _i100754_ '1)
                       (+ _j100755_ '1)))
                    '#!void))))
      (lambda (_target100757_
               _tstart100758_
               _source100759_
               _sstart100760_
               _send100761_)
        (_loop100749_
         _target100757_
         _source100759_
         _sstart100760_
         (- _send100761_ '1)
         _tstart100758_))))
  (define std/srfi/133#%vector-reverse!
    (letrec ((_loop100737_
              (lambda (_vec100739_ _i100740_ _j100741_)
                (if (<= _i100740_ _j100741_)
                    (let ((_v100743_ (vector-ref _vec100739_ _i100740_)))
                      (vector-set!
                       _vec100739_
                       _i100740_
                       (vector-ref _vec100739_ _j100741_))
                      (vector-set! _vec100739_ _j100741_ _v100743_)
                      (_loop100737_
                       _vec100739_
                       (+ _i100740_ '1)
                       (- _j100741_ '1)))
                    '#!void))))
      (lambda (_vec100745_ _start100746_ _end100747_)
        (_loop100737_ _vec100745_ _start100746_ (- _end100747_ '1)))))
  (define std/srfi/133#%vector-fold1
    (letrec ((_loop100724_
              (lambda (_kons100726_
                       _knil100727_
                       _len100728_
                       _vec100729_
                       _i100730_)
                (if (= _i100730_ _len100728_)
                    _knil100727_
                    (_loop100724_
                     _kons100726_
                     (_kons100726_
                      _knil100727_
                      (vector-ref _vec100729_ _i100730_))
                     _len100728_
                     _vec100729_
                     (+ _i100730_ '1))))))
      (lambda (_kons100732_ _knil100733_ _len100734_ _vec100735_)
        (_loop100724_ _kons100732_ _knil100733_ _len100734_ _vec100735_ '0))))
  (define std/srfi/133#%vector-fold2+
    (letrec ((_loop100711_
              (lambda (_kons100713_
                       _knil100714_
                       _len100715_
                       _vectors100716_
                       _i100717_)
                (if (= _i100717_ _len100715_)
                    _knil100714_
                    (_loop100711_
                     _kons100713_
                     (apply _kons100713_
                            _knil100714_
                            (std/srfi/133#vectors-ref
                             _vectors100716_
                             _i100717_))
                     _len100715_
                     _vectors100716_
                     (+ _i100717_ '1))))))
      (lambda (_kons100719_ _knil100720_ _len100721_ _vectors100722_)
        (_loop100711_
         _kons100719_
         _knil100720_
         _len100721_
         _vectors100722_
         '0))))
  (define std/srfi/133#%vector-map1!
    (letrec ((_loop100697_
              (lambda (_f100699_ _target100700_ _vec100701_ _i100702_)
                (if (zero? _i100702_)
                    _target100700_
                    (let ((_j100704_ (- _i100702_ '1)))
                      (vector-set!
                       _target100700_
                       _j100704_
                       (_f100699_ (vector-ref _vec100701_ _j100704_)))
                      (_loop100697_
                       _f100699_
                       _target100700_
                       _vec100701_
                       _j100704_))))))
      (lambda (_f100706_ _target100707_ _vec100708_ _len100709_)
        (_loop100697_ _f100706_ _target100707_ _vec100708_ _len100709_))))
  (define std/srfi/133#%vector-map2+!
    (letrec ((_loop100683_
              (lambda (_f100685_ _target100686_ _vectors100687_ _i100688_)
                (if (zero? _i100688_)
                    _target100686_
                    (let ((_j100690_ (- _i100688_ '1)))
                      (vector-set!
                       _target100686_
                       _j100690_
                       (apply _f100685_
                              (std/srfi/133#vectors-ref
                               _vectors100687_
                               _j100690_)))
                      (_loop100683_
                       _f100685_
                       _target100686_
                       _vectors100687_
                       _j100690_))))))
      (lambda (_f100692_ _target100693_ _vectors100694_ _len100695_)
        (_loop100683_ _f100692_ _target100693_ _vectors100694_ _len100695_))))
  (define std/srfi/133#vector-unfold
    (lambda (_f100677_ _length100678_ . _initial-seeds100679_)
      (letrec* ((_vec100681_ (make-vector _length100678_)))
        (apply std/srfi/133#vector-unfold!
               _f100677_
               _vec100681_
               '0
               _length100678_
               _initial-seeds100679_)
        _vec100681_)))
  (define std/srfi/133#vector-unfold!
    (letrec ((_tabulate!100639_
              (lambda (_f100643_ _vec100644_ _i100645_ _len100646_)
                (if (< _i100645_ _len100646_)
                    (begin
                      (vector-set! _vec100644_ _i100645_ (_f100643_ _i100645_))
                      (_tabulate!100639_
                       _f100643_
                       _vec100644_
                       (+ _i100645_ '1)
                       _len100646_))
                    '#!void)))
             (_unfold1!100640_
              (lambda (_f100648_
                       _vec100649_
                       _i100650_
                       _len100651_
                       _seed100652_)
                (if (< _i100650_ _len100651_)
                    (let ((_g285541_ (_f100648_ _i100650_ _seed100652_)))
                      (begin
                        (let ((_g285542_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g285541_)
                                     (##vector-length _g285541_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx= _g285542_ 2)))
                              (error "Context expects 2 values" _g285542_)))
                        (let ((_elt100654_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g285541_ 0)))
                              (_new-seed100655_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g285541_ 1))))
                          (begin
                            (vector-set! _vec100649_ _i100650_ _elt100654_)
                            (_unfold1!100640_
                             _f100648_
                             _vec100649_
                             (+ _i100650_ '1)
                             _len100651_
                             _new-seed100655_)))))
                    '#!void)))
             (_unfold2+!100641_
              (lambda (_f100657_
                       _vec100658_
                       _i100659_
                       _len100660_
                       _seeds100661_)
                (if (< _i100659_ _len100660_)
                    (let ((_g285543_
                           (apply _f100657_ _i100659_ _seeds100661_)))
                      (begin
                        (let ((_g285544_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g285543_)
                                     (##vector-length _g285543_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx>= _g285544_ 1)))
                              (error "Context expects at least 1 values"
                                     _g285544_)))
                        (let ((_elt100663_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g285543_)
                                     (##vector-ref _g285543_ 0)
                                     _g285543_)))
                              (_new-seeds100664_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g285543_)
                                     (##cdr (##vector->list _g285543_))
                                     '()))))
                          (begin
                            (vector-set! _vec100658_ _i100659_ _elt100663_)
                            (_unfold2+!100641_
                             _f100657_
                             _vec100658_
                             (+ _i100659_ '1)
                             _len100660_
                             _new-seeds100664_)))))
                    '#!void))))
      (lambda (_f100666_
               _vec100667_
               _start100668_
               _end100669_
               .
               _initial-seeds100670_)
        (let ((_f100672_
               (std/srfi/133#check-type
                procedure?
                _f100666_
                std/srfi/133#vector-unfold!))
              (_start100673_
               (std/srfi/133#check-type
                std/srfi/133#nonneg-int?
                _start100668_
                std/srfi/133#vector-unfold!))
              (_end100674_
               (std/srfi/133#check-type
                std/srfi/133#nonneg-int?
                _end100669_
                std/srfi/133#vector-unfold!)))
          (let ()
            (if (null? _initial-seeds100670_)
                (_tabulate!100639_
                 _f100672_
                 _vec100667_
                 _start100673_
                 _end100674_)
                (if (null? (cdr _initial-seeds100670_))
                    (_unfold1!100640_
                     _f100672_
                     _vec100667_
                     _start100673_
                     _end100674_
                     (car _initial-seeds100670_))
                    (_unfold2+!100641_
                     _f100672_
                     _vec100667_
                     _start100673_
                     _end100674_
                     _initial-seeds100670_))))))))
  (define std/srfi/133#vector-unfold-right
    (lambda (_f100633_ _len100634_ . _initial-seeds100635_)
      (letrec* ((_vec100637_ (make-vector _len100634_)))
        (apply std/srfi/133#vector-unfold-right!
               _f100633_
               _vec100637_
               '0
               _len100634_
               _initial-seeds100635_)
        _vec100637_)))
  (define std/srfi/133#vector-unfold-right!
    (lambda (_f100597_
             _vec100598_
             _start100599_
             _end100600_
             .
             _initial-seeds100601_)
      (letrec ((_tabulate!100603_
                (lambda (_f100607_ _vec100608_ _i100609_)
                  (if (>= _i100609_ _start100599_)
                      (begin
                        (vector-set!
                         _vec100608_
                         _i100609_
                         (_f100607_ _i100609_))
                        (_tabulate!100603_
                         _f100607_
                         _vec100608_
                         (- _i100609_ '1)))
                      '#!void)))
               (_unfold1!100604_
                (lambda (_f100611_ _vec100612_ _i100613_ _seed100614_)
                  (if (>= _i100613_ _start100599_)
                      (let ((_g285545_ (_f100611_ _i100613_ _seed100614_)))
                        (begin
                          (let ((_g285546_
                                 (let ()
                                   (declare (not safe))
                                   (if (##values? _g285545_)
                                       (##vector-length _g285545_)
                                       1))))
                            (if (not (let ()
                                       (declare (not safe))
                                       (##fx= _g285546_ 2)))
                                (error "Context expects 2 values" _g285546_)))
                          (let ((_elt100616_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _g285545_ 0)))
                                (_new-seed100617_
                                 (let ()
                                   (declare (not safe))
                                   (##vector-ref _g285545_ 1))))
                            (begin
                              (vector-set! _vec100612_ _i100613_ _elt100616_)
                              (_unfold1!100604_
                               _f100611_
                               _vec100612_
                               (- _i100613_ '1)
                               _new-seed100617_)))))
                      '#!void)))
               (_unfold2+!100605_
                (lambda (_f100619_ _vec100620_ _i100621_ _seeds100622_)
                  (if (>= _i100621_ _start100599_)
                      (let ((_g285547_
                             (apply _f100619_ _i100621_ _seeds100622_)))
                        (begin
                          (let ((_g285548_
                                 (let ()
                                   (declare (not safe))
                                   (if (##values? _g285547_)
                                       (##vector-length _g285547_)
                                       1))))
                            (if (not (let ()
                                       (declare (not safe))
                                       (##fx>= _g285548_ 1)))
                                (error "Context expects at least 1 values"
                                       _g285548_)))
                          (let ((_elt100624_
                                 (let ()
                                   (declare (not safe))
                                   (if (##values? _g285547_)
                                       (##vector-ref _g285547_ 0)
                                       _g285547_)))
                                (_new-seeds100625_
                                 (let ()
                                   (declare (not safe))
                                   (if (##values? _g285547_)
                                       (##cdr (##vector->list _g285547_))
                                       '()))))
                            (begin
                              (vector-set! _vec100620_ _i100621_ _elt100624_)
                              (_unfold2+!100605_
                               _f100619_
                               _vec100620_
                               (- _i100621_ '1)
                               _new-seeds100625_)))))
                      '#!void))))
        (let ((_f100627_
               (std/srfi/133#check-type
                procedure?
                _f100597_
                std/srfi/133#vector-unfold-right!))
              (_start100628_
               (std/srfi/133#check-type
                std/srfi/133#nonneg-int?
                _start100599_
                std/srfi/133#vector-unfold-right!))
              (_end100629_
               (std/srfi/133#check-type
                std/srfi/133#nonneg-int?
                _end100600_
                std/srfi/133#vector-unfold-right!)))
          (let ((_i100631_ (- _end100629_ '1)))
            (if (null? _initial-seeds100601_)
                (_tabulate!100603_ _f100627_ _vec100598_ _i100631_)
                (if (null? (cdr _initial-seeds100601_))
                    (_unfold1!100604_
                     _f100627_
                     _vec100598_
                     _i100631_
                     (car _initial-seeds100601_))
                    (_unfold2+!100605_
                     _f100627_
                     _vec100598_
                     _i100631_
                     _initial-seeds100601_))))))))
  (define std/srfi/133#vector-copy
    (lambda (_vec100586_ . _args100587_)
      (let* ((_vec100589_
              (std/srfi/133#check-type
               vector?
               _vec100586_
               std/srfi/133#vector-copy))
             (_g285549_
              (std/srfi/133#vector-copy:parse-args _vec100589_ _args100587_)))
        (begin
          (let ((_g285550_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g285549_) (##vector-length _g285549_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g285550_ 3)))
                (error "Context expects 3 values" _g285550_)))
          (let ((_start100591_
                 (let () (declare (not safe)) (##vector-ref _g285549_ 0)))
                (_end100592_
                 (let () (declare (not safe)) (##vector-ref _g285549_ 1)))
                (_fill100593_
                 (let () (declare (not safe)) (##vector-ref _g285549_ 2))))
            (let ((_new-vector100595_
                   (make-vector (- _end100592_ _start100591_) _fill100593_)))
              (std/srfi/133#%vector-copy!
               _new-vector100595_
               '0
               _vec100589_
               _start100591_
               (if (> _end100592_ (vector-length _vec100589_))
                   (vector-length _vec100589_)
                   _end100592_))
              _new-vector100595_))))))
  (define std/srfi/133#vector-copy:parse-args
    (lambda (_vec100571_ _args100572_)
      (letrec ((_parse-args100574_
                (lambda (_start100578_ _end100579_ _n100580_ _fill100581_)
                  (let ((_start100583_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _start100578_
                          std/srfi/133#vector-copy))
                        (_end100584_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _end100579_
                          std/srfi/133#vector-copy)))
                    (if (and (<= '0 _start100583_ _end100584_)
                             (<= _start100583_ _n100580_))
                        (values _start100583_ _end100584_ _fill100581_)
                        (error '"illegal arguments"
                               (cons 'while
                                     (cons 'calling
                                           (cons std/srfi/133#vector-copy
                                                 '())))
                               (cons 'start
                                     (cons 'was (cons _start100583_ '())))
                               (cons 'end (cons 'was (cons _end100584_ '())))
                               (cons 'vector
                                     (cons 'was (cons _vec100571_ '())))))))))
        (let ((_n100576_ (vector-length _vec100571_)))
          (if (null? _args100572_)
              (_parse-args100574_
               '0
               _n100576_
               _n100576_
               (std/srfi/133#unspecified-value))
              (if (null? (cdr _args100572_))
                  (_parse-args100574_
                   (car _args100572_)
                   _n100576_
                   _n100576_
                   (std/srfi/133#unspecified-value))
                  (if (null? (cddr _args100572_))
                      (_parse-args100574_
                       (car _args100572_)
                       (cadr _args100572_)
                       _n100576_
                       (std/srfi/133#unspecified-value))
                      (if (null? (cdddr _args100572_))
                          (_parse-args100574_
                           (car _args100572_)
                           (cadr _args100572_)
                           _n100576_
                           (caddr _args100572_))
                          (error '"too many arguments"
                                 std/srfi/133#vector-copy
                                 (cdddr _args100572_))))))))))
  (define std/srfi/133#vector-reverse-copy
    (lambda (_vec100561_ . _maybe-start+end100562_)
      (let* ((_vec100564_
              (std/srfi/133#check-type
               vector?
               _vec100561_
               std/srfi/133#vector-reverse-copy))
             (_g285551_
              (std/srfi/133#vector-parse-start+end
               _vec100564_
               _maybe-start+end100562_
               'start
               'end
               std/srfi/133#vector-reverse-copy)))
        (begin
          (let ((_g285552_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g285551_) (##vector-length _g285551_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g285552_ 2)))
                (error "Context expects 2 values" _g285552_)))
          (let ((_start100566_
                 (let () (declare (not safe)) (##vector-ref _g285551_ 0)))
                (_end100567_
                 (let () (declare (not safe)) (##vector-ref _g285551_ 1))))
            (let ((_new100569_ (make-vector (- _end100567_ _start100566_))))
              (std/srfi/133#%vector-reverse-copy!
               _new100569_
               '0
               _vec100564_
               _start100566_
               _end100567_)
              _new100569_))))))
  (define std/srfi/133#vector-append
    (lambda _vectors100559_
      (std/srfi/133#vector-concatenate:aux
       _vectors100559_
       std/srfi/133#vector-append)))
  (define std/srfi/133#vector-concatenate
    (lambda (_vector-list100557_)
      (std/srfi/133#vector-concatenate:aux
       _vector-list100557_
       std/srfi/133#vector-concatenate)))
  (define std/srfi/133#vector-concatenate:aux
    (letrec ((_compute-length100527_
              (lambda (_vectors100530_ _len100531_ _callee100532_)
                (if (null? _vectors100530_)
                    _len100531_
                    (let ((_vec100534_
                           (std/srfi/133#check-type
                            vector?
                            (car _vectors100530_)
                            _callee100532_)))
                      (_compute-length100527_
                       (cdr _vectors100530_)
                       (+ (vector-length _vec100534_) _len100531_)
                       _callee100532_)))))
             (_concatenate!100528_
              (lambda (_vectors100536_ _target100537_ _to100538_)
                (if (null? _vectors100536_)
                    _target100537_
                    (let* ((_vec1100540_ (car _vectors100536_))
                           (_len100542_ (vector-length _vec1100540_)))
                      (std/srfi/133#%vector-copy!
                       _target100537_
                       _to100538_
                       _vec1100540_
                       '0
                       _len100542_)
                      (_concatenate!100528_
                       (cdr _vectors100536_)
                       _target100537_
                       (+ _to100538_ _len100542_)))))))
      (lambda (_vectors100545_ _callee100546_)
        (if (null? _vectors100545_)
            (make-vector '0)
            (if (null? (cdr _vectors100545_))
                (let* ((_vec100548_
                        (std/srfi/133#check-type
                         vector?
                         (car _vectors100545_)
                         _callee100546_))
                       (_len100550_ (vector-length _vec100548_))
                       (_new100552_ (make-vector _len100550_)))
                  (std/srfi/133#%vector-copy!
                   _new100552_
                   '0
                   _vec100548_
                   '0
                   _len100550_)
                  _new100552_)
                (let ((_new-vector100555_
                       (make-vector
                        (_compute-length100527_
                         _vectors100545_
                         '0
                         _callee100546_))))
                  (_concatenate!100528_ _vectors100545_ _new-vector100555_ '0)
                  _new-vector100555_))))))
  (define std/srfi/133#vector-append-subvectors
    (lambda _args100478_
      (letrec ((_gather-args100480_
                (lambda (_args100518_)
                  (let _loop100520_ ((_args100522_ _args100518_)
                                     (_vecs100523_ '())
                                     (_starts100524_ '())
                                     (_ends100525_ '()))
                    (if (null? _args100522_)
                        (values (reverse _vecs100523_)
                                (reverse _starts100524_)
                                (reverse _ends100525_))
                        (_loop100520_
                         (cdddr _args100522_)
                         (cons (car _args100522_) _vecs100523_)
                         (cons (cadr _args100522_) _starts100524_)
                         (cons (caddr _args100522_) _ends100525_))))))
               (_total-length100481_
                (lambda (_starts100506_ _ends100507_)
                  (let _loop100509_ ((_count100511_ '0)
                                     (_starts100512_ _starts100506_)
                                     (_ends100513_ _ends100507_))
                    (if (null? _starts100512_)
                        _count100511_
                        (let ((_start100515_ (car _starts100512_))
                              (_end100516_ (car _ends100513_)))
                          (_loop100509_
                           (+ _count100511_ (- _end100516_ _start100515_))
                           (cdr _starts100512_)
                           (cdr _ends100513_)))))))
               (_copy-each!100482_
                (lambda (_result100490_
                         _vecs100491_
                         _starts100492_
                         _ends100493_)
                  (let _loop100495_ ((_at100497_ '0)
                                     (_vecs100498_ _vecs100491_)
                                     (_starts100499_ _starts100492_)
                                     (_ends100500_ _ends100493_))
                    (if (null? _vecs100498_)
                        _result100490_
                        (let ((_vec100502_ (car _vecs100498_))
                              (_start100503_ (car _starts100499_))
                              (_end100504_ (car _ends100500_)))
                          (std/srfi/133#%vector-copy!
                           _result100490_
                           _at100497_
                           _vec100502_
                           _start100503_
                           _end100504_)
                          (_loop100495_
                           (+ _at100497_ (- _end100504_ _start100503_))
                           (cdr _vecs100498_)
                           (cdr _starts100499_)
                           (cdr _ends100500_))))))))
        (let ((_g285553_ (_gather-args100480_ _args100478_)))
          (begin
            (let ((_g285554_
                   (let ()
                     (declare (not safe))
                     (if (##values? _g285553_)
                         (##vector-length _g285553_)
                         1))))
              (if (not (let () (declare (not safe)) (##fx= _g285554_ 3)))
                  (error "Context expects 3 values" _g285554_)))
            (let ((_vecs100484_
                   (let () (declare (not safe)) (##vector-ref _g285553_ 0)))
                  (_starts100485_
                   (let () (declare (not safe)) (##vector-ref _g285553_ 1)))
                  (_ends100486_
                   (let () (declare (not safe)) (##vector-ref _g285553_ 2))))
              (letrec* ((_result100488_
                         (make-vector
                          (_total-length100481_ _starts100485_ _ends100486_))))
                (_copy-each!100482_
                 _result100488_
                 _vecs100484_
                 _starts100485_
                 _ends100486_))))))))
  (define std/srfi/133#vector-empty?
    (lambda (_vec100474_)
      (let ((_vec100476_
             (std/srfi/133#check-type
              vector?
              _vec100474_
              std/srfi/133#vector-empty?)))
        (zero? (vector-length _vec100476_)))))
  (define std/srfi/133#vector=
    (lambda (_elt=?100459_ . _vectors100460_)
      (let ((_elt=?100462_
             (std/srfi/133#check-type
              procedure?
              _elt=?100459_
              std/srfi/133#vector=)))
        (if (null? _vectors100460_)
            '#t
            (if (null? (cdr _vectors100460_))
                (begin
                  (std/srfi/133#check-type
                   vector?
                   (car _vectors100460_)
                   std/srfi/133#vector=)
                  '#t)
                (let _loop100464_ ((_vecs100466_ _vectors100460_))
                  (let ((_vec1100468_
                         (std/srfi/133#check-type
                          vector?
                          (car _vecs100466_)
                          std/srfi/133#vector=))
                        (_vec2+100469_ (cdr _vecs100466_)))
                    (let ((_$e100471_ (null? _vec2+100469_)))
                      (if _$e100471_
                          _$e100471_
                          (if (std/srfi/133#binary-vector=
                               _elt=?100462_
                               _vec1100468_
                               (car _vec2+100469_))
                              (_loop100464_ _vec2+100469_)
                              '#f))))))))))
  (define std/srfi/133#binary-vector=
    (lambda (_elt=?100448_ _vector-a100449_ _vector-b100450_)
      (let ((_length-a100452_ (vector-length _vector-a100449_))
            (_length-b100453_ (vector-length _vector-b100450_)))
        (if (= _length-a100452_ _length-b100453_)
            (let _loop100455_ ((_i100457_ '0))
              (if (= _i100457_ _length-a100452_)
                  '#t
                  (if (_elt=?100448_
                       (vector-ref _vector-a100449_ _i100457_)
                       (vector-ref _vector-b100450_ _i100457_))
                      (_loop100455_ (+ _i100457_ '1))
                      '#f)))
            '#f))))
  (define std/srfi/133#vector-fold
    (lambda (_kons100440_ _knil100441_ _vec100442_ . _vectors100443_)
      (let ((_kons100445_
             (std/srfi/133#check-type
              procedure?
              _kons100440_
              std/srfi/133#vector-fold))
            (_vec100446_
             (std/srfi/133#check-type
              vector?
              _vec100442_
              std/srfi/133#vector-fold)))
        (if (null? _vectors100443_)
            (std/srfi/133#%vector-fold1
             _kons100445_
             _knil100441_
             (vector-length _vec100446_)
             _vec100446_)
            (std/srfi/133#%vector-fold2+
             _kons100445_
             _knil100441_
             (std/srfi/133#%smallest-length
              _vectors100443_
              (vector-length _vec100446_)
              std/srfi/133#vector-fold)
             (cons _vec100446_ _vectors100443_))))))
  (define std/srfi/133#vector-fold-right
    (letrec ((_loop1100419_
              (lambda (_kons100422_ _knil100423_ _vec100424_ _i100425_)
                (if (negative? _i100425_)
                    _knil100423_
                    (_loop1100419_
                     _kons100422_
                     (_kons100422_
                      _knil100423_
                      (vector-ref _vec100424_ _i100425_))
                     _vec100424_
                     (- _i100425_ '1)))))
             (_loop2+100420_
              (lambda (_kons100427_ _knil100428_ _vectors100429_ _i100430_)
                (if (negative? _i100430_)
                    _knil100428_
                    (_loop2+100420_
                     _kons100427_
                     (apply _kons100427_
                            _knil100428_
                            (std/srfi/133#vectors-ref
                             _vectors100429_
                             _i100430_))
                     _vectors100429_
                     (- _i100430_ '1))))))
      (lambda (_kons100432_ _knil100433_ _vec100434_ . _vectors100435_)
        (let ((_kons100437_
               (std/srfi/133#check-type
                procedure?
                _kons100432_
                std/srfi/133#vector-fold-right))
              (_vec100438_
               (std/srfi/133#check-type
                vector?
                _vec100434_
                std/srfi/133#vector-fold-right)))
          (if (null? _vectors100435_)
              (_loop1100419_
               _kons100437_
               _knil100433_
               _vec100438_
               (- (vector-length _vec100438_) '1))
              (_loop2+100420_
               _kons100437_
               _knil100433_
               (cons _vec100438_ _vectors100435_)
               (- (std/srfi/133#%smallest-length
                   _vectors100435_
                   (vector-length _vec100438_)
                   std/srfi/133#vector-fold-right)
                  '1)))))))
  (define std/srfi/133#vector-map
    (lambda (_f100408_ _vec100409_ . _vectors100410_)
      (let ((_f100412_
             (std/srfi/133#check-type
              procedure?
              _f100408_
              std/srfi/133#vector-map))
            (_vec100413_
             (std/srfi/133#check-type
              vector?
              _vec100409_
              std/srfi/133#vector-map)))
        (if (null? _vectors100410_)
            (let ((_len100415_ (vector-length _vec100413_)))
              (std/srfi/133#%vector-map1!
               _f100412_
               (make-vector _len100415_)
               _vec100413_
               _len100415_))
            (let ((_len100417_
                   (std/srfi/133#%smallest-length
                    _vectors100410_
                    (vector-length _vec100413_)
                    std/srfi/133#vector-map)))
              (std/srfi/133#%vector-map2+!
               _f100412_
               (make-vector _len100417_)
               (cons _vec100413_ _vectors100410_)
               _len100417_))))))
  (define std/srfi/133#vector-map!
    (lambda (_f100401_ _vec100402_ . _vectors100403_)
      (let ((_f100405_
             (std/srfi/133#check-type
              procedure?
              _f100401_
              std/srfi/133#vector-map!))
            (_vec100406_
             (std/srfi/133#check-type
              vector?
              _vec100402_
              std/srfi/133#vector-map!)))
        (if (null? _vectors100403_)
            (std/srfi/133#%vector-map1!
             _f100405_
             _vec100406_
             _vec100406_
             (vector-length _vec100406_))
            (std/srfi/133#%vector-map2+!
             _f100405_
             _vec100406_
             (cons _vec100406_ _vectors100403_)
             (std/srfi/133#%smallest-length
              _vectors100403_
              (vector-length _vec100406_)
              std/srfi/133#vector-map!)))
        (std/srfi/133#unspecified-value))))
  (define std/srfi/133#vector-for-each
    (letrec ((_for-each1100381_
              (lambda (_f100384_ _vec100385_ _i100386_ _len100387_)
                (if (< _i100386_ _len100387_)
                    (begin
                      (_f100384_ (vector-ref _vec100385_ _i100386_))
                      (_for-each1100381_
                       _f100384_
                       _vec100385_
                       (+ _i100386_ '1)
                       _len100387_))
                    '#!void)))
             (_for-each2+100382_
              (lambda (_f100389_ _vecs100390_ _i100391_ _len100392_)
                (if (< _i100391_ _len100392_)
                    (begin
                      (apply _f100389_
                             (std/srfi/133#vectors-ref _vecs100390_ _i100391_))
                      (_for-each2+100382_
                       _f100389_
                       _vecs100390_
                       (+ _i100391_ '1)
                       _len100392_))
                    '#!void))))
      (lambda (_f100394_ _vec100395_ . _vectors100396_)
        (let ((_f100398_
               (std/srfi/133#check-type
                procedure?
                _f100394_
                std/srfi/133#vector-for-each))
              (_vec100399_
               (std/srfi/133#check-type
                vector?
                _vec100395_
                std/srfi/133#vector-for-each)))
          (if (null? _vectors100396_)
              (_for-each1100381_
               _f100398_
               _vec100399_
               '0
               (vector-length _vec100399_))
              (_for-each2+100382_
               _f100398_
               (cons _vec100399_ _vectors100396_)
               '0
               (std/srfi/133#%smallest-length
                _vectors100396_
                (vector-length _vec100399_)
                std/srfi/133#vector-for-each)))))))
  (define std/srfi/133#vector-count
    (lambda (_pred?100368_ _vec100369_ . _vectors100370_)
      (let ((_pred?100372_
             (std/srfi/133#check-type
              procedure?
              _pred?100368_
              std/srfi/133#vector-count))
            (_vec100373_
             (std/srfi/133#check-type
              vector?
              _vec100369_
              std/srfi/133#vector-count)))
        (if (null? _vectors100370_)
            (std/srfi/133#%vector-fold1
             (lambda (_count100375_ _elt100376_)
               (if (_pred?100372_ _elt100376_)
                   (+ _count100375_ '1)
                   _count100375_))
             '0
             (vector-length _vec100373_)
             _vec100373_)
            (std/srfi/133#%vector-fold2+
             (lambda (_count100378_ . _elts100379_)
               (if (apply _pred?100372_ _elts100379_)
                   (+ _count100378_ '1)
                   _count100378_))
             '0
             (std/srfi/133#%smallest-length
              _vectors100370_
              (vector-length _vec100373_)
              std/srfi/133#vector-count)
             (cons _vec100373_ _vectors100370_))))))
  (define std/srfi/133#vector-cumulate
    (lambda (_f100349_ _knil100350_ _vec100351_)
      (let* ((_len100353_ (vector-length _vec100351_))
             (_result100355_ (make-vector _len100353_)))
        (let _loop100358_ ((_i100360_ '0) (_left100361_ _knil100350_))
          (if (= _i100360_ _len100353_)
              _result100355_
              (let* ((_right100363_ (vector-ref _vec100351_ _i100360_))
                     (_r100365_ (_f100349_ _left100361_ _right100363_)))
                (vector-set! _result100355_ _i100360_ _r100365_)
                (_loop100358_ (+ _i100360_ '1) _r100365_)))))))
  (define std/srfi/133#vector-index
    (lambda (_pred?100345_ _vec100346_ . _vectors100347_)
      (std/srfi/133#vector-index/skip
       _pred?100345_
       _vec100346_
       _vectors100347_
       std/srfi/133#vector-index)))
  (define std/srfi/133#vector-skip
    (lambda (_pred?100339_ _vec100340_ . _vectors100341_)
      (std/srfi/133#vector-index/skip
       (lambda _elts100343_ (not (apply _pred?100339_ _elts100343_)))
       _vec100340_
       _vectors100341_
       std/srfi/133#vector-skip)))
  (define std/srfi/133#vector-index/skip
    (letrec ((_loop1100318_
              (lambda (_pred?100321_ _vec100322_ _len100323_ _i100324_)
                (if (= _i100324_ _len100323_)
                    '#f
                    (if (_pred?100321_ (vector-ref _vec100322_ _i100324_))
                        _i100324_
                        (_loop1100318_
                         _pred?100321_
                         _vec100322_
                         _len100323_
                         (+ _i100324_ '1))))))
             (_loop2+100319_
              (lambda (_pred?100326_ _vectors100327_ _len100328_ _i100329_)
                (if (= _i100329_ _len100328_)
                    '#f
                    (if (apply _pred?100326_
                               (std/srfi/133#vectors-ref
                                _vectors100327_
                                _i100329_))
                        _i100329_
                        (_loop2+100319_
                         _pred?100326_
                         _vectors100327_
                         _len100328_
                         (+ _i100329_ '1)))))))
      (lambda (_pred?100331_ _vec100332_ _vectors100333_ _callee100334_)
        (let ((_pred?100336_
               (std/srfi/133#check-type
                procedure?
                _pred?100331_
                _callee100334_))
              (_vec100337_
               (std/srfi/133#check-type vector? _vec100332_ _callee100334_)))
          (if (null? _vectors100333_)
              (_loop1100318_
               _pred?100336_
               _vec100337_
               (vector-length _vec100337_)
               '0)
              (_loop2+100319_
               _pred?100336_
               (cons _vec100337_ _vectors100333_)
               (std/srfi/133#%smallest-length
                _vectors100333_
                (vector-length _vec100337_)
                _callee100334_)
               '0))))))
  (define std/srfi/133#vector-index-right
    (lambda (_pred?100314_ _vec100315_ . _vectors100316_)
      (std/srfi/133#vector-index/skip-right
       _pred?100314_
       _vec100315_
       _vectors100316_
       std/srfi/133#vector-index-right)))
  (define std/srfi/133#vector-skip-right
    (lambda (_pred?100308_ _vec100309_ . _vectors100310_)
      (std/srfi/133#vector-index/skip-right
       (lambda _elts100312_ (not (apply _pred?100308_ _elts100312_)))
       _vec100309_
       _vectors100310_
       std/srfi/133#vector-index-right)))
  (define std/srfi/133#vector-index/skip-right
    (letrec ((_loop1100289_
              (lambda (_pred?100292_ _vec100293_ _i100294_)
                (if (negative? _i100294_)
                    '#f
                    (if (_pred?100292_ (vector-ref _vec100293_ _i100294_))
                        _i100294_
                        (_loop1100289_
                         _pred?100292_
                         _vec100293_
                         (- _i100294_ '1))))))
             (_loop2+100290_
              (lambda (_pred?100296_ _vectors100297_ _i100298_)
                (if (negative? _i100298_)
                    '#f
                    (if (apply _pred?100296_
                               (std/srfi/133#vectors-ref
                                _vectors100297_
                                _i100298_))
                        _i100298_
                        (_loop2+100290_
                         _pred?100296_
                         _vectors100297_
                         (- _i100298_ '1)))))))
      (lambda (_pred?100300_ _vec100301_ _vectors100302_ _callee100303_)
        (let ((_pred?100305_
               (std/srfi/133#check-type
                procedure?
                _pred?100300_
                _callee100303_))
              (_vec100306_
               (std/srfi/133#check-type vector? _vec100301_ _callee100303_)))
          (if (null? _vectors100302_)
              (_loop1100289_
               _pred?100305_
               _vec100306_
               (- (vector-length _vec100306_) '1))
              (_loop2+100290_
               _pred?100305_
               (cons _vec100306_ _vectors100302_)
               (- (std/srfi/133#%smallest-length
                   _vectors100302_
                   (vector-length _vec100306_)
                   _callee100303_)
                  '1)))))))
  (define std/srfi/133#vector-binary-search
    (lambda (_vec100264_ _value100265_ _cmp100266_ . _maybe-start+end100267_)
      (let* ((_cmp100269_
              (std/srfi/133#check-type
               procedure?
               _cmp100266_
               std/srfi/133#vector-binary-search))
             (_vec100271_
              (std/srfi/133#check-type
               vector?
               _vec100264_
               std/srfi/133#vector-binary-search))
             (_g285555_
              (std/srfi/133#vector-parse-start+end
               _vec100271_
               _maybe-start+end100267_
               'start
               'end
               std/srfi/133#vector-binary-search)))
        (begin
          (let ((_g285556_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g285555_) (##vector-length _g285555_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g285556_ 2)))
                (error "Context expects 2 values" _g285556_)))
          (let ((_start100273_
                 (let () (declare (not safe)) (##vector-ref _g285555_ 0)))
                (_end100274_
                 (let () (declare (not safe)) (##vector-ref _g285555_ 1))))
            (let _loop100276_ ((_start100278_ _start100273_)
                               (_end100279_ _end100274_)
                               (_j100280_ '#f))
              (let ((_i100282_ (quotient (+ _start100278_ _end100279_) '2)))
                (if (or (= _start100278_ _end100279_)
                        (and _j100280_ (= _i100282_ _j100280_)))
                    '#f
                    (let ((_comparison100287_
                           (std/srfi/133#check-type
                            integer?
                            (_cmp100269_
                             (vector-ref _vec100271_ _i100282_)
                             _value100265_)
                            (cons _cmp100269_
                                  (cons 'for
                                        (cons std/srfi/133#vector-binary-search
                                              '()))))))
                      (if (zero? _comparison100287_)
                          _i100282_
                          (if (positive? _comparison100287_)
                              (_loop100276_ _start100278_ _i100282_ _i100282_)
                              (_loop100276_
                               _i100282_
                               _end100279_
                               _i100282_))))))))))))
  (define std/srfi/133#vector-any
    (letrec ((_loop1100232_
              (lambda (_pred?100235_
                       _vec100236_
                       _i100237_
                       _len100238_
                       _len-1100239_)
                (if (not (= _i100237_ _len100238_))
                    (if (= _i100237_ _len-1100239_)
                        (_pred?100235_ (vector-ref _vec100236_ _i100237_))
                        (let ((_$e100241_
                               (_pred?100235_
                                (vector-ref _vec100236_ _i100237_))))
                          (if _$e100241_
                              _$e100241_
                              (_loop1100232_
                               _pred?100235_
                               _vec100236_
                               (+ _i100237_ '1)
                               _len100238_
                               _len-1100239_))))
                    '#f)))
             (_loop2+100233_
              (lambda (_pred?100244_
                       _vectors100245_
                       _i100246_
                       _len100247_
                       _len-1100248_)
                (if (not (= _i100246_ _len100247_))
                    (if (= _i100246_ _len-1100248_)
                        (apply _pred?100244_
                               (std/srfi/133#vectors-ref
                                _vectors100245_
                                _i100246_))
                        (let ((_$e100250_
                               (apply _pred?100244_
                                      (std/srfi/133#vectors-ref
                                       _vectors100245_
                                       _i100246_))))
                          (if _$e100250_
                              _$e100250_
                              (_loop2+100233_
                               _pred?100244_
                               _vectors100245_
                               (+ _i100246_ '1)
                               _len100247_
                               _len-1100248_))))
                    '#f))))
      (lambda (_pred?100253_ _vec100254_ . _vectors100255_)
        (let ((_pred?100257_
               (std/srfi/133#check-type
                procedure?
                _pred?100253_
                std/srfi/133#vector-any))
              (_vec100258_
               (std/srfi/133#check-type
                vector?
                _vec100254_
                std/srfi/133#vector-any)))
          (if (null? _vectors100255_)
              (let ((_len100260_ (vector-length _vec100258_)))
                (_loop1100232_
                 _pred?100257_
                 _vec100258_
                 '0
                 _len100260_
                 (- _len100260_ '1)))
              (let ((_len100262_
                     (std/srfi/133#%smallest-length
                      _vectors100255_
                      (vector-length _vec100258_)
                      std/srfi/133#vector-any)))
                (_loop2+100233_
                 _pred?100257_
                 (cons _vec100258_ _vectors100255_)
                 '0
                 _len100262_
                 (- _len100262_ '1))))))))
  (define std/srfi/133#vector-every
    (letrec ((_loop1100200_
              (lambda (_pred?100203_
                       _vec100204_
                       _i100205_
                       _len100206_
                       _len-1100207_)
                (let ((_$e100209_ (= _i100205_ _len100206_)))
                  (if _$e100209_
                      _$e100209_
                      (if (= _i100205_ _len-1100207_)
                          (_pred?100203_ (vector-ref _vec100204_ _i100205_))
                          (if (_pred?100203_
                               (vector-ref _vec100204_ _i100205_))
                              (_loop1100200_
                               _pred?100203_
                               _vec100204_
                               (+ _i100205_ '1)
                               _len100206_
                               _len-1100207_)
                              '#f))))))
             (_loop2+100201_
              (lambda (_pred?100212_
                       _vectors100213_
                       _i100214_
                       _len100215_
                       _len-1100216_)
                (let ((_$e100218_ (= _i100214_ _len100215_)))
                  (if _$e100218_
                      _$e100218_
                      (if (= _i100214_ _len-1100216_)
                          (apply _pred?100212_
                                 (std/srfi/133#vectors-ref
                                  _vectors100213_
                                  _i100214_))
                          (if (apply _pred?100212_
                                     (std/srfi/133#vectors-ref
                                      _vectors100213_
                                      _i100214_))
                              (_loop2+100201_
                               _pred?100212_
                               _vectors100213_
                               (+ _i100214_ '1)
                               _len100215_
                               _len-1100216_)
                              '#f)))))))
      (lambda (_pred?100221_ _vec100222_ . _vectors100223_)
        (let ((_pred?100225_
               (std/srfi/133#check-type
                procedure?
                _pred?100221_
                std/srfi/133#vector-every))
              (_vec100226_
               (std/srfi/133#check-type
                vector?
                _vec100222_
                std/srfi/133#vector-every)))
          (if (null? _vectors100223_)
              (let ((_len100228_ (vector-length _vec100226_)))
                (_loop1100200_
                 _pred?100225_
                 _vec100226_
                 '0
                 _len100228_
                 (- _len100228_ '1)))
              (let ((_len100230_
                     (std/srfi/133#%smallest-length
                      _vectors100223_
                      (vector-length _vec100226_)
                      std/srfi/133#vector-every)))
                (_loop2+100201_
                 _pred?100225_
                 (cons _vec100226_ _vectors100223_)
                 '0
                 _len100230_
                 (- _len100230_ '1))))))))
  (define std/srfi/133#vector-partition
    (lambda (_pred?100182_ _vec100183_)
      (let* ((_len100185_ (vector-length _vec100183_))
             (_cnt100187_
              (std/srfi/133#vector-count _pred?100182_ _vec100183_))
             (_result100189_ (make-vector _len100185_)))
        (let _loop100192_ ((_i100194_ '0)
                           (_yes100195_ '0)
                           (_no100196_ _cnt100187_))
          (if (= _i100194_ _len100185_)
              (values _result100189_ _cnt100187_)
              (let ((_elem100198_ (vector-ref _vec100183_ _i100194_)))
                (if (_pred?100182_ _elem100198_)
                    (begin
                      (vector-set! _result100189_ _yes100195_ _elem100198_)
                      (_loop100192_
                       (+ _i100194_ '1)
                       (+ _yes100195_ '1)
                       _no100196_))
                    (begin
                      (vector-set! _result100189_ _no100196_ _elem100198_)
                      (_loop100192_
                       (+ _i100194_ '1)
                       _yes100195_
                       (+ _no100196_ '1))))))))))
  (define std/srfi/133#vector-swap!
    (lambda (_vec100171_ _i100172_ _j100173_)
      (let ((_vec100175_
             (std/srfi/133#check-type
              vector?
              _vec100171_
              std/srfi/133#vector-swap!)))
        (let ((_i100177_
               (std/srfi/133#check-index
                _vec100175_
                _i100172_
                std/srfi/133#vector-swap!))
              (_j100178_
               (std/srfi/133#check-index
                _vec100175_
                _j100173_
                std/srfi/133#vector-swap!)))
          (let ((_x100180_ (vector-ref _vec100175_ _i100177_)))
            (vector-set!
             _vec100175_
             _i100177_
             (vector-ref _vec100175_ _j100178_))
            (vector-set! _vec100175_ _j100178_ _x100180_))))))
  (define std/srfi/133#vector-fill!
    (lambda (_vec100157_ _value100158_ . _maybe-start+end100159_)
      (let* ((_vec100161_
              (std/srfi/133#check-type
               vector?
               _vec100157_
               std/srfi/133#vector-fill!))
             (_g285557_
              (std/srfi/133#vector-parse-start+end
               _vec100161_
               _maybe-start+end100159_
               'start
               'end
               std/srfi/133#vector-fill!)))
        (begin
          (let ((_g285558_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g285557_) (##vector-length _g285557_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g285558_ 2)))
                (error "Context expects 2 values" _g285558_)))
          (let ((_start100163_
                 (let () (declare (not safe)) (##vector-ref _g285557_ 0)))
                (_end100164_
                 (let () (declare (not safe)) (##vector-ref _g285557_ 1))))
            (let _$loop100166_ ((_i100169_ _start100163_))
              (if (= _i100169_ _end100164_)
                  '#!void
                  (begin
                    (vector-set! _vec100161_ _i100169_ _value100158_)
                    (_$loop100166_ (+ _i100169_ '1))))))))))
  (define std/srfi/133#vector-copy!
    (lambda (_target100140_
             _tstart100141_
             _source100142_
             .
             _maybe-sstart+send100143_)
      (letrec ((_doit!100145_
                (lambda (_sstart100149_ _send100150_ _source-length100151_)
                  (let ((_tstart100153_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _tstart100141_
                          std/srfi/133#vector-copy!))
                        (_sstart100154_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _sstart100149_
                          std/srfi/133#vector-copy!))
                        (_send100155_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _send100150_
                          std/srfi/133#vector-copy!)))
                    (if (and (<= '0
                                 _sstart100154_
                                 _send100155_
                                 _source-length100151_)
                             (<= (+ _tstart100153_
                                    (- _send100155_ _sstart100154_))
                                 (vector-length _target100140_)))
                        (std/srfi/133#%vector-copy!
                         _target100140_
                         _tstart100153_
                         _source100142_
                         _sstart100154_
                         _send100155_)
                        (error '"illegal arguments"
                               (cons 'while
                                     (cons 'calling
                                           (cons std/srfi/133#vector-copy!
                                                 '())))
                               (cons 'target
                                     (cons 'was (cons _target100140_ '())))
                               (cons 'target-length
                                     (cons 'was
                                           (cons (vector-length _target100140_)
                                                 '())))
                               (cons 'tstart
                                     (cons 'was (cons _tstart100153_ '())))
                               (cons 'source
                                     (cons 'was (cons _source100142_ '())))
                               (cons 'source-length
                                     (cons 'was
                                           (cons _source-length100151_ '())))
                               (cons 'sstart
                                     (cons 'was (cons _sstart100154_ '())))
                               (cons 'send
                                     (cons 'was (cons _send100155_ '())))))))))
        (let ((_n100147_ (vector-length _source100142_)))
          (if (null? _maybe-sstart+send100143_)
              (_doit!100145_ '0 _n100147_ _n100147_)
              (if (null? (cdr _maybe-sstart+send100143_))
                  (_doit!100145_
                   (car _maybe-sstart+send100143_)
                   _n100147_
                   _n100147_)
                  (if (null? (cddr _maybe-sstart+send100143_))
                      (_doit!100145_
                       (car _maybe-sstart+send100143_)
                       (cadr _maybe-sstart+send100143_)
                       _n100147_)
                      (error '"too many arguments"
                             std/srfi/133#vector-copy!
                             (cddr _maybe-sstart+send100143_)))))))))
  (define std/srfi/133#vector-reverse-copy!
    (lambda (_target100120_
             _tstart100121_
             _source100122_
             .
             _maybe-sstart+send100123_)
      (letrec ((_doit!100125_
                (lambda (_sstart100129_ _send100130_ _source-length100131_)
                  (let ((_tstart100133_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _tstart100121_
                          std/srfi/133#vector-reverse-copy!))
                        (_sstart100134_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _sstart100129_
                          std/srfi/133#vector-reverse-copy!))
                        (_send100135_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _send100130_
                          std/srfi/133#vector-reverse-copy!)))
                    (if (and (eq? _target100120_ _source100122_)
                             (or (std/srfi/133#between?
                                  _sstart100134_
                                  _tstart100133_
                                  _send100135_)
                                 (std/srfi/133#between?
                                  _tstart100133_
                                  _sstart100134_
                                  (+ _tstart100133_
                                     (- _send100135_ _sstart100134_)))))
                        (error '"vector range for self-copying overlaps"
                               std/srfi/133#vector-reverse-copy!
                               (cons 'vector
                                     (cons 'was (cons _target100120_ '())))
                               (cons 'tstart
                                     (cons 'was (cons _tstart100133_ '())))
                               (cons 'sstart
                                     (cons 'was (cons _sstart100134_ '())))
                               (cons 'send
                                     (cons 'was (cons _send100135_ '()))))
                        (if (and (<= '0
                                     _sstart100134_
                                     _send100135_
                                     _source-length100131_)
                                 (<= (+ _tstart100133_
                                        (- _send100135_ _sstart100134_))
                                     (vector-length _target100120_)))
                            (std/srfi/133#%vector-reverse-copy!
                             _target100120_
                             _tstart100133_
                             _source100122_
                             _sstart100134_
                             _send100135_)
                            (error '"illegal arguments"
                                   (cons 'while
                                         (cons 'calling
                                               (cons std/srfi/133#vector-reverse-copy!
                                                     '())))
                                   (cons 'target
                                         (cons 'was (cons _target100120_ '())))
                                   (cons 'target-length
                                         (cons 'was
                                               (cons (vector-length
                                                      _target100120_)
                                                     '())))
                                   (cons 'tstart
                                         (cons 'was (cons _tstart100133_ '())))
                                   (cons 'source
                                         (cons 'was (cons _source100122_ '())))
                                   (cons 'source-length
                                         (cons 'was
                                               (cons _source-length100131_
                                                     '())))
                                   (cons 'sstart
                                         (cons 'was (cons _sstart100134_ '())))
                                   (cons 'send
                                         (cons 'was
                                               (cons _send100135_ '()))))))))))
        (let ((_n100127_ (vector-length _source100122_)))
          (if (null? _maybe-sstart+send100123_)
              (_doit!100125_ '0 _n100127_ _n100127_)
              (if (null? (cdr _maybe-sstart+send100123_))
                  (_doit!100125_
                   (car _maybe-sstart+send100123_)
                   _n100127_
                   _n100127_)
                  (if (null? (cddr _maybe-sstart+send100123_))
                      (_doit!100125_
                       (car _maybe-sstart+send100123_)
                       (cadr _maybe-sstart+send100123_)
                       _n100127_)
                      (error '"too many arguments"
                             std/srfi/133#vector-reverse-copy!
                             (cddr _maybe-sstart+send100123_)))))))))
  (define std/srfi/133#vector-reverse!
    (lambda (_vec100112_ . _start+end100113_)
      (let* ((_vec100115_
              (std/srfi/133#check-type
               vector?
               _vec100112_
               std/srfi/133#vector-reverse!))
             (_g285559_
              (std/srfi/133#vector-parse-start+end
               _vec100115_
               _start+end100113_
               'start
               'end
               std/srfi/133#vector-reverse!)))
        (begin
          (let ((_g285560_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g285559_) (##vector-length _g285559_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g285560_ 2)))
                (error "Context expects 2 values" _g285560_)))
          (let ((_start100117_
                 (let () (declare (not safe)) (##vector-ref _g285559_ 0)))
                (_end100118_
                 (let () (declare (not safe)) (##vector-ref _g285559_ 1))))
            (std/srfi/133#%vector-reverse!
             _vec100115_
             _start100117_
             _end100118_))))))
  (define std/srfi/133#vector->list
    (lambda (_vec100098_ . _maybe-start+end100099_)
      (let* ((_vec100101_
              (std/srfi/133#check-type
               vector?
               _vec100098_
               std/srfi/133#vector->list))
             (_g285561_
              (std/srfi/133#vector-parse-start+end
               _vec100101_
               _maybe-start+end100099_
               'start
               'end
               std/srfi/133#vector->list)))
        (begin
          (let ((_g285562_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g285561_) (##vector-length _g285561_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g285562_ 2)))
                (error "Context expects 2 values" _g285562_)))
          (let ((_start100103_
                 (let () (declare (not safe)) (##vector-ref _g285561_ 0)))
                (_end100104_
                 (let () (declare (not safe)) (##vector-ref _g285561_ 1))))
            (let _$loop100106_ ((_i100109_ (- _end100104_ '1))
                                (_result100110_ '()))
              (if (< _i100109_ _start100103_)
                  _result100110_
                  (_$loop100106_
                   (- _i100109_ '1)
                   (cons (vector-ref _vec100101_ _i100109_)
                         _result100110_)))))))))
  (define std/srfi/133#reverse-vector->list
    (lambda (_vec100084_ . _maybe-start+end100085_)
      (let* ((_vec100087_
              (std/srfi/133#check-type
               vector?
               _vec100084_
               std/srfi/133#reverse-vector->list))
             (_g285563_
              (std/srfi/133#vector-parse-start+end
               _vec100087_
               _maybe-start+end100085_
               'start
               'end
               std/srfi/133#reverse-vector->list)))
        (begin
          (let ((_g285564_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g285563_) (##vector-length _g285563_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g285564_ 2)))
                (error "Context expects 2 values" _g285564_)))
          (let ((_start100089_
                 (let () (declare (not safe)) (##vector-ref _g285563_ 0)))
                (_end100090_
                 (let () (declare (not safe)) (##vector-ref _g285563_ 1))))
            (let _$loop100092_ ((_i100095_ _start100089_) (_result100096_ '()))
              (if (= _i100095_ _end100090_)
                  _result100096_
                  (_$loop100092_
                   (+ _i100095_ '1)
                   (cons (vector-ref _vec100087_ _i100095_)
                         _result100096_)))))))))
  (define std/srfi/133#list->vector
    (lambda (_lst100040_ . _maybe-start+end100041_)
      (if (null? _maybe-start+end100041_)
          (let* ((_start100043_ '0) (_end100045_ (length _lst100040_)))
            (let ((_start100048_
                   (std/srfi/133#check-type
                    std/srfi/133#nonneg-int?
                    _start100043_
                    std/srfi/133#list->vector))
                  (_end100049_
                   (std/srfi/133#check-type
                    std/srfi/133#nonneg-int?
                    _end100045_
                    std/srfi/133#list->vector)))
              ((lambda (_f100051_)
                 (std/srfi/133#vector-unfold
                  _f100051_
                  (- _end100049_ _start100048_)
                  (list-tail _lst100040_ _start100048_)))
               (lambda (_index100053_ _l100054_)
                 (if (null? _l100054_)
                     (error '"list was too short"
                            (cons 'list (cons 'was (cons _lst100040_ '())))
                            (cons 'attempted
                                  (cons 'end
                                        (cons 'was (cons _end100049_ '()))))
                            (cons 'while
                                  (cons 'calling
                                        (cons std/srfi/133#list->vector '()))))
                     (if (pair? _l100054_)
                         (values (car _l100054_) (cdr _l100054_))
                         (error '"erroneous value"
                                (list list? _lst100040_)
                                (cons 'while
                                      (cons 'calling
                                            (cons std/srfi/133#list->vector
                                                  '()))))))))))
          (let ((_start100056_ (car _maybe-start+end100041_))
                (_new-args100057_ (cdr _maybe-start+end100041_)))
            (if (null? _new-args100057_)
                (let ((_end100060_ (length _lst100040_)))
                  (let ((_start100063_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _start100056_
                          std/srfi/133#list->vector))
                        (_end100064_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _end100060_
                          std/srfi/133#list->vector)))
                    ((lambda (_f100066_)
                       (std/srfi/133#vector-unfold
                        _f100066_
                        (- _end100064_ _start100063_)
                        (list-tail _lst100040_ _start100063_)))
                     (lambda (_index100068_ _l100069_)
                       (if (null? _l100069_)
                           (error '"list was too short"
                                  (cons 'list
                                        (cons 'was (cons _lst100040_ '())))
                                  (cons 'attempted
                                        (cons 'end
                                              (cons 'was
                                                    (cons _end100064_ '()))))
                                  (cons 'while
                                        (cons 'calling
                                              (cons std/srfi/133#list->vector
                                                    '()))))
                           (if (pair? _l100069_)
                               (values (car _l100069_) (cdr _l100069_))
                               (error '"erroneous value"
                                      (list list? _lst100040_)
                                      (cons 'while
                                            (cons 'calling
                                                  (cons std/srfi/133#list->vector
                                                        '()))))))))))
                (let ((_end100071_ (car _new-args100057_))
                      (_new-args100072_ (cdr _new-args100057_)))
                  (if (null? _new-args100072_)
                      (let ()
                        (let ((_start100076_
                               (std/srfi/133#check-type
                                std/srfi/133#nonneg-int?
                                _start100056_
                                std/srfi/133#list->vector))
                              (_end100077_
                               (std/srfi/133#check-type
                                std/srfi/133#nonneg-int?
                                _end100071_
                                std/srfi/133#list->vector)))
                          ((lambda (_f100079_)
                             (std/srfi/133#vector-unfold
                              _f100079_
                              (- _end100077_ _start100076_)
                              (list-tail _lst100040_ _start100076_)))
                           (lambda (_index100081_ _l100082_)
                             (if (null? _l100082_)
                                 (error '"list was too short"
                                        (cons 'list
                                              (cons 'was
                                                    (cons _lst100040_ '())))
                                        (cons 'attempted
                                              (cons 'end
                                                    (cons 'was
                                                          (cons _end100077_
                                                                '()))))
                                        (cons 'while
                                              (cons 'calling
                                                    (cons std/srfi/133#list->vector
                                                          '()))))
                                 (if (pair? _l100082_)
                                     (values (car _l100082_) (cdr _l100082_))
                                     (error '"erroneous value"
                                            (list list? _lst100040_)
                                            (cons 'while
                                                  (cons 'calling
                                                        (cons std/srfi/133#list->vector
                                                              '()))))))))))
                      (error '"too many arguments"
                             (length _maybe-start+end100041_)
                             _maybe-start+end100041_))))))))
  (define std/srfi/133#reverse-list->vector
    (lambda (_lst99996_ . _maybe-start+end99997_)
      (if (null? _maybe-start+end99997_)
          (let* ((_start99999_ '0) (_end100001_ (length _lst99996_)))
            (let ((_start100004_
                   (std/srfi/133#check-type
                    std/srfi/133#nonneg-int?
                    _start99999_
                    std/srfi/133#reverse-list->vector))
                  (_end100005_
                   (std/srfi/133#check-type
                    std/srfi/133#nonneg-int?
                    _end100001_
                    std/srfi/133#reverse-list->vector)))
              ((lambda (_f100007_)
                 (std/srfi/133#vector-unfold-right
                  _f100007_
                  (- _end100005_ _start100004_)
                  (list-tail _lst99996_ _start100004_)))
               (lambda (_index100009_ _l100010_)
                 (if (null? _l100010_)
                     (error '"list too short"
                            (cons 'list (cons 'was (cons _lst99996_ '())))
                            (cons 'attempted
                                  (cons 'end
                                        (cons 'was (cons _end100005_ '()))))
                            (cons 'while
                                  (cons 'calling
                                        (cons std/srfi/133#reverse-list->vector
                                              '()))))
                     (if (pair? _l100010_)
                         (values (car _l100010_) (cdr _l100010_))
                         (error '"erroneous value"
                                (list list? _lst99996_)
                                (cons 'while
                                      (cons 'calling
                                            (cons std/srfi/133#reverse-list->vector
                                                  '()))))))))))
          (let ((_start100012_ (car _maybe-start+end99997_))
                (_new-args100013_ (cdr _maybe-start+end99997_)))
            (if (null? _new-args100013_)
                (let ((_end100016_ (length _lst99996_)))
                  (let ((_start100019_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _start100012_
                          std/srfi/133#reverse-list->vector))
                        (_end100020_
                         (std/srfi/133#check-type
                          std/srfi/133#nonneg-int?
                          _end100016_
                          std/srfi/133#reverse-list->vector)))
                    ((lambda (_f100022_)
                       (std/srfi/133#vector-unfold-right
                        _f100022_
                        (- _end100020_ _start100019_)
                        (list-tail _lst99996_ _start100019_)))
                     (lambda (_index100024_ _l100025_)
                       (if (null? _l100025_)
                           (error '"list too short"
                                  (cons 'list
                                        (cons 'was (cons _lst99996_ '())))
                                  (cons 'attempted
                                        (cons 'end
                                              (cons 'was
                                                    (cons _end100020_ '()))))
                                  (cons 'while
                                        (cons 'calling
                                              (cons std/srfi/133#reverse-list->vector
                                                    '()))))
                           (if (pair? _l100025_)
                               (values (car _l100025_) (cdr _l100025_))
                               (error '"erroneous value"
                                      (list list? _lst99996_)
                                      (cons 'while
                                            (cons 'calling
                                                  (cons std/srfi/133#reverse-list->vector
                                                        '()))))))))))
                (let ((_end100027_ (car _new-args100013_))
                      (_new-args100028_ (cdr _new-args100013_)))
                  (if (null? _new-args100028_)
                      (let ()
                        (let ((_start100032_
                               (std/srfi/133#check-type
                                std/srfi/133#nonneg-int?
                                _start100012_
                                std/srfi/133#reverse-list->vector))
                              (_end100033_
                               (std/srfi/133#check-type
                                std/srfi/133#nonneg-int?
                                _end100027_
                                std/srfi/133#reverse-list->vector)))
                          ((lambda (_f100035_)
                             (std/srfi/133#vector-unfold-right
                              _f100035_
                              (- _end100033_ _start100032_)
                              (list-tail _lst99996_ _start100032_)))
                           (lambda (_index100037_ _l100038_)
                             (if (null? _l100038_)
                                 (error '"list too short"
                                        (cons 'list
                                              (cons 'was
                                                    (cons _lst99996_ '())))
                                        (cons 'attempted
                                              (cons 'end
                                                    (cons 'was
                                                          (cons _end100033_
                                                                '()))))
                                        (cons 'while
                                              (cons 'calling
                                                    (cons std/srfi/133#reverse-list->vector
                                                          '()))))
                                 (if (pair? _l100038_)
                                     (values (car _l100038_) (cdr _l100038_))
                                     (error '"erroneous value"
                                            (list list? _lst99996_)
                                            (cons 'while
                                                  (cons 'calling
                                                        (cons std/srfi/133#reverse-list->vector
                                                              '()))))))))))
                      (error '"too many arguments"
                             (length _maybe-start+end99997_)
                             _maybe-start+end99997_))))))))
  (define std/srfi/133#vector->string
    (lambda (_vec99977_ . _maybe-start+end99978_)
      (let* ((_len99980_ (vector-length _vec99977_))
             (_start99982_
              (if (null? _maybe-start+end99978_)
                  '0
                  (car _maybe-start+end99978_)))
             (_end99984_
              (if (null? _maybe-start+end99978_)
                  _len99980_
                  (if (null? (cdr _maybe-start+end99978_))
                      _len99980_
                      (cadr _maybe-start+end99978_))))
             (_size99986_ (- _end99984_ _start99982_)))
        (letrec* ((_result99989_ (make-string _size99986_)))
          (let _loop99991_ ((_at99993_ '0) (_i99994_ _start99982_))
            (if (= _i99994_ _end99984_)
                _result99989_
                (begin
                  (string-set!
                   _result99989_
                   _at99993_
                   (vector-ref _vec99977_ _i99994_))
                  (_loop99991_ (+ _at99993_ '1) (+ _i99994_ '1)))))))))
  (define std/srfi/133#string->vector
    (lambda (_str99958_ . _maybe-start+end99959_)
      (let* ((_len99961_ (string-length _str99958_))
             (_start99963_
              (if (null? _maybe-start+end99959_)
                  '0
                  (car _maybe-start+end99959_)))
             (_end99965_
              (if (null? _maybe-start+end99959_)
                  _len99961_
                  (if (null? (cdr _maybe-start+end99959_))
                      _len99961_
                      (cadr _maybe-start+end99959_))))
             (_size99967_ (- _end99965_ _start99963_)))
        (letrec* ((_result99970_ (make-vector _size99967_)))
          (let _loop99972_ ((_at99974_ '0) (_i99975_ _start99963_))
            (if (= _i99975_ _end99965_)
                _result99970_
                (begin
                  (vector-set!
                   _result99970_
                   _at99974_
                   (string-ref _str99958_ _i99975_))
                  (_loop99972_ (+ _at99974_ '1) (+ _i99975_ '1))))))))))
