(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/text/zlib#compress__%
    (lambda (_data170199_ _level170200_)
      (if (u8vector? _data170199_)
          (std/text/zlib#compress-bytes _data170199_ _level170200_)
          (if (string? _data170199_)
              (std/text/zlib#compress-bytes
               (std/text/utf8#string->utf8__0 _data170199_)
               _level170200_)
              (if (input-port? _data170199_)
                  (std/text/zlib#compress-port _data170199_ _level170200_)
                  (error '"Bad input source" _data170199_))))))
  (define std/text/zlib#compress__0
    (lambda (_data170205_)
      (let ((_level170207_ std/text/_zlib#Z_DEFAULT_COMPRESSION))
        (std/text/zlib#compress__% _data170205_ _level170207_))))
  (define std/text/zlib#compress
    (lambda _g286201_
      (let ((_g286200_ (let () (declare (not safe)) (##length _g286201_))))
        (cond ((let () (declare (not safe)) (##fx= _g286200_ 1))
               (apply std/text/zlib#compress__0 _g286201_))
              ((let () (declare (not safe)) (##fx= _g286200_ 2))
               (apply std/text/zlib#compress__% _g286201_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/zlib#compress
                _g286201_))))))
  (define std/text/zlib#compress-bytes
    (lambda (_data170190_ _level170191_)
      (let* ((_buf170193_
              (make-u8vector
               (std/text/_zlib#compressBound (u8vector-length _data170190_))))
             (_res170195_
              (std/text/_zlib#compress2
               _buf170193_
               _data170190_
               _level170191_)))
        (if (let () (declare (not safe)) (##fxnegative? _res170195_))
            (std/error#raise-io-error 'compress '"zlib error" _res170195_)
            (begin (u8vector-shrink! _buf170193_ _res170195_) _buf170193_)))))
  (define std/text/zlib#compress-port
    (lambda (_inp170187_ _level170188_)
      (std/text/zlib#deflate-port
       _inp170187_
       _level170188_
       std/text/_zlib#deflateInit)))
  (define std/text/zlib#compress-gz__%
    (lambda (_data170174_ _level170175_)
      (if (u8vector? _data170174_)
          (std/text/zlib#compress-gz-bytes _data170174_ _level170175_)
          (if (string? _data170174_)
              (std/text/zlib#compress-gz-bytes
               (std/text/utf8#string->utf8__0 _data170174_)
               _level170175_)
              (if (input-port? _data170174_)
                  (std/text/zlib#compress-gz-port _data170174_ _level170175_)
                  (error '"Bad input source" _data170174_))))))
  (define std/text/zlib#compress-gz__0
    (lambda (_data170180_)
      (let ((_level170182_ std/text/_zlib#Z_DEFAULT_COMPRESSION))
        (std/text/zlib#compress-gz__% _data170180_ _level170182_))))
  (define std/text/zlib#compress-gz
    (lambda _g286203_
      (let ((_g286202_ (let () (declare (not safe)) (##length _g286203_))))
        (cond ((let () (declare (not safe)) (##fx= _g286202_ 1))
               (apply std/text/zlib#compress-gz__0 _g286203_))
              ((let () (declare (not safe)) (##fx= _g286202_ 2))
               (apply std/text/zlib#compress-gz__% _g286203_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/zlib#compress-gz
                _g286203_))))))
  (define std/text/zlib#compress-gz-bytes
    (lambda (_data170162_ _level170163_)
      (let* ((_zs170165_ (std/text/_zlib#make_z_stream))
             (_res170167_
              (std/text/_zlib#deflateInit_gz _zs170165_ _level170163_)))
        (if (eq? _res170167_ std/text/_zlib#Z_OK)
            '#!void
            (std/error#raise-io-error
             'compress
             '"zlib stream initialization error"
             _res170167_))
        (with-unwind-protect
         (lambda () (std/text/zlib#compress-gz-data _zs170165_ _data170162_))
         (lambda () (std/text/_zlib#deflateEnd _zs170165_))))))
  (define std/text/zlib#compress-gz-data
    (lambda (_zs170154_ _data170155_)
      (let* ((_buf170157_
              (make-u8vector
               (std/text/_zlib#deflateBound
                _zs170154_
                (u8vector-length _data170155_))))
             (_res170159_
              (std/text/_zlib#deflate
               _zs170154_
               _buf170157_
               _data170155_
               '0
               std/text/_zlib#Z_FINISH)))
        (if (eq? _res170159_ std/text/_zlib#Z_STREAM_END)
            '#!void
            (std/error#raise-io-error
             'compress-gz
             '"incomplete deflate"
             (std/text/_zlib#z_stream_msg _zs170154_)
             _res170159_))
        (u8vector-shrink!
         _buf170157_
         (std/text/_zlib#z_stream_total_out _zs170154_))
        _buf170157_)))
  (define std/text/zlib#compress-gz-port
    (lambda (_inp170151_ _level170152_)
      (std/text/zlib#deflate-port
       _inp170151_
       _level170152_
       std/text/_zlib#deflateInit_gz)))
  (define std/text/zlib#deflate-port
    (lambda (_inp170139_ _level170140_ _init-e170141_)
      (let* ((_zs170143_ (std/text/_zlib#make_z_stream))
             (_res170145_ (_init-e170141_ _zs170143_ _level170140_)))
        (if (eq? _res170145_ std/text/_zlib#Z_OK)
            '#!void
            (std/error#raise-io-error
             'compress
             '"zlib stream initialization error"
             _res170145_))
        (with-unwind-protect
         (lambda () (std/text/zlib#do-deflate-port _zs170143_ _inp170139_))
         (lambda () (std/text/_zlib#deflateEnd _zs170143_))))))
  (define std/text/zlib#do-deflate-port
    (lambda (_zs170097_ _inp170098_)
      (letrec* ((_buflen170100_ '1024)
                (_fini170101_
                 (lambda (_r170137_)
                   (u8vector-concatenate (reverse _r170137_))))
                (_deflate-next170102_
                 (lambda (_ibuf170114_ _r170115_ _flush170116_)
                   (let _lp170118_ ((_obuf170120_
                                     (make-u8vector _buflen170100_))
                                    (_start170121_ '0)
                                    (_r170122_ _r170115_))
                     (let* ((_icount170124_
                             (std/text/_zlib#z_stream_total_in _zs170097_))
                            (_ocount170126_
                             (std/text/_zlib#z_stream_total_out _zs170097_))
                            (_res170128_
                             (std/text/_zlib#deflate
                              _zs170097_
                              _obuf170120_
                              _ibuf170114_
                              _start170121_
                              _flush170116_))
                            (_ocount170130_
                             (let ((__tmp286204
                                    (std/text/_zlib#z_stream_total_out
                                     _zs170097_)))
                               (declare (not safe))
                               (##fx- __tmp286204 _ocount170126_))))
                       (if (eq? _res170128_ std/text/_zlib#Z_OK)
                           (let ((_acount170133_
                                  (std/text/_zlib#z_stream_avail_out
                                   _zs170097_)))
                             (if (let ()
                                   (declare (not safe))
                                   (##fxzero? _acount170133_))
                                 (let ((_icount170135_
                                        (let ((__tmp286205
                                               (std/text/_zlib#z_stream_total_in
                                                _zs170097_)))
                                          (declare (not safe))
                                          (##fx- __tmp286205 _icount170124_))))
                                   (u8vector-shrink!
                                    _obuf170120_
                                    _ocount170130_)
                                   (_lp170118_
                                    (make-u8vector _buflen170100_)
                                    (let ()
                                      (declare (not safe))
                                      (##fx+ _start170121_ _icount170135_))
                                    (cons _obuf170120_ _r170122_)))
                                 (if (let ()
                                       (declare (not safe))
                                       (##fx> _ocount170130_ '0))
                                     (begin
                                       (u8vector-shrink!
                                        _obuf170120_
                                        _ocount170130_)
                                       (cons _obuf170120_ _r170122_))
                                     _r170122_)))
                           (if (eq? _res170128_ std/text/_zlib#Z_STREAM_END)
                               (if (let ()
                                     (declare (not safe))
                                     (##fx> _ocount170130_ '0))
                                   (begin
                                     (u8vector-shrink!
                                      _obuf170120_
                                      _ocount170130_)
                                     (cons _obuf170120_ _r170122_))
                                   _r170122_)
                               (std/error#raise-io-error
                                'deflate-port
                                '"deflate: zlib error"
                                (std/text/_zlib#z_stream_msg _zs170097_)
                                _res170128_))))))))
        (let ((_ibuf170104_ (make-u8vector _buflen170100_)))
          (let _lp170106_ ((_r170108_ '()))
            (let ((_rd170110_
                   (read-subu8vector
                    _ibuf170104_
                    '0
                    _buflen170100_
                    _inp170098_)))
              (if (let () (declare (not safe)) (##fxzero? _rd170110_))
                  (_fini170101_
                   (_deflate-next170102_
                    '#f
                    _r170108_
                    std/text/_zlib#Z_FINISH))
                  (if (let ()
                        (declare (not safe))
                        (##fx< _rd170110_ _buflen170100_))
                      (begin
                        (u8vector-shrink! _ibuf170104_ _rd170110_)
                        (_fini170101_
                         (_deflate-next170102_
                          _ibuf170104_
                          _r170108_
                          std/text/_zlib#Z_FINISH)))
                      (let ((_r170112_
                             (_deflate-next170102_
                              _ibuf170104_
                              _r170108_
                              std/text/_zlib#Z_NO_FLUSH)))
                        (_lp170106_ _r170112_))))))))))
  (define std/text/zlib#uncompress
    (lambda (_data170095_)
      (if (u8vector? _data170095_)
          (std/text/zlib#uncompress-bytes _data170095_)
          (if (input-port? _data170095_)
              (std/text/zlib#uncompress-port _data170095_)
              (error '"Bad input source" _data170095_)))))
  (define std/text/zlib#uncompress-bytes
    (lambda (_data170093_)
      (std/text/zlib#do-inflate _data170093_ std/text/zlib#uncompress-data)))
  (define std/text/zlib#do-inflate
    (lambda (_data170082_ _inflate-e170083_)
      (let* ((_zs170085_ (std/text/_zlib#make_z_stream))
             (_res170087_ (std/text/_zlib#inflateInit _zs170085_)))
        (if (eq? _res170087_ std/text/_zlib#Z_OK)
            '#!void
            (std/error#raise-io-error
             'uncompress
             '"zlib stream initialization error"
             _res170087_))
        (with-unwind-protect
         (lambda () (_inflate-e170083_ _zs170085_ _data170082_))
         (lambda () (std/text/_zlib#inflateEnd _zs170085_))))))
  (define std/text/zlib#uncompress-data
    (lambda (_zs170059_ _data170060_)
      (letrec* ((_buflen170062_ '1024))
        (let _lp170064_ ((_start170066_ '0) (_r170067_ '()))
          (let* ((_buf170069_ (make-u8vector _buflen170062_))
                 (_icount170071_ (std/text/_zlib#z_stream_total_in _zs170059_))
                 (_ocount170073_
                  (std/text/_zlib#z_stream_total_out _zs170059_))
                 (_res170075_
                  (std/text/_zlib#inflate
                   _zs170059_
                   _buf170069_
                   _data170060_
                   _start170066_))
                 (_ocount170077_
                  (let ((__tmp286206
                         (std/text/_zlib#z_stream_total_out _zs170059_)))
                    (declare (not safe))
                    (##fx- __tmp286206 _ocount170073_))))
            (if (eq? _res170075_ std/text/_zlib#Z_OK)
                (let ((_icount170080_
                       (let ((__tmp286207
                              (std/text/_zlib#z_stream_total_in _zs170059_)))
                         (declare (not safe))
                         (##fx- __tmp286207 _icount170071_))))
                  (u8vector-shrink! _buf170069_ _ocount170077_)
                  (_lp170064_
                   (let ()
                     (declare (not safe))
                     (##fx+ _start170066_ _icount170080_))
                   (cons _buf170069_ _r170067_)))
                (if (eq? _res170075_ std/text/_zlib#Z_STREAM_END)
                    (begin
                      (u8vector-shrink! _buf170069_ _ocount170077_)
                      (u8vector-concatenate
                       (reverse (cons _buf170069_ _r170067_))))
                    (std/error#raise-io-error
                     'uncompress
                     '"zlib error"
                     (std/text/_zlib#z_stream_msg _zs170059_)
                     _res170075_))))))))
  (define std/text/zlib#uncompress-port
    (lambda (_inp170057_)
      (std/text/zlib#do-inflate _inp170057_ std/text/zlib#do-inflate-port)))
  (define std/text/zlib#do-inflate-port
    (lambda (_zs170017_ _inp170018_)
      (letrec* ((_buflen170020_ '1024)
                (_fini170021_
                 (lambda (_r170055_)
                   (u8vector-concatenate (reverse _r170055_))))
                (_inflate-next170022_
                 (lambda (_ibuf170032_ _r170033_)
                   (let _lp170035_ ((_obuf170037_
                                     (make-u8vector _buflen170020_))
                                    (_start170038_ '0)
                                    (_r170039_ _r170033_))
                     (let* ((_icount170041_
                             (std/text/_zlib#z_stream_total_in _zs170017_))
                            (_ocount170043_
                             (std/text/_zlib#z_stream_total_out _zs170017_))
                            (_res170045_
                             (std/text/_zlib#inflate
                              _zs170017_
                              _obuf170037_
                              _ibuf170032_
                              _start170038_))
                            (_ocount170047_
                             (let ((__tmp286208
                                    (std/text/_zlib#z_stream_total_out
                                     _zs170017_)))
                               (declare (not safe))
                               (##fx- __tmp286208 _ocount170043_))))
                       (if (eq? _res170045_ std/text/_zlib#Z_OK)
                           (let* ((_icount170050_
                                   (let ((__tmp286209
                                          (std/text/_zlib#z_stream_total_in
                                           _zs170017_)))
                                     (declare (not safe))
                                     (##fx- __tmp286209 _icount170041_)))
                                  (_start170052_
                                   (let ()
                                     (declare (not safe))
                                     (##fx+ _start170038_ _icount170050_))))
                             (u8vector-shrink! _obuf170037_ _ocount170047_)
                             (if (let ()
                                   (declare (not safe))
                                   (##fx< _start170052_ _buflen170020_))
                                 (_lp170035_
                                  (make-u8vector _buflen170020_)
                                  _start170052_
                                  (cons _obuf170037_ _r170039_))
                                 (cons _obuf170037_ _r170039_)))
                           (if (eq? _res170045_ std/text/_zlib#Z_STREAM_END)
                               (begin
                                 (u8vector-shrink! _obuf170037_ _ocount170047_)
                                 (cons _obuf170037_ _r170039_))
                               (std/error#raise-io-error
                                'inflate-port
                                '"zlib error"
                                (std/text/_zlib#z_stream_msg _zs170017_)
                                _res170045_))))))))
        (let ((_ibuf170024_ (make-u8vector _buflen170020_)))
          (let _lp170026_ ((_r170028_ '()))
            (let ((_rd170030_
                   (read-subu8vector
                    _ibuf170024_
                    '0
                    _buflen170020_
                    _inp170018_)))
              (if (let () (declare (not safe)) (##fxzero? _rd170030_))
                  (_fini170021_ _r170028_)
                  (if (let ()
                        (declare (not safe))
                        (##fx< _rd170030_ _buflen170020_))
                      (begin
                        (u8vector-shrink! _ibuf170024_ _rd170030_)
                        (_fini170021_
                         (_inflate-next170022_ _ibuf170024_ _r170028_)))
                      (_lp170026_
                       (_inflate-next170022_ _ibuf170024_ _r170028_)))))))))))
